#'
#'    rmatclust.R
#'
#'   $Revision: 1.13 $ $Date: 2025/05/20 08:21:15 $
#'
#'   Simulation of Matern cluster process
#'   naive algorithm or BKBC algorithm
#'
#'   rMatClustHom    Interface to C code for stationary case (BKBC)
#'   rMatClust       General case (naive or BKBC)
#' 
#'   Copyright (C) Adrian Baddeley and Ya-Mei Chang 2022-2023
#'   Licence: GNU Public Licence >= 2

rMatClustHom <- function(kappa, mu, R, W=unit.square(), ...,
                         nsim=1, drop=TRUE, inflate=NULL,
                         saveparents=FALSE) {
  check.1.real(kappa) && check.finite(kappa, xname="kappa")
  check.1.real(mu) && check.finite(mu, xname="mu")
  check.1.real(R) && check.finite(R, xname="R")
  if(!is.null(inflate)) {
    check.1.real(inflate) && check.finite(inflate, xname="inflate")
    stopifnot(inflate >= 1)
  }
  check.1.integer(nsim)
  stopifnot(kappa >= 0)
  stopifnot(mu >= 0)
  stopifnot(R > 0)
  ## trivial cases
  if(nsim == 0) return(simulationresult(list()))
  if(kappa == 0 || mu == 0) {
    ## intensity is zero - patterns are empty
    empt <- ppp(window=W)
    if(saveparents) {
      attr(empt, "parents") <- list(x=numeric(0), y=numeric(0))
      attr(empt, "parentid") <- integer(0)
      attr(empt, "cost") <- 0
    }
    result <- rep(list(empt), nsim)
    return(simulationresult(result, nsim=nsim, drop=drop))
  }
  ## shift window to convenient origin
  oldW <- W
  oldcentre <- as.numeric(centroid.owin(Frame(oldW)))
  W <- shift(oldW, -oldcentre)
  ## enclose it in a disc
  rD <- with(vertices(Frame(W)), sqrt(max(x^2+y^2)))
  ## optimal inflation
  if(is.null(inflate)) {
    rE <- if(R < rD) (rD + R) else rD
    inflate <- rE/rD
  }
  ## Prepare for C code
  storage.mode(kappa) <- "double"
  storage.mode(mu) <- "double"
  storage.mode(R) <- "double"
  storage.mode(rD) <- "double"
  storage.mode(inflate) <- "double"
  ##
  resultlist <- vector(mode="list", length=nsim)
  for(isim in seq_len(nsim)) {
    ## call C code
    if(saveparents) {
      z <- .Call(SR_rmatclusAll,
                 kappa, mu, R, rD, inflate,
                 PACKAGE="spatstat.random")
    } else {
      z <- .Call(SR_rmatclusOff,
                 kappa, mu, R, rD, inflate,
                 PACKAGE="spatstat.random")
    }
    ## unpack
    xo <- z[[1]]
    yo <- z[[2]]
    if(saveparents) {
      xp <- z[[3]]
      yp <- z[[4]]
      parentid <- z[[5]]
    }
    ## shift back to original window
    xo <- xo + oldcentre[1L]
    yo <- yo + oldcentre[2L]
    if(saveparents) {
      xp <- xp + oldcentre[1L]
      yp <- yp + oldcentre[2L]
    }
    ## restrict to original window
    retain <- inside.owin(xo, yo, oldW)
    if(!all(retain)) {
      xo <- xo[retain]
      yo <- yo[retain]
      if(saveparents) {
        parentid <- parentid[retain]
        retainedparents <- sort(unique(parentid))
        parentid <- match(parentid, retainedparents)
        xp <- xp[retainedparents]
        yp <- yp[retainedparents]
      }
    }
    ## save as point pattern
    Y <- ppp(xo, yo, window=oldW, check=FALSE)
    if(saveparents) {
      attr(Y, "parents") <- list(x = xp, y = yp)
      attr(Y, "parentid") <- parentid
      attr(Y, "cost") <- length(xo) + length(xp)
    }
    resultlist[[isim]] <- Y
  }
  result <- simulationresult(resultlist, nsim, drop=drop)
  return(result)
}


rMatClust <- local({
  
  ## like runifdisc but returns only the coordinates
  rundisk <- function(n, radius) {
    R <- radius * sqrt(runif(n, min=0, max=1))
    Theta <- runif(n, min=0, max=2*pi)
    cbind(R * cos(Theta), R * sin(Theta))
  }

  rMatClust <- 
  function(kappa, scale, mu, win = square(1),
           nsim=1, drop=TRUE, 
           ...,
           n.cond=NULL, w.cond=NULL, 
           algorithm=c("BKBC", "naive"),
           nonempty=TRUE, 
           poisthresh=1e-6,
           saveparents=FALSE, saveLambda=FALSE,
           kappamax=NULL, mumax=NULL, LambdaOnly=FALSE) {
    ## Matern Cluster Process
    ## Poisson (mu) number of offspring, uniform inside disc

    check.1.integer(nsim) && check.finite(nsim, xname="nsim")
    stopifnot(nsim >= 0)
    if(nsim == 0) return(simulationresult(list()))

    ## Catch old scale syntax (r)
    if(missing(scale)) scale <- list(...)$r
    check.1.real(scale)
    stopifnot(scale > 0)

    ## algorithm choices
    doLambda <- isTRUE(saveLambda) || isTRUE(LambdaOnly)
    conditioning <- !is.null(n.cond)
    if((conditioning || doLambda) && !isTRUE(spatstat.options("developer"))) {
      ## The naive algorithm must be used
      ## Change defaults      
      algorithm <- if(missing(algorithm)) "naive" else match.arg(algorithm)
      nonempty  <- if(missing(nonempty)) FALSE else isTRUE(nonempty)
      ## Override given arguments with a warning
      reason <- if(conditioning) "for conditional simulation" else "for intensity calculation"
      algorithm <- warn.reset.arg(algorithm, "naive", reason)
      nonempty  <- warn.reset.arg(nonempty,  FALSE,   reason)
    } else {
      ## Any choice of algorithm is permitted
      algorithm <- match.arg(algorithm)
      nonempty <- isTRUE(nonempty)
    }
    
    #' validate 'kappa' and 'mu'
    km <- validate.kappa.mu(kappa, mu, kappamax, mumax,
                            win, scale, ..., 
                            context="In rMatClust")
    kappamax <- km[["kappamax"]]
    mumax    <- km[["mumax"]]

    ## conditional simulation
    if(conditioning) {
      mod <- clusterprocess("MatClust", mu=mu, kappa=kappa, scale=scale)
      result <- CondSimCox(mod, nsim=nsim, ...,
                           nonempty=nonempty, algorithm=algorithm,
                           win=win, n.cond=n.cond, w.cond=w.cond,
                           saveparents=saveparents,
                           saveLambda=saveLambda, LambdaOnly=LambdaOnly,
                           drop=drop)
      return(result)
    }

    ## ------- Unconditional simulation ------------------
    
    ## detect trivial case where patterns are empty
    if(kappamax == 0 || mumax == 0) {
      result <- emptyNeyScot(win, nsim,
                             saveLambda, saveparents, LambdaOnly, ...)
      return(simulationresult(result, nsim=nsim, drop=drop))
    }

    
    #' determine algorithm
    do.parents <- saveparents || doLambda || !is.numeric(kappa)
    do.hybrid <- (algorithm == "BKBC") && nonempty 

    if(do.hybrid) {
      ## ........ Fast algorithm (BKBC) .................................
      ## run BKBC algorithm for stationary model
      result <- rMatClustHom(kappamax, mumax, scale, W=win, ...,
                             nsim=nsim, drop=FALSE,
                             saveparents=do.parents)

      ## thin 
      if(!is.numeric(kappa))
        result <- solapply(result, thinParents,
                           P=kappa, Pmax=kappamax)

      if(!is.numeric(mu)) 
        result <- solapply(result, rthin,
                           P=mu, Pmax=mumax,
                           na.zero=TRUE, fatal=FALSE)
    } else {
      ## .......... Slower algorithm ('naive') ..........................
      ## trap case of large clusters, close to Poisson
      if(is.numeric(kappa) && 1/(pi * kappa * scale^2) < poisthresh) {
        if(is.function(mu)) mu <- as.im(mu, W=win, ...)
        kapmu <- kappa * mu
        result <- rpoispp(kapmu, win=win, nsim=nsim, drop=drop, warnwin=FALSE)
        result <- fakeNeyScot(result, kapmu, win,
                              saveLambda, saveparents, LambdaOnly)
        return(result)
      }

      result <- rNeymanScott(kappa=kappa,
                             expand=scale,
                             rcluster=list(mu, rundisk),
                             win=win,
                             radius=scale, # formal argument of 'rundisk'
                             nsim=nsim, drop=FALSE,
                             nonempty=nonempty,
                             saveparents = do.parents,
                             kappamax=kappamax, mumax=mumax)
    }
    
    if(doLambda){
      B <- grow.rectangle(Frame(win), scale)
      for(i in 1:nsim) {
        parents <- attr(result[[i]], "parents")
        parents <- as.ppp(parents, W=B, check=FALSE)
        Lambda <- clusterfield("MatClust", parents, scale=scale, mu=mu, ...)
        Lambda <- Lambda[win, drop=FALSE]
        if(LambdaOnly) {
          #' save only the intensity
          result[[i]] <- Lambda
          if(saveparents) attr(result[[i]], "parents") <- parents
        } else {
          #' usual case - save intensity as attribute
          attr(result[[i]], "Lambda") <- Lambda
        }
      }
    }
    return(simulationresult(result, nsim, drop))
  }

  rMatClust
})

#
#   rlabel.R
#
#   random (re)labelling
#
#   $Revision: 1.13 $   $Date: 2020/10/23 15:18:00 $
#
#
rlabel <- local({

  resample <- function(x, replace=FALSE) {
    x[sample(length(x), replace=replace)]
  }

  rlabel <- function(X, labels=marks(X), permute=TRUE,
                     group=NULL, ..., nsim=1, drop=TRUE) {
    stopifnot(is.ppp(X) || is.lpp(X) || is.pp3(X) || is.ppx(X) || is.psp(X))
    if(is.null(labels))
      stop("labels not given and marks not present")
    singlecolumn <- (length(dim(labels)) < 2)
    nthings <- nobjects(X)
    things <- if(is.psp(X)) "segments" else "points"
    nlabels <- if(singlecolumn) length(labels) else nrow(labels)
    if((nlabels != nthings) && (permute || !is.null(group))) 
      stop(paste(if(singlecolumn) "Length" else "Number of rows",
                 "of labels does not match the number of",
                 things),
           call.=FALSE)
    ##
    if(is.null(group)) {
      Y <- replicate(nsim, {
        X %mark% marksubset(labels, sample(nlabels, nthings, replace=!permute))
      },
      simplify=FALSE)
    } else {
      group <- marks(cut(X, group, ...))
      seqn <- seq_len(nlabels)
      pieces <- split(seqn, group)
      Y <- replicate(nsim, {
        X %mark% marksubset(labels,
                            unsplit(lapply(pieces, resample, replace=!permute),
                                    group))
      },
      simplify=FALSE)
    }
    ## 
    return(simulationresult(Y, nsim, drop))
  }

  rlabel
})

#'
#'   is.cadlag.R
#'
#'   Test whether a stepfun is cadlag/rcll
#'   (continue a droite; limites a gauche)
#'
#'   $Revision: 1.4 $ $Date: 2020/11/30 04:10:33 $


is.cadlag <- function (s) {
  stopifnot(is.stepfun(s))
  r <- knots(s)
  h <- s(r)
  n <- length(r)
  r1 <- c(r[-1L],r[n]+1)
  rm <- (r+r1)/2
  hm <- s(rm)
  isTRUE(all.equal(h,hm))
}

#'
#'   randomppx.R
#'
#'   $Revision: 1.2 $ $Date: 2022/04/06 07:16:18 $
#'

runifpointx <- function(n, domain, nsim=1, drop=TRUE) {
  check.1.integer(n)
  check.1.integer(nsim)
  stopifnot(nsim >= 0)
  stopifnot(inherits(domain, "boxx"))
  ra <- domain$ranges
  d <- length(ra)
  result <- vector(mode="list", length=nsim)
  for(i in seq_len(nsim)) {
    if(n == 0) {
      coo <- matrix(numeric(0), nrow=0, ncol=d)
    } else {
      coo <- mapply(runif,
                    n=rep(n, d),
                    min=ra[1,],
                    max=ra[2,])
      if(!is.matrix(coo)) coo <- matrix(coo, ncol=d)
    }
    colnames(coo) <- colnames(ra)
    df <- as.data.frame(coo)
    result[[i]] <- ppx(df, domain, coord.type=rep("s", d))
  }
  if(nsim == 1 && drop)
    return(result[[1]])
  result <- as.anylist(result)
  if(nsim > 0) names(result) <- paste("Simulation", 1:nsim)
  return(result)
}

rpoisppx <- function(lambda, domain, nsim=1, drop=TRUE) {
  check.1.integer(nsim)
  stopifnot(nsim >= 0)
  stopifnot(inherits(domain, "boxx"))
  stopifnot(is.numeric(lambda) && length(lambda) == 1 && lambda >= 0)
  n <- rpois(nsim, lambda * volume.boxx(domain))
  result <- vector(mode="list", length=nsim)
  for(i in seq_len(nsim))
    result[[i]] <- runifpointx(n[i], domain)
  if(nsim == 1 && drop)
    return(result[[1]])
  result <- as.anylist(result)
  if(nsim > 0) names(result) <- paste("Simulation", 1:nsim)
  return(result)
}

#'
#'   clusterprocess.R
#'
#'   $Revision: 1.4 $ $Date: 2026/02/27 06:37:01 $
#'


clusterprocess <- function(name="Thomas", ..., mu, kappa, scale) {
  if(missing(kappa)) stop("The parent intensity kappa must be given")
  if(missing(mu)) stop("The mean cluster size mu must be given")
  if(missing(scale)) stop("The cluster scale must be given")
  rules <- spatstatClusterModelInfo(name)
  if(!isTRUE(rules$isPCP))
    stop("clusterprocess only supports Neyman-Scott processes")
  par.std <- c(kappa=kappa, scale=scale)
  par.std <- rules$checkpar(par.std, native=FALSE)
  par.idio <- rules$checkpar(par.std, native=TRUE)
  other <- rules$resolveshape(...)
  clustargs <- rules$outputshape(other$margs)
  out <- list(name=name, rules=rules,
              par.std=par.std, par.idio=par.idio,
              mu=mu, clustargs=clustargs,
              other=other)
  class(out) <- "clusterprocess"
  return(out)
}

print.clusterprocess <- local({

  print.clusterprocess <- function(x, ...) {
    with(x, {
      splat(rules$printmodelname(list(clustargs=clustargs)))
      newpar <- rules$checkpar(par.std, native=FALSE)
      splat("Parent intensity kappa =", blurb("kappa", newpar["kappa"]))
      splat("Cluster scale = ", newpar["scale"])
      splat("Mean cluster size mu =", blurb("mu", mu))
      if(length(clustargs) > 0) {
        hdr <- paste("Cluster shape",
                     ngettext(length(clustargs), "parameter:", "parameters:"))
        if(is.list(clustargs) &&
           all(sapply(clustargs, is.numeric)) &&
           all(lengths(clustargs) == 1)) {
          splat(hdr,
                paste(names(clustargs), as.numeric(clustargs),
                      sep="=",
                      collapse=", "))
        } else {
          splat(hdr)
          print(clustargs)
        }
      }
    })
    return(invisible(NULL))
  }

  blurb <- function(name, value) {
    if(is.numeric(value)) as.character(value) else
    if(is.im(value)) "[image]" else "[unrecognized format]"
  }

  print.clusterprocess
})


                             
intensity.clusterprocess <- function(X, ...) {
  X$par.std[["kappa"]] * X$mu
}
  
predict.clusterprocess <- function(object, ...,
                                 locations,
                                 type="intensity",
                                 ngrid=NULL) {
  ## limited use!!!
  if(!identical(type, "intensity"))
    stop("Sorry, only type='intensity' is implemented")
  lambda <- object$par.std[["kappa"]] * object$mu
  if(is.numeric(lambda)) {
    ## stationary
    if(is.ppp(locations))
      return(rep(lambda, npoints(locations)))
    W <- as.owin(locations)
    if(!is.mask(W))
      W <- as.mask(W, dimyx=ngrid, ...)
    return(as.im(lambda, W=W))
  } else {
    ## nonstationary; lambda is an image
    if(missing(locations) || is.null(locations)) 
      return(lambda)
    return(lambda[locations, drop=FALSE])
  }
}

clusterradius.clusterprocess <- function(model, ...,
                                        thresh = NULL, precision = FALSE) {
  do.call(clusterradius.character,
          resolve.defaults(
            list(model = model$name, thresh = thresh, precision = precision),
            list(...),
            as.list(model$par.std), # sic
            model$clustargs)
          )
}

reach.clusterprocess <- function(x, ..., epsilon) {
  thresh <- if(missing(epsilon)) NULL else epsilon
  2 * clusterradius(x, ..., thresh=thresh)
}

simulate.clusterprocess <- function(object, nsim=1, ...,
                                    win=unit.square(), window=win) {
  with(object, {
    switch(name,
         Thomas = {
           rThomas(kappa=par.std[["kappa"]],
                   scale=par.std[["scale"]],
                   mu=mu,
                   win=window,
                   nsim=nsim,
                   ...)
         },
         MatClust = {
           rMatClust(kappa=par.std[["kappa"]],
                     scale=par.std[["scale"]],
                     mu=mu,
                     win=window,
                     nsim=nsim,
                     ...)
         },
         Cauchy = {
           rCauchy(kappa=par.std[["kappa"]],
                   scale=par.std[["scale"]],
                   mu=mu,
                   win=window,
                   nsim=nsim,
                   ...)
         },
         VarGamma = {
           do.call(rVarGamma,
                   resolve.defaults(
                     list(kappa=par.std[["kappa"]],
                          scale=par.std[["scale"]],
                          mu=mu,
                          win=window,
                          nsim=nsim,
                          ...),
                     clustargs))
         },
         stop(paste("Unrecognised cluster process model name",
                    sQuote(object$name)),
              call.=FALSE)
         )})
}

clusterkernel.clusterprocess <- function(model, ...) {
  info <- spatstatClusterModelInfo(model$name)
  k <- info$kernel
  par <- model$par.std
  clustargs <- model$clustargs
  f <- function(x, y=0, ...) { k(par, sqrt(x^2+y^2), margs=clustargs) }
  return(f)
}


#' for other methods, see also spatstat.model

#'
#'   R/randomfields.R
#'
#'   Random generators of Gaussian random fields
#'
#'   $Revision: 1.7 $ $Date: 2023/10/20 14:50:06 $
#'
#'   Copyright (c) 2023 Adrian Baddeley
#'   GNU Public Licence (>= 2.0)

rGRFgauss <- function(W=owin(), mu=0, var=1, scale, ..., nsim=1, drop=TRUE) {
  ## Gaussian random field with Gaussian covariance function
  check.1.real(scale)
  stopifnot(scale > 0)
  gfun <- function(x) { exp(-(x/scale)^2) }
  rGRFcircembed(W=W, mu=mu, var=var, corrfun = gfun,
             ...,
             nsim=nsim, drop=drop)
}

rGRFexpo <- function(W=owin(), mu=0, var=1, scale, ...,
                     nsim=1, drop=TRUE) {
  ## Gaussian random field with exponential covariance function
  check.1.real(scale)
  stopifnot(scale > 0)
  efun <- function(x) { exp(-x/scale) }
  rGRFcircembed(W=W, mu=mu, var=var, corrfun = efun,
             ...,
             nsim=nsim, drop=drop)
}

rGRFstable <- function(W=owin(), mu=0, var=1, scale,
                       alpha,
                       ...,
                       nsim=1, drop=TRUE) {
  ## Gaussian random field with stable covariance
  check.1.real(alpha)
  sfun <- function(x) { exp(-(x/scale)^alpha) }
  rGRFcircembed(W=W, mu=mu, var=var, corrfun = sfun,
             ...,
             nsim=nsim, drop=drop)
}

rGRFgencauchy <- function(W=owin(), mu=0, var=1, scale,
                          alpha, beta,
                          ...,
                       nsim=1, drop=TRUE) {
  ## Gaussian random field with generalised Cauchy covariance
  check.1.real(alpha)
  check.1.real(beta)
  cfun <- function(x) { (1 + (x/scale)^alpha)^(-beta/alpha) }
  rGRFcircembed(W=W, mu=mu, var=var, corrfun = cfun,
             ...,
             nsim=nsim, drop=drop)
}

rGRFmatern <- function(W=owin(), mu=0, var=1, scale,
                       nu,
                       ...,
                       nsim=1, drop=TRUE) {
  ## Gaussian random field with Matern covariance
  check.1.real(nu)
  mfun <- function(x) {
    z <- (x/scale) * sqrt(2 * nu)
    ifelse(x == 0,
           1, 
           (z^nu) * besselK(z, nu) * (2^(1-nu))/gamma(nu))
  }
  rGRFcircembed(W=W, mu=mu, var=var, corrfun = mfun,
             ...,
             nsim=nsim, drop=drop)
}


## test functions - not for distribution!

## pvar <- function(Zlist, X=ppp(0.5, 0.5, 0:1, 0:1)) {
##   zvals <- sapply(Zlist, "[", i=X)
##   var(zvals)
## }

## pcor <- function(Zlist,
##                  lag=0.1, X=ppp(0.5, 0.5, 0:1, 0:1),
##                  Y=ppp(0.5, 0.5+lag, 0:1, 0:1)) {
##   zXvals <- sapply(Zlist, "[", i=X)
##   zYvals <- sapply(Zlist, "[", i=Y)
##   cov(zXvals, zYvals)/sqrt(var(zXvals) * var(zYvals))
## }

#
#
#   rmhmodel.R
#
#   $Revision: 1.85 $  $Date: 2026/01/21 06:26:39 $
#
#

rmhmodel <- function(...) {
  UseMethod("rmhmodel")
}


rmhmodel.rmhmodel <- function(model, ...) {
  # Check for outdated internal format
  # C.par was replaced by C.beta and C.ipar in spatstat 1.22-3 
  if(outdated <- !is.null(model$C.par))
    warning("Outdated internal format of rmhmodel object; rebuilding it")
  if(outdated || (length(list(...)) > 0))
    model <- rmhmodel.list(unclass(model), ...)
  return(model)
}

rmhmodel.list <- function(model, ...) {
  argnames <- c("cif","par","w","trend","types")
  ok <- argnames %in% names(model)
  do.call(rmhmodel.default,
          resolve.defaults(list(...), model[argnames[ok]]))
}

rmhmodel.default <- local({
  
  rmhmodel.default <- function(...,
    cif=NULL, par=NULL, w=NULL, trend=NULL, types=NULL) {
    rmhmodelDefault(..., cif=cif, par=par, w=w, trend=trend, types=types)
  }

  rmhmodelDefault <- function(...,
    cif=NULL, par=NULL, w=NULL, trend=NULL, types=NULL,
    stopinvalid=TRUE) {

    if(length(list(...)) > 0)
      stop(paste("rmhmodel.default: syntax should be", 
                 "rmhmodel(cif, par, w, trend, types)",
                 "with arguments given by name if they are present"), 
           call. = FALSE)

    ## Validate parameters
    if(is.null(cif)) stop("cif is missing or NULL")
    if(is.null(par)) stop("par is missing or NULL")

    if(!is.null(w))
      w <- as.owin(w)
  
    if(!is.character(cif))
      stop("cif should be a character string")

    betamultiplier <- 1
    
    Ncif <- length(cif)
    if(Ncif > 1) {
      ## hybrid
      ## check for Poisson components
      ispois <- (cif == 'poisson')
      if(any(ispois)) {
        ## validate Poisson components
        Npois <- sum(ispois)
        poismodels <- vector(mode="list", length=Npois)
        parpois <- par[ispois]
        for(i in 1:Npois)
          poismodels[[i]] <- rmhmodel(cif='poisson', par=parpois[[i]],
                                      w=w, trend=NULL, types=types,
                                      stopinvalid=FALSE)
        ## consolidate Poisson intensity parameters
        poisbetalist <- lapply(poismodels, getElement, name="C.beta")
        poisbeta <- Reduce("*", poisbetalist)
        if(all(ispois)) {
          ## model collapses to a Poisson process
          cif <- 'poisson'
          Ncif <- 1
          par <- list(beta=poisbeta)
          betamultiplier <- 1
        } else {
          ## remove Poisson components
          cif <- cif[!ispois]
          Ncif <- sum(!ispois)
          par <- par[!ispois]
          if(Ncif == 1) # revert to single-cif format
            par <- par[[1]]
          ## absorb beta parameters 
          betamultiplier <- poisbeta
        }
      }
    }
  
    if(Ncif > 1) {
      ## genuine hybrid 
      models <- vector(mode="list", length=Ncif)
      check <- vector(mode="list", length=Ncif)
      for(i in 1:Ncif) 
        models[[i]] <- rmhmodel(cif=cif[i], par=par[[i]],
                                w=w, trend=NULL, types=types,
                                stopinvalid=FALSE)
      C.id  <- unlist(lapply(models, getElement, name="C.id"))
      C.betalist <- lapply(models, getElement, name="C.beta")
      C.iparlist <- lapply(models, getElement, name="C.ipar")
      ## absorb beta multiplier into beta parameter of first component
      C.betalist[[1]] <- C.betalist[[1]] * betamultiplier
      ## concatenate for use in C
      C.beta     <- unlist(C.betalist)
      C.ipar     <- unlist(C.iparlist)
      check <- lapply(models, getElement, name="check")
      maxr <- max(unlist(lapply(models, getElement, name="reach")))
      ismulti <- unlist(lapply(models, getElement, name="multitype.interact"))
      multi <- any(ismulti)
      ## determine whether model exists
      integ <- unlist(lapply(models, getElement, name="integrable"))
      stabi <- unlist(lapply(models, getElement, name="stabilising"))
      integrable <- all(integ) || any(stabi)
      stabilising <- any(stabi)
      ## string explanations of conditions for validity
      expl <- lapply(models, getElement, name="explainvalid")
      integ.ex <- unlist(lapply(expl, getElement, name="integrable"))
      stabi.ex <- unlist(lapply(expl, getElement, name="stabilising"))
      stabi.oper <- !(stabi.ex %in% c("TRUE", "FALSE"))
      integ.oper <- !(integ.ex %in% c("TRUE", "FALSE"))
      compnames <- if(!anyDuplicated(C.id)) paste("cif", sQuote(C.id)) else 
      paste("component", 1:Ncif, paren(sQuote(C.id)))
      if(!integrable && stopinvalid) {
        ## model is not integrable: explain why
        ifail <- !integ & integ.oper
        ireason <- paste(compnames[ifail], "should satisfy",
                         paren(integ.ex[ifail], "{"))
        ireason <- verbalogic(ireason, "and")
        if(sum(ifail) <= 1) {
          ## There's only one offending cif, so stability is redundant
          sreason <- "FALSE"
        } else {
          sfail <- !stabi & stabi.oper
          sreason <- paste(compnames[sfail], "should satisfy",
                           paren(stabi.ex[sfail], "{"))
          sreason <- verbalogic(sreason, "or")
        }
        reason <- verbalogic(c(ireason, sreason), "or")
        stop(paste("rmhmodel: hybrid model is not integrable; ", reason),
             call.=FALSE)
      } else {
        ## construct strings summarising conditions for validity
        if(!any(integ.oper))
          ireason <- as.character(integrable)
        else {
          ireason <- paste(compnames[integ.oper], "should satisfy",
                           paren(integ.ex[integ.oper], "{"))
          ireason <- verbalogic(ireason, "and")
        }
        if(!any(stabi.oper))
          sreason <- as.character(stabilising)
        else {
          sreason <- paste(compnames[stabi.oper], "should satisfy",
                           paren(stabi.ex[stabi.oper], "{"))
          sreason <- verbalogic(sreason, "or")
        }
        ireason <- verbalogic(c(ireason, sreason), "or")
        explainvalid <- list(integrable=ireason,
                             stabilising=sreason)
      }
      
      out <- list(cif=cif,
                  par=par,
                  w=w,
                  trend=trend,
                  types=types,
                  C.id=C.id,
                  C.beta=C.beta,
                  C.ipar=C.ipar,
                  C.betalist=C.betalist,
                  C.iparlist=C.iparlist,
                  check=check,
                  multitype.interact=multi,
                  integrable=integrable,
                  stabilising=stabilising,
                  explainvalid=explainvalid,
                  reach=maxr)
      class(out) <- c("rmhmodel", class(out))
      return(out)
    }

    ## non-hybrid
  
    ## Check that this is a recognised model
    ## and look up the rules for this model
    rules <- spatstatRmhInfo(cif)
  
    ## Map the name of the cif from R to C
    ##      (the names are normally identical in R and C,
    ##      except "poisson" -> NA)
    C.id <- rules$C.id
  
    ## Check that the C name is recognised in C 
    if(!is.na(C.id)) {
      z <- .C(SR_knownCif,
              cifname=as.character(C.id),
              answer=as.integer(0),
              PACKAGE="spatstat.random")
      ok <- as.logical(z$answer)
      if(!ok)
        stop(paste("Internal error: the cif", sQuote(C.id),
                   "is not recognised in the C code"))
    }

    ## Validate the model parameters and reformat them 
    check <- rules$parhandler
    checkedpar <-
      if(!rules$multitype)
        check(par)
      else if(!is.null(types))
        check(par, types)
      else 
      ## types vector not given - defer checking
      NULL

    if(!is.null(checkedpar)) {
      stopifnot(is.list(checkedpar))
      stopifnot(!is.null(names(checkedpar)) && all(nzchar(names(checkedpar))))
      stopifnot(names(checkedpar)[[1]] == "beta")
      C.beta  <- unlist(checkedpar[[1]])
      C.beta <- C.beta * betamultiplier
      C.ipar <- as.numeric(unlist(checkedpar[-1]))
    } else {
      C.beta <- C.ipar <- NULL
    }
  
    ## Determine whether model is integrable
    integrable <- rules$validity(par, "integrable")
    explainvalid  <- rules$explainvalid
    
    if(!integrable && stopinvalid) 
      stop(paste("rmhmodel: the model is not integrable; it should satisfy",
                 explainvalid$integrable),
           call.=FALSE)
  
    ## Determine whether cif is stabilising
    ## (i.e. any hybrid including this cif will be integrable)
    stabilising <- rules$validity(par, "stabilising")

    ## Calculate reach of model
    mreach <- rules$reach(par)

    ###################################################################
    ## return augmented list  
    out <- list(cif=cif,
                par=par,
                w=w,
                trend=trend,
                types=types,
                C.id=C.id,
                C.beta=C.beta,
                C.ipar=C.ipar,
                check= if(is.null(C.ipar)) check else NULL,
                multitype.interact=rules$multitype,
                integrable=integrable,
                stabilising=stabilising,
                explainvalid=explainvalid,
                reach=mreach
                )
    class(out) <- c("rmhmodel", class(out))
    return(out)
  }

  rmhmodel.default
})

print.rmhmodel <- function(x, ...) {
  verifyclass(x, "rmhmodel")

  splat("Metropolis-Hastings algorithm, model parameters\n")

  Ncif <- length(x$cif)
  splat("Conditional intensity:",
        if(Ncif == 1) "cif=" else "hybrid of cifs",
        commasep(sQuote(x$cif)))
  
  if(!is.null(x$types)) {
    if(length(x$types) == 1)
      splat("Univariate process.")
    else {
      cat("Multitype process with types =\n")
      print(x$types)
      if(!x$multitype.interact)
        splat("Interaction does not depend on type")
    }
  } else if(x$multitype.interact) {
      splat("Multitype process, types not yet specified.")
  } else {
    typ <- try(rmhResolveTypes(x, rmhstart(), rmhcontrol()))
    if(!inherits(typ, "try-error")) {
      ntyp <- length(typ)
      if(ntyp > 1) {
        splat("Data imply a multitype process with", ntyp, "types of points.")
        splat("Interaction does not depend on type.")
      }
    }
  }
  
  cat("\nNumerical parameters: par =\n")
  print(x$par)
  if(is.null(x$C.ipar))
    splat("Parameters have not yet been checked for compatibility with types.")
  if(is.owin(x$w)) print(x$w) else splat("Window: not specified.")
  cat("\nTrend: ")
  tren <- x$trend
  if(is.null(tren)) {
    cat("none.\n")
  } else {
    if(is.list(tren)) cat(paste0("List of ", length(tren), ":\n"))
    print(tren)
  }
  if(!is.null(x$integrable) && !x$integrable) 
    cat("\n*Warning: model is not integrable and cannot be simulated*\n")
  return(invisible(NULL))
}

reach.rmhmodel <- function(x, ...) {
  if(length(list(...)) == 0)
    return(x$reach)
  # reach must be recomputed 
  cif <- x$cif
  Ncif <- length(cif)
  pars <- if(Ncif == 1) list(x$par) else x$par
  maxr <- 0
  for(i in seq_len(Ncif)) {
    cif.i <- cif[i]
    par.i <- pars[[i]]
    rules <- spatstatRmhInfo(cif.i)
    rchfun  <- rules$reach
    if(!is.function(rchfun))
      stop(paste("Internal error: reach is unknown for cif=", sQuote(cif.i)),
           call.=FALSE)
    r.i <- rchfun(par.i, ...)
    maxr <- max(maxr, r.i, na.rm=TRUE)
  }
  return(maxr)
}

is.poisson <- function(x) {
  UseMethod("is.poisson")
}

is.poisson.rmhmodel <- function(x) {
  verifyclass(x, "rmhmodel")
  identical(x$cif, 'poisson')
}

is.poisson.NAobject <- function(x) { NA_integer_ }

is.stationary <- function(x) {
  UseMethod("is.stationary")
}

is.stationary.rmhmodel <- function(x) {
  verifyclass(x, "rmhmodel")
  tren <- x$trend
  return(is.null(tren) || is.numeric(tren))
}

is.stationary.NAobject <- function(x) { NA_integer_ }

as.owin.rmhmodel <- function(W, ..., fatal=FALSE) {
  # W is the rmhmodel object. It contains a window w
  ans <- W$w
  if(is.owin(ans)) return(ans)
  if(fatal) stop("rmhmodel object does not contain a window")
  return(NULL)
}

domain.rmhmodel <- Window.rmhmodel <- function(X, ...) { as.owin(X) }

is.expandable.rmhmodel <- local({

  ok <- function(z) { is.null(z) || is.numeric(z) || is.function(z) }

  is.expandable.rmhmodel <- function(x) {
    tren <- x$tren
    ans <- if(!is.list(tren)) ok(tren) else all(sapply(tren, ok))
    return(ans)
  }

  is.expandable.rmhmodel
})

  
#####  Table of rules for handling rmh models ##################

spatstatRmhInfo <- function(cifname) {
  rules <- .Spatstat.RmhTable[[cifname]]
  if(is.null(rules))
    stop(paste("Unrecognised cif:", sQuote(cifname)), call.=FALSE)
  return(rules)
}
  
.Spatstat.RmhTable <-
  list(
#
# 0. Poisson (special case)
#
       'poisson'=
       list(
            C.id=NA,
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the Poisson process"
              with(par, forbidNA(beta, ctxt, xname="beta"))
              par <- check.named.list(par, "beta", ctxt, xtitle="par")
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              return(par)
            },
            validity=function(par, kind) {
              switch(kind,
                     integrable=TRUE,
                     stabilising=FALSE)
            },
            explainvalid=list(integrable="TRUE",stabilising="FALSE"),
            reach = function(par, ...) { return(0) },
            hardcore = function(par, ...) { return(0) },
            temper = function(par, invtemp) { return(par^invtemp) }
            ),
#       
# 1. Strauss.
#       
       'strauss'=
       list(
            C.id="strauss",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the strauss cif"
              par <- check.named.list(par, c("beta","gamma","r"), 
				      ctxt, xtitle="par")
              # treat r=NA as absence of interaction
              par <- within(par, if(is.na(r)) { r <- 0; gamma <- 1 })
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(gamma, ctxt, "gamma"))
              with(par, check.finite(r, ctxt, "r"))
              with(par, check.1.real(gamma, ctxt))
              with(par, check.1.real(r,     ctxt))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, explain.ifnot(gamma >= 0, ctxt))
              with(par, explain.ifnot(r >= 0, ctxt))
              return(par)
            },
            validity=function(par, kind) {
              gamma <- par$gamma
              switch(kind,
                     integrable=(gamma <= 1),
                     stabilising=(gamma == 0)
                     )
            },
            explainvalid=list(
              integrable="gamma <= 1",
              stabilising="gamma == 0"),
            reach = function(par, ...) {
              r <- par[["r"]]
              g <- par[["gamma"]]
              return(if(g == 1) 0 else r)
            },
            hardcore = function(par, ..., epsilon=0) {
              r <- par[["r"]]
              g <- par[["gamma"]]
              return(if(g <= epsilon) r else 0)
            },
            temper = function(par, invtemp) {
              within(par, {
                beta <- beta^invtemp
                gamma <- gamma^invtemp
              })
            }
            ),
#       
# 2. Strauss with hardcore.
#       
       'straush' =
       list(
            C.id="straush",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the straush cif"
              par <- check.named.list(par, c("beta","gamma","r","hc"), 
                                      ctxt, xtitle="par")
              # treat hc=NA as absence of hard core
              par <- within(par, if(is.na(hc)) { hc <- 0 } )
              # treat r=NA as absence of interaction
              par <- within(par, if(is.na(r)) { r <- hc; gamma <- 1 } )
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(gamma, ctxt, "gamma"))
              with(par, check.finite(r, ctxt, "r"))
              with(par, check.finite(hc, ctxt, "hc"))
              with(par, check.1.real(gamma, ctxt))
              with(par, check.1.real(r,     ctxt))
              with(par, check.1.real(hc,     ctxt))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, explain.ifnot(gamma >= 0, ctxt))
              with(par, explain.ifnot(r >= 0, ctxt))
              with(par, explain.ifnot(hc >= 0, ctxt))
              with(par, explain.ifnot(hc <= r, ctxt))
              return(par)
            },
            validity=function(par, kind) {
              hc <- par$hc
              gamma <- par$gamma
              switch(kind,
                     integrable=(hc > 0 || gamma <= 1),
                     stabilising=(hc > 0)
                   )
            },
            explainvalid=list(
              integrable="hc > 0 or gamma <= 1",
              stabilising="hc > 0"),
            reach = function(par, ...) {
              h <- par[["hc"]]
              r <- par[["r"]]
              g <- par[["gamma"]]
              return(if(g == 1) h else r)
            },
            hardcore = function(par, ..., epsilon=0) {
              h <- par[["hc"]]
              r <- par[["r"]]
              g <- par[["gamma"]]
              return(if(g <= epsilon) r else h)
            },
            temper = function(par, invtemp) {
              within(par, {
                beta <- beta^invtemp
                gamma <- gamma^invtemp
              })
            }
            ),
#       
# 3. Softcore.
#
       'sftcr' =
       list(
            C.id="sftcr",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the sftcr cif"
              par <- check.named.list(par, c("beta","sigma","kappa"),
                                      ctxt, xtitle="par")
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(sigma, ctxt, "sigma"))
              with(par, check.finite(kappa, ctxt, "kappa"))
              with(par, check.1.real(sigma, ctxt))
              with(par, check.1.real(kappa, ctxt))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, explain.ifnot(sigma >= 0, ctxt))
              with(par, explain.ifnot(kappa >= 0 && kappa <= 1, ctxt))
              return(par)
            },
            validity=function(par, kind) {
              switch(kind,
                     integrable=TRUE,
                     stabilising=FALSE)
            },
            explainvalid=list(integrable="TRUE",stabilising="FALSE"),
            reach = function(par, ..., epsilon=0) {
              if(epsilon==0)
                return(Inf)
              kappa <- par[["kappa"]]
              sigma <- par[["sigma"]]
              return(sigma/(epsilon^(kappa/2)))
            },
            hardcore = function(par, ..., epsilon=0) {
              if(epsilon==0)
                return(0)
              kappa <- par[["kappa"]]
              sigma <- par[["sigma"]]
              return(sigma/((-log(epsilon))^(kappa/2)))
            },
            temper = function(par, invtemp) {
              within(par, {
                beta <- beta^invtemp
                sigma <- sigma * (invtemp^(kappa/2))
              })
            }
            ),
#       
# 4. Multitype Strauss.
#       
       'straussm' =
       list(
            C.id="straussm",
            multitype=TRUE,
            parhandler=function(par, types) {
              ctxt <- "For the straussm cif"
              par <- check.named.list(par, c("beta","gamma","radii"),
                                      ctxt, xtitle="par")
              beta <- par$beta
              gamma <- par$gamma
              r <- par$radii
              ntypes <- length(types)

              check.finite(beta, ctxt, "beta")
              check.nvector(beta, ntypes, TRUE, "types", vname="beta")

              MultiPair.checkmatrix(gamma, ntypes, "par$gamma")
	      gamma[is.na(gamma)] <- 1
              check.finite(gamma, ctxt, "gamma")

              MultiPair.checkmatrix(r, ntypes, "par$radii")
              if(any(nar <- is.na(r))) {
                r[nar] <- 0
                gamma[nar] <- 1
              }
              check.finite(r, ctxt, "r")

              explain.ifnot(all(beta >= 0), ctxt)
              explain.ifnot(all(gamma >= 0), ctxt)
              explain.ifnot(all(r >= 0), ctxt)

              par <- list(beta=beta, gamma=gamma, r=r)
              return(par)
            }, 
            validity=function(par, kind) {
              gamma <- par$gamma
              radii <- par$radii
              dg <- diag(gamma)
              dr <- diag(radii)
              hard <-!is.na(dg) & (dg == 0) & !is.na(dr) & (dr > 0)
              operative <- !is.na(gamma) & !is.na(radii) & (radii > 0)
              switch(kind,
                     stabilising=all(hard),
                     integrable=all(hard) || all(gamma[operative] <= 1))
            },
            explainvalid=list(
              integrable=paste(
                "gamma[i,j] <= 1 for all i and j,",
                "or gamma[i,i] = 0 for all i"),
              stabilising="gamma[i,i] = 0 for all i"),
            reach = function(par, ...) {
              r <- par$radii
              g <- par$gamma
              operative <- ! (is.na(r) | (g == 1))
              return(max(0, r[operative]))
            },
            hardcore = function(par, ..., epsilon=0) {
              r <- par$radii
              g <- par$gamma
              return(max(0, r[!is.na(r) & g <= epsilon]))
            },
            temper = function(par, invtemp) {
              within(par, {
                beta <- beta^invtemp
                gamma <- gamma^invtemp
              })
            }
            ),
#       
# 5. Multitype Strauss with hardcore.
#       
       'straushm' = 
       list(
            C.id="straushm",
            multitype=TRUE,
            parhandler=function(par, types) {
              ctxt="For the straushm cif"
              par <- check.named.list(par,
                                      c("beta","gamma","iradii","hradii"),
                                      ctxt, xtitle="par")
              beta <- par$beta
              gamma <- par$gamma
              iradii <- par$iradii
              hradii <- par$hradii
              ntypes <- length(types)

              check.nvector(beta, ntypes, TRUE, "types", vname="beta")
              check.finite(beta, ctxt, "beta")
              
              MultiPair.checkmatrix(gamma, ntypes, "par$gamma")
              gamma[is.na(gamma)] <- 1
              check.finite(gamma, ctxt, "gamma")

              MultiPair.checkmatrix(iradii, ntypes, "par$iradii")
              if(any(nar <- is.na(iradii))) {
                iradii[nar] <- 0
                gamma[nar] <- 1
              }
              check.finite(iradii, ctxt, "iradii")

              MultiPair.checkmatrix(hradii, ntypes, "par$hradii")
              nah <- is.na(hradii)
              hradii[nah] <- 0
              check.finite(hradii, ctxt, "hradii")

              explain.ifnot(all(beta >= 0), ctxt)
              explain.ifnot(all(gamma >= 0), ctxt)
              explain.ifnot(all(iradii >= 0), ctxt)
              explain.ifnot(all(hradii >= 0), ctxt)

              comparable <- !nar & !nah
              explain.ifnot(all((iradii >= hradii)[comparable]), ctxt)

              par <- list(beta=beta,gamma=gamma,iradii=iradii,hradii=hradii)
              return(par)
            },
            validity=function(par, kind) {
              gamma <- par$gamma
              iradii <- par$iradii
              hradii <- par$hradii
              dh <- diag(hradii)
              dg <- diag(gamma)
              dr <- diag(iradii)
              hhard <- !is.na(dh) & (dh > 0)
              ihard <- !is.na(dr) & (dr > 0) & !is.na(dg) & (dg == 0)
              hard <- hhard | ihard
              operative <- !is.na(gamma) & !is.na(iradii) & (iradii > 0)
              switch(kind,
                     stabilising=all(hard),
                     integrable={
                       all(hard) || all(gamma[operative] <= 1)
                     })
            },
            explainvalid=list(
              integrable=paste(
                "hradii[i,i] > 0 or gamma[i,i] = 0 for all i, or",
                "gamma[i,j] <= 1 for all i and j"),
              stabilising="hradii[i,i] > 0 or gamma[i,i] = 0 for all i"),
            reach=function(par, ...) {
              r <- par$iradii
              h <- par$hradii
              g <- par$gamma
              roperative <- ! (is.na(r) | (g == 1))
              hoperative <- ! is.na(h)
              return(max(0, r[roperative], h[hoperative]))
            },
            hardcore = function(par, ..., epsilon=0) {
              r <- par$radii
              h <- par$hradii
              g <- par$gamma
              return(max(h[!is.na(h)],
                         r[!is.na(r) & g <= epsilon]))
            },
            temper = function(par, invtemp) {
              within(par, {
                beta <- beta^invtemp
                gamma <- gamma^invtemp
              })
            }
            ),
#       
# 6. Diggle-Gates-Stibbard interaction
#    (function number 1 from Diggle, Gates, and Stibbard)
       
       'dgs' = 
       list(
            C.id="dgs",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the dgs cif"
              par <- check.named.list(par, c("beta","rho"),
                                      ctxt, xtitle="par")
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(rho, ctxt, "rho"))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, check.1.real(rho, ctxt))
              with(par, explain.ifnot(rho >= 0, ctxt))
              return(par)
            },
            validity=function(par, kind) {
              switch(kind,
                     integrable=TRUE,
                     stabilising=FALSE)
            },
            explainvalid=list(integrable="TRUE", stabilising="FALSE"),
            reach=function(par, ...) {
              return(par[["rho"]])
            },
            hardcore=function(par, ..., epsilon=0) {
              if(epsilon == 0) return(0)
              return(par[["rho"]] * (2/pi) * asin(sqrt(epsilon)))
            },
            temper = NULL  # not a loglinear model
            ),
#
# 7. Diggle-Gratton interaction 
#    (function number 2 from Diggle, Gates, and Stibbard).

       'diggra' =
       list(
            C.id="diggra",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the diggra cif"
              par <- check.named.list(par, c("beta","kappa","delta","rho"),
                                      ctxt, xtitle="par")
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(kappa, ctxt, "kappa"))
              with(par, check.finite(delta, ctxt, "delta"))
              with(par, check.finite(rho, ctxt, "rho"))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, check.1.real(kappa, ctxt))
              with(par, check.1.real(delta, ctxt))
              with(par, check.1.real(rho,   ctxt))
              with(par, explain.ifnot(kappa >= 0, ctxt))              
              with(par, explain.ifnot(delta >= 0, ctxt))              
              with(par, explain.ifnot(rho >= 0, ctxt))              
              with(par, explain.ifnot(delta < rho, ctxt))              
              return(par)
            },
            validity=function(par, kind) {
              switch(kind,
                     integrable=TRUE,
                     stabilising=FALSE)
            },
            explainvalid=list(integrable="TRUE",stabilising="FALSE"),
            reach=function(par, ...) {
              return(par[["rho"]])
            },
            hardcore=function(par, ..., epsilon=0) {
              return(par[["delta"]])
            },
            temper = function(par, invtemp) {
              within(par, {
                kappa <- kappa * invtemp
              })
            }),
#       
# 8. Geyer saturation model
#       
       'geyer' = 
       list(
            C.id="geyer",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the geyer cif"
              par <- check.named.list(par,
                                      c("beta","gamma","r","sat"),
                                      ctxt, xtitle="par")
              with(par, check.1.real(gamma, ctxt))
              with(par, check.1.real(r,     ctxt))
              with(par, check.1.real(sat,   ctxt))
              par <- within(par, sat <- min(sat, .Machine$integer.max-100))
              par <- within(par, if(is.na(gamma)) { r <- 0; gamma <- 1 })
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(gamma, ctxt, "gamma"))
              with(par, check.finite(r, ctxt, "r"))
              with(par, check.finite(sat, ctxt, "sat"))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              return(par)
            },
            validity=function(par, kind) {
              switch(kind,
                     integrable=TRUE,
                     stabilising=FALSE)
            },
            explainvalid=list(integrable="TRUE", stabilising="FALSE"),
            reach = function(par, ...) {
              r <- par[["r"]]
              g <- par[["gamma"]]
              return(if(g == 1) 0 else 2 * r)
            },
            hardcore = function(par, ..., epsilon=0) {
              r <- par[["r"]]
              g <- par[["gamma"]]
              return(if(g <= epsilon) r else 0)
            },
            temper = function(par, invtemp) {
              within(par, {
                beta <- beta^invtemp
                gamma <- gamma^invtemp
              })
            }
            ),
#       
# 9. The ``lookup'' device.  This permits simulating, at least
# approximately, ANY pairwise interaction function model
# with isotropic pair interaction (i.e. depending only on distance).
# The pair interaction function is provided as a vector of
# distances and corresponding function values which are used
# as a ``lookup table'' by the C code.
#
       'lookup' = 
       list(
            C.id="lookup",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the lookup cif"
              par <- check.named.list(par,
                                      c("beta","h"),
                                      ctxt, "r", xtitle="par")
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              beta   <- par[["beta"]]
              h.init <- par[["h"]]
              r      <- par[["r"]]
              if(is.null(r)) {
		if(!is.stepfun(h.init))
                  stop(paste("For cif=lookup, if component r of",
                             "par is absent then component h must",
                             "be a stepfun object."))
		if(!is.cadlag(h.init))
                  stop(paste("The lookup pairwise interaction step",
			     "function must be right continuous,\n",
			     "i.e. built using the default values of the",
                             sQuote("f"), "and", sQuote("right"),
                             "arguments for stepfun."))
		r     <- knots(h.init)
		h0    <- get("yleft",envir=environment(h.init))
		h     <- h.init(r)
		nlook <- length(r)
		if(!isTRUE(all.equal(h[nlook],1)))
                  stop(paste("The lookup interaction step function",
                             "must be equal to 1 for", dQuote("large"),
                             "distances."))
		if(r[1] <= 0)
                  stop(paste("The first jump point (knot) of the lookup",
                             "interaction step function must be",
                             "strictly positive."))
		h <- c(h0,h)
              } else {
		h     <- h.init
		nlook <- length(r)
		if(length(h) != nlook)
                  stop("Mismatch of lengths of h and r lookup vectors.")
		if(anyNA(r))
                  stop("Missing values not allowed in r lookup vector.")
		if(is.unsorted(r))
                  stop("The r lookup vector must be in increasing order.")
		if(r[1] <= 0)
                  stop(paste("The first entry of the lookup vector r",
                             "should be strictly positive."))
		h <- c(h,1)
              }
              if(any(h < 0))
		stop(paste("Negative values in the lookup",
                           "pairwise interaction function."))
              if(h[1] > 0 & any(h > 1))
		stop(paste("Lookup pairwise interaction function does",
                           "not define a valid point process."))
              rmax   <- r[nlook]
              r <- c(0,r)
              nlook <- nlook+1
              deltar <- mean(diff(r))
              if(isTRUE(all.equal(diff(r),rep.int(deltar,nlook-1)))) {
		par <- list(beta=beta,nlook=nlook,
                            equisp=1,
                            deltar=deltar,rmax=rmax, h=h)
              } else {
		par <- list(beta=beta,nlook=nlook,
                            equisp=0,
                            deltar=deltar,rmax=rmax, h=h,
                            r=r)
              }
              return(par) 
            },
            validity=function(par, kind) {
              h <- par$h
              if(is.stepfun(h))
                h <- eval(expression(c(yleft,y)),envir=environment(h))
              switch(kind,
                     integrable={
                       (h[1] == 0) || all(h <= 1)
                     },
                     stabilising={ h[1] == 0 })
            },
            explainvalid=list(
              integrable="h[1] == 0 or h[i] <= 1 for all i",
              stabilising="h[1] == 0"),
            reach = function(par, ...) {
              r <- par[["r"]]
              h <- par[["h"]]
              if(is.null(r)) 
                r <- knots(h)
              return(max(r))
            },
            hardcore = function(par, ..., epsilon=0) {
              r <- par[["r"]]
              h <- par[["h"]]
              if(is.null(r)) 
                r <- knots(h)
              return(max(0, r[h <= epsilon]))
            },
            temper = function(par, invtemp) {
              within(par, {
                beta <- beta^invtemp
                h <- h^invtemp
              })
            }
            ),
#       
# 10. Area interaction
#       
       'areaint'=
       list(
            C.id="areaint",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the areaint cif"
              par <- check.named.list(par, c("beta","eta","r"),
                                      ctxt, xtitle="par")
              par <- within(par, if(is.na(r)) { r <- 0 })
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, check.1.real(eta, ctxt))
              with(par, check.1.real(r,   ctxt))
              with(par, check.finite(eta, ctxt, "eta"))
              with(par, check.finite(r,   ctxt, "r"))
              with(par, explain.ifnot(eta >= 0, ctxt))
              with(par, explain.ifnot(r >= 0,   ctxt))
              return(par)
            },
            validity=function(par, kind) {
              switch(kind,
                     integrable=TRUE,
                     stabilising=FALSE)
            },
            explainvalid=list(integrable="TRUE", stabilising="FALSE"),
            reach = function(par, ...) {
              r <- par[["r"]]
              eta <- par[["eta"]]
              return(if(eta == 1) 0 else (2 * r))
            },
            hardcore = function(par, ..., epsilon=0) {
              r <- par[["r"]]
              eta <- par[["eta"]]
              if(eta > epsilon) return(0)
              if(eta == 0) return(2 * r)
              # linear approximation
              return(2 * r * eta/epsilon)
            },
            temper = function(par, invtemp) {
              within(par, {
                beta <- beta^invtemp
                eta  <- eta^invtemp
              })
            }
            ),
#
# 11. The ``badgey'' (Baddeley-Geyer) model.
#
       'badgey' =
       list(
            C.id="badgey",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the badgey cif"
              par <- check.named.list(par,
                                      c("beta","gamma","r","sat"),
                                      ctxt, xtitle="par")
              par <- within(par, sat <- pmin(sat, .Machine$integer.max-100))
              par <- within(par, gamma[is.na(gamma) | is.na(r)] <- 1)
              par <- within(par, r[is.na(r)] <- 0)
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(gamma, ctxt, "gamma"))
              with(par, check.finite(r, ctxt, "r"))
              with(par, check.finite(sat, ctxt, "sat"))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, explain.ifnot(all(gamma >= 0), ctxt))
              with(par, explain.ifnot(all(r >= 0), ctxt))
              with(par, explain.ifnot(all(sat >= 0), ctxt))
              with(par, explain.ifnot(length(gamma) == length(r), ctxt)) 
              gamma <- par[["gamma"]]
              r     <- par[["r"]]
              sat   <- par[["sat"]]
              if(length(sat)==1) sat <- rep.int(sat,length(gamma))
              else explain.ifnot(length(sat) == length(gamma), ctxt)
              mmm <- cbind(gamma,r,sat)
              mmm <- mmm[fave.order(r),]
              ndisc <- length(r)
              par <- list(beta=par$beta,ndisc=ndisc,parms=as.vector(t(mmm)))
              return(par)
            },
            validity=function(par, kind) {
              switch(kind,
                     integrable=TRUE,
                     stabilising=FALSE)
            },
            explainvalid=list(integrable="TRUE", stabilising="FALSE"),
            reach = function(par, ...) {
              r <- par[["r"]]
              gamma <- par[["gamma"]]
              operative <- (gamma != 1)
              return(if(!any(operative)) 0 else (2 * max(r[operative])))
            },
            hardcore = function(par, ..., epsilon=0) {
              r <- par[["r"]]
              gamma <- par[["gamma"]]
              return(max(0, r[gamma <= epsilon]))
            },
            temper = function(par, invtemp) {
              within(par, {
                beta  <- beta^invtemp
                gamma <- gamma^invtemp
              })
            }
            ),
#
# 12. The hard core process
       'hardcore' =
       list(
            C.id="hardcore",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the hardcore cif"
              par <- check.named.list(par, c("beta", "hc"), ctxt, xtitle="par")
              par <- within(par, if(is.na(hc)) { hc <- 0 })
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(hc, ctxt, "hc"))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, check.1.real(hc, ctxt))
              return(par)
            },
            validity=function(par, kind) {
              hc <- par$hc
              switch(kind,
                     integrable=TRUE,
                     stabilising=(hc > 0))
            },
            explainvalid=list(integrable="TRUE", stabilising="hc > 0"),
            reach = function(par, ...) {
              hc <- par[["hc"]]
              return(hc)
            },
            hardcore = function(par, ...) {
              hc <- par[["hc"]]
              return(hc)
            },
            temper = function(par, invtemp) {
              within(par, {
                beta  <- beta^invtemp
              })
            }
            ),
#
# Lucky 13. Fiksel process
       'fiksel' =
       list(
            C.id="fiksel",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the Fiksel cif"
              par <- check.named.list(par,
                                      c("beta", "r", "hc", "kappa", "a"),
                                      ctxt, xtitle="par")
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(r, ctxt, "r"))
              with(par, check.finite(hc, ctxt, "hc"))
              with(par, check.finite(kappa, ctxt, "kappa"))
              with(par, check.finite(a, ctxt, "a"))
              with(par, check.1.real(r, ctxt))
              with(par, check.1.real(hc, ctxt))
              with(par, check.1.real(kappa, ctxt))
              with(par, check.1.real(a, ctxt))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, explain.ifnot(hc >= 0, ctxt))
              with(par, explain.ifnot(r > hc, ctxt))
              return(par)
            },
            validity=function(par, kind) {
              hc <- par$hc
              a  <- par$a
              switch(kind,
                     integrable=(hc > 0 || a <= 0),
                     stabilising=(hc > 0))
            },
            explainvalid=list(
              integrable="hc > 0 or a <= 0",
              stabilising="hc > 0"),
            reach = function(par, ...) {
              r <- par[["r"]]
              hc <- par[["hc"]]              
              a <- par[["a"]]
              return(if(a != 0) r else hc)
            },
            hardcore = function(par, ...) {
              return(par[["hc"]])
            },
            temper = function(par, invtemp) {
              within(par, {
                beta  <- beta^invtemp
                a <- a * invtemp
              })
            }
            ),
#
# 14. Lennard-Jones
       'lennard' =
       list(
            C.id="lennard",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the Lennard-Jones cif"
              par <- check.named.list(par,
                                      c("beta", "sigma", "epsilon"),
                                      ctxt, xtitle="par")
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(sigma, ctxt, "sigma"))
              with(par, check.finite(epsilon, ctxt, "epsilon"))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, check.1.real(sigma, ctxt))
              with(par, check.1.real(epsilon, ctxt))
              with(par, explain.ifnot(sigma > 0, ctxt))
              with(par, explain.ifnot(epsilon > 0, ctxt))
              return(par)
            },
            validity=function(par, kind) {
              switch(kind,
                     integrable=(par$sigma > 0),
                     stabilising=FALSE)
            },
            explainvalid=list(
              integrable="sigma > 0",
              stabilising="FALSE"),
            reach = function(par, ...) {
              sigma <- par[["sigma"]]
              return(2.5 * sigma)
            },
            hardcore = function(par, ...) {
              sigma <- par[["sigma"]]
              return(sigma/2.5)
            },
            temper = function(par, invtemp) {
              within(par, {
                beta  <- beta^invtemp
                epsilon <- epsilon * invtemp
              })
            }
            ),
#       
# 15. Multitype hardcore.
#       
       'multihard' = 
       list(
            C.id="multihard",
            multitype=TRUE,
            parhandler=function(par, types) {
              ctxt="For the multihard cif"
              par <- check.named.list(par,
                                      c("beta","hradii"),
                                      ctxt, xtitle="par")

              beta <- par$beta
              hradii <- par$hradii
              ntypes <- length(types)

              check.nvector(beta, ntypes, TRUE, "types", vname="beta")
              check.finite(beta, ctxt, "beta")
              
              MultiPair.checkmatrix(hradii, ntypes, "par$hradii")
              hradii[is.na(hradii)] <- 0
              check.finite(hradii, ctxt, "hradii")

              explain.ifnot(all(beta >= 0), ctxt)
              explain.ifnot(all(hradii >= 0), ctxt)

              par <- list(beta=beta,hradii=hradii)
              return(par)
            },
            validity=function(par, kind) {
              switch(kind,
                     integrable=return(TRUE),
                     stabilising={
                       hself <- diag(par$hradii)
                       repel <- !is.na(hself) & (hself > 0)
                       return(all(repel))
                     })
            },
            explainvalid=list(
              integrable="TRUE",
              stabilising="hradii[i,i] > 0 for all i"),
            reach=function(par, ...) {
              return(max(0, par$hradii, na.rm=TRUE))
            },
            hardcore=function(par, ..., epsilon=0) {
              return(max(0, par$hradii, na.rm=TRUE))
            },
            temper = function(par, invtemp) {
              within(par, {
                beta  <- beta^invtemp
              })
            }
            ),
#       
# 16. Triplets.
#       
       'triplets'=
       list(
            C.id="triplets",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the triplets cif"
              par <- check.named.list(par,
                                      c("beta","gamma","r"),
                                      ctxt, xtitle="par")
              # treat r=NA as absence of interaction
              par <- within(par, if(is.na(r)) { r <- 0; gamma <- 1 })
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(gamma, ctxt, "gamma"))
              with(par, check.finite(r, ctxt, "r"))
              with(par, check.1.real(gamma, ctxt))
              with(par, check.1.real(r,     ctxt))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, explain.ifnot(gamma >= 0, ctxt))
              with(par, explain.ifnot(r >= 0, ctxt))
              return(par)
            },
            validity=function(par, kind) {
              gamma <- par$gamma
              switch(kind,
                     integrable=(gamma <= 1),
                     stabilising=(gamma == 0)
                     )
            },
            explainvalid=list(
              integrable="gamma <= 1",
              stabilising="gamma == 0"),
            reach = function(par, ...) {
              r <- par[["r"]]
              g <- par[["gamma"]]
              return(if(g == 1) 0 else r)
            },
            hardcore = function(par, ...) {
              return(0)
            },
            temper = function(par, invtemp) {
              within(par, {
                beta  <- beta^invtemp
                gamma <- gamma^invtemp
              })
            }
            ),
#       
# 17. Penttinen.
#       
       'penttinen'=
       list(
            C.id="penttinen",
            multitype=FALSE,
            parhandler=function(par, ...) {
              ctxt <- "For the penttinen cif"
              par <- check.named.list(par,
                                      c("beta", "gamma", "r"),
                                      ctxt, xtitle="par")
              # treat r=NA as absence of interaction
              par <- within(par, if(is.na(r)) { r <- 0; gamma <- 1 })
              with(par, check.finite(beta, ctxt, "beta"))
              with(par, check.finite(gamma, ctxt, "gamma"))
              with(par, check.finite(r, ctxt, "r"))
              with(par, check.1.real(gamma, ctxt))
              with(par, check.1.real(r, ctxt))
              with(par, explain.ifnot(all(beta >= 0), ctxt))
              with(par, explain.ifnot(gamma >= 0, ctxt))
              with(par, explain.ifnot(r > 0, ctxt))
              return(par)
            },
            validity=function(par, kind) {
              gamma <- par$gamma
              switch(kind,
                     integrable=(gamma <= 1),
                     stabilising=(gamma == 0)
                     )
            },
            explainvalid=list(
              integrable="gamma <= 1",
              stabilising="gamma == 0"),
            reach = function(par, ...) {
              r <- par[["r"]]
              g <- par[["gamma"]]
              return(if(g == 1) 0 else (2 * r))
            },
            hardcore = function(par, ..., epsilon=0) {
              r <- par[["r"]]
              g <- par[["gamma"]]
              return(if(g <= epsilon) (2 * r) else 0)
            },
            temper = function(par, invtemp) {
              within(par, {
                beta <- beta^invtemp
                gamma <- gamma^invtemp
              })
            }
            )
       # end of list '.Spatstat.RmhTable'
       )

#'   rclusterBKBC.R
#'
#'   $Revision: 1.9 $ $Date: 2025/11/21 01:24:47 $
#' 
#'   Simulation of stationary cluster process
#'   using Brix-Kendall algorithm and Baddeley-Chang modification
#'
#'   Copyright (C) Adrian Baddeley and Ya-Mei Chang 2022-2023
#'   GNU Public Licence >= 2

rclusterBKBC <- function(clusters="Thomas",
               kappa, mu, scale, ..., 
               W=unit.square(), nsim=1, drop=TRUE,
               best=FALSE,
               external=c("BK", "superBK", "border"),
               internal=c("dominating", "naive"),
               inflate=1,
               psmall=1e-4,
               use.inverse=TRUE,
               use.special=TRUE,
               integralmethod=c("quadrature", "trapezoid"),
               verbose=TRUE, warn=TRUE) {
  external.given <- !missing(external)
  integralmethod <- match.arg(integralmethod)
  if(!missing(inflate)) {
    if(is.numeric(inflate)) {
      check.1.real(inflate)
      stopifnot(inflate >= 1)
      if(verbose && inflate > 1) splat("Inflating disc by factor", inflate)
    } else if(is.function(inflate)) {
      if(verbose) splat("Using a user-supplied inflation rule")
    } else if(identical(inflate, "optimal")) {
      if(verbose) splat("Using optimal inflation rule")
    } else stop("Argument 'inflate' should be a number or a function")
  }
  ## ............. Information about the model .............................
  cinfo <- spatstatClusterModelInfo(clusters) # error if unrecognised
  sinfo <- spatstatClusterSimInfo(clusters)      # NULL if unrecognised
  iscompact <- isTRUE(sinfo$iscompact)
  ## Validate parameters and convert to native parametrisation
  par.generic <- c(kappa=kappa, scale=scale)
  par <- cinfo$checkpar(par.generic, old=TRUE)
  if(length(cinfo$shapenames)) { ## there are parameters controlling shape of kernel
    shapestuff <- cinfo$resolveshape(...)$covmodel ## resolve the parameter values
    shapemodel <- shapestuff$model ## optional: name of covariance model e.g. 'exponential'
    shapeargs <- shapestuff$margs ## values of the shape parameters
  } else shapemodel <- shapeargs <- NULL
  ## Assemble model information in format required by cluster simulation functions in bkinfo.R
  mod <- list(par=par, mu=mu, shapemodel=shapemodel, shapeargs=shapeargs)
  
  ## ................ Geometry .............................
  ## shift window to convenient origin
  oldW <- W
  oldcentre <- as.numeric(centroid.owin(Frame(oldW)))
  W <- shift(oldW, -oldcentre)
  ## enclose it in a disc
  rD <- with(vertices(Frame(W)), sqrt(max(x^2+y^2)))
  if(verbose) splat("Disc radius rD =", rD)
  ## D <- disc(radius=rD)
  ## inflated disc
  if(identical(inflate, "optimal")) {
    rE <- optimalinflation(clusters, mod, rD)
  } else if(is.function(inflate)) {
    rE <- inflate(mod, rD)
    if(rE < rD) stop("Function 'inflate' yielded rE < rD")
  } else if(inflate == 1) {
    ## default
    rE <- rD
  } else {
    rE <- inflate * rD
    if(iscompact) {
      rmax <- cinfo$range(par=par.generic, margs=shapeargs)
      rEmax <- rD + rmax
      if(rE > rEmax) {
        if(verbose) splat("Kernel has compact support;",
                          "reducing inflated radius from", rE, "to", rEmax)
        rE <- rEmax
      }
    }
  }
  if(rE == rD) {
    if(verbose) splat("Disc will not be inflated")
    discEname <- "disc"
  } else {
    if(verbose) splat("Inflated radius rE =", rE)
    discEname <- "inflated disc"
  }
  
  ## ............. Decide on computation policy ..........................................
  use.special <- isTRUE(use.special) && !is.null(sinfo) # TRUE if using specialised code in 'sinfo'
  use.inverse <- isTRUE(use.inverse)
  sizecode <- 1L + (scale > rD/10) + (scale > rD/2)
  external <- if(best) switch(sizecode, "border", "BK", "superBK")           else match.arg(external) 
  internal <- if(best) switch(sizecode, "naive", "dominating", "dominating") else match.arg(internal)
  if(use.special && external == "superBK") {
    ## check whether this is supported
    if(!all(c("rhoplusplus", "Mplusplus", "MplusplusInf") %in% names(sinfo))) {
      external <- "BK"
      if(!best && external.given)
        message("Superdominating strategy (external='superBK') is not supported for this cluster process; reverting to 'BK'")
    }
  }
  ## create empty pattern in required format
  emptypattern <- ppp(window=oldW)
  attr(emptypattern, "parents") <- list(x=numeric(0), y=numeric(0))
  attr(emptypattern, "parentid") <- integer(0)
  ## Threshold for warnings about large number of points
  if(warn) 
    nhuge <- spatstat.options("huge.npoints")
  ## ...........................................
  ## Define components of simulation algorithm
  ## ...........................................
  ## intensity of parents conditioned on having any offspring anywhere
  kappadag <- kappa * (1 - exp(-mu))
  ## integral over D of dominating kernel, given distance to origin from parent
  if(use.special) {
    ## function to compute expected number of dominating offspring of a parent at given distance from origin
    Eplus <- sinfo$Eplus
    hdomfun <- sinfo$hdom
    ## random generator of offspring
    roffspring <- sinfo$roffspring
  } else {
    ## generic code
    kernel <- cinfo$kernel # function(par, r, ..., model, margs)
    hdomfun <- function(r, mod, rD) {
      z <- numeric(length(r))
      high <- (r > rD)
      z[!high] <- with(mod, kernel(par, 0, model=shapemodel, margs=shapeargs))
      z[high] <- with(mod,  kernel(par, (r[high]-rD), model=shapemodel, margs=shapeargs))
      return(z)
    }
    Eplus <- function(r, ...) { mu * pi * rD^2 * hdomfun(r, mod, rD) }
    ## random generator of offspring
    cinfo.roff <- cinfo$roffspring
    if(!is.function(cinfo.roff))
      stop("I don't know how to generate clusters of this kind")
    roffspring <- function(n, mod) {
      with(mod, cinfo.roff(n, par, model=shapemodel, margs=shapeargs))
    }
  }
  ## For Brix-Kendall and super-dominating algorithms,
  ## kernel must be bounded at r=0
  LowerLimit <- 0
  if(is.infinite(hdomfun(0, mod, rD))) {
    offence <- remedy <- NULL
    if(internal != "naive") {
      offence <- "Cannot use Brix-Kendall type algorithm"
      remedy  <- "Switching to hybrid algorithm"
      internal <- "naive"
    }
    if(inflate == 1) {
      offence <- c(offence, "Cannot use inflate = 1")
      remedy <- c(remedy, "Setting inflate = 2")
      inflate <- 2
      rE <- inflate * rD
    }
    if(length(offence)) 
      message(paste("The kernel is infinite at distance zero.",
                    paste0(paste(offence, collapse="; "), "."),
                    paste0(paste(remedy, collapse="; "), ".")))
    if(!use.special) 
      LowerLimit <- rE
  }
  ## intensity of Brix-Kendall dominating parent process, given distance to origin
  switch(external,
         border = {
           ## determine border width 
           if(iscompact) {
             ## compact support: determine radius of disc containing support
             rbord <- cinfo$range(par=par.generic, model=shapemodel, margs=shapeargs)
           } else {
             ## non-compact support: determine radius of disc which has probability (1 - psmall)
             rbord <- cinfo$range(par=par.generic, model=shapemodel, margs=shapeargs, thresh=psmall)
           }
           Rmax <- rD + rbord
           if(Rmax > rE) {
             Eborder <- kappadag * pi * (Rmax^2 - rE^2)
             if(verbose) splat("External parents: border method",
                               "\n\tBorder width:", signif(Rmax - rE, 3),
                               "\n\tMaximum distance of parent from origin:", signif(Rmax, 3),
                               "\n\tExpected number of parents in border:", round(Eborder, 3))
           } else {
             Eborder <- 0
             if(verbose)
               splat("External parents: border method\n\tNot required; covered by inflated disc")
           }
         },
         BK = {
           ## .......................
           ## original B-K algorithm 
           ## .......................
           if(verbose) splat("External parents: Brix-Kendall dominating process")
           ## Radial cumulative integral of dominating parent intensity
           if(use.special) {
             rhoplus <- sinfo$rhoplus
             sinfoMplus <- sinfo$Mplus
             Mplus <- function(r) {
               sinfoMplus(r, mod, rD, method=integralmethod)
             }
             ## Integral of dominating parent intensity = Mplus(Inf)
             MplusInf <- sinfo$MplusInf(mod, rD)
           } else {
             ## generic code
             rhoplus <- function(r, ...) {
               kappa <- mod$par[["kappa"]]
               z <- numeric(length(r))
               above <- (r > rD)
               z[!above] <- Eplus(0)
               z[above]  <- Eplus(r[above])
               return(kappa * (1 - exp(-z)))
             }
             MplusIntegrand <- function(r) {
               2 * pi * r * rhoplus(r)
             }
             ## Mplus(r) is the integral from LowerLimit to r
             Mplus <- function(r) {
               rstart <- LowerLimit
               if(rstart == 0) {
                 z <- pi * pmin(r, rD)^2 * rhoplus(0)
                 high <- (r > rD)
                 if(any(high)) 
                   z[high] <- z[high] + indefinteg(MplusIntegrand,
                                                   r[high],
                                                   lower=rD,
                                                   method=integralmethod)
               } else {
                 z <- numeric(length(r))
                 high <- (r > rstart)
                 if(any(high))
                   z[high] <- indefinteg(MplusIntegrand,
                                         r[high],
                                         lower=rstart,
                                         method=integralmethod)
               }
               return(z)
             }
             MplusInf <- Mplus(Inf)
           }
           if(verbose) splat("\tTotal integral of intensity of dominating parents:", round(MplusInf, 2))
           ## We will generate values uniformly distributed between Mmin and MplusInf
           Mmin <- switch(internal,
                          dominating=0,
                          naive=Mplus(rE))
           if(verbose && internal == "naive") {
             splat("\tIntegral inside", paste0(discEname, ":"), round(Mmin, 2))
             splat("\tDifference:", MplusInf - Mmin)
           }
           ## use a slightly lower maximum, to ensure finite radii
           Margin <- MplusInf - Mmin
           eps <- sqrt(.Machine$double.eps)
           if(Margin >= 0) {
             delta <- 1e-4 * Margin
             delta <- max(min(delta, 0.1), eps)
             Mmax <- MplusInf - delta
           } else {
             if(Margin < -eps)
               warning(paste0("Internal numerical problem: MplusInf < Mmin ",
                              paren(paste("difference", Margin)), 
                              "; reset MplusInf = Mmin"))
             Mmax <- MplusInf <- Mmin 
           }
           if(Mmin >= Mmax) {
             Mmax <- MplusInf <- Mmin
             if(verbose) splat("\tNo dominating parents required (Mmax <= Mmin)")
           } else {
             if(verbose) splat("\tExpected number of dominating parents to be generated:", round(Mmax-Mmin, 2))
             ## Inverse function of Mplus available?
             inverseMplus <- sinfo$invMplus
             use.inverse <- use.special && isTRUE(use.inverse) && is.function(inverseMplus)
             if(!use.inverse) {
               ## Numerical root-finding is required
               ## Mplus(r) is proportional to r^2 on [0, rD]
               MplusrD <- Mplus(rD)
               ## Find upper bound on distance to origin corresponding to 'Mmax'
               Rmax <- rD + scale
               doublings <- 0L
               while(Mplus(Rmax) < Mmax) {
                 Rmax <- 2 * Rmax
                 doublings <- doublings + 1L
                 if(doublings > 1e5) stop("Internal error: no solution for Mplus(Rmax) >= Mmax")
               }
               if(verbose) splat("\tUpper bound on distance from parent to centre of window:", signif(Rmax, 4))
               Contrast <- function(x, m) { Mplus(x) - m  }
               SolveRadius <- function(m, rD, rmax, MrD) {
                 if(m <= MrD) return(rD * sqrt(m/MrD))
                 if(m >= Mmax) return(Rmax)
                 uniroot(Contrast, c(rD, 1.1*rmax), m=m)[["root"]]
               }
             }
           }
         },
         superBK = {
           ## ..............................................................................................
           ## Use a process that dominates the dominating process
           ## ..............................................................................................
           if(verbose) splat("External parents: super-dominating process")
           if(use.special) {
             rhoplus <- sinfo$rhoplus
             ## superdominating parent intensity, given distance to origin
             rhoplusplus <- sinfo$rhoplusplus
             ## radial cumulative integral of intensity for superdominating process
             ## i.e. Mplusplus(r) = int_0^r { s * rhoplusplus(s) } ds
             sinfoMplusplus <- sinfo$Mplusplus
             Mplusplus <- function(r) {
               sinfoMplusplus(r, mod, rD, method=integralmethod)
             }
             ## integral of superparent intensity = Mplusplus(Inf)
             MplusplusInf <- sinfo$MplusplusInf(mod, rD)
           } else {
             ## generic code
             rhoplus <- function(r, ...) {
               kappa <- mod$par[["kappa"]]
               z <- numeric(length(r))
               above <- (r > rD)
               z[!above] <- Eplus(0)
               z[above]  <- Eplus(r[above])
               return(kappa * (1 - exp(-z)))
             }
             rhoplusplus <- function(r, ...) {
               kappa <- mod$par[["kappa"]]
               z <- numeric(length(r))
               above <- (r > rD)
               z[!above] <- Eplus(0)
               z[above]  <- Eplus(r[above])
               return(kappa * z)
             }
             MplusplusIntegrand <- function(r) {
               2 * pi * r * rhoplusplus(r)
             }
             Mplusplus <- function(r) {
               rstart <- LowerLimit
               if(rstart == 0) {
                 z <- pi * pmin(r, rD)^2 * rhoplusplus(0)
                 high <- (r > rD)
                 if(any(high)) 
                   z[high] <- z[high] + indefinteg(MplusplusIntegrand,
                                                   r[high],
                                                   lower=rD,
                                                   method=integralmethod)
               } else {
                 z <- numeric(length(r))
                 high <- (r > rstart)
                 if(any(high)) 
                   z[high] <- indefinteg(MplusplusIntegrand,
                                         r[high],
                                         lower=rstart,
                                         method=integralmethod)
               }
               return(z)
             }
             MplusplusInf <- Mplusplus(Inf)
           }
           if(verbose) splat("\tTotal integral of intensity of superparents:", round(MplusplusInf, 2))
           ## generate values uniformly distributed between Mmin and MplusplusInf
           Mmin <- switch(internal,
                          dominating=0,
                          naive=Mplusplus(rE))
           if(verbose && internal == "naive") {
             splat("\tIntegral inside", paste0(discEname, ":"), round(Mmin, 2))
             splat("\tDifference:", MplusplusInf - Mmin)
           }
           ## use a slightly lower maximum, to ensure finite radii
           Margin <- MplusplusInf - Mmin
           eps <- sqrt(.Machine$double.eps)
           if(Margin >= 0) {
             delta <- 1e-4 * Margin
             delta <- max(min(delta, 0.1), eps)
             Mmax <- MplusplusInf - delta
           } else {
             if(Margin < -eps)
               warning(paste0("Internal numerical problem: ",
                              "MplusplusInf < Mmin ",
                              paren(paste("difference", Margin)),
                              "; reset MplusplusInf = Mmin"))
             Mmax <- MplusplusInf <- Mmin 
           }
           if(Mmin >= Mmax) {
             Mmax <- MplusplusInf <- Mmin 
             if(verbose) splat("\tNo superparents required (Mmax = Mmin)")
           } else {
             if(verbose) splat("\tExpected number of superparents to be generated:", round(Mmax-Mmin, 2))
             ## Inverse function of Mplusplus available?
             inverseMplusplus <- sinfo$invMplusplus
             use.inverse <- use.special && isTRUE(use.inverse) && is.function(inverseMplusplus)
             if(!use.inverse) {
               ## Numerical root-finding required
               ## Mplusplus(r) is proportional to r^2 on [0, rD]
               MplusplusrD <- Mplusplus(rD)
               ## Find upper bound on solution corresponding to 'Mmax'
               Rmax <- rD + scale
               doublings <- 0L
               while(Mplusplus(Rmax) < Mmax) {
                 Rmax <- 2 * Rmax
                 doublings <- doublings + 1L
                 if(doublings > 1e5) stop("Internal error: no solution for Mplusplus(Rmax) >= Mmax")
               }
               if(verbose)
                 splat("Upper bound on distance from superparent to centre of window:", signif(Rmax, 6))
               Contrast <- function(x, m) { Mplusplus(x) - m }
               SolveRadius <- function(m, rD, rmax, MrD) {
                 if(m <= MrD) return(rD * sqrt(m/MrD))
                 if(m >= Mmax) return(Rmax)
                 uniroot(Contrast, c(rD, 1.1*rmax), m=m)[["root"]]
               }
             }
           }
         })
  
  ## >>>>>>>>>>>>>>>  s t a r t    s i m u l a t i o n    l o o p   <<<<<<<<<<<<<<<<<<<<<<<
  resultlist <- vector(mode="list", length=nsim)
  for(isim in seq_len(nsim)) {
    if(verbose && nsim > 1) splat("Generating realisation", isim)
    cost <- 0
    ## .......................
    ##   PARENTS OUTSIDE DISC
    ## .......................
    switch(external,
           border = {
             ## .................................................................
             ##  naive: generate parents uniformly in border region
             ## .................................................................
             externalparentname <- "dominating parents in border region"
             if(Eborder == 0) {
               ndom <- 0
             } else {
               ndom <- rpois(1, Eborder)
               cost <- cost + ndom
               if(verbose) splat("Generated", externalparentname, "\n\tNumber:", ndom)
               if(warn && ndom > nhuge) {
                 whinge <- paste("Generating", ndom, externalparentname)
                 message(whinge)
                 warning(whinge, call.=FALSE)
               }
             } 
             if(ndom > 0)
               rdom <- sqrt(runif(ndom, min=rE^2, max=Rmax^2))
           },
           BK = {
             ## .................................................................
             ## original Brix-Kendall (possibly restricted to parents outside E)
             ## .................................................................      
             ## generate Poisson number of parents in dominating process
             ##                  (possibly restricted to locations outside E)
             externalparentname <- if(internal != "naive") "dominating parents" else
                                   paste("dominating parents outside", discEname)
             if(MplusInf > Mmin) {
               ndom <- rpois(1, MplusInf - Mmin)
               cost <- cost + ndom
               if(verbose) splat("Generated", externalparentname, "\n\tNumber:", ndom)
               if(warn && ndom > nhuge) {
                 whinge <- paste("Generating", ndom, externalparentname)
                 message(whinge)
                 warning(whinge, call.=FALSE)
               }
             } else {
               ndom <- 0
             }
             ## generate parent locations
             if(ndom > 0) {
               mdom <- runif(ndom, min=Mmin, max=Mmax)
               if(use.inverse) {
                 ## inverse function is analytic
                 rdom <- inverseMplus(mdom, mod, rD, MplusInf)
               } else {
                 ## use root-finding
                 mdom <- sort(mdom, decreasing=TRUE)
                 rdom <- numeric(ndom)
                 rmax <- Rmax
                 ## Mplus(r) is proportional to r^2 on [0, rD]
                 below <- (mdom <= MplusrD)
                 rdom[below] <- rD * sqrt(mdom[below]/MplusrD)
                 for(i in which(!below)) {
                   ## solve for radius, and use this as the upper bound for the next problem
                   rmax <- rdom[i] <- SolveRadius(mdom[i], rD, rmax, MplusrD)
                 }
               }
               if(verbose) splat("\tRange of distances from origin:", prange(signif(range(rdom), 3)))
             }
           },
           superBK = {
             ## .................................................................
             ##    Brix-Kendall with super-dominating process
             ##                     (possibly restricted to parents outside E)
             ## .................................................................
             externalparentname <- if(internal != "naive") "super-parents" else
                                   paste("super-parents outside", discEname)
             ## generate Poisson number of superparents
             if(MplusplusInf > Mmin) {
               nsuper <- rpois(1, MplusplusInf - Mmin)
               cost <- cost + nsuper
               if(verbose) splat("Generated", externalparentname, "\n\tNumber:", nsuper)
               if(warn && nsuper > nhuge) {
                 whinge <- paste("Generating", nsuper, externalparentname)
                 message(whinge)
                 warning(whinge, call.=FALSE)
               }
             } else {
               nsuper <- 0
             }
             ## generate superparent locations
             if(nsuper == 0) {
               ndom <- 0
             } else {
               ## generate radii by inverting Mplusplus
               msuper <- runif(nsuper, min=Mmin, max=Mmax)
               rsuper <- numeric(nsuper)
               if(use.inverse) {
                 ## inverse function is analytic
                 rsuper <- inverseMplusplus(msuper, mod, rD, MplusplusInf)
               } else {
                 ## use numerical root-finding
                 msuper <- sort(msuper, decreasing=TRUE)
                 rmax <- Rmax
                 ## Mplusplus(r) is proportional to r^2 on [0, rD]
                 below <- (msuper < MplusplusrD)
                 rsuper[below] <- rD * sqrt(msuper[below]/MplusplusrD)
                 for(i in which(!below))
                   rmax <- rsuper[i] <- SolveRadius(msuper[i], rD, rmax, MplusplusrD)
               }
               if(verbose) splat("\tRange of distances from origin:", prange(signif(range(rsuper), 3)))
               ## thin the superdominating parents to dominating parents
               rdom <- rsuper[rhoplus(rsuper, mod, rD) > runif(nsuper) * rhoplusplus(rsuper, mod, rD)]
               ndom <- length(rdom)
               if(verbose) {
                 splat("Thinned superparents to obtain dominating parents\n",
                       "\tNumber of dominating parents:", ndom,
                       "\n\t", "Acceptance rate:", signif(as.numeric(ndom)/nsuper, 4))
                 if(ndom > 0)
                   splat("\tRange of distances from origin:", prange(signif(range(rdom), 3)))
               }
             }
           })

    ## Now generate offspring 
    if(ndom == 0) {
      noff <- 0L
    } else {
      ## generate locations of [dominating/proposed] parents
      theta <- runif(ndom, max=2*pi)
      xp <- rdom * cos(theta)
      yp <- rdom * sin(theta)
      if(verbose) {
        splat("Generated spatial locations of", ndom, externalparentname)
        splat("\n\nGenerating offspring of", externalparentname)
      }
      ## generate offspring 
      switch(external,
             border = {
               ##  for each proposed parent, generate nonzero number of offspring,
               ##                            according to cluster mechanism
               offspringname <- paste("offspring of", externalparentname)
               noffeach <- rpoisnonzero(ndom, mu)
               noff <- sum(noffeach)
               cost <- cost + noff
               if(verbose) splat("Generated", offspringname,
                                 "\n\tNumber of offspring:", noff)
               if(warn && noff > nhuge) {
                 whinge <- paste("Generating", noff, offspringname)
                 message(whinge)
                 warning(whinge, call.=FALSE)
               }
               ## assign offspring to parents
               parentid <- rep.int(1:ndom, noffeach)
               ## offspring are random displacements of parents
               displace <- roffspring(noff, mod)
               xoff <- xp[parentid] + displace$x
               yoff <- yp[parentid] + displace$y
               ## clip to window
               retain <- inside.owin(xoff, yoff, W)
               noff <- sum(retain)
               if(verbose) splat("Clipped to window\n\tNumber of offspring in window:", noff)
             },
             BK = ,
             superBK = {
               ## generate nonzero number of offspring in disc, for each dominating parent
               Edom <- Eplus(rdom, mod, rD)
               noffeach <- rpoisnonzero(ndom, Edom)
               noff <- sum(noffeach)
               cost <- cost + noff
               offspringname <- paste("offspring (inside disc) of",
                                      externalparentname)
               if(verbose) splat("Generated", offspringname,
                                 "\n\tNumber of offspring:", noff)
               if(warn && noff > nhuge) {
                 whinge <- paste("Generating", noff, offspringname)
                 message(whinge)
                 warning(whinge, call.=FALSE)
               }
               ## offspring are uniform in disc
               roff <- sqrt(runif(noff, max=rD^2))
               toff <- runif(noff, max=2*pi)
               xoff <- roff * cos(toff)
               yoff <- roff * sin(toff)
               ## assign offspring to parents
               parentid <- rep.int(1:ndom, noffeach)
               ## thin using correct kernel
               dx <- xoff - xp[parentid]
               dy <- yoff - yp[parentid]
               dr <- sqrt(dx^2 + dy^2)
               hcorrect <- cinfo$kernel(par=par, rvals=dr, model=shapemodel, margs=shapeargs)
               hdom     <- hdomfun(rdom, mod, rD)[parentid]
               if(any(bad <- (hcorrect > hdom)))
                 stop(paste("Internal error:", sum(bad),
                   "values of the dominating kernel do not dominate the true kernel"),
                   call.=FALSE)
                 retain <- (hcorrect >= runif(noff) * hdom)
                 if(verbose) splat("Thinned offspring to correct process\n",
                                   "\tNumber of retained offspring in disc:", sum(retain),
                                   "\n\tAcceptance rate:", signif(mean(retain), 4))
                 if(any(retain)) {
                   ## finally clip to window
                   retain[retain] <- inside.owin(xoff[retain], yoff[retain], W)
                 }
                 noff <- sum(retain)
                 if(verbose) splat("Clipped to window\n\tNumber of offspring in window:", noff)
             })
    }
    ## ...................................
    ##    Apply the thinning
    ## ...................................
    if(noff > 0) {
      xoff <- xoff[retain]
      yoff <- yoff[retain]
      parentid <- parentid[retain]
      retainedparents <- sort(unique(parentid))
      parentid <- match(parentid, retainedparents)
      xp <- xp[retainedparents]
      yp <- yp[retainedparents]
      np <- length(retainedparents)
    } else {
      xoff <- yoff <- xp <- yp <- numeric(0)
      parentid <- integer(0)
      np <- 0L
    }
    if(verbose)
      splat("Total number of offspring points",
            if(internal == "naive") "(of parents outside disc):" else ":",
            noff)

    ## ................................
    ##   PARENTS INSIDE (inflated) DISC
    ## ................................

    switch(internal,
           dominating = {
             ## Parents were already generated above
             if(verbose) splat("Internal parents:",
                               switch(external,
                                      BK="Brix-Kendall dominating process",
                                      superBK = "super-dominating process",
                                      border = "border method"),
                               "(already generated)")
           },
           naive = {
             ## Generate parents inside (inflated) disc 
             ##  conditional on having at least 1 offspring **anywhere**
             internalparentname <- paste("additional parents inside", discEname)
             if(verbose) {
               splat("Internal parents: naive method",
                     "\n\tGenerating", internalparentname, 
                     "with intensity", signif(kappadag, 4))
             }
             npin <- rpois(1, kappadag * pi * rE^2)
             rpin <- sqrt(runif(npin, max=rE^2))
             tpin <- runif(npin, max=2*pi)
             xpin <- rpin * cos(tpin)
             ypin <- rpin * sin(tpin)
             cost <- cost + npin
             if(verbose) splat("\tNumber of",
                               paste0(internalparentname, ":"), npin)
             if(warn && npin > nhuge) {
               whinge <- paste("Generating", npin, internalparentname)
               message(whinge)
               warning(whinge, call.=FALSE)
             }
             if(npin > 0) {
               offspringname <- paste("offspring of", internalparentname)
               if(verbose) splat("\nGenerating", offspringname)
               noff.in.each <- rpoisnonzero(npin, mu)
               noff.in <- sum(noff.in.each)
               cost <- cost + noff.in
               if(verbose) splat("\tNumber of",
                                 paste0(offspringname, ":"), noff.in)
               if(warn && noff.in > nhuge) {
                 whinge <- paste("Generating", noff.in, offspringname)
                 message(whinge)
                 warning(whinge, call.=FALSE)
               }
               pid.in <- rep.int(1:npin, noff.in.each)
               displace <- roffspring(noff.in, mod)
               xoff.in <- xpin[pid.in] + displace[["x"]]
               yoff.in <- ypin[pid.in] + displace[["y"]]
               ## restrict to window
               retain.in <- inside.owin(xoff.in, yoff.in, W)
               if(verbose) splat("Clipping", offspringname, "to window",
                                 "\n\tNumber retained:", sum(retain.in),
                                 paren(paste("acceptance rate", signif(mean(retain.in), 4))))
               if(any(retain.in)) {
                 ## retain these offspring
                 xoff.in <- xoff.in[retain.in]
                 yoff.in <- yoff.in[retain.in]
                 pid.in  <- pid.in[retain.in]
                 retainedpid.in <- sort(unique(pid.in))
                 pid.in <- match(pid.in, retainedpid.in)
                 xpin <- xpin[retainedpid.in]
                 ypin <- ypin[retainedpid.in]
                 npin <- length(retainedpid.in)
                 ## append to existing
                 xoff <- c(xoff, xoff.in)
                 yoff <- c(yoff, yoff.in)
                 parentid <- c(parentid, np + pid.in)
                 noff <- noff + sum(retain.in)
                 xp <- c(xp, xpin)
                 yp <- c(yp, ypin)
                 np   <- np   + npin
               }
             }
           })

    ## Pack up simulation result [[isim]]
    if(verbose) splat("Final total number of offspring points:", noff)
    if(noff == 0) {
      Y <- emptypattern
    } else {
      Y <- ppp(xoff + oldcentre[1],
               yoff + oldcentre[2],
               window=oldW)
      attr(Y, "parents") <- list(x = xp + oldcentre[1],
                                 y = yp + oldcentre[2])
      attr(Y, "parentid") <- parentid
    }
    attr(Y, "cost") <- cost
    resultlist[[isim]] <- Y
  }
  ## >>>>>>>>>>>>>>>   e n d       l o o p   <<<<<<<<<<<<<<<<<<<<<<<
  result <- simulationresult(resultlist, nsim, drop)
  return(result)
}
  
optimalinflation <- function(clusters, mod, rD) {
  ## Optimal inflated disc radius rE, determined by root-finding
  ## as in section 6.6 of Baddeley and Chang (2023)
  cinfo <- spatstatClusterModelInfo(clusters) # error if unrecognised
  par.native <- cinfo$checkpar(mod$par, native=TRUE)
  mu    <- mod$mu
  margs <- mod$shapeargs
  a <- if(mu == 0) 1 else (1 + (1-exp(-mu))/mu)
  b <- a/(pi * rD^2)
  ## solve the equation h(r) = b where h is the 2D kernel
  if(is.function(kerinv <- cinfo$kerinverse)) {
    ## use specialised code to solve h(r) = b
    delta <- kerinv(par.native, level=b, margs=margs)
    rE <- rD + delta
  } else if(is.function(kernel <- cinfo$kernel)) {
    ## apply root-finding to solve h(r) = b
    h0 <- kernel(par.native, 0, margs=margs)
    if(h0 <= b) {
      rE <- rD
    } else {
      f <- function(x) { b - kernel(par.native, x, margs=margs) }
      u <- try(uniroot(f, c(0, 100 * scale)), silent=TRUE)
      if(inherits(u, "try-error")) {
        rE <- 2 * rD
      } else {
        rE <- rD + u$root
      }
    }
  } else {
    rE <- 2 * rD
  }
  return(rE)
}

#'        clusterinfo.R
#' 
#'   Lookup table of information about cluster processes and Cox processes
#'
#'   $Revision: 1.76 $ $Date: 2025/11/21 02:05:24 $
#'
#'   Information is extracted by calling
#'             spatstatClusterModelInfo(<name>)
#'   where <name> is the name of the cluster type (e.g. 'Thomas', 'MatClust', 'Cauchy').
#'         
#'   Information is stored in the named list .Spatstat.ClusterModelInfoTable
#'   with names 'Thomas', 'MatClust' etc.
#' 
#'   Each list entry contains information about a particular cluster mechanism.
#'   It is a list with the following entries:
#'
#'   ................... Names .............................................
#'
#'       modelname       (String) The name of the process as it would be stated in an article
#'                       e.g. "Neyman-Scott process with Cauchy kernel"
#' 
#'       descname        (String) abbreviated name of the process for use in fv objects
#'                       e.g. "Cauchy process"
#' 
#'       modelabbrev     (String) short name of the process for use in kppm object
#'                       e.g. "Cauchy process"
#' 
#'       printmodelname  function(obj)
#'                       Invoked by print.kppm to construct the name of the process
#'                       (where the name includes shape parameters of the kernel)
#'                       e.g. produces value "Variance-Gamma process with nu=0.3"
#'
#'       parnames        (Character vector of length 2)
#'                       The names of the "NATIVE" cluster parameters
#'                       e.g. Thomas -> c('kappa', 'sigma2')
#'                            MatClust -> c('kappa', 'R')
#'
#'                       **NOTE** that there are two parametrisations:
#'                             - the 'GENERIC' parameters (e.g. 'kappa' and 'scale' for cluster models)
#'                             - the 'NATIVE' parameters depend on the model.
#' 
#'                       The native parameters are designed to be a more efficient representation
#'                       for internal use when fitting models. Starting values for the parameters
#'                       are expected to be given in the native parametrisation.
#'
#'       shapenames      (Character vector)
#'                       The names of any shape parameters of the kernel
#'                       that could/should be provided by the user
#'                       e.g.   'nu'
#'                       Or "*" if shape parameters are present but their names are not fixed
#'
#' 
#'   ................... Argument processing  ..............................
#'       
#'       checkpar        function(par, native=TRUE, ...)
#'                       Validates the parameters 'par' (in either format)
#'                       and converts them to the native parameters (if native=TRUE)
#'                       or converts them to the generic parameters (if native=FALSE).
#'                       Transitional syntax: function(par, native=old, ..., old=TRUE)
#'                                            ('old' is a synonym for 'native')
#'
#'       native2generic  function(par)
#'                       Streamlined function to convert 'par' from native to generic format.
#'
#'       outputshape     function(margs, ..)
#'                       Convert 'margs' to the format required for printed output.
#' 
#'       resolveshape    function(...) 
#'                       Extracts any shape parameters that may be present in '...'
#'                       under different aliases or formats (e.g. 'nu.pcf' versus 'nu.ker').
#'                       Returns list(margs, covmodel) where covmodel=list(type, model, margs)
#'                       where 'margs' is in the format required for internal use.
#' 
#'       tocanonical     function(par, ..., model, margs)
#'                       [DEFINED ONLY FOR POISSON CLUSTER PROCESSES]
#'                       Convert 'par' from native format to experimental 'canonical' format
#'
#'       tohuman         function(can, ..., model, margs)
#'                       [DEFINED ONLY FOR POISSON CLUSTER PROCESSES]
#'                       Convert from experimental 'canonical' format to 'native' par format
#'
#'   ................... Properties of the cluster mechanism . ..............
#'   ................... [defined only for cluster processes] ...............
#'
#'       ddist           function(r, scale, ...)
#'                       One-dimensional probability density of distance from parent to offspring
#'                       ('scale' is in generic format)
#'
#'       range           function(..., par, thresh)
#'                       Computes cluster radius
#'                       'par' is in generic format
#'                       (thresh = probability that parent-to-offspring distance exceeds this radius)
#'
#'       kernel          function(par, rvals, ..., margs)
#'                       compute kernel (two-dimensional probability density of offspring)
#'                       as a function of distance from parent to offspring.
#'                       'par' is in native format
#'                       'margs' is a list of shape arguments, if required
#'
#'       kerinverse       function(par, level, ..., margs)
#'                       [OPTIONAL]
#'                       compute the minimum distance at which kernel <= level
#'                       'par' is in native format
#'
#'       isPCP           logical.
#'                       TRUE iff the model is a Poisson cluster process
#'
#'       iscompact       logical.
#'                       TRUE if the kernel has compact support.
#'
#'       roffspring      function(n, par, ..., model, margs)
#'                       Random generator of cluster.
#'                       Generates n offspring of a parent at the origin.
#'
#'   ................... Properties of the point process ..............
#' 
#'       K               function(par, rvals, ..., model, margs)
#'                       Compute K-function
#'                       'par' is in native format
#'                       Arguments 'model', 'margs' are required if there are shape parameters
#'
#'       B1              function(par, rvals, ..., model, margs)
#'                       [DEFINED ONLY FOR POISSON CLUSTER PROCESSES]
#'                       Standardised term in K function: equals K function when kappa = 1, scale=1.
#'                        
#'       pcf             function(par, rvals, ..., model, margs)
#'                       Compute pair correlation function
#'                       'par' is in native format
#'                       Arguments 'model', 'margs' are required if there are shape parameters
#'                       
#'       A1              function(par, rvals, ..., model, margs)
#'                       [DEFINED ONLY FOR POISSON CLUSTER PROCESSES]
#'                       Standardised term in pcf: equals pcf when kappa = 1, scale=1.
#'                        
#'       a1              function(par, rvals, ..., model, margs)
#'                       [DEFINED ONLY FOR POISSON CLUSTER PROCESSES]
#'                       Standardised term in pcf: a1(r) = A1(r)/A1(0).
#' 
#'       a1prime         function(par, rvals, ..., model, margs)
#'                       [DEFINED ONLY FOR POISSON CLUSTER PROCESSES]
#'                       Derivative of a1(r) with respect to r
#' 
#'       a1primeprime    function(par, rvals, ..., model, margs)
#'                       [DEFINED ONLY FOR POISSON CLUSTER PROCESSES]
#'                       Second derivative of a1(r) with respect to r
#'                        
#'       Dpcf            function(par, rvals, ..., model, margs)
#'                       Compute vector of partial derivatives of pair correlation function
#'                       with respect to 'par' 
#'                       'par' is in native format
#'                       Arguments 'model', 'margs' are required if there are shape parameters
#'
#' ...................... Utilities .........................................................
#'
#'       selfstart       function(X)
#'                       Calculates reasonable default estimates of 'par' from point pattern X
#'                       Returns 'par' in native format
#'
#'       interpret       function(par, lambda)
#'                       Return a full set of model parameters in a meaningful format for printing
#'
#'

#' ..................................................................................................
#'      This file defines each entry in the table separately, then creates the table
#' ..................................................................................................
#'  


## ................. general helper functions (exported) ....................

## The following function simplifies code maintenance
## (due to changes in subscripting behaviour in recent versions of R)

retrieve.param <- function(desired, aliases, ..., par=NULL) {
  ## Retrieve the generic parameter named <desired> (or one of its <aliases>)
  ## from (...) or from 'par'
  dots <- list(...)
  par  <- as.list(par) # may be empty
  dnames <- names(dots)
  pnames <- names(par)
  for(key in c(desired, aliases)) {
    if(key %in% dnames) return(dots[[key]])
    if(key %in% pnames) return(par[[key]])
  }
  ## failed
  nali <- length(aliases)
  if(nali == 0) {
    explain <- NULL
  } else {
    explain <- paren(paste("also tried", ngettext(nali, "alias", "aliases"), commasep(sQuote(aliases))))
  }
  mess <- paste("Unable to retrieve argument", sQuote(desired), explain)
  stop(mess, call.=FALSE)
}

detect.par.format <- function(par, native, generic) {
  a <- check.named.vector(par, native, onError="null", xtitle="par")
  if(!is.null(a)) return("native")
  a <- check.named.vector(par, generic, onError="null", xtitle="par")
  if(!is.null(a)) return("generic")
  whinge <- paste("'par' should be a named vector with elements",
                  paren(paste(sQuote(native), collapse=" and "), "["),
                  "or",
                  paren(paste(sQuote(generic), collapse=" and "), "["))
  stop(whinge, call.=FALSE)
}


#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
#'  >>>>>>>>>>>>>>>>>>>>>> Thomas process <<<<<<<<<<<<<<<<<<<<<<<<<<<<
#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

.ThomasInfo <- list(
  modelname      = "Thomas process", # In modelname field of mincon fv obj.
  descname       = "Thomas process", # In desc field of mincon fv obj.
  modelabbrev    = "Thomas process", # In fitted kppm obj.
  printmodelname = function(...) "Thomas process", # Used by print.kppm
  parnames       = c("kappa", "sigma2"),
  shapenames     = NULL,
  ## ............... Argument processing ................................
  checkpar = function(par, native = old, ..., old=TRUE, strict=TRUE){
    ## 'par' is in either format
    if(is.null(par))
      par <- c(kappa=1,scale=1)
    if(strict && any(par<=0))
      stop("par values must be positive.", call.=FALSE)
    fmt <- detect.par.format(par, native=c("kappa", "sigma2"), generic=c("kappa", "scale"))
    if(fmt == "generic" && native) {
      ## convert generic to native
      par[2L] <- par[2L]^2
      names(par)[2L] <- "sigma2"
    } else if(fmt == "native" && !native) {
      ## convert native to generic
      par[2L] <- sqrt(par[2L])
      names(par)[2L] <- "scale"
    }
    return(par)
  },
  native2generic = function(par) {
    par[2L] <- sqrt(par[2L])
    names(par) <- c("kappa", "scale")
    return(par)
  },
  outputshape = function(margs, ...) list(),
  resolveshape = function(...){ return(list(...)) },
  ## Convert to/from canonical cluster parameters
  tocanonical = function(par, ...) {
    ## 'par' is in native format
    ## convert to experimental 'canonical' format
    kappa <- par[[1L]]
    sigma2 <- par[[2L]]
    c(strength=1/(4 * pi * kappa * sigma2), scale=sqrt(sigma2))
  },
  tohuman = function(can, ...) {
    ## 'can' is in 'canonical' format
    ## convert to native format
    strength <- can[[1L]]
    scale <- can[[2L]]
    sigma2 <- scale^2
    c(kappa=1/(4 * pi * strength * sigma2), sigma2=sigma2)
  },
  ## .......... Properties of the cluster mechanism ............
  ## Density function for the distance to offspring
  ddist = function(r, scale, ...) {
    ## 'scale' is generic format
    2 * pi * r * dnorm(r, 0, scale)/sqrt(2*pi*scale^2)
  },
  ## Practical range of clusters
  range = function(..., par=NULL, thresh=NULL){
    ## 'par' is in generic format
    scale <- retrieve.param("scale", "sigma", ..., par=par)
    if(!is.null(thresh)){
      ## The squared length of isotropic Gaussian (sigma)
      ## is exponential with mean 2 sigma^2
      rmax <- scale * sqrt(2 * qexp(thresh, lower.tail=FALSE))
    } else {
      rmax <- 4*scale
    }
    return(rmax)
  },
  ## Cluster kernel (2D probability density, expressed as function of distance from origin)
  kernel = function(par, rvals, ...) {
    ## 'par' is in native format
    scale <- sqrt(par[2L])
    dnorm(rvals, 0, scale)/sqrt(2*pi*scale^2)
  },
  ## Distance at which 2D kernel falls below 'level'
  kerinverse = function(par, level, ...) {
    ## 'par' is in native format
    sigma2 <- par[2L]
    v <- - 2 * sigma2 * log(2 * pi * sigma2 * level)
    r <- if(v <= 0) 0 else sqrt(v)
    return(r)
  },
  isPCP=TRUE,
  iscompact=FALSE,
  roffspring=function(n, par, ...) {
    ## 'par' is in native format
    sigma <- sqrt(par[2L])
    list(x=rnorm(n, sd=sigma), y=rnorm(n, sd=sigma))
  },
  ## .............. Properties of the point process ...................
  ## K-function
  K = function(par,rvals, ..., strict=TRUE){
    ## 'par' is in native format
    if(strict && any(par <= 0))
      return(rep.int(Inf, length(rvals)))
    pi*rvals^2+(1-exp(-rvals^2/(4*par[2L])))/par[1L]
  },
  ## standardised term in K function
  B1 = function(r, ...) { 1 - exp(-(r^2)/4) },
  ## pair correlation function
  pcf= function(par,rvals, ..., strict=TRUE){
    ## 'par' is in native format
    if(strict && any(par <= 0))
      return(rep.int(Inf, length(rvals)))
    1 + exp(-rvals^2/(4 * par[2L]))/(4 * pi * par[1L] * par[2L])
  },
  ## standardised term in pcf
  A1 = function(r, ...) { exp(-r^2/4)/(4*pi) },
  a1 = function(r, ...) { exp(-r^2/4) },
  a1prime = function(r, ...) { -(r/2) * exp(-r^2/4) },
  a1primeprime = function(r, ...) { (r^2/4 - 1/2) * exp(-r^2/4) },
  ## gradient of pcf with respect to 'par' (contributed by Chiara Fend)
  Dpcf= function(par,rvals, ..., strict=TRUE){
    ## 'par' is in native format
    if(strict && any(par <= 0)){
      dsigma2 <- rep.int(Inf, length(rvals))
      dkappa <- rep.int(Inf, length(rvals))
    } else {
      dsigma2 <- exp(-rvals^2/(4 * par[2L])) * (rvals/(4^2 * pi * par[1L] * par[2L]^3) - 1/(4 * pi * par[1L] * par[2L]^2))
      dkappa <- -exp(-rvals^2/(4 * par[2L]))/(4 * pi * par[1L]^2 * par[2L])
    }
    out <- rbind(dkappa, dsigma2)
    rownames(out) <- c("kappa","sigma2")
    return(out)
  },
  ## sensible starting parameters
  selfstart = function(X) {
    ## return 'par' in native format
    kappa <- intensity(X)
    sigma2 <- 4 * mean(nndist(X))^2
    c(kappa=kappa, sigma2=sigma2)
  },
  ## meaningful model parameters
  interpret = function(par, lambda) {
    kappa <- par[["kappa"]]
    sigma <- sqrt(par[["sigma2"]])
    mu <- if(is.numeric(lambda) && length(lambda) == 1)
            lambda/kappa else NA
    c(kappa=kappa, sigma=sigma, mu=mu)
  }
)

#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
#'  >>>>>>>>>>>>>>>>> Matern cluster process <<<<<<<<<<<<<<<<<<<<<<<<<<
#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

#' auxiliary functions
.MatClustHfun <- function(zz) {
  ok <- (zz < 1)
  h <- numeric(length(zz))
  h[!ok] <- 1
  z <- zz[ok]
  h[ok] <- 2 + (1/pi) * (
    (8 * z^2 - 4) * acos(z)
    - 2 * asin(z)
    + 4 * z * sqrt((1 - z^2)^3)
    - 6 * z * sqrt(1 - z^2)
  )
  return(h)
}

.MatClustDOH <- function(zz) {
  ok <- (zz < 1)
  h <- numeric(length(zz))
  h[!ok] <- 0
  z <- zz[ok]
  h[ok] <- (16/pi) * (z * acos(z) - (z^2) * sqrt(1 - z^2))
  return(h)
}

## g(z) = DOH(z)/z has a limit at z=0.
.MatClustgfun <- function(zz) {
  ok <- (zz < 1)
  h <- numeric(length(zz))
  h[!ok] <- 0
  z <- zz[ok]
  h[ok] <- (2/pi) * (acos(z) - z * sqrt(1 - z^2))
  return(h)
}

.MatClustgprime <- function(zz) {
  ok <- (zz < 1)
  h <- numeric(length(zz))
  h[!ok] <- 0
  z <- zz[ok]
  h[ok] <- -(2/pi) * 2 * sqrt(1 - z^2)
  return(h)
}

#' main list of info

.MatClustInfo = list(
  modelname      = "Matern cluster process", # In modelname field of mincon fv obj.
  descname       = "Matern cluster process", # In desc field of mincon fv obj.
  modelabbrev    = "Matern cluster process", # In fitted obj.
  printmodelname = function(...) "Matern cluster process", # Used by print.kppm
  parnames       = c("kappa", "R"),
  shapenames     = NULL,
  ## ............ Argument processing ...........................
  checkpar = function(par, native = old, ..., old=TRUE, strict=TRUE){
    ## 'par' is in either format
    if(is.null(par))
      par <- c(kappa=1,scale=1)
    if(strict && any(par<=0))
      stop("par values must be positive.", call.=FALSE)
    detect.par.format(par, native=c("kappa", "R"), generic=c("kappa", "scale"))
    names(par)[2L] <- if(native) "R" else "scale"
    return(par)
  },
  native2generic = function(par) {
    names(par) <- c("kappa", "scale")
    return(par)
  },
  outputshape = function(margs,  ...) list(),
  resolveshape = function(...){ return(list(...)) },
  ## Convert to/from canonical cluster parameters
  tocanonical = function(par, ...) {
    ## 'par' is in native format
    ## convert to experimental 'canonical' format
    kappa <- par[[1L]]
    R <- par[[2L]]
    c(strength=1/(pi * kappa * R^2), scale=R)
  },
  tohuman = function(can, ...) {
    ## 'can' is in 'canonical' format
    ## convert to native format
    strength <- can[[1L]]
    scale <- can[[2L]]
    c(kappa=1/(pi * strength * scale^2), R=scale)
  },
  ## ............. Properties of cluster mechanism ........................
  ## Density function for the distance to offspring
  ddist = function(r, scale, ...) {
    ## 'scale' is generic format
    ifelse(r>scale, 0, 2 * r / scale^2)
  },
  ## Practical range of clusters
  range = function(..., par=NULL, thresh=NULL){
    ## 'par' is in generic format
    scale <- retrieve.param("scale", "R", ..., par=par)
    return(scale)
  },
  ## cluster kernel (2D probability density, expressed as function of distance from origin)
  kernel = function(par, rvals, ...) {
    ## 'par' is in native format
    scale <- par[2L]
    ifelse(rvals>scale, 0, 1/(pi*scale^2))
  },
  ## Distance at which 2D kernel falls below 'level'
  kerinverse = function(par, level, ...) {
    ## 'par' is in native format
    R <- par[2L]
    f <- 1/(pi * R^2)
    r <- if(f <= level) 0 else R
    return(r)
  },
  isPCP=TRUE,
  iscompact=TRUE,
  roffspring = function(n, par, ...) {
    ## 'par' is in native format
    R <- par[2L]
    rad <- R * sqrt(runif(n))
    theta <- runif(n, max=2*pi)
    list(x = rad * cos(theta), y = rad * sin(theta))
  },
  ## ................. Properties of the point process ..................
  K = function(par,rvals, ...){
    ## 'par' is in native format
    if(any(par <= 0))
      return(rep.int(Inf, length(rvals)))
    kappa <- par[1L]
    R <- par[2L]
    y <- pi * rvals^2 + (1/kappa) * .MatClustHfun(rvals/(2 * R))
    return(y)
  },
  B1 = function(r, ...) { .MatClustHfun(r/2) },
  pcf= function(par,rvals, ...){
    ## 'par' is in native format
    if(any(par <= 0))
      return(rep.int(Inf, length(rvals)))
    kappa <- par[1L]
    R <- par[2L]
    y <- 1 + (1/(pi * kappa * R^2)) * .MatClustgfun(rvals/(2 * R))
    return(y)
  },
  A1 = function(r, ...) { .MatClustgfun(r/2)/pi },
  a1 = function(r, ...) { .MatClustgfun(r/2) },
  a1prime = function(r, ...) { ifelse(r < 2, -(2/pi) * sqrt(1 - r^2/4), 0) },
  a1primeprime = function(r, ...) {
    ifelse(r < 2, -r/(2*pi * sqrt(1 - r^2/4)), 0)
  },
  Dpcf= function(par,rvals, ...){
    ## 'par' is in native format
    kappa <- par[1L]
    R <- par[2L]
    if(any(par <= 0)){
      dkappa <- rep.int(Inf, length(rvals))
      dR <- rep.int(Inf, length(rvals))
    } else {
      dkappa <- -.MatClustgfun(rvals/(2 * R)) / (pi * kappa^2 * R^2)
      dR <- -2*.MatClustgfun(rvals/(2 * R))/(pi * kappa * R^3) - (1/(pi * kappa * R^2)) * .MatClustgprime(rvals/(2 * R))*rvals/(2*R^2)
    }
    out <- rbind(dkappa, dR)
    rownames(out) <- c("kappa","R")
    return(out)
  },         
  ## ................ Utilities ...................................
  ## sensible starting paramters
  selfstart = function(X) {
    ## return 'par' in native format
    kappa <- intensity(X)
    R <- 2 * mean(nndist(X)) 
    c(kappa=kappa, R=R)
  },
  ## meaningful model parameters
  interpret = function(par, lambda) {
    kappa <- par[["kappa"]]
    R     <- par[["R"]]
    mu    <- if(is.numeric(lambda) && length(lambda) == 1)
               lambda/kappa else NA           
    c(kappa=kappa, R=R, mu=mu)
  }
)

#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
#'  >>>>>>>>>>>>>>>>>>>>> Cauchy kernel cluster process <<<<<<<<<<<<<<<
#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||


.CauchyInfo <- list(
  modelname      = "Neyman-Scott process with Cauchy kernel", # In modelname field of mincon fv obj.
  descname       = "Neyman-Scott process with Cauchy kernel", # In desc field of mincon fv obj.
  modelabbrev    = "Cauchy process", # In fitted obj.
  printmodelname = function(...) "Cauchy process", # Used by print.kppm
  parnames       = c("kappa", "eta2"),
  shapenames     = NULL,
  ## .................. Argument processing ...................................
  checkpar = function(par, native = old, ..., old=TRUE, strict=TRUE){
    ## 'par' is in either format
    if(is.null(par))
      par <- c(kappa=1,scale=1)
    if(strict && any(par<=0))
      stop("par values must be positive.", call.=FALSE)
    fmt <- detect.par.format(par, native=c("kappa", "eta2"), generic=c("kappa", "scale"))
    if(fmt == "generic" && native) {
      ## convert generic to native
      ## eta2 = 4 * scale^2
      par[2L] <- (2*par[2L])^2
      names(par)[2L] <- "eta2"
    } else if(fmt == "native" && !native) {
      ## convert native to generic
      ## scale = sqrt(eta2/4)
      par[2L] <- sqrt(par[2L])/2
      names(par)[2L] <- "scale"
    }
    return(par)
  },
  native2generic = function(par) {
    par[2L] <- sqrt(par[2L])/2
    names(par) <- c("kappa", "scale")
    return(par)
  },
  outputshape = function(margs, ...) list(),
  resolveshape = function(...){ return(list(...)) },
  ## Convert to/from canonical cluster parameters
  tocanonical = function(par, ...) {
    ## 'par' is in native format
    ## convert to experimental 'canonical' format
    kappa <- par[[1L]]
    eta2 <- par[[2L]]
    c(strength=1/(2 * pi * kappa * eta2), scale=sqrt(eta2)/2)
  },
  tohuman = function(can, ...) {
    ## 'can' is in 'canonical' format
    ## convert to native format
    strength <- can[[1L]]
    scale <- can[[2L]]
    eta2 <- 4 * scale^2
    c(kappa=1/(2 * pi * strength * eta2), eta2=eta2)
  },
  ## ...................... Properties of the cluster mechanism ....................
  ## density function for the distance to offspring
  ddist = function(r, scale, ...) {
    ## 'scale' is generic format
    r/(scale^2) *  (1 + (r / scale)^2)^(-3/2)
  },
  ## Practical range of clusters
  range = function(..., par=NULL, thresh=0.01){
    ## 'par' is in generic format
    thresh <- as.numeric(thresh %orifnull% 0.01)
    scale <- retrieve.param("scale", character(0), ..., par=par)
    ## integral of ddist(r) dr is 1 - (1+(r/scale)^2)^(-1/2)
    ## solve for integral = 1-thresh:
    rmax <- scale * sqrt(1/thresh^2 - 1)
    return(rmax)
  },
  ## Offspring kernel (2D probability density, expressed as function of distance from origin)
  kernel = function(par, rvals, ...) {
    ## 'par' is in native format
    scale <- sqrt(par[2L])/2
    1/(2*pi*scale^2)*((1 + (rvals/scale)^2)^(-3/2))
  },
  ## Distance at which 2D kernel falls below 'level'
  kerinverse = function(par, level, ...) {
    ## 'par' is in native format
    scale2 <- par[2L]/4
    r <- max(0, scale2 * ((2 * pi * scale2 * level)^(-2/3) - 1))
    return(r)
  },
  isPCP=TRUE,
  iscompact=FALSE,
  roffspring=function(n, par, ...) {
    ## 'par' is in native format
    rate <- par[["eta2"]]/8 
    b <- 1/sqrt(rgamma(n, shape=1/2, rate=rate))
    list(x = b * rnorm(n), y = b * rnorm(n))
  },
  ## .................... Properties of the point process ..................
  K = function(par,rvals, ...){
    ## 'par' is in native format
    if(any(par <= 0))
      return(rep.int(Inf, length(rvals)))
    pi*rvals^2 + (1 - 1/sqrt(1 + rvals^2/par[2L]))/par[1L]
  },
  B1 = function(r, ...) { 1 - 1/sqrt(1 + r^2/4) },
  pcf= function(par,rvals, ...){
    ## 'par' is in native format
    if(any(par <= 0))
      return(rep.int(Inf, length(rvals)))
    1 + ((1 + rvals^2/par[2L])^(-1.5))/(2 * pi * par[2L] * par[1L])
  },
  A1 = function(r, ...) {  ((1 + r^2/4)^(-1.5))/(8 * pi) },
  a1 = function(r, ...) {  (1 + r^2/4)^(-1.5) },
  a1prime = function(r, ...) {  (-3*r/4) * (1 + r^2/4)^(-2.5) },
  a1primeprime = function(r, ...) {
    (-3/4) * (1 + r^2/4)^(-5/2) + (15/16) * (1 + r^2/4)^(-7/2) 
  },
  Dpcf= function(par,rvals, ...){
    ## 'par' is in native format
    if(any(par <= 0)){
      dkappa <- rep.int(Inf, length(rvals))
      deta2 <- rep.int(Inf, length(rvals))
    } else {
      dkappa <- -(1 + rvals^2/par[2L])^(-1.5)/(2 * pi * par[2L] * par[1L]^2)
      deta2 <- 1.5 * rvals^2 * (1 + rvals^2/par[2L])^(-2.5)/(2 * par[2L]^3 * par[1L] * pi) - (1 + rvals^2/par[2L])^(-1.5)/(2*pi*par[1L]*par[2L]^2)
    }
    out <- rbind(dkappa, deta2)
    rownames(out) <- c("kappa","eta2")
    return(out)
  },
  ## ............ Utilities ................................
  selfstart = function(X) {
    ## return 'par' in native format
    kappa <- intensity(X)
    eta2 <- 4 * mean(nndist(X))^2
    c(kappa = kappa, eta2 = eta2)
  },
  ## meaningful model parameters
  interpret = function(par, lambda) {
    #' par is in native format
    kappa <- par[["kappa"]]
    omega <- sqrt(par[["eta2"]])/2
    mu <- if(is.numeric(lambda) && length(lambda) == 1)
            lambda/kappa else NA
    c(kappa=kappa, omega=omega, mu=mu)
  }
)


#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
#'  >>>>>>>>>>>>>>>>> Variance Gamma kernel cluster process <<<<<<<<<<<
#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

#' helper functions

resolve.vargamma.shape <- function(...,
                                   nu.ker=NULL,  nu.pcf=NULL,
                                   nu = NULL, allow.nu = FALSE,
                                   allow.default = FALSE) {
  ## ingest any kind of 'nu' argument by name
  if(is.null(nu.ker) && is.null(nu.pcf)) {
    if(allow.nu && !is.null(nu)) {
      nu.ker <- nu
    } else if(allow.default) {
      nu.ker <- -1/4
    } else stop("Must specify nu.ker or nu.pcf", call.=FALSE)
  }
  if(!is.null(nu.ker) && !is.null(nu.pcf))
    stop("Only one of nu.ker and nu.pcf should be specified",
         call.=FALSE)
  if(!is.null(nu.ker)) {
    check.1.real(nu.ker)
    stopifnot(nu.ker > -1/2)
    nu.pcf <- 2 * nu.ker + 1
  } else {
    check.1.real(nu.pcf)
    stopifnot(nu.pcf > 0)
    nu.ker <- (nu.pcf - 1)/2
  }
  return(list(nu.ker=nu.ker, nu.pcf=nu.pcf))
}

.VarGammaResolveShape <- function(...){
  nu.ker <- resolve.vargamma.shape(...,
                                   allow.default=TRUE, allow.nu=TRUE)$nu.ker
  check.1.real(nu.ker)
  stopifnot(nu.ker > -1/2)
  margs <- list(nu.ker=nu.ker, nu.pcf=2*nu.ker+1)
  cmodel <- list(type="Kernel", model="VarGamma", margs=margs)
  out <- list(margs = margs, covmodel = cmodel)
  return(out)
}

.VarGammaOutputShape <- function(margs, ...) { list(nu=margs$nu.ker) }

.VarGammaDdist <- function(r, scale, nu, ...) {
  ## one-dimensional probability density function for the distance to offspring
  ## 'scale' is generic format
  numer <- ((r/scale)^(nu+1)) * besselK(r/scale, nu)
  numer[r==0] <- 0
  denom <- (2^nu) * scale * gamma(nu + 1)
  y <- numer/denom
  y[!is.finite(y)] <- 0
  return(y)
}

.VarGammaPdist <- function(r, scale, nu, ...) {
  n <- length(r)
  z <- numeric(n)
  for(i in seq_len(n)) 
    z[i] <- integrate(.VarGammaDdist, 0, r[i], scale=scale, nu=nu)$value
  return(z)
}

.VarGammaPdistContrast <- function(r, scale, nu, p, ...) {
  .VarGammaPdist(r, scale, nu, ...) - p
}

.VarGammaKintegrand <- function(x, par, nu.pcf) {
  ## x * pcf(x) without check on par values
  numer <- (x/par[2L])^nu.pcf * besselK(x/par[2L], nu.pcf)
  denom <- 2^(nu.pcf+1) * pi * par[2L]^2 * par[1L] * gamma(nu.pcf + 1)
  return(x * (1 + numer/denom))
}

#'    main list of info
#'   NOTE: 'nu' represents 'nu.ker',
#'         the parameter \nu^\prime in equation (12)
#'         of Jalilian, Guan & Waagepetersen 2013

.VarGammaInfo <- list(
  modelname      = "Neyman-Scott process with Variance Gamma kernel", # In modelname field of mincon fv obj.
  descname       = "Neyman-Scott process with Variance Gamma kernel", # In desc field of mincon fv obj.
  modelabbrev    = "Variance Gamma process", # In fitted obj.
  printmodelname = function(obj){ # Used by print.kppm
    paste0("Variance Gamma process (nu=",
           signif(obj$clustargs[["nu"]], 2), ")")
  },
  parnames = c("kappa", "eta"),
  shapenames     = "nu",
  ## ...................... Argument processing ...........................
  checkpar = function(par, native = old, ..., old = TRUE, strict=TRUE){
    ## 'par' is in either format
    if(is.null(par))
      par <- c(kappa=1,scale=1)
    if(strict && any(par<=0))
      stop("par values must be positive.", call.=FALSE)
    detect.par.format(par, native=c("kappa", "eta"), generic=c("kappa", "scale"))
    names(par)[2L] <- if(native) "eta" else "scale"
    return(par)
  },
  native2generic = function(par) {
    names(par) <- c("kappa", "scale")
    return(par)
  },
  outputshape = .VarGammaOutputShape,
  resolveshape = .VarGammaResolveShape,
  ## Convert to/from canonical cluster parameters
  tocanonical = function(par, ..., margs) {
    ## 'par' is in native format
    ## convert to experimental 'canonical' format
    kappa <- par[[1L]]
    eta <- par[[2L]]
    nu.pcf <- margs$nu.pcf
    c(strength=1/(4 * pi * nu.pcf * kappa * eta^2), scale=eta)
  },
  tohuman = function(can, ..., margs) {
    ## 'can' is in 'canonical' format
    ## convert to native format
    strength <- can[[1L]]
    eta <- scale <- can[[2L]]
    nu.pcf <- margs$nu.pcf
    c(kappa=1/(4 * pi * nu.pcf * strength * eta^2), eta=scale)
  },
  ## .............. Properties of the cluster mechanism .................
  ## Probability density of distance from parent to offspring
  ddist = .VarGammaDdist,
  ## Practical range of clusters
  range = function(..., par=NULL, thresh=0.001){
    ## 'par' is in generic format
    thresh <- as.numeric(thresh %orifnull% 0.001)
    scale <- retrieve.param("scale", character(0), ..., par=par)
    ## Find value of nu:
    margs <- .VarGammaResolveShape(...)$margs
    nu <-    .VarGammaOutputShape(margs)$nu
    if(is.null(nu))
      stop(paste("Argument ", sQuote("nu"), " must be given."),
           call.=FALSE)
    rmax <- uniroot(.VarGammaPdistContrast, lower = scale, upper = 1000 * scale,
                    scale=scale, nu=nu, p=1-thresh)$root
    return(rmax)
  },
  ## 2D kernel probability density function in polar coordinates (no angular argument).
  kernel = function(par, rvals, ..., margs) {
    ## 'par' is in native format
    scale <- as.numeric(par[2L])
    nu.ker <- margs$nu.ker %orifnull% margs$nu
    ## evaluate
    numer <- ((rvals/scale)^nu.ker) * besselK(rvals/scale, nu.ker)
    numer[rvals==0] <- if(nu.ker > 0) 2^(nu.ker-1)*gamma(nu.ker) else Inf
    denom <- pi * (2^(nu.ker+1)) * scale^2 * gamma(nu.ker + 1)
    numer/denom
  },
  ## Distance at which 2D kernel falls below 'level'
  kerinverse = NULL, # fall back on root-finding algorithm
  isPCP=TRUE,
  iscompact=FALSE,
  roffspring=function(n, par, ..., margs) {
    ## 'par' is in native format
    scale <- par[["eta"]] ## eta = omega = scale
    nu.ker <- margs$nu.ker
    alpha <- 2 * (nu.ker + 1)
    beta  <- 1/(2 * scale^2)
    sdee <- sqrt(rgamma(n, shape=alpha/2, rate=beta))
    list(x = sdee * rnorm(n),
         y = sdee * rnorm(n))
  },
  K = function(par,rvals, ..., margs){
    ## 'par' is in native format
    ## margs = list(.. nu.pcf.. )
    ## K function requires integration of pair correlation
    if(any(par <= 0))
      return(rep.int(Inf, length(rvals)))
    nu.pcf <- margs$nu.pcf
    out <- numeric(length(rvals))
    for (i in which(rvals > 0))
      out[i] <- 2 * pi * integrate(.VarGammaKintegrand,
                                   lower=0, upper=rvals[i],
                                   par=par, nu.pcf=nu.pcf)$value
    return(out)
  },
  B1 = NULL,
  pcf= function(par,rvals, ..., margs){
    ## 'par' is in native format
    ## margs = list(..nu.pcf..)
    if(any(par <= 0))
      return(rep.int(Inf, length(rvals)))
    nu.pcf <- margs$nu.pcf
    sig2 <- 1 / (4 * pi * (par[2L]^2) * nu.pcf * par[1L])
    denom <- 2^(nu.pcf - 1) * gamma(nu.pcf)
    rr <- rvals / par[2L]
    ## Matern correlation function
    fr <- ifelseXB(rr > 0,
                  (rr^nu.pcf) * besselK(rr, nu.pcf) / denom,
                  1)
    return(as.numeric(1 + sig2 * fr))
  },
  A1 = function(r, ..., margs) {
    nu.pcf <- margs$nu.pcf
    phi <- 1/(4 * pi * nu.pcf)
    denom <- 2^(nu.pcf - 1) * gamma(nu.pcf)
    ## Matern correlation function
    fr <- ifelseXB(r > 0,
                  (r^nu.pcf) * besselK(r, nu.pcf) / denom,
                  1)
    return(as.numeric(phi * fr))
  },
  a1 = function(r, ..., margs) {
    nu <- margs$nu.pcf
    denom <- 2^(nu - 1) * gamma(nu)
    ## Matern correlation function
    fr <- ifelseXB(r > 0,
                  (r^nu) * besselK(r, nu) / denom,
                  1)
    return(as.numeric(fr))
  },
  a1prime = function(r, ..., margs) {
    nu <- margs$nu.pcf
    denom <- 2^(nu - 1) * gamma(nu)
    fr <- ifelseXB(r > 0,
                  (r^nu) * besselK(r, nu - 1) / denom,
                  0)
    return(as.numeric(-fr))
  },
  a1primeprime = function(r, ..., margs) {
    nu <- margs$nu.pcf
    denom <- 2^(nu - 1) * gamma(nu)
    fr <- ifelseXB(r > 0,
                   (   (r^nu)     * besselK(r, nu - 2)
                     - (r^(nu-1)) * besselK(r, nu - 1))
                   ,
                   2^(nu-2) * gamma(nu-1))
    return(as.numeric(fr/denom))
  },
  Dpcf = NULL,
  ## sensible starting values
  selfstart = function(X) {
    ## return 'par' in native format
    kappa <- intensity(X)
    eta <- 2 * mean(nndist(X))
    c(kappa=kappa, eta=eta)
  },
  ## meaningful model parameters
  interpret = function(par, lambda) {
    #' par is in native format
    kappa <- par[["kappa"]]
    omega <- par[["eta"]]
    mu <- if(is.numeric(lambda) && length(lambda) == 1)
            lambda/kappa else NA
    c(kappa=kappa, omega=omega, mu=mu)
  }
)

#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
#'  >>>>>>>>>>>>>>>>>>  Log-Gaussian Cox process <<<<<<<<<<<<<<<<<<<<<<
#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

#' helper functions

.LGCPResolveShape <- function(...){
  ## resolve shape parameters for kppm and friends allowing for native/generic par syntax
  dots <- list(...)
  nam <- names(dots)
  out <- list()
  cmod <- dots$covmodel
  model <- cmod$model %orifnull% dots$model %orifnull% "exponential"
  margs <- NULL
  ## extract shape parameters and validate them
  switch(model,
         exponential = ,
         gauss = {
           ## no shape parameters
         },
         stable = ,
         fastStable = {
           stuff <- cmod %orifnull% dots
           ok <- "alpha" %in% names(stuff)
           if(!ok) stop("Parameter 'alpha' is required")
           margs <- stuff["alpha"]
           with(margs, {
             check.1.real(alpha)
             stopifnot(0 < alpha && alpha <= 2)
           })
         },
         gencauchy = ,
         fastGencauchy = {
           stuff <- cmod %orifnull% dots
           ok <- c("alpha", "beta") %in% names(stuff)
           if(!ok[1]) stop("Parameter 'alpha' is required")
           if(!ok[2]) stop("Parameter 'beta' is required")
           margs <- stuff[c("alpha", "beta")]
           with(margs, {
             check.1.real(alpha)
             check.1.real(beta)
             stopifnot(0 < alpha && alpha <= 2)
             stopifnot(beta > 0)
           })
         },
         matern = {
           stuff <- cmod %orifnull% dots
           ok <- "nu" %in% names(stuff)
           if(!ok) stop("Parameter 'nu' is required")
           margs <- stuff["nu"]
           with(margs, {
             check.1.real(nu)
           })
         },
         stop(paste("Covariance model", sQuote(model),
                    "is not yet supported"), call.=FALSE)
         )
  if(length(margs)==0) {
    margs <- NULL
  } else {
    ## detect anisotropic model
    if("Aniso" %in% names(margs))
      stop("Anisotropic covariance models cannot be used",
           call.=FALSE)
  }
  out$margs <- margs
  out$model <- model
  out$covmodel <- list(type="Covariance", model=model, margs=margs)
  return(out)
}

#'      main list of info

.LGCPInfo <- list(
  ## Log Gaussian Cox process: native par = (sigma2, alpha) 
  ## Log Gaussian Cox process: generic par = (var, scale) 
  modelname      = "Log-Gaussian Cox process", # In modelname field of mincon fv obj.
  descname       = "LGCP", # In desc field of mincon fv obj.
  modelabbrev    = "log-Gaussian Cox process", # In fitted obj.
  printmodelname = function(...) "log-Gaussian Cox process", # Used by print.kppm
  parnames       = c("sigma2", "alpha"),
  shapenames     = "*",  # shape parameters are present but depend on the model
  ## ................. Argument handling ...........................
  checkpar = function(par, native = old, ..., old=TRUE, strict=TRUE){
    ## 'par' is in either format
    if(is.null(par))
      par <- c(var=1,scale=1)
    if(strict && any(par<=0))
      stop("par values must be positive.", call.=FALSE)
    detect.par.format(par, native=c("sigma2", "alpha"), generic=c("var", "scale"))
    names(par) <- if(native) c("sigma2", "alpha") else c("var","scale")
    return(par)
  },
  native2generic = function(par) {
    names(par) <- c("var","scale")
    return(par)
  },
  outputshape = function(margs, ...) return(margs),
  resolveshape = .LGCPResolveShape,
  ## canonical parameters are not defined for LGCP 
  tocanonical = NULL,
  tohuman = NULL,
  ## ..... Empty entries for cluster mechanism ....
  ddist = NULL,
  range = NULL,
  kernel = NULL,
  kerinverse = NULL,
  isPCP=FALSE,
  iscompact=FALSE,
  roffspring=NULL,
  ## ...... Properties of the point process ...............
  K = function(par, rvals, ..., model, margs) {
    ## 'par' is in native format
    if(any(par <= 0))
      return(rep.int(Inf, length(rvals)))
    ## Determine covariance function 
    switch(model,
           exponential = {
             Cfun <- function(x) exp(-x)
           },
           gauss = ,
           fastGauss = {
             Cfun <- function(x) exp(-x^2)
           },
           stable = ,
           fastStable = {
             alpha <- margs[["alpha"]]
             Cfun <- function(x) exp(-x^alpha)
           },
           gencauchy = ,
           fastGencauchy = {
             alpha <- margs[["alpha"]]
             beta  <- margs[["beta"]]
             Cfun <- function(x) { (1 + x^alpha)^(-beta/alpha) }
           },
           matern = {
             nu <- margs[["nu"]]
             Cfun <- function(x) {
               z <- x * sqrt(2 * nu)
               ifelse(x == 0,
                      1, 
                      (z^nu) * besselK(z, nu) * (2^(1-nu))/gamma(nu))
             }
           },
           stop(paste("Model", sQuote(model), "is not recognised"))
           )
    ## hence determine integrand for K function
    integrand <- function(r) 2 * pi * r * exp(par[1L] * Cfun(r/par[2L]))
    ## compute indefinite integral
    imethod <- if(spatstat.options("fastK.lgcp")) "trapezoid" else "quadrature"
    th <- indefinteg(integrand, rvals, lower=0, method=imethod)
    return(th)
  },
  B1 = NULL, # not a cluster process
  pcf= function(par, rvals, ..., model, margs) {
    ## 'par' is in native format
    if(any(par <= 0))
      return(rep.int(Inf, length(rvals)))
    ## Determine covariance function 
    switch(model,
           exponential = {
             Cfun <- function(x) exp(-x)
           },
           gauss = ,
           fastGauss = {
             Cfun <- function(x) exp(-x^2)
           },
           stable = ,
           fastStable = {
             alpha <- margs[["alpha"]]
             Cfun <- function(x) exp(-x^alpha)
           },
           gencauchy = ,
           fastGencauchy = {
             alpha <- margs[["alpha"]]
             beta  <- margs[["beta"]]
             Cfun <- function(x) { (1 + x^alpha)^(-beta/alpha) }
           },
           matern = {
             nu <- margs[["nu"]]
             Cfun <- function(x) {
               z <- x * sqrt(2 * nu)
               ifelse(x == 0,
                      1, 
                      (z^nu) * besselK(z, nu) * (2^(1-nu))/gamma(nu))
             }
           },
           stop(paste("Model", sQuote(model), "is not recognised"))
           )
    ## Hence evaluate pcf
    gtheo <- exp(par[1L] * Cfun(rvals/par[2L]))
    return(gtheo)
  },
  A1 = NULL, # not a cluster process
  a1 = NULL, # not a cluster process
  a1prime = NULL, # not a cluster process
  a1primeprime = NULL, # not a cluster process
  Dpcf= function(par,rvals, ..., model){
    ## 'par' is in native format
    if(!(model %in% c("exponential", "stable")))
      stop("Gradient of the pcf is not available for this model")
    if(model=="exponential") {
      dsigma2 <- exp(-rvals/par[2L]) * exp(par[1L]*exp(-rvals/par[2L]))
      dalpha <- rvals * par[1L] * exp(-rvals/par[2L]) * exp(par[1L]*exp(-rvals/par[2L]))/par[2L]^2
    } else if(model=="stable"){
      dsigma2 <- exp(-sqrt(rvals/par[2L])) * exp(par[1L]*exp(-sqrt(rvals/par[2L])))
      dalpha <- sqrt(rvals/par[2L]^3) * par[1L] * exp(-sqrt(rvals/par[2L])) * exp(par[1L] * exp(-sqrt(rvals/par[2L])))
    }
    out <- rbind(dsigma2, dalpha)
    rownames(out) <- c("sigma2","alpha")
    return(out)
  },
  ## sensible starting values
  selfstart = function(X) {
    ## return 'par' in native format
    alpha <- 2 * mean(nndist(X))
    c(sigma2=1, alpha=alpha)
  },
  ## meaningful model parameters
  interpret = function(par, lambda) {
    sigma2 <- par[["sigma2"]]
    alpha  <- par[["alpha"]]
    mu <- if(is.numeric(lambda) && length(lambda) == 1 && lambda > 0)
            log(lambda) - sigma2/2 else NA
    c(sigma2=sigma2, alpha=alpha, mu=mu)
  }
)

#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
#' >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
#'              C O N S T R U C T     T A B L E
#' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#'  |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

.Spatstat.ClusterModelInfoTable <- 
  list(
    Thomas   = .ThomasInfo,
    MatClust = .MatClustInfo,
    Cauchy   = .CauchyInfo,
    VarGamma = .VarGammaInfo,
    LGCP     = .LGCPInfo)


spatstatClusterModelInfo <- function(name, onlyPCP = FALSE) {
  if(inherits(name, "detpointprocfamily")) {
    if(requireNamespace("spatstat.model")) {
      return(spatstat.model::spatstatDPPModelInfo(name))
    } else {
      message("The package 'spatstat.model' is required")
      return(NULL)
    }
  }
  if(!is.character(name) || length(name) != 1)
    stop("Argument must be a single character string", call.=FALSE)
  nama2 <- names(.Spatstat.ClusterModelInfoTable)
  if(onlyPCP){
    ok <- sapply(.Spatstat.ClusterModelInfoTable, getElement, name="isPCP")
    nama2 <- nama2[ok]
  } 
  if(!(name %in% nama2))
    stop(paste(sQuote(name), "is not recognised;",
               "valid names are", commasep(sQuote(nama2))),
         call.=FALSE)
  out <- .Spatstat.ClusterModelInfoTable[[name]]
  return(out)
}

#'
#'           pkgRandomFields.R
#' 
#'    Dealing with the (DEFUNCT) Random Fields package
#'
#'    $Revision: 1.6 $  $Date: 2023/10/20 11:17:19 $

kraeverRandomFields <- function() {
  stop("The package RandomFields is no longer available.")
##  kraever("RandomFieldsUtils")
##  kraever("RandomFields")
# should no longer be needed:  
#  capture.output(RandomFieldsUtils:::.onLoad())
#  capture.output(RandomFields:::.onLoad())
  return(invisible(NULL))
}

# require a namespace and optionally check whether it is attached
kraever <- function(package, fatal=TRUE) {
  if(!requireNamespace(package, quietly=TRUE)) {
    if(fatal)
      stop(paste("The package", sQuote(package), "is required"),
           call.=FALSE)
    return(FALSE)
  }
  if(spatstat.options(paste("check", package, "loaded", sep=".")) &&
    !isNamespaceLoaded(package)){
    if(fatal)
      stop(paste("The package", sQuote(package),
                 "must be loaded: please type",
                 sQuote(paste0("library", paren(package)))),
           call.=FALSE)
    return(FALSE)
  }
  return(TRUE)
}

# legacy functions

RandomFieldsSafe <- function() { FALSE }

getRandomFieldsModelGen <- function(model) {
  return(NULL)
}

#'
#'  randomsets.R
#'
#'  Generation of random sets
#'
#'  $Revision: 1.2 $ $Date: 2019/08/16 07:53:05 $


rthinclumps <- function(W, p, ...) {
  check.1.real(p)
  if(badprobability(p, TRUE))
    stop("p must be a valid probability between 0 and 1", call.=FALSE)
  if(!(is.im(W) || is.owin(W)))
    stop("W should be a window or pixel image", call.=FALSE)
  clumps <- connected(W, ...)
  keep <- (runif(length(levels(clumps))) < p)
  retained <- eval.im(keep[clumps])
  return(solutionset(retained))
}


  

#'
#'    rvargamma.R
#'
#'   $Revision: 1.13 $ $Date: 2025/05/20 08:21:09 $
#'
#'   Simulation of Variance-Gamma cluster process
#'   using either naive algorithm or BKBC algorithm
#'   (R code)
#'
#'   rVarGamma
#'
#'    Original code for naive simulation of Neyman-Scott by Adrian Baddeley
#'    Original code for simulation of rVarGamma offspring by Abdollah Jalilian
#'    Bug fixes by Abdollah, Adrian Baddeley, and Rolf Turner
#'
#'   Implementation of BKBC algorithm by Adrian Baddeley and Ya-Mei Chang
#' 
#'   Copyright (c) 2000-2023 Adrian Baddeley, Abdollah Jalilian, Ya-Mei Chang 
#'   GNU Public Licence >= 2

##    
## =================================================================
## Neyman-Scott process with Variance Gamma (Bessel) kernel function
## =================================================================

## nu.ker: smoothness parameter of Variance Gamma kernel function
## omega: scale parameter of kernel function
## nu.pcf: smoothness parameter of Variance Gamma pair correlation function
## eta: scale parameter of Variance Gamma pair correlation function
## nu.pcf = 2 * nu.ker + 1    and    eta = omega

rVarGamma <- local({
  
  ## simulates mixture of isotropic Normal points in 2D with gamma variances
  rnmix.gamma <- function(n = 1, shape, rate) {
    V <- matrix(rnorm(2 * n, 0, 1), nrow = n, ncol = 2)
    s <- rgamma(n, shape=shape, rate=rate)
    return(sqrt(s) * V)
  }

  ## main function
  rVarGamma <- function(kappa, scale, mu,
                        nu,
                        win = square(1),
                        nsim=1, drop=TRUE, 
                        ...,
                        n.cond=NULL, w.cond=NULL,
                        algorithm=c("BKBC", "naive"),
                        nonempty=TRUE, 
                        thresh = 0.001,
                        poisthresh=1e-6,
                        expand = NULL,
                        saveparents=FALSE, saveLambda=FALSE,
                        kappamax=NULL, mumax=NULL, LambdaOnly=FALSE) {
    ## Variance-Gamma cluster process
    
    ## nu / nu.ker: smoothness parameter of Variance Gamma kernel function
    ## scale / omega: scale parameter of kernel function

    check.1.integer(nsim)
    stopifnot(nsim >= 0)
    if(nsim == 0) return(simulationresult(list()))

    ## Catch old nu.ker/nu.pcf syntax and resolve nu-value.
    dots <- list(...)
    if(missing(nu)){
      nu <- resolve.vargamma.shape(nu.ker=dots$nu.ker,
                                   nu.pcf=dots$nu.pcf,
                                   allow.default=TRUE)$nu.ker
    } else {
      check.1.real(nu)
      stopifnot(nu > -1)
    }
    nu.ker <- nu
    ## Catch old scale syntax (omega)
    if(missing(scale)) scale <- dots$omega

    ## algorithm choices
    doLambda <- isTRUE(saveLambda) || isTRUE(LambdaOnly)
    conditioning <- !is.null(n.cond)
    if((conditioning || doLambda) && !isTRUE(spatstat.options("developer"))) {
      ## The naive algorithm must be used
      ## Change defaults 
      algorithm <- if(missing(algorithm)) "naive" else match.arg(algorithm)
      nonempty  <- if(missing(nonempty)) FALSE else isTRUE(nonempty)
      ## Override given arguments with a warning
      reason <- if(conditioning) "for conditional simulation" else "for intensity calculation"
      algorithm <- warn.reset.arg(algorithm, "naive", reason)
      nonempty  <- warn.reset.arg(nonempty,  FALSE,   reason)
    } else {
      ## Any choice of algorithm is permitted
      algorithm <- match.arg(algorithm)
      nonempty <- isTRUE(nonempty)
    }

    ## conditional simulation
    if(conditioning) {
      mod <- clusterprocess("VarGamma", mu=mu, kappa=kappa, scale=scale, nu=nu)
      result <- CondSimCox(mod, nsim=nsim, ...,
                           nonempty=nonempty, algorithm=algorithm,
                           win=win, n.cond=n.cond, w.cond=w.cond,
                           saveparents=saveparents,
                           saveLambda=saveLambda, LambdaOnly=LambdaOnly,
                           drop=drop)
      return(result)
    }

    ## ------- Unconditional simulation ------------------
    
    ## Catch old name 'eps' for 'thresh':
    if(missthresh <- missing(thresh))
      thresh <- dots$eps %orifnull% 0.001

    ## determine the effective maximum radius of clusters
    ## (for the naive algorithm, or when kappa is not constant)    
    if(missing(expand)){
      expand <- clusterradius("VarGamma", scale = scale, nu = nu.ker,
                              thresh = thresh, ...)
    } else if(!missthresh) {
      warning("Argument ", sQuote("thresh"), " is ignored when ",
              sQuote("expand"), " is given")
    }

    #' validate 'kappa' and 'mu'
    km <- validate.kappa.mu(kappa, mu, kappamax, mumax,
                            win, expand, ...,
                            context="In rCauchy")
    kappamax <- km[["kappamax"]]
    mumax    <- km[["mumax"]]
      
    ## detect trivial case where patterns are empty
    if(kappamax == 0 || mumax == 0) {
      result <- emptyNeyScot(win, nsim,
                             saveLambda, saveparents, LambdaOnly, ...)
      return(simulationresult(result, nsim=nsim, drop=drop))
    }

    #' determine algorithm
    do.parents <- saveparents || doLambda || !is.numeric(kappa)
    do.hybrid <- (algorithm == "BKBC") && nonempty 


    if(do.hybrid) {
      ## ........ Fast algorithm (BKBC) .................................
      ## run BKBC algorithm for stationary model
      ## (generic R implementation using information from cluster model table)
      result <- do.call(rclusterBKBC,
                        resolve.defaults(
                          list(clusters = "VarGamma",
                               kappa    = kappamax,
                               scale    = scale,
                               mu       = mumax,
                               nu.ker   = nu.ker,
                               W        = quote(win),
                               nsim     = nsim,
                               drop     = FALSE),
                          list(...),
                          list(internal = "naive",
                               external = "super",
                               inflate  = "optimal",
                               verbose=FALSE)))
      ## thin 
      if(!is.numeric(kappa))
        result <- solapply(result, thinParents,
                           P=kappa, Pmax=kappamax)
      
      if(!is.numeric(mu)) 
        result <- solapply(result, rthin,
                           P=mu, Pmax=mumax,
                           na.zero=TRUE, fatal=FALSE)
    } else {
      ## .......... Slower algorithm ('naive') ..........................
      ## trap case of large clusters, close to Poisson
      if(is.numeric(kappa) && 1/(4 * pi * kappamax * scale^2) < poisthresh) {
        if(is.function(mu)) mu <- as.im(mu, W=win, ...)
        kapmu <- kappa * mu
        result <- rpoispp(kapmu, win=win, nsim=nsim, drop=drop, warnwin=FALSE)
        result <- fakeNeyScot(result, kapmu, win,
                              saveLambda, saveparents, LambdaOnly)
        return(result)
      }
    
      ## gamma mixture of normals
      alpha <- 2 * (nu.ker + 1)
      beta  <- 1/(2 * scale^2)
    
      ## simulate
      result <- rNeymanScott(kappa=kappa,
                             expand=expand,
                             rcluster=list(mu, rnmix.gamma),
                             win=win,
                             shape = alpha/2, # formal argument of rnmix.gamma
                             rate = beta, # formal argument of rnmix.gamma
                             nsim=nsim, drop=FALSE,
                             nonempty = nonempty,
                             saveparents = do.parents,
                             kappamax=kappamax, mumax=mumax)

    }
    if(doLambda){
      BW <- Frame(win)
      for(i in 1:nsim) {
        parents <- attr(result[[i]], "parents")
        BX <- boundingbox(BW, bounding.box.xy(parents))
        parents <- as.ppp(parents, W=BX, check=FALSE)
        Lambda <- clusterfield("VarGamma", parents, scale=scale,
                               nu=nu.ker, mu=mu, ...)
        Lambda <- Lambda[win, drop=FALSE]
        if(LambdaOnly) {
          #' save only the intensity
          result[[i]] <- Lambda
          if(saveparents) attr(result[[i]], "parents") <- parents
        } else {
          #' usual case - save intensity as attribute
          attr(result[[i]], "Lambda") <- Lambda
        }
      }
    }
    return(simulationresult(result, nsim, drop))
  }

  inflateVarGamma <- function(mod, rD) {
    optimalinflation("VarGamma", mod, rD) 
  }
  
  rVarGamma
})

#'
#'   Header for all (concatenated) test files
#'
#'   Require spatstat.random
#'   Obtain environment variable controlling tests.
#'
#'   $Revision: 1.5 $ $Date: 2020/04/30 05:31:37 $

require(spatstat.random)
FULLTEST <- (nchar(Sys.getenv("SPATSTAT_TEST", unset="")) > 0)
ALWAYS   <- TRUE
cat(paste("--------- Executing",
          if(FULLTEST) "** ALL **" else "**RESTRICTED** subset of",
          "test code -----------\n"))
#'  tests/randoms.R
#'   Further tests of random generation code
#'  $Revision: 1.23 $ $Date: 2025/11/21 01:38:26 $


local({
  if(FULLTEST) {
    #' cases not covered in examples
    A <- runifdisc(6, nsim=2)
    A <- runifpoispp(5, nsim=2)
    A <- runifpoispp(0, nsim=2)
    A <- rSSI(0.05, 6, nsim=2)
    A <- rSSI(0.05, 10, win=square(c(-0.5, 1.5)), x.init=A[[1]], nsim=2)  
    A <- rstrat(nx=4, nsim=2)
    A <- rcell(square(1), nx=5, nsim=2)
  }
  if(ALWAYS) { # involves C code etc
    A <- rthin(cells, P=0.5, nsim=2)
    A <- rthin(cells, runif(42))
    A <- rthin(cells[FALSE], P=0.5, nsim=2)
  }
  f <- function(x,y) { 10*x }
  Z <- as.im(f, square(1))
  if(ALWAYS) {
    A <- rpoint(n=6, f=f, fmax=10, nsim=2)
    A <- rpoint(n=6, f=Z, fmax=10, nsim=2)
    A <- rpoint(n=0, f=f, fmax=10, nsim=2)
    A <- rpoint(n=0, f=Z, fmax=10, nsim=2)

    op <- spatstat.options(fastpois=FALSE)
    A <- runifpoispp(5, nsim=2)
    A <- rpoispp(Z)
    spatstat.options(op)
  }
  if(FULLTEST) {
    b3 <- box3(c(0,1))
    b4 <- boxx(c(0,1), c(0,1), c(0,1), c(0,1))
    b5 <- c(0, 2, 0, 2)
    X <- rMaternInhibition(2, kappa=20, r=0.1, win=b3)
    Y <- rMaternInhibition(2, kappa=20, r=0.1, win=b4)
    Y <- rMaternInhibition(2, kappa=20, r=0.1, win=b5, nsim=2)

    X <- rSSI(0.05, 6)
    Y <- rSSI(0.05, 6, x.init=X) # no extra points

    Z <- rlabel(finpines)
  }

  if(FULLTEST) {
    ## intensity constant on each tile of a tessellation
    X <- cells[c(2, 22, 32, 37)]
    V <- dirichlet(X)
    lam <- as.function(V, values=rep(5, nobjects(V)))
    Y <- rpoispp(lam, tilewise=TRUE) # tilewise algorithm
    Y <- rpoispp(lam) # code for default value of 'tilewise'
  }
  
  f1 <- function(x,y){(x^2 + y^3)/10}
  f2 <- function(x,y){(x^3 + y^2)/10}
  ZZ <- solist(A=as.im(f1, letterR),
               B=as.im(f2, letterR))
  g <- function(x,y,m){(10+as.integer(m)) * (x^2 + y^3)}
  if(FULLTEST) {
    XX <- rmpoispp(ZZ, nsim=3)
    YY <- rmpoint(10, f=ZZ, nsim=3)
    UU <- rmpoint(10, f=ZZ[[1]], types=letters[1:2])
    VV <- rpoint.multi(10, f=g,
                       marks=factor(sample(letters[1:3], 10, replace=TRUE)),
                       nsim=3)
  }
  if(ALWAYS) { # depends on C code
    L <- edges(letterR)
    E <- runifpoisppOnLines(5, L)
    G <- rpoisppOnLines(ZZ, L)
    G2 <- rpoisppOnLines(list(A=f1, B=f2), L, lmax=max(sapply(ZZ, max)))
  }

  if(FULLTEST) {
    #' cluster models + bells + whistles
    X <- rThomas(10, 0.2, 5, saveLambda=TRUE)
    if(is.null(attr(X, "Lambda")))
      stop("rThomas did not save Lambda image")
    Y <- rThomas(0, 0.2, 5, saveLambda=TRUE)
    if(is.null(attr(Y, "Lambda")))
      stop("rThomas did not save Lambda image when kappa=0")
    X <- rMatClust(10, 0.05, 4, saveLambda=TRUE)
    X <- rCauchy(30, 0.01, 5, saveLambda=TRUE)
    X <- rVarGamma(30, 2, 5, nu=0.02, saveLambda=TRUE)
    Z <- as.im(function(x,y){ 5 * exp(2 * x - 1) }, owin())
    Y <- rThomas(10, 0.2, Z, saveLambda=TRUE)
    Y <- rMatClust(10, 0.05, Z, saveLambda=TRUE)
    Y <- rCauchy(30, 0.01, Z, saveLambda=TRUE)
    Y <- rVarGamma(30, 2, Z, nu=0.02, saveLambda=TRUE)
    #' inhomogeneous
    Moo <- as.im(function(x,y) { 10 * x }, unit.square())
    X <- rMatClust(10, 0.2, Moo)
  }

  if(FULLTEST) {
    #' perfect simulation code infrastructure
    expandwinPerfect(letterR, 2, 3)

    #' trivial cases of random generators for ppx
    B4 <- boxx(0:1, 0:1, 0:1, 0:1)
    Z0 <- runifpointx(0, domain=B4, nsim=2)
    Z1 <- runifpointx(1, domain=B4, nsim=2)
  }

  if(FULLTEST) {
    ## check sanity of cluster info table
    cnames <- c("Thomas", "MatClust", "Cauchy", "VarGamma", "LGCP")
    required <- names(spatstatClusterModelInfo('Thomas'))
    for(cn in cnames) {
      en <- spatstatClusterModelInfo(cn)
      na <- names(en)
      if(anyDuplicated(na)) {
        wh <- unique(na[duplicated(na)])
        stop(paste("Duplicated",
                   ngettext(length(wh), "entry", "entries"),
                   paste(sQuote(wh), collapse=", "),
                   "in cluster info table for", cn , "model"),
             call.=FALSE)
      }
      mus <- setdiff(required, na)
      if(length(mus))
        stop(paste(ngettext(length(mus), "Entry", "Entries"),
                   paste(sQuote(mus), collapse=", "),
                   "missing from cluster info table for", cn, "model"),
             call.=FALSE)
      if(!identical(na, required))
        stop("Mismatch in cluster info table for", cn, "and Thomas models",
             call.=FALSE)
    }
  }

})

local({
  if(ALWAYS) {
    #' Bug in rLGCP spotted by Tilman Davies
    X <- rLGCP("matern", function(x,y) { 1 - 0.4* y },
               var=2, scale=0.7, nu=0.5, win = square(10),
               dimyx=c(32,64))
  }
  if(FULLTEST) {
    ## Bug in rGRFcircembed
    ## when handling incompatible data for 'mu' and 'win'
    win <- owin(c(0, 3), c(0, 3))
    npix <- 300
    spatstat.options(npixel = npix)
    beta0 <- 3
    beta1 <- 0
    sigma2x <- 0.2
    range <- 1.2
    nu <- 1
    set.seed(7)
    x0 <- seq(0, 3, length=npix)
    y0 <- seq(0, 3, length=npix)
    gridcov <- outer(x0, y0, function(x,y) cos(x) - sin(y - 2))
    MU <- im(beta0 + beta1 * gridcov, xcol = x0, yrow = y0)
    lg.s.c <- rLGCP('matern', mu=MU,
                    var = sigma2x, scale = range / sqrt(8), 
                    nu = 1, win = win)
  }
  if(ALWAYS) {
    #' rLGCP in window other than the unit square
    ow <- owin(c(-3.75, 25.75), c(-3.75, 25.75))
    X <- rLGCP(model = "exp", mu = -1.75, var = 1, scale = 2,
               win = ow, saveLambda=TRUE, eps=0.5, rule.eps="shrink.frame")
    if(FULLTEST) {
      #' conditional simulation, same parameters
      Y <- rLGCP(model = "exp", mu = -1.75, var = 1, scale = 2,
                 win = ow, saveLambda=TRUE, eps=0.5, rule.eps="shrink.frame",
                 n.cond=256)
    }
  }
})

reset.spatstat.options()

#'
#'           kraever.R
#' 
#'    Requiring a package namespace
#'
#'    $Revision: 1.9 $  $Date: 2026/02/21 03:20:59 $

# require a namespace and optionally check whether it is attached
kraever <- function(package, fatal=TRUE, loaded=TRUE, ..., preamble=NULL) {
  if(!requireNamespace(package, quietly=TRUE)) {
    if(fatal) {
      p <- paste("package", sQuote(package))
      q <- if(is.null(preamble)) paste("The", p) else paste(preamble, "the", p)
      stop(paste(q, "is required"), call.=FALSE)
    }      
    return(FALSE)
  }
  if(loaded && !isNamespaceLoaded(package)){
    if(fatal) {
      p <- paste("package", sQuote(package))
      q <- if(is.null(preamble)) paste("The", p) else paste(preamble, "the", p)
      stop(paste(q, "must be loaded: please type",
                 sQuote(paste0("library", paren(package)))),
           call.=FALSE)
    }
    return(FALSE)
  }
  return(TRUE)
}

#
# randomseg.R
#
# $Revision: 1.19 $ $Date: 2025/12/31 03:18:14 $
#


rpoisline <- function(lambda, win=owin()) {
  win <- as.owin(win)
  # determine circumcircle
  xr <- win$xrange
  yr <- win$yrange
  xmid <- mean(xr)
  ymid <- mean(yr)
  width <- diff(xr)
  height <- diff(yr)
  rmax <- sqrt(width^2 + height^2)/2
  boundbox <- owin(xmid + c(-1,1) * rmax, ymid + c(-1,1) * rmax)
  # generate poisson lines through circumcircle
  n <- rpois(1, lambda * 2 * pi * rmax)
  if(n == 0) {
    X <- psp(numeric(0), numeric(0), numeric(0), numeric(0),
             marks=integer(0), 
             window=win)
    attr(X, "lines") <- infline(p=numeric(0), theta=numeric(0))
    attr(X, "linemap") <- integer(0)
    return(X)
  }
  theta <- runif(n, max= 2 * pi)
  p <- runif(n, max=rmax)
  # compute intersection points with circle
  q <- sqrt(rmax^2 - p^2)
  co <- cos(theta)
  si <- sin(theta)
  X <- psp(x0= xmid + p * co + q * si,
           y0= ymid + p * si - q * co,
           x1= xmid + p * co - q * si,
           y1= ymid + p * si + q * co,
           marks = seq_len(n),
           window=boundbox, check=FALSE)
  # infinite lines
  L <- infline(p = p + xmid * co + ymid * si,
               theta = theta)
  # clip to window
  X <- X[win]
  # append info
  linemap <- as.integer(marks(X))
  X <- unmark(X)
  attr(X, "lines") <- L
  attr(X, "linemap") <- linemap
  return(X)
}

rjitter.psp <- function(X, radius, ..., clip=TRUE, nsim=1, drop=TRUE) {
  if(nsegments(X) == 0) {
    result <- rep(list(X), nsim)
    result <- simulationresult(result, nsim, drop)
    return(result)
  }
  marx <- marks(X)
  Xfrom <- endpoints.psp(X, "first")
  Xto   <- endpoints.psp(X, "second")
  if(clip) 
    Window(Xfrom) <- Window(Xto) <- grow.rectangle(Frame(X), radius)
  result <- vector(mode="list", length=nsim)
  for(isim in seq_len(nsim)) {
    Xfrom <- rjitter(Xfrom, radius)
    Xto   <- rjitter(Xto, radius)
    Y <- as.psp(from=Xfrom, to=Xto)
    marks(Y) <- marx
    if(clip)
      Y <- Y[Window(X), clip=TRUE]
    result[[isim]] <- Y
  }
  result <- simulationresult(result, nsim, drop)
  return(result)
}

#'
#'    condSimCox.R
#'
#'    $Revision: 1.8 $ $Date: 2025/05/20 08:21:36 $
#'
#'    Conditional simulation for Cox models

CondSimCox <- function(object, nsim=1,
                       ..., win=NULL, window=win,
                       n.cond=NULL, w.cond=NULL,
                       giveup=1000, maxchunk=100,
                       saveLambda=FALSE, LambdaOnly=FALSE,
                       verbose=TRUE, drop=FALSE) {
  stopifnot(inherits(object, c("kppm", "clusterprocess", "zclustermodel")))

  #' argument used only for cluster processes
  saveparents <- isTRUE(list(...)$saveparents)
  
  if(is.null(window)) {
    if(!inherits(object, "kppm"))
      stop("Argument 'window' or 'win' is required", call.=FALSE)
    ## default to window of original data
    window <- Window(object)
  }
  w.sim <- as.owin(window)
  fullwindow <- is.null(w.cond)
  if(fullwindow) {
    w.cond <- w.sim
    w.free <- NULL
  } else {
    stopifnot(is.owin(w.cond))
    w.free <- setminus.owin(w.sim, w.cond)
  }

#  if(verbose) {
#    ## calculate order-of-magnitude approximate mean acceptance probability
#    EN <- integral(predict(object, locations=w.sim), domain=w.cond)
#    phat <- exp(n.cond * log(EN/n.cond) + n.cond - EN)
#    message("Rough estimate of mean acceptance probability:", signif(phat, 2))
#  }
  
  nremaining <- nsim
  ntried <- 0
  accept <- FALSE
  nchunk <- 1
  phistory <- mhistory <- numeric(0)
  results <- list()
  while(nremaining > 0) {
    ## increase chunk length
    nchunk <- min(maxchunk, giveup - ntried, 2 * nchunk)
    ## bite off next chunk of simulations
    lamlist <- simulate(object, window=w.sim, nsim=nchunk,
                        LambdaOnly=TRUE,
                        ..., drop=FALSE, verbose=FALSE)
    ## validate/recover
    if(!all(sapply(lamlist, is.im))) {
      if(all(sapply(lamlist, is.ppp))) {
        lamlist <- lapply(unname(lamlist), attr, which="Lambda", exact=TRUE)
        if(!all(sapply(lamlist, is.im)))
          stop("Internal error: intensity images were not saved", call.=FALSE)
      } else stop("Internal error: corrupted result from simulate method")
    }
    ## extract cluster parents if required
    if(saveparents) {
      parentlist <- lapply(lamlist, attr, which="parents")
      if(any(sapply(parentlist, is.null))) {
        warning("Internal error: cluster parents were not returned", call.=FALSE)
        saveparents <- FALSE
      } else {
        clusker <- clusterkernel(object)
      }
    }
    ## compute acceptance probabilities
    lamlist <- lapply(lamlist, "[", i=w.sim, drop=FALSE, tight=TRUE)
    if(fullwindow) {
      mu <- sapply(lamlist, integral)
    } else {
      mu <- sapply(lamlist, integral, domain=w.cond)
    }
    p <- exp(n.cond * log(mu/n.cond) + n.cond - mu)
    phistory <- c(phistory, p)
    mhistory <- c(mhistory, mu)
    ## accept/reject
    accept <- (runif(length(p)) < p)
    if(any(accept)) {
      jaccept <- which(accept)
      if(length(jaccept) > nremaining)
        jaccept <- jaccept[seq_len(nremaining)]
      naccepted <- length(jaccept)
      if(verbose)
        splat("Accepted the",
              commasep(ordinal(ntried + jaccept)),
              ngettext(naccepted, "proposal", "proposals"))
      nremaining <- nremaining - naccepted
      for(j in jaccept) {
        lamj <- lamlist[[j]]
        if(min(lamj) < 0)
          lamj <- eval.im(pmax(lamj, 0))
        if(LambdaOnly) {
          ## return only the intensity
          Y <- lamj
        } else {
          ## generate point pattern
          if(fullwindow) {
            Y <- rpoint(n.cond, lamj, win=w.sim, forcewin=TRUE)
          } else {
            lamj.cond <- lamj[w.cond, drop=FALSE, tight=TRUE]
            lamj.free <- lamj[w.free, drop=FALSE, tight=TRUE]
            Ycond <- rpoint(n.cond, lamj.cond, win=w.cond)
            Yfree <- rpoispp(lamj.free)
            Y <- superimpose(Ycond, Yfree, W=w.sim)
          }
          if(saveLambda) attr(Y, "Lambda") <- lamj
          if(saveparents) {
            genitori <- parentlist[[j]]
            attr(Y, "parents") <- genitori
            attr(Y, "parentid") <- assignParents(Y, genitori, clusker)
            attr(Y, "cost") <- npoints(genitori) + npoints(Y)
          }
        }
        results <- append(results, list(Y))
      }
    }
    ntried <- ntried + nchunk
    naccepted <- nsim - nremaining
    if(ntried >= giveup && nremaining > 0) {
      message(paste("Gave up after", ntried,
                    "proposals with", naccepted, "accepted"))
      message(paste("Average acceptance probability =",
                    signif(mean(phistory), 3)))
      break
    }
    
    if(verbose && ((ntried >= 30 && naccepted == 0) || ((pbar <- mean(phistory)) < 1e-3)))
      message(paste("Accepted", naccepted,
                    "of the first", ntried, "proposals;",
                    "average acceptance probability =",
                    signif(mean(phistory), 3)))
  }
  nresults <- length(results)
  results <- simulationresult(results, nresults, drop)
  attr(results, "history") <- data.frame(mu=mhistory, p=phistory)
  if(verbose && nresults == nsim)
    message(paste("Average acceptance probability", signif(mean(phistory), 3)))
  return(results)
}

assignParents <- function(offspring, parents, kernfun) {
  #' assign parents to offspring in Neyman-Scott Cox model
  dx <- outer(offspring$x, parents$x, "-")
  dy <- outer(offspring$y, parents$y, "-")
  #' offspring pdf value for each (offspring, parent) pair
  kerval <- matrix(0, nrow=nrow(dx), ncol=ncol(dx))
  kerval[] <- kernfun(as.numeric(dx), as.numeric(dy))
  #' probabilities of offspring are proportional to pdf values
  kersum <- rowSums(kerval)
  probs <- kerval/kersum
  if(all(ok <- is.finite(probs) & probs >= 0 & probs <= 1)) {
    #' select at random 
    parentmap <- apply(probs, 1, function(p) { sample.int(length(p), 1, prob=p) })
  } else {
    #' handle 0/0 etc, using l'Hopital's rule
    badrow <- matrowany(!ok)
    d2 <- dx^2 + dy^2
    parentmap <- integer(nrow(probs))
    parentmap[badrow] <- apply(d2[badrow, , drop=FALSE], 1, which.min)
    if(!all(badrow))
      parentmap[!badrow] <- apply(probs[!badrow, , drop=FALSE], 1,
                                  function(p) { sample.int(length(p), 1, prob=p) })
  }
  return(parentmap)
}

#
#   rknn.R
#
#   Distribution of distance to k-th nearest point in d dimensions
#   (Poisson process of intensity lambda)
#
#   $Revision: 1.2 $  $Date: 2009/12/31 01:33:44 $
#

dknn <- function(x, k=1, d=2, lambda=1) {
  validposint(k, "dknn")
  validposint(d, "dknn")
  alpha.d <- (2 * pi^(d/2))/(d * gamma(d/2.))
  y <- dgamma(x^d, shape=k, rate=lambda * alpha.d)
  y <- y * d * x^(d-1)
  return(y)
}

pknn <- function(q, k=1, d=2, lambda=1) {
  validposint(k, "pknn")
  validposint(d, "pknn")
  alpha.d <- (2 * pi^(d/2))/(d * gamma(d/2.))
  p <- pgamma(q^d, shape=k, rate=lambda * alpha.d)
  return(p)
}

qknn <- function(p, k=1, d=2, lambda=1) {
  validposint(k, "qknn")
  validposint(d, "qknn")
  alpha.d <- (2 * pi^(d/2))/(d * gamma(d/2.))
  y <- qgamma(p, shape=k, rate=lambda * alpha.d)
  z <- y^(1/d)
  return(z)
}

rknn <- function(n, k=1, d=2, lambda=1) {
  validposint(k, "rknn")
  validposint(d, "rknn")
  alpha.d <- (2 * pi^(d/2))/(d * gamma(d/2.))  
  y <- rgamma(n, shape=k, rate=lambda * alpha.d)
  x <- y^(1/d)
  return(x)
}

  

#'
#'    rthomas.R
#'
#'   $Revision: 1.15 $ $Date: 2025/05/20 08:21:20 $
#' 
#'   Simulation of modified Thomas cluster process
#'   using either naive algorithm or BKBC algorithm
#'
#'   rThomasHom    Interface to C code for stationary case (BKBC)
#'   rThomas       General case (naive or BKBC)
#'
#'   Copyright (C) Adrian Baddeley, Rolf Turner and Ya-Mei Chang 2000-2023
#'   Licence: GNU Public Licence >= 2

rThomasHom <-function(kappa, mu, sigma, W=unit.square(), ..., nsim=1, drop=TRUE,
                      inflate=NULL, saveparents=FALSE, maxinflate=10) {
  check.1.real(kappa) && check.finite(kappa, xname="kappa")
  check.1.real(mu) && check.finite(mu, xname="mu")
  check.1.real(sigma) && check.finite(sigma, xname="sigma")
  check.1.integer(nsim)
  stopifnot(kappa >= 0)
  stopifnot(mu >= 0)
  stopifnot(sigma > 0)
  if(!is.null(inflate)) {
    check.1.real(inflate) && check.finite(inflate, xname="inflate")
    stopifnot(inflate >= 1)
  }
  ## trivial cases
  if(nsim == 0) return(simulationresult(list()))
  if(kappa == 0 || mu == 0) {
    ## intensity is zero - patterns are empty
    empt <- ppp(window=W)
    if(saveparents) {
      attr(empt, "parents") <- list(x=numeric(0), y=numeric(0))
      attr(empt, "parentid") <- integer(0)
      attr(empt, "cost") <- 0
    }
    result <- rep(list(empt), nsim)
    return(simulationresult(result, nsim=nsim, drop=drop))
  }
  ## shift window to convenient origin
  oldW <- W
  oldcentre <- as.numeric(centroid.owin(Frame(oldW)))
  W <- shift(oldW, -oldcentre)
  ## enclose it in a disc
  rD <- with(vertices(Frame(W)), sqrt(max(x^2+y^2)))
  ## optimal inflation
  if(is.null(inflate)) {
    a <- if(mu == 0) 1 else (1 + (1-exp(-mu))/mu)
    b <- (rD^2)/(2*a*sigma^2)
    if(b <= 1) {
      inflate <- 1
    } else {
      delta <- 2 * sigma * sqrt(log(b)/2)
      inflate <- 1 + delta/rD
      inflate <- min(inflate, maxinflate)
    }
  }
  ## Prepare for C code
  storage.mode(kappa) <- "double"
  storage.mode(mu) <- "double"
  storage.mode(sigma) <- "double"
  storage.mode(rD) <- "double"
  storage.mode(inflate) <- "double"
  ##
  resultlist <- vector(mode="list", length=nsim)
  for(isim in 1:nsim) {
    ## call C code
    if(saveparents) {
      z <- .Call(SR_rthomasAll,
                 kappa, mu, sigma, rD, inflate,
                 PACKAGE="spatstat.random")
    } else {
      z <- .Call(SR_rthomasOff,
                 kappa, mu, sigma, rD, inflate,
                 PACKAGE="spatstat.random")
    }
    ## unpack
    xo <- z[[1]]
    yo <- z[[2]]
    if(saveparents) {
      xp <- z[[3]]
      yp <- z[[4]]
      parentid <- z[[5]]
    }
    ## shift back to original window
    xo <- xo + oldcentre[1L]
    yo <- yo + oldcentre[2L]
    if(saveparents) {
      xp <- xp + oldcentre[1L]
      yp <- yp + oldcentre[2L]
    }
    ## restrict to original window
    retain <- inside.owin(xo, yo, oldW)
    if(!all(retain)) {
      xo <- xo[retain]
      yo <- yo[retain]
      if(saveparents) {
        parentid <- parentid[retain]
        retainedparents <- sort(unique(parentid))
        parentid <- match(parentid, retainedparents)
        xp <- xp[retainedparents]
        yp <- yp[retainedparents]
      }
    }
    ## save as point pattern
    Y <- ppp(xo, yo, window=oldW, check=FALSE)
    if(saveparents) {
      attr(Y, "parents") <- list(x = xp, y = yp)
      attr(Y, "parentid") <- parentid
      attr(Y, "cost") <- length(xo) + length(xp)
    }
    resultlist[[isim]] <- Y
  }
  result <- simulationresult(resultlist, nsim, drop=drop)
  return(result)
}



rThomas <- local({

  ## random displacements
  gaus <- function(n, sigma) {
    matrix(rnorm(2 * n, mean=0, sd=sigma), ncol=2)
  }

  ## main function
  rThomas <-
    function(kappa, scale, mu, win = square(1),
             nsim=1, drop=TRUE,
             ...,
             n.cond=NULL, w.cond=NULL,
             algorithm=c("BKBC", "naive"),
             nonempty=TRUE, 
             poisthresh=1e-6,
             expand = 4*scale,
             saveparents=FALSE, saveLambda=FALSE,
             kappamax=NULL, mumax=NULL, LambdaOnly=FALSE, sigma) {
      ## modified Thomas process
      ## Poisson(mu) number of offspring
      ## at isotropic Normal(0,sigma^2) displacements from parent
      
      check.1.integer(nsim)
      stopifnot(nsim >= 0)
      if(nsim == 0) return(simulationresult(list()))

      ## Catch old scale syntax (sigma)
      if((missing(scale) || is.null(scale)) && !missing(sigma)) {
        ## message("Argument 'sigma' is deprecated; it has been replaced by 'scale'")
        scale <- sigma
      }
      check.1.real(scale)
      stopifnot(scale > 0)

      ## algorithm choices
      doLambda <- isTRUE(saveLambda) || isTRUE(LambdaOnly)
      conditioning <- !is.null(n.cond)
      if((conditioning || doLambda) && !isTRUE(spatstat.options("developer"))) {
        ## The naive algorithm must be used
        ## Change defaults
        algorithm <- if(missing(algorithm)) "naive" else match.arg(algorithm)
        nonempty  <- if(missing(nonempty)) FALSE else isTRUE(nonempty)
        ## Override given arguments with a warning
        reason <- if(conditioning) "for conditional simulation" else "for intensity calculation"
        algorithm <- warn.reset.arg(algorithm, "naive", reason)
        nonempty  <- warn.reset.arg(nonempty,  FALSE,   reason)
      } else {
        ## Any choice of algorithm is permitted
        algorithm <- match.arg(algorithm)
        nonempty <- isTRUE(nonempty)
      }
      
      ## conditional simulation
      if(conditioning) {
        mod <- clusterprocess("Thomas", mu=mu, kappa=kappa, scale=scale)
        result <- CondSimCox(mod, nsim=nsim, ...,
                             nonempty=nonempty, algorithm=algorithm,
                             win=win, n.cond=n.cond, w.cond=w.cond,
                             saveparents=saveparents,
                             saveLambda=saveLambda, LambdaOnly=LambdaOnly,
                             drop=drop)
        return(result)
      }

      ## ------- Unconditional simulation ------------------

      ## determine the effective maximum radius of clusters
      ## (for the naive algorithm, or when kappa is not constant)
      if(missing(expand))
          expand <- clusterradius("Thomas", scale = scale, ...)

      #' validate 'kappa' and 'mu'
      km <- validate.kappa.mu(kappa, mu, kappamax, mumax,
                              win, expand, ...,
                              context="In rThomas")
      kappamax <- km[["kappamax"]]
      mumax    <- km[["mumax"]]

      ## detect trivial case where patterns are empty
      if(kappamax == 0 || mumax == 0) {
        result <- emptyNeyScot(win, nsim,
                               saveLambda, saveparents, LambdaOnly, ...)
        return(simulationresult(result, nsim=nsim, drop=drop))
      }

      #' determine algorithm
      do.parents <- saveparents || doLambda || !is.numeric(kappa)
      do.hybrid <- (algorithm == "BKBC") && nonempty 

      if(do.hybrid) {
        ## ........ Fast algorithm (BKBC) .................................
        ## run BKBC algorithm for stationary model
        result <- rThomasHom(kappamax, mumax, sigma=scale,
                             W=win, ..., nsim=nsim, drop=FALSE,
                             saveparents=do.parents)

        ## thin 
        if(!is.numeric(kappa))
          result <- solapply(result, thinParents,
                             P=kappa, Pmax=kappamax)

        if(!is.numeric(mu)) 
          result <- solapply(result, rthin,
                             P=mu, Pmax=mumax,
                             na.zero=TRUE, fatal=FALSE)
      } else {
        ## .......... Slower algorithm ('naive') ..........................
        ## trap case of large clusters, close to Poisson
        if(is.numeric(kappa) && 1/(4*pi * kappa * scale^2) < poisthresh) {
          if(is.function(mu)) mu <- as.im(mu, W=win, ...)
          kapmu <- kappa * mu
          result <- rpoispp(kapmu, win=win, nsim=nsim, drop=drop, warnwin=FALSE)
          result <- fakeNeyScot(result, kapmu, win,
                                saveLambda, saveparents, LambdaOnly)
          return(result)
        }

        result <- rNeymanScott(kappa=kappa,
                               expand=expand,
                               rcluster=list(mu, gaus),
                               win=win,
                               sigma=scale, # formal argument of 'gaus'
                               nsim=nsim, drop=FALSE,
                               nonempty=nonempty,
                               saveparents = do.parents,
                               kappamax=kappamax, mumax=mumax)
      }
      
      if(doLambda){
        BW <- Frame(win)
        for(i in 1:nsim) {
          parents <- attr(result[[i]], "parents")
          BX <- boundingbox(BW, bounding.box.xy(parents))
          parents <- as.ppp(parents, W=BX, check=FALSE)
          Lambda <- clusterfield("Thomas", parents, scale=scale, mu=mu, ...)
          Lambda <- Lambda[win, drop=FALSE]
          if(LambdaOnly) {
            #' save only the intensity
            result[[i]] <- Lambda
            if(saveparents) attr(result[[i]], "parents") <- parents
          } else {
            #' usual case - save intensity as attribute
            attr(result[[i]], "Lambda") <- Lambda
          }
        }
      }
      return(simulationresult(result, nsim, drop))
    }

  rThomas
})

## clusterfunctions.R
##
## Contains the generic functions:
##  - clusterkernel
##  - clusterfield
##  - clusterradius.
##
##   $Revision: 1.13 $  $Date: 2023/06/09 05:13:54 $
##

clusterkernel <- function(model, ...) {
  UseMethod("clusterkernel")
}
clusterkernel.character <- function(model, ...){
  info <- spatstatClusterModelInfo(model, onlyPCP = TRUE)
  internalkernel <- info$kernel
  dots <- list(...)
  par <- c(kappa = 1, scale = dots$scale)
  par <- info$checkpar(par, native = TRUE)
  nam <- info$shapenames
  margs <- NULL
  if(!is.null(nam))
    margs <- dots[nam]
  f <- function(x, y = 0, ...){
    internalkernel(par = par, rvals = sqrt(x^2+y^2), margs = margs)
  }
  return(f)
}

## The method clusterkernel.kppm is in spatstat.model

clusterfield <- function(model, locations = NULL, ...) {
    UseMethod("clusterfield")
}

clusterfield.character <- function(model, locations = NULL, ...){
    f <- clusterkernel(model, ...)
    clusterfield.function(f, locations, ...)
}

clusterfield.function <- function(model, locations = NULL, ..., mu = NULL) {
  if(is.null(locations)){
    locations <- ppp(.5, .5, window=square(1))
  } else if(!is.ppp(locations))
    stop("Argument ", sQuote("locations"), " must be a point pattern (ppp).")

  if("sigma" %in% names(list(...)) && "sigma" %in% names(formals(model)))
    warning("Currently ", sQuote("sigma"),
            "cannot be passed as an extra argument to the kernel function. ",
            "Please redefine the kernel function to use another argument name.")

  if(requireNamespace("spatstat.explore")) {
    rslt <- spatstat.explore::density.ppp(locations, kernel=model, ..., edge=FALSE)
  } else {
    message("The package spatstat.explore is required.")
    return(NULL)
  }
  
  if(is.null(mu))
    return(rslt)
  
  mu <- as.im(mu, W=rslt)
  if(min(mu)<0)
    stop("Cluster reference intensity ", sQuote("mu"), " is negative.")

  return(rslt*mu)
}


## The method clusterfield.kppm is in spatstat.model

clusterradius <- function(model, ...){
    UseMethod("clusterradius")
}

clusterradius.character <- function(model, ..., thresh = NULL, precision = FALSE){
  info <- spatstatClusterModelInfo(model, onlyPCP=FALSE)
  if(!isTRUE(info$isPCP)) {
    warning("cluster radius is only defined for cluster processes", call.=FALSE)
    return(NA)
  }
  rmax <- info$range(..., thresh = thresh)
  if(precision && is.function(info$ddist)){
    ddist <- function(r) info$ddist(r, ...)
    prec <- integrate(ddist, 0, rmax)
    attr(rmax, "prec") <- prec
  }
  return(rmax)
}

## The method clusterradius.kppm is in spatstat.model

#'
#'     clustersiminfo.R
#'
#'   Copyright (C) Adrian Baddeley and Ya-Mei Chang 2022-2023
#'   GNU Public Licence >= 2
#'
#' -----------------------------------------------------------------
#' 
#'  Table of additional information for cluster models
#'  for use in Brix-Kendall and Baddeley-Chang simulation algorithms
#'
#'  The simulation algorithm rclusterBKBC uses this information
#'  provided there is an entry in this table for the desired model,
#'  and provided use.special=TRUE. Otherwise it uses a generic algorithm.
#'
#' -------------------------------------------------------------------
#'
#'  D = bounding disc
#'  rD = radius of D (numeric > 0)
#'  r = distance from parent point to centre of disc (numeric vector)
#'  mod = list containing all model parameters:
#'        $par = original (native) parameters of cluster model e.g. (kappa, sigma2) 
#'        $mu = mean number of offspring per parent in stationary process
#'        $margs = list of shape parameters
#' 
#'  Entries:
#'
#' (A) cluster model
#'
#'     roffspring = function(n, mod)
#'          generate x, y coordinates of n offspring of parent at origin
#'
#' (B) Brix-Kendall dominating process
#'
#'     hdom = function(r, mod, rD)
#'          Value inside D of the dominating offspring density, for a parent at distance r from centre of D
#' 
#'     Eplus = function(r, mod, rD)
#'          Integral over D of dominating kernel, for a parent at distance r from centre of D
#'          Eplus(r) = pi * rD^2 * mu * hdom(r)
#' 
#'     rhoplus = function(r, mod, rD)
#'          Intensity of Brix-Kendall dominating parent process, given distance to origin
#'          rhoplus(r) = kappa * (1 - exp(-Eplus(r)))
#' 
#'     Mplus = function(r, mod, rD, ...)
#'          Radial cumulative integral of intensity of Brix-Kendall dominating intensity
#'          Mplus(r) = \int_0^r 2 pi t rhoplus(t) dt
#' 
#'     MplusInf = function(mod, rD)
#'          Total integral Mplus(infty)
#'          Expected total number of parents  in the dominating process
#'
#'     invMplus = function(v, mod, rD, Minfty)
#'          Inverse function of Mplus (IF KNOWN)
#'
#' (C) Baddeley-Chang super-dominating process
#' 
#'     rhoplusplus = function(r, mod, rD)
#'          Intensity of superdominating process
#'          rhoplusplus(r) = kappa * Eplus(r)
#' 
#'     Mplusplus = function(r, mod, rD, ...)
#'          Radial cumulative integral of superdominating intensity
#'          Mplusplus(r) = \int_0^r 2 pi t rhoplusplus(t) dt
#'                       = kappa \int_0^r 2 pi t Eplus(t) dt
#' 
#'     MplusplusInf = function(mod, rD)
#'          Total integral Mplusplus(infty)
#'          Expected total number of parents in the superdominating process
#' 
#'     invMplusplus = function(v, mod, rD, Minfty)
#'          Inverse function of Mplusplus (IF KNOWN)
#'
#'     inflate = function(mod, rD)
#'          Rule for determining optimal inflated radius rE
#'          according to Baddeley and Chang (2023) section 6.6


#' >>>>>>>>>>>>>>>>   THOMAS PROCESS   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

.Thomas.roffspring <- function(n, mod) {
  sigma <- sqrt(mod$par[["sigma2"]])
  list(x=rnorm(n, sd=sigma), y=rnorm(n, sd=sigma))
}

.Thomas.hdom <- function(r, mod, rD) {
  inv2sig2 <- 1/(2 * mod$par[["sigma2"]])
  B <- inv2sig2/pi
  z <- numeric(length(r))
  above <- (r > rD)
  z[!above] <- B
  z[above]  <- B * exp(- inv2sig2 * (r[above] - rD)^2)
  return(z)
}
  
.Thomas.Eplus <- function(r, mod, rD) {
  mu <- mod$mu
  inv2sig2 <- 1/(2 * mod$par[["sigma2"]])
  A <- mu * rD^2 * inv2sig2
  z <- numeric(length(r))
  above <- (r > rD)
  z[!above] <- A
  z[above]  <- A * exp(- inv2sig2 * (r[above]-rD)^2)
  return(z)
}

.Thomas.rhoplus <- function(r, mod, rD) {
  kappa <- mod$par[["kappa"]]
  z <- numeric(length(r))
  above <- (r > rD)
  z[!above] <- kappa * (1 - exp(-.Thomas.Eplus(0,        mod, rD)))
  z[above]  <- kappa * (1 - exp(-.Thomas.Eplus(r[above], mod, rD)))
  return(z)
}

.Thomas.MplusIntegrand <- function(r, mod, rD) {
  2 * pi * r * .Thomas.rhoplus(r, mod, rD)
}

.Thomas.Mplus <- function(r, mod, rD, ..., method="q") {
  ## integrand is linear on [0, rD]
  z <- pi * pmin(r, rD)^2 * .Thomas.rhoplus(0, mod, rD)
  high <- (r > rD)
  if(any(high)) 
    z[high] <- z[high] + indefinteg(.Thomas.MplusIntegrand,
                                    r[high],
                                    lower=rD,
                                    mod=mod, rD=rD, method=method)
  return(z)
}

.Thomas.MplusInf <- function(mod, rD) { .Thomas.Mplus(Inf, mod, rD) }

## inverse function requires numerical root-finding

.Thomas.rhoplusplus <- function(r, mod, rD) {
  mod$par[["kappa"]] * .Thomas.Eplus(r, mod, rD)
}

.Thomas.Mplusplus <- function(r, mod, rD, ...) {
  mu <- mod$mu
  kappa <- mod$par[["kappa"]]
  sigma2 <- mod$par[["sigma2"]]
  inv2sig2 <- 1/(2 * sigma2)
  z <- pi * pmin(r, rD)^2
  high <- (r > rD)
  z[high] <- z[high] +
    2 * pi * sigma2 * (1 - exp(-inv2sig2 * (r[high]-rD)^2)) +
    2 * pi * rD * sqrt(2 * pi * sigma2) * (
      pnorm(r[high]-rD, sd=sqrt(sigma2)) - 1/2
    )
  z <- kappa * mu * rD^2 * inv2sig2 * z
  return(z)
}

.Thomas.MplusplusInf <- function(mod, rD) {
  mu <- mod$mu
  kappa <- mod$par[["kappa"]]
  sigma2 <- mod$par[["sigma2"]]
  inv2sig2 <- 1/(2 * sigma2)
  kappa * mu * pi * rD^2 * (
    rD^2 * inv2sig2 +
    1 +
    rD * sqrt(2 * pi * sigma2) * inv2sig2
  )
}

## inverse function requires numerical root-finding

.Thomas.inflate <- function(mod, rD) {
  mu <- mod$mu
  sigma2 <- mod$par[["sigma2"]]
  a <- if(mu == 0) 1 else (1 + (1-exp(-mu))/mu)
  b <- (rD^2)/(2*a*sigma2)
  if(b <= 1) return(rD)
  delta <- 2 * sqrt(sigma2) * sqrt(log(b)/2)
  return(rD + delta)
}
  
#' >>>>>>>>>>>>>>>>   MATERN CLUSTER PROCESS   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

.MatClust.roffspring <- function(n, mod) {
  R <- mod$par[["R"]]
  rad <- R * sqrt(runif(n))
  theta <- runif(n, max=2*pi)
  list(x = rad * cos(theta), y = rad * sin(theta))
}

.MatClust.hdom <- function(r, mod, rD) {
  R <- mod$par[["R"]]
  (r - rD < R)/(pi * R^2)
}
  
.MatClust.Eplus <- function(r, mod, rD) {
  R <- mod$par[["R"]]
  mu <- mod$mu
  mu * (r - rD < R) * (rD/R)^2
}

.MatClust.rhoplus <- function(r, mod, rD) {
  mod$par[["kappa"]] * (1 - exp(-.MatClust.Eplus(r, mod, rD)))
}

.MatClust.Mplus <- function(r, mod, rD, ...) {
  R <- mod$par[["R"]]
  kappa <- mod$par[["kappa"]]
  mu <- mod$mu
  pi * pmin(r, R+rD)^2 * kappa * ( 1 - exp(-mu * (rD/R)^2))
}

.MatClust.MplusInf <- function(mod, rD) {
  R <- mod$par[["R"]]
  kappa <- mod$par[["kappa"]]
  mu <- mod$mu
  pi * (R+rD)^2 * kappa * ( 1 - exp(-mu * (rD/R)^2))
}

.MatClust.inverseMplus <- function(v, mod, rD, Minfty) {
  R <- mod$par[["R"]]
  kappa <- mod$par[["kappa"]]
  mu <- mod$mu
  B <- pi * kappa * (1 - exp(- mu * rD^2/R^2))
  sqrt(v/B)
}

.MatClust.rhoplusplus <- function(r, mod, rD) {
  R <- mod$par[["R"]]
  kappa <- mod$par[["kappa"]]
  mu <- mod$mu
  kappa * mu * (r < (R+rD)) * (rD/R)^2
}

.MatClust.Mplusplus <- function(r, mod, rD, ...) {
  R <- mod$par[["R"]]
  kappa <- mod$par[["kappa"]]
  mu <- mod$mu
  kappa * mu * pi * (pmin(r, R+rD) * rD/R)^2
}

.MatClust.MplusplusInf <- function(mod, rD) {
  R <- mod$par[["R"]]
  kappa <- mod$par[["kappa"]]
  mu <- mod$mu
  kappa * mu * pi * ((R+rD) * rD/R)^2
}

.MatClust.inverseMplusplus <- function(v, mod, rD, Minfty) {
  R <- mod$par[["R"]]
  kappa <- mod$par[["kappa"]]
  mu <- mod$mu
  (R/rD) * sqrt(v/(pi * kappa * mu))
}

.MatClust.inflate <- function(mod, rD) {
  R <- mod$par[["R"]]
  rE <- if(R < rD) (rD + R) else rD
  return(rE)
}
  
  
#' >>>>>>>>>>>>>>>>   CAUCHY CLUSTER PROCESS   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

#' idiosyncratic parameter eta2 = 4 * scale^2
#'  scale <-  sqrt(mod$par[["eta2"]])/2

.Cauchy.roffspring <- function(n, mod) {
  rate <- mod$par[["eta2"]]/8 
  b <- 1/sqrt(rgamma(n, shape=1/2, rate=rate))
  list(x = b * rnorm(n), y = b * rnorm(n))
}

.Cauchy.hdom <- function(r, mod, rD) {
  scale2 <-  mod$par[["eta2"]]/4
  z <- numeric(length(r))
  above <- (r > rD)
  z[!above] <- 1/(2*pi*scale2)
  z[above]  <- (1/(2*pi*scale2)) * (1 + ((r[above]-rD)^2)/scale2)^(-3/2)
  return(z)
}
  
.Cauchy.Eplus <- function(r, mod, rD) {
  scale2 <-  mod$par[["eta2"]]/4
  mu <- mod$mu
  z <- numeric(length(r))
  above <- (r > rD)
  A <- mu * (rD^2/(2*scale2))
  z[!above] <- A
  z[above]  <- A * (1 + ((r[above]-rD)^2)/scale2)^(-3/2)
  return(z)
}

.Cauchy.rhoplus <- function(r, mod, rD) {
  kappa <- mod$par[["kappa"]]
  z <- numeric(length(r))
  above <- (r > rD)
  z[!above] <- kappa * (1 - exp(-.Cauchy.Eplus(0, mod, rD)))
  z[above]  <- kappa * (1 - exp(-.Cauchy.Eplus(r[above], mod, rD)))
  return(z)
}

.Cauchy.MplusIntegrand <- function(r, mod, rD) {
  2 * pi * r * .Cauchy.rhoplus(r, mod, rD)
}

.Cauchy.Mplus <- function(r, mod, rD, ..., method="q") {
  ## integrand is linear on [0, rD]
  z <- pi * pmin(r, rD)^2 * .Cauchy.rhoplus(0, mod, rD)
  high <- (r > rD)
  if(any(high))
    z[high] <- z[high] + indefinteg(.Cauchy.MplusIntegrand,
                                    r[high],
                                    lower=rD,
                                    mod=mod, rD=rD, method=method)
  return(z)
}

.Cauchy.MplusInf <- function(mod, rD) { .Cauchy.Mplus(Inf, mod, rD) }

.Cauchy.rhoplusplus <- function(r, mod, rD) {
  mod$par[["kappa"]] * .Cauchy.Eplus(r, mod, rD)
}

.Cauchy.Mplusplus <- function(r, mod, rD, ...) {
  mu <- mod$mu
  kappa <- mod$par[["kappa"]]
  lambda <- kappa * mu
  scale2 <-  mod$par[["eta2"]]/4
  distD <- pmax(0, r - rD)
  lambda * pi * rD^2 * ifelse(r <= rD,
                              r^2/(2*scale2),
                              rD^2/(2*scale2) + 1 + (rD * distD/scale2 - 1)/sqrt(1+distD^2/scale2))
}

.Cauchy.MplusplusInf <- function(mod, rD) {
  mu <- mod$mu
  kappa <- mod$par[["kappa"]]
  lambda <- kappa * mu
  scale2 <-  mod$par[["eta2"]]/4
  rdons2 <- rD^2/scale2
  lambda * pi * rD^2 * (1 + sqrt(rdons2) + rdons2/2)
}

.Cauchy.inflate <- function(mod, rD) {
  mu <- mod$mu
  scale2 <- mod$par[["eta2"]]/4
  a <- if(mu == 0) 1 else (1 + (1-exp(-mu))/mu)
  b <- (rD^2)/(2*a*scale2)
  if(b <= 1) return(rD)
  delta <- sqrt(scale2) * (b^(2/3) - 1)
  return(rD + delta)
}
  


#' ........................................................................

.spatstat.clustersim.InfoTable <- list(
  Thomas = list(
    iscompact    = FALSE,
    roffspring   = .Thomas.roffspring,
    hdom         = .Thomas.hdom,
    Eplus        = .Thomas.Eplus,
    rhoplus      = .Thomas.rhoplus,
    Mplus        = .Thomas.Mplus,
    MplusInf     = .Thomas.MplusInf,
    invMplus     = NULL,
    rhoplusplus  = .Thomas.rhoplusplus,
    Mplusplus    = .Thomas.Mplusplus,
    MplusplusInf = .Thomas.MplusplusInf,
    invMplusplus = NULL,
    inflate      = .Thomas.inflate
  ),
  MatClust = list(
    iscompact    = TRUE,
    roffspring   = .MatClust.roffspring,
    hdom         = .MatClust.hdom,
    Eplus        = .MatClust.Eplus,
    rhoplus      = .MatClust.rhoplus,
    Mplus        = .MatClust.Mplus,
    MplusInf     = .MatClust.MplusInf,
    invMplus     = .MatClust.inverseMplus,
    rhoplusplus  = .MatClust.rhoplusplus,
    Mplusplus    = .MatClust.Mplusplus,
    MplusplusInf = .MatClust.MplusplusInf,
    invMplusplus = .MatClust.inverseMplusplus,
    inflate      = .MatClust.inflate
  ),
  Cauchy = list(
    iscompact    = FALSE,
    roffspring   = .Cauchy.roffspring,
    hdom         = .Cauchy.hdom,
    Eplus        = .Cauchy.Eplus,
    rhoplus      = .Cauchy.rhoplus,
    Mplus        = .Cauchy.Mplus,
    MplusInf     = .Cauchy.MplusInf,
    invMplus     = NULL,
    rhoplusplus  = .Cauchy.rhoplusplus,
    Mplusplus    = .Cauchy.Mplusplus,
    MplusplusInf = .Cauchy.MplusplusInf,
    invMplusplus = NULL,
    inflate      = .Cauchy.inflate
  )
)

spatstatClusterSimModelMatch <- function(name, verbose=TRUE) {
  if(!is.character(name) || length(name) != 1)
    stop("Argument must be a single character string", call.=FALSE)
  TheTable <- .spatstat.clustersim.InfoTable
  nama2 <- names(TheTable)
  mat <- pmatch(name, nama2)
  if(!is.null(mat))
    return(nama2[mat])
  if(verbose)
    warning(sQuote(name), "is not supported;",
            "available options are", commasep(sQuote(nama2)))
  return(NULL)
}

spatstatClusterSimInfo <- function(name) {
  known <- spatstatClusterSimModelMatch(name, FALSE)
  if(is.null(known)) return(NULL)
  return(.spatstat.clustersim.InfoTable[[known]])
}
  

#'
#'   indefinteg.R
#'
#'   Indefinite integral
#'
#'   $Revision: 1.8 $ $Date: 2022/02/12 02:56:33 $

indefinteg <- function (f, x, ...,
                        method=c("trapezoid", "quadrature"),
                        lower=min(x), nfine=8192) {
  method <- match.arg(method)
  if(length(x) == 0) return(numeric(0))
  adjust <- !missing(lower)
  if(method == "trapezoid" && (any(is.infinite(x)) ||
                               (adjust && is.infinite(lower)) ||
                               (diff(ra <- range(x)) < sqrt(.Machine$double.eps)))) {
    method <- "quadrature"
  }
  switch(method,
         trapezoid = {
           ## indefinite integral using trapezoidal rule
           ## Determine range for numerical calculation
           if(adjust) {
             check.1.real(lower)
             raplus <- ra + c(-1,1) * diff(ra)/2
             included <- inside.range(lower, raplus)
             if(included) ra <- range(ra, lower)
           }
           ## Make a fine sequence of x values
           xfine <- seq(ra[1L], ra[2L], length.out=nfine)
           delta <- diff(ra)/(nfine - 1)
           ## Evaluate integrand on finer sequence
           yfine <- f(xfine, ...) 
           ## Apply trapezoidal rule
           zfine <- c(0, cumsum(delta * (yfine[-1L] + yfine[-nfine]))/2)
           ## Evaluate at 'x'
           Intf <- approxfun(xfine, zfine, rule=2)
           z <- Intf(x)
           ## Adjust for different lower limit
           if(adjust) {
             ## calculate indefinite integral from 'lower' to min(xfine)
             x0 <- ra[1L]
             deltaI <- if(included) {
                         Intf(x0) - Intf(lower)
                       } else {
                         integrate(f, lower=lower, upper=x0, ...)$value
                       }
             ## adjust
             z <- z + deltaI
           }
         },
         quadrature = {
           ## indefinite integral using 'integrate' at each value
           n <- length(x)
           z <- numeric(n)
           for(i in 1:n)
             z[i] <- integrate(f, lower=lower, upper=x[i], ...)$value
         })
  return(z)
}

#'   simulation of product shot-noise Cox process
#'   Original: (c) Abdollah Jalilian 2021
#'   Adapted to spatstat by Adrian Baddeley
#'   $Revision: 1.6 $ $Date: 2022/04/06 07:29:33 $

rPSNCP <- local({
  
  ## ===================================================================
  ## kernel functions
  ## ===================================================================
  
  bkernels <- list(
    ## Gaussian kernel with bandwidth omega
    Thomas = function(r, omega, ...){ 
      exp(- r^2/(2 * omega^2)) / (2 * pi * omega^2)
    },
    ## Variance-Gamma (Bessel) kernel
    ## with bandwidth omega and shape parameter nu.ker
    VarGamma = function(r, omega, nu.ker){
      stopifnot(nu.ker > -1/2)
      sigma2 <- 1 / (4 * pi * nu.ker * omega^2)
      u <- r/omega
      u <- ifelse(u > 0,
      (u^nu.ker) * besselK(u, nu.ker) / (2^(nu.ker - 1) * gamma(nu.ker)),
      1)
      return(abs(sigma2 * u))
    },
    ## Cauchy kernel with bandwith omega
    Cauchy = function(r, omega, ...){
      ((1 + (r / omega)^2)^(-1.5)) / (2 * pi * omega^2)
    }
    ## end of 'bkernels' list
    )
  
  ## ===================================================================
  ## simulating from the product shot-noise Cox processes
  ## ===================================================================

  ## simulation from the null model of independent shot-noise components
  rPSNCP0 <- function(lambda, kappa, omega, kernels=NULL, nu.ker=NULL, 
                      win=owin(), nsim=1, drop=TRUE,
                      ...,
                      cnames=NULL, 
                      epsth=0.001
                      # , mc.cores=1L
                      ) {
    check.1.integer(nsim)
    stopifnot(nsim >= 0)
    if(nsim == 0) return(simulationresult(list()))
    m <- length(lambda)
    if(m == 0) stop("No lambda values supplied")
    if ((length(kappa) != m) || length(omega) != m ) 
      stop("arguments kappa and omega must have the same length as lambda")
    if (is.null(kernels))
      kernels <- rep("Thomas", m)
    else if(length(kernels) != m)
      stop("length of argument 'kernels' must equal the number of components")
    if(is.null(nu.ker))
      nu.ker <- rep(-1/4, m)
    lambda <- as.list(lambda)
    if (is.null(cnames))
      cnames <- 1:m
  ## simulation from the null model of independent shot-noise components
    corefun0 <- function(dumm) {
      xp <- yp <- numeric(0)
      mp <- integer(0)
      for (i in 1:m) {
        mui <- lambda[[i]]/kappa[i]
        Xi <- switch(kernels[i], 
                     Thomas   = rThomas(kappa[i], scale=omega[i],
                                        mu=mui, win=win,
                                        ...),
                     Cauchy   =  rCauchy(kappa[i], scale=omega[i],
                                         mu=mui, win=win,
                                         thresh=epsth,
                                         ...),
                     VarGamma = rVarGamma(kappa[i], scale=omega[i],
                                          mu=mui, win=win,
                                          nu.ker=nu.ker[i], nu.pcf=NULL,
                                          thresh=epsth,
                                          ...))
        xp <- c(xp, Xi$x)
        yp <- c(yp, Xi$y)
        mp <- c(mp, rep.int(i, Xi$n))
      }
      mp <- factor(mp, labels=cnames)
      out <- ppp(xp, yp, window=win, marks=mp, check=FALSE)
      return(out)
    }
    ## outlist <- if (mc.cores == 1) lapply(1:nsim, corefun0) 
    ## else parallel::mclapply(1:nsim, corefun0, mc.cores=mc.cores)
    outlist <- lapply(seq_len(nsim), corefun0)
    outlist <- simulationresult(outlist, nsim, drop)
    return(outlist)
  }
  
  # ===================================================================
  # simulation from the model
  rPSNCP <- function(lambda=rep(100, 4), kappa=rep(25, 4), omega=rep(0.03, 4), 
                     alpha=matrix(runif(16, -1, 3), nrow=4, ncol=4), 
                     kernels=NULL, nu.ker=NULL, win=owin(),
                     nsim=1, drop=TRUE, 
                     ...,
                     cnames=NULL, epsth=0.001
                                        # , mc.cores=1L
                     ) {
    m <- length(lambda)
    if(m == 0) stop("No lambda values supplied")
    if ((length(kappa) != m) || length(omega) != m ) 
      stop("Arguments kappa and omega must have the same length as lambda")
    if (!all(dim(alpha) == c(m, m)))
      stop("Dimensions of matrix alpha are not correct")
    if (is.null(kernels))
      kernels <- rep("Thomas", m)
    else if(length(kernels) != m)
      stop("Length of argument kernels must equal the number of components")
    if (is.null(nu.ker))
      nu.ker <- rep(-1/4, m)
    diag(alpha) <- 0
    if(all(alpha == 0))
      return(rPSNCP0(lambda=lambda, kappa=kappa, omega=omega, kernels=kernels, 
                     nu.ker=nu.ker, win=win, nsim=nsim, cnames=cnames, 
                     ..., 
                     epsth=epsth
                                        # , mc.cores=mc.cores
                     ))
    
    lambda <- as.list(lambda)
    frame <- boundingbox(win)
    dframe <- diameter(frame)
    W <- as.mask(win, ...)
    Wdim <- dim(W)
    wx <- as.vector(raster.x(W))
    wy <- as.vector(raster.y(W))
    
    sigma <- rmax <- numeric(m)
    for (i in 1:m) {
      if(is.im(lambda[[i]])) 
        lambda[[i]] <- as.im(lambda[[i]], dimyx=Wdim, W=W)
      keri <- function(r){ bkernels[[kernels[i]]](r, omega[i], nu.ker[i]) }
      keri0 <- keri(0)
      sigma[i] <- kappa[i] / keri0
      kerithresh <- function(r){ keri(r) / keri0 - epsth}
      rmax[i] <- uniroot(kerithresh, lower = omega[i] / 2, 
                         upper = 5 * dframe)$root # 4 * omega[i] #
    }
    dilated <- grow.rectangle(frame, max(rmax))
    
    corefun <- function(idumm)
    {
      Phi <- lapply(kappa, rpoispp, win=dilated)
      fr <- vector("list", length=m)
      for (i in 1:m) {
        keri <- function(r){ bkernels[[kernels[i]]](r, omega[i], nu.ker[i]) }
        keri0 <- keri(0)
        Phii <- Phi[[i]]
        fr[[i]] <- keri(crossdist.default(wx, wy, Phii$x, Phii$y)) / keri0
      }
      
      if (is.null(cnames))
        cnames <- 1:m
      xp <- yp <- numeric(0)
      mp <- integer(0)
      for (i in 1:m) {
        Si <- rowSums(fr[[i]])  / sigma[i]
        E <- matrix(1, nrow=length(wx), ncol=m)
        for (j in (1:m)[-i]) {
          E[, j] <- apply(1 + alpha[j, i] * fr[[j]], 1, prod) * exp(-alpha[j, i] * sigma[j])
        }
        values <-  Si * apply(E, 1, prod)
        Lam <- im(values, xcol=W$xcol, yrow=W$yrow, unitname = unitname(W))
        rhoi <- lambda[[i]]
        Xi <- rpoispp(rhoi * Lam)
        xp <- c(xp, Xi$x)
        yp <- c(yp, Xi$y)
        mp <- c(mp, rep.int(i, Xi$n))
      }
      mp <- factor(mp, labels=cnames)
      simout <- ppp(xp, yp, window=win, marks=mp, check=FALSE)
      # attr(simout, "parents") <- Phi
      return(simout)
    }
    ## outlist <- if (mc.cores == 1) lapply(1:nsim, corefun) 
    ## else parallel::mclapply(1:nsim, corefun, mc.cores=mc.cores)
    outlist <- lapply(seq_len(nsim), corefun)
    outlist <- simulationresult(outlist, nsim, drop)
    return(outlist)
  }
  
  rPSNCP
})

#'
#'   rLGCP.R
#'
#'   simulation of log-Gaussian Cox process
#'
#'  original code by Abdollah Jalilian
#'
#'  modifications by Adrian Baddeley, Ege Rubak and Tilman Davies
#' 
#'  $Revision: 1.37 $    $Date: 2025/04/19 03:41:26 $
#'

rLGCP <- local({

  rLGCP <- function(model=c("exponential", "gauss", "stable",
                            "gencauchy", "matern"),
                    mu = 0, param = NULL, ...,
                    win=NULL, saveLambda=TRUE, nsim=1, drop=TRUE,
                    n.cond=NULL, w.cond=NULL) {
    ## validate
    model <- match.arg(model)
    if (is.numeric(mu)) {
      check.1.real(mu, paste("if", sQuote("mu"), "is numeric,"))
    } else if(!is.function(mu) && !is.im(mu))
      stop(paste(sQuote("mu"), "must be a constant, a function or an image"))
    check.1.integer(nsim)
    stopifnot(nsim >= 0)
    ## check for outdated usage
    if(!all(nzchar(names(param))))
      stop("Outdated syntax of argument 'param' to rLGCP", call.=FALSE)
    ##
    do.call(dispatch.rLGCP,
            append(list(model=model,
                        mu=mu,
                        win=win,
                        saveLambda=saveLambda,
                        nsim=nsim,
                        drop=drop,
                        n.cond=n.cond),
                   resolve.defaults(list(...), param)))
  }

  dispatch.rLGCP <- function(..., n.cond=NULL, w.cond=NULL) {
    if(is.null(n.cond)) {
      do.rLGCP(...)
    } else {
      do.cond.rLGCP(..., n.cond=n.cond, w.cond=w.cond)
    }
  }
  
  do.rLGCP <- function(model=c("exponential", "gauss", "stable",
                            "gencauchy", "matern"),
                       mu = 0, ...,
                       win=NULL, saveLambda=TRUE,
                       LambdaOnly=FALSE, Lambdaonly=FALSE,
                       nsim=1, drop=TRUE,
                       n.cond=NULL) {

    ## empty list
    if(nsim == 0) return(simulationresult(list()))
    
    model <- match.arg(model)

    LambdaOnly <- LambdaOnly || Lambdaonly  # old spelling

    ## simulation window
    win.given <- !is.null(win)
    mu.image <- is.im(mu)
    win <- if(win.given) as.owin(win) else if(mu.image) as.owin(mu) else owin()

    if(win.given && mu.image && !is.subset.owin(win, as.owin(mu)))
      stop(paste("The spatial domain of the pixel image", sQuote("mu"),
                 "does not cover the simulation window", sQuote("win")))
    
    ## get shape parameters
    needed <- switch(model,
                     exponential = ,
                     gauss       = character(0),
                     stable      = "alpha",
                     gencauchy   = c("alpha", "beta"),
                     matern      = "nu")
    if(length(needed)) {
      stuff <- list(...)
      missed <- is.na(match(needed, names(stuff)))
      if(any(missed)) {
        nbad <- sum(missed)
        stop(paste(ngettext(nbad, "Parameter", "Parameters"),
                   commasep(sQuote(needed[missed])),
                   ngettext(nbad, "is", "are"), "required"),
             call.=FALSE)
      }
    }

    ## generate Gaussian Random Field
    Zlist <- switch(model,
                    exponential = {
                      rGRFexpo(W=win, mu=mu, 
                               ..., nsim=nsim, drop=FALSE)
                    },
                    gauss       = {
                      rGRFgauss(W=win, mu=mu,
                                ..., nsim=nsim, drop=FALSE)
                    },
                    stable = {
                      rGRFstable(W=win, mu=mu, 
                                 ..., nsim=nsim, drop=FALSE)
                    },
                    gencauchy = {
                      rGRFgencauchy(W=win, mu=mu, 
                                    ..., nsim=nsim, drop=FALSE)
                    },
                    matern = {
                      rGRFmatern(W=win, mu=mu, 
                                 ..., nsim=nsim, drop=FALSE)
                    },
                    stop(paste("Model", sQuote(model), "not matched")))

    if(length(Zlist) != nsim)
      stop("Internal error in generating realisations")
    
    ## exponentiate
    Lambdalist <- solapply(Zlist, exp)

    if(LambdaOnly) {
      ## undocumented exit - return Lambda only
      return(simulationresult(Lambdalist, nsim, drop))
    }
    
    ## generate realisations of LGCP
    result <- vector(mode="list", length=nsim)
    for(isim in seq_len(nsim)) {
      Lambda <- Lambdalist[[isim]]
      ## generate Poisson points
      X <- rpoispp(Lambda)[win]
      ## 
      if(saveLambda)
        attr(X, "Lambda") <- Lambda
      result[[isim]] <- X
    }
    return(simulationresult(result, nsim, drop))
  }

  do.cond.rLGCP <- function(model=c("exponential", "gauss", "stable",
                            "gencauchy", "matern"),
                            mu = 0, ...,
                            n.cond=NULL, w.cond=NULL, 
                            giveup=1000, maxchunk=100,
                            win=NULL, saveLambda=TRUE,
                            LambdaOnly=FALSE, Lambdaonly=FALSE,
                            nsim=1,
                            verbose=FALSE, drop=FALSE) {
    ## simulation window
    win.given <- !is.null(win)
    mu.image <- is.im(mu)
    win <- if(win.given) as.owin(win) else if(mu.image) as.owin(mu) else owin()

    LambdaOnly <- LambdaOnly || Lambdaonly  # old spelling
    
    ## type of simulation
    w.sim <- as.owin(win)
    fullwindow <- is.null(w.cond)
    if(fullwindow) {
      w.cond <- w.sim
      w.free <- NULL
    } else {
      #' not yet public
      stopifnot(is.owin(w.cond))
      w.free <- setminus.owin(w.sim, w.cond)
    }
  
    nremaining <- nsim
    ntried <- 0
    accept <- FALSE
    nchunk <- 1
    phistory <- Lamhistory <- numeric(0)
    results <- list()
    while(nremaining > 0) {
      ## increase chunk length
      nchunk <- min(maxchunk, giveup - ntried, 2 * nchunk)
      ## bite off next chunk of unconditional simulations
      lamlist <- do.rLGCP(model=model, mu=mu, win=win, ..., 
                          nsim=nchunk,
                          LambdaOnly=TRUE,
                          drop=FALSE)
      ## compute acceptance probabilities
      lamlist <- lapply(lamlist, "[", i=w.sim, drop=FALSE, tight=TRUE)
      if(fullwindow) {
        Lam <- sapply(lamlist, integral)
      } else {
        Lam <- sapply(lamlist, integral, domain=w.cond)
      }
      p <- exp(n.cond * log(Lam/n.cond) + n.cond - Lam)
      phistory <- c(phistory, p)
      Lamhistory <- c(Lamhistory, Lam)
      ## accept/reject
      accept <- (runif(length(p)) < p)
      if(any(accept)) {
        jaccept <- which(accept)
        if(length(jaccept) > nremaining)
          jaccept <- jaccept[seq_len(nremaining)]
        naccepted <- length(jaccept)
        if(verbose)
          splat("Accepted the",
                commasep(ordinal(ntried + jaccept)),
                ngettext(naccepted, "proposal", "proposals"))
        nremaining <- nremaining - naccepted
        for(j in jaccept) {
          lamj <- lamlist[[j]]
          if(min(lamj) < 0)
            lamj <- eval.im(pmax(lamj, 0))
          if(LambdaOnly) {
            #' undocumented: return the driving intensities only
            results <- append(results, list(lamj))
          } else {
            #' normal: return the simulated patterns
            if(fullwindow) {
              Y <- rpoint(n.cond, lamj, win=w.sim, forcewin=TRUE)
            } else {
              lamj.cond <- lamj[w.cond, drop=FALSE, tight=TRUE]
              lamj.free <- lamj[w.free, drop=FALSE, tight=TRUE]
              Ycond <- rpoint(n.cond, lamj.cond, win=w.cond)
              Yfree <- rpoispp(lamj.free)
              Y <- superimpose(Ycond, Yfree, W=w.sim)
            }
            if(saveLambda) attr(Y, "Lambda") <- lamj
            results <- append(results, list(Y))
          }
        }
      }
      ntried <- ntried + nchunk
      if(ntried >= giveup && nremaining > 0) {
        message(paste("Gave up after", ntried,
                      "proposals with", nsim - nremaining, "accepted"))
        message(paste("Mean acceptance probability =",
                      signif(mean(phistory), 3)))
        break
      }
    }
    nresults <- length(results)
    results <- simulationresult(results, nresults, drop)
    attr(results, "history") <- data.frame(Lam=Lamhistory, p=phistory)
    if(verbose && nresults == nsim)
      splat("Mean acceptance probability", signif(mean(phistory), 3))
    return(results)
  }
  
  rLGCP
})

#
# rmhsnoop.R
#
#   visual debug mechanism for rmh
#
#   $Revision: 1.34 $  $Date: 2021/12/24 04:30:06 $
#
#   When rmh is called in visual debug mode (snooping = TRUE),
#   it calls e <- rmhSnoopEnv(...) to create an R environment 'e'
#   containing variables that will represent the current state
#   of the M-H algorithm with initial state X and model reach R.
#
#   The environment 'e' is passed to the C routine xmethas.
#   This makes it possible for data to be exchanged between
#   the C and R code.
#
#   When xmethas reaches the debugger's stopping time,
#   the current state of the simulation and the proposal
#   are copied from C into the R environment 'e'.
#
#   Then to execute the visual display, the C code calls
#   'eval' to execute the R function rmhsnoop().
#
#   The function rmhsnoop uses the 'simplepanel' class
#   to generate a plot showing the state of the simulation
#   and the proposal, and then wait for point-and-click input using
#   locator(). 
#  
#   When rmhsnoop() exits, it returns an integer giving the
#   (user-specified) next stopping time. This is read back into
#   the C code. Then xmethas resumes simulations.
#
#   I said it was simple! %^]

rmhSnoopEnv <- function(Xinit, Wclip, R) {
  stopifnot(is.ppp(Xinit))
  # Create an environment that will be accessible to R and C code
  e <- new.env()
  # initial state (point pattern)
  X <- Xinit
  assign("Wsim",     as.owin(X),      envir=e)
  assign("xcoords",  coords(X)[,1],   envir=e)
  assign("ycoords",  coords(X)[,2],   envir=e)
  if(is.multitype(X)) {
    mcodes <- as.integer(marks(X)) - 1L
    mlevels <- levels(marks(X))
    assign("mcodes",  mcodes,  envir=e)
    assign("mlevels", mlevels, envir=e)
  } else {
    assign("mcodes",  NULL, envir=e)
    assign("mlevels", NULL, envir=e)
  }
  # clipping window
  assign("Wclip",    Wclip,           envir=e)
  # reach of model (could be infinite)
  assign("R",        R,               envir=e)
  # current iteration number 
  assign("irep", 0L,             envir=e)
  # next iteration to be inspected
  assign("inxt",  1L,             envir=e)
  # next transition to be inspected
  assign("tnxt",  1L,             envir=e)
  # proposal type
  assign("proptype", NULL,     envir=e)
  # outcome of proposal
  assign("itype",    NULL,     envir=e)
  # proposal location
  assign("proplocn", NULL,     envir=e)
  # proposal mark 
  assign("propmark", NULL,     envir=e)
  # index of proposal point in existing pattern
  assign("propindx", NULL,     envir=e)
  # Hastings ratio
  assign("numerator",   NULL,  envir=e)
  assign("denominator", NULL,  envir=e)
  # Expression actually evaluated to execute visual debug
  # Expression is evaluated in the environment 'e'
  snoopexpr <-
    expression({
      rslt <- rmhsnoop(Wsim=Wsim, Wclip=Wclip, R=R,
                       xcoords=xcoords,
                       ycoords=ycoords,
                       mlevels=mlevels,
                       mcodes=mcodes,
                       irep=irep,
                       itype=itype,
                       proptype=proptype,
                       proplocn=proplocn,
                       propmark=propmark,
                       propindx=propindx,
                       numerator=numerator,
                       denominator=denominator)
      inxt <- rslt$inxt
      tnxt <- rslt$tnxt
      itype <- if(rslt$accepted) proptype else 0
      storage.mode(tnxt) <-
        storage.mode(inxt) <- storage.mode(itype) <- "integer"
})
  assign("snoopexpr", snoopexpr,  envir=e)
  # callback expression
  assign("callbackexpr", quote(eval(snoopexpr)), envir=e)
  return(e)
}

# visual debug display using base graphics

rmhsnoop <- local({

  rmhsnoop <- function(..., Wsim, Wclip, R,
                       xcoords, ycoords,
                       mlevels=NULL, mcodes,
                       irep, itype, 
                       proptype, proplocn, propmark, propindx,
                       numerator, denominator, panel.only=FALSE) {
    trap.extra.arguments(..., .Context="In rmhsnoop")
    X <- ppp(xcoords, ycoords, window=Wsim)
    if(ismarked <- (length(mlevels) > 0))
      marks(X) <- factor(mlevels[mcodes+1L], levels=mlevels)
    Wclip.orig <- Wclip
    # determine plot arguments
    if(is.mask(Wclip)) {
      parg.Wclip <- list(invert=TRUE, col="grey")
    } else {
      Wclip <- edges(Wclip) 
      parg.Wclip <- list(lty=3, lwd=2, col="grey")
    }
    parg.birth <- list(cols="green", lwd=3)
    parg.death <- list(cols="red", lwd=3)
    parg.birthcircle <- list(col="green", lty=3)
    parg.deathcircle <- list(col="red", lty=3)

    # assemble a layered object representing the state and the proposal
    if(is.null(proptype)) {
      # initial state
      L <- layered(Wsim,
                   Wclip,
                   X)
      layerplotargs(L)$Wclip <- parg.Wclip
      accepted <- TRUE
    } else {
      accepted <- (itype == proptype)
      # add proposal info
      switch(decode.proptype(proptype),
             Reject=
             {
               propname <- "rejected"
               L <- layered(Wsim=Wsim,
                            Wclip=Wclip,
                            X=X)
               layerplotargs(L)$Wclip <- parg.Wclip
             },
             Birth = 
             {
               propname <- "birth proposal"
               U <- ppp(proplocn[1L], proplocn[2L], window=Wsim)
               if(ismarked)
                 marks(U) <- factor(mlevels[propmark+1L], levels=mlevels)
               D <- if(is.finite(R) && R > 0) {
                 edges(disc(R, proplocn))[Wsim]
               } else NULL
               L <- layered(Wsim=Wsim,
                            Wclip=Wclip,
                            PrevState=X,
                            Reach=D,
                            NewPoint=U)
               layerplotargs(L)$Wclip <- parg.Wclip
               layerplotargs(L)$NewPoint <- parg.birth
             },
             Death = 
             {
               propname <- "death proposal"
               # convert from C to R indexing
               propindx <- propindx + 1
               XminI <- X[-propindx]
               XI <- X[propindx]
               D <- if(is.finite(R) && R > 0) {
                 edges(disc(R, c(XI$x, XI$y)))[Wsim]
               } else NULL
               L <- layered(Wsim=Wsim,
                            Wclip=Wclip,
                            RetainedPoints=XminI,
                            Reach=D,
                            Deletion=XI)
               layerplotargs(L)$Wclip    <- parg.Wclip
               layerplotargs(L)$Reach    <-  parg.deathcircle
               layerplotargs(L)$Deletion <- parg.death
             },
             Shift = 
             {
               propname <- "shift proposal"
               # convert from C to R indexing
               propindx <- propindx + 1L
               # make objects
               XminI <- X[-propindx]
               XI <- X[propindx]
               U <- ppp(proplocn[1L], proplocn[2L], window=Wsim)
               if(ismarked)
                 marks(U) <- factor(mlevels[propmark+1L], levels=mlevels)
               if(is.finite(R) && R > 0) {
                 DU <- edges(disc(R, proplocn))[Wsim]
                 DXI <- edges(disc(R, c(XI$x, XI$y)))[Wsim]
               } else { DU <- DXI <- NULL }
               # make layers
               L <- layered(Wsim=Wsim,
                            Wclip=Wclip,
                            OtherPoints=XminI,
                            ReachAfter=DU,
                            AfterShift=U,
                            ReachBefore=DXI,
                            BeforeShift=XI)
               layerplotargs(L)$Wclip       <- parg.Wclip
               layerplotargs(L)$ReachAfter  <- parg.birthcircle
               layerplotargs(L)$AfterShift  <- parg.birth
               layerplotargs(L)$ReachBefore <- parg.deathcircle
               layerplotargs(L)$BeforeShift <- parg.death
             },
             stop("Unrecognised proposal type")
             )
    }
    header <- c(paste("Iteration", irep),
                propname,
                paste("Hastings ratio =",
                      signif(numerator, 4), "/", signif(denominator, 4),
                      "=", signif(numerator/denominator, 4)))
    info <- list(irep=irep,
                 Wsim=Wsim,
                 Wclip=Wclip.orig,
                 X=X,
                 proptype=proptype,
                 proplocn=proplocn,
                 propindx=propindx,
                 propmark=propmark,
                 mlevels=mlevels,
                 accepted=accepted,
                 numerator=numerator,
                 denominator=denominator)
    inspectProposal(L, info, title=header, panel.only=panel.only)
  }

  decode.proptype <- function(n) {
    if(n < 0 || n > 3) stop(paste("Unrecognised proposal type:", n))
    switch(n+1, "Reject", "Birth", "Death", "Shift")
  }
  encode.proptype <- function(s) {
    switch(s, Reject=0, Birth=1, Death=2, Shift=3)
  }
  
  inspectProposal <- function(X, info, ..., title, panel.only=FALSE) {
    if(missing(title)) title <- short.deparse(substitute(X))
    if(!inherits(X, "layered"))
      X <- layered(X)
    lnames <- names(X)
    if(sum(nzchar(lnames)) != length(X))
      lnames <- paste("Layer", seq_len(length(X)))
    # Find window and bounding box (validates X)
    W <- as.owin(X)
    BX <- as.rectangle(W)
    # Initialise environment for state variables etc
    # This environment is accessible to the panel button functions
    en <- new.env()
    assign("X", X, envir=en)
    assign("W", W, envir=en)
    assign("BX", BX, envir=en)
    assign("zoomfactor", 1L, envir=en)
    midX <- unlist(centroid.owin(BX))
    assign("midX", midX, envir=en)
    assign("zoomcentre", midX, envir=en)
    assign("irep", info$irep, envir=en)
    assign("inxt", info$irep+1, envir=en) 
    assign("tnxt", -1, envir=en)
    assign("accepted", info$accepted, envir=en)
    assign("proplocn", info$proplocn, envir=en)
    assign("info", info, envir=en)
    # Build interactive panel
    # Start with data panel
    P <- simplepanel(title,
                     BX,
                     list(Data=BX),
                     list(Data=dataclickfun),
                     list(Data=dataredrawfun),
                     snoopexit,
                     en)
    # Add pan buttons
    margin <- max(sidelengths(BX))/4
    panelwidth <- sidelengths(BX)[1L]/2
    P <- grow.simplepanel(P, "top", margin, navfuns["Up"], aspect=1)
    P <- grow.simplepanel(P, "bottom", margin, navfuns["Down"], aspect=1)
    P <- grow.simplepanel(P, "left", margin, navfuns["Left"], aspect=1)
    P <- grow.simplepanel(P, "right", margin, navfuns["Right"], aspect=1)
    # Zoom/Pan buttons at right
    P <- grow.simplepanel(P, "right", panelwidth, zoomfuns)
    # Accept/reject buttons at top
    P <- grow.simplepanel(P, "top", margin, accept.clicks, accept.redraws)
    # Dump/print buttons at bottom 
    P <- grow.simplepanel(P, "bottom", margin, dumpfuns)
    # Jump controls at left
    maxchars <- max(4, nchar(names(jump.clicks)))
    P <- grow.simplepanel(P, "left", panelwidth * maxchars/6, jump.clicks)
    ## exit for debug/test code
    if(panel.only) return(P)
    ## go
    rslt <- run.simplepanel(P, popup=FALSE)
    clear.simplepanel(P)
    rm(en)
    return(rslt)
  }


# button control functions
  zoomfuns <- 
    rev(list(
             "Zoom In"=function(env, xy) {
               z <- get("zoomfactor", envir=env)
               assign("zoomfactor", z * 2, envir=env)
               return(TRUE)
             },
             "Zoom Out"=function(env, xy) {
               z <- get("zoomfactor", envir=env)
               assign("zoomfactor", z / 2, envir=env)
               return(TRUE)
             },
             "At Proposal"=function(env, xy) {
               proplocn <- get("proplocn", envir=env)
               assign("zoomcentre", proplocn, envir=env)
               return(TRUE)
             },
             Reset=function(env, xy) {
               assign("zoomfactor", 1L, envir=env)
               midX <- get("midX", envir=env)
               assign("zoomcentre", midX, envir=env)
               return(TRUE)
             }))
                           
  navfuns <-
    list(
         Left = function(env, xy) {
           zoom <- get("zoomfactor", envir=env)
           ce <- get("zoomcentre", envir=env)
           BX <- get("BX", envir=env)
           width <- sidelengths(BX)[1L]
           stepsize <- (width/4)/zoom
           ce <- ce - c(stepsize, 0)
           assign("zoomcentre", ce, envir=env)
           return(TRUE)
         },
         Right = function(env, xy) {
           zoom <- get("zoomfactor", envir=env)
           ce <- get("zoomcentre", envir=env)
           BX <- get("BX", envir=env)
           width <- sidelengths(BX)[1L]
           stepsize <- (width/4)/zoom
           ce <- ce + c(stepsize, 0)
           assign("zoomcentre", ce, envir=env)
           return(TRUE)
         },
         Up = function(env, xy) {
           zoom <- get("zoomfactor", envir=env)
           ce <- get("zoomcentre", envir=env)
           BX <- get("BX", envir=env)
           height <- sidelengths(BX)[2]
           stepsize <- (height/4)/zoom
           ce <- ce + c(0, stepsize)
           assign("zoomcentre", ce, envir=env)
           return(TRUE)
         },
         Down = function(env, xy) {
           zoom <- get("zoomfactor", envir=env)
           ce <- get("zoomcentre", envir=env)
           BX <- get("BX", envir=env)
           height <- sidelengths(BX)[2]
           stepsize <- (height/4)/zoom
           ce <- ce - c(0, stepsize)
           assign("zoomcentre", ce, envir=env)
           return(TRUE)
         })

  accept.clicks <-
    rev(list(
             Accept=function(env, xy) {
               assign("accepted", TRUE, envir=env)
               return(TRUE)
             },
             Reject=function(env, xy) {
               assign("accepted", FALSE, envir=env)
               return(TRUE)
             }))

  accept.redraws <-
    rev(list(
             Accept=function(button, name, env) {
               accepted <- get("accepted", envir=env)
               if(accepted) {
                 plot(button, add=TRUE, col="green")
               } else {
                 plot(button, add=TRUE)
               }
               text(centroid.owin(button), labels=name)
             },
             Reject=function(button, name, env) {
               accepted <- get("accepted", envir=env)
               if(accepted) {
                 plot(button, add=TRUE)
               } else {
                 plot(button, add=TRUE, col="pink")
               }
               text(centroid.owin(button), labels=name)
             }))
             
  jump.clicks <-
    rev(list(
             "Next Iteration"=function(env, xy) {
               irep <- get("irep", envir=env)
               assign("inxt", irep+1, envir=env)
               return(FALSE)
             },
             "Skip 10"=function(env, xy) {
               irep <- get("irep", envir=env)
               assign("inxt", irep+10, envir=env)
               return(FALSE)
             },
             "Skip 100"=function(env, xy) {
               irep <- get("irep", envir=env)
               assign("inxt", irep+100, envir=env)
               return(FALSE)
             },
             "Skip 1000"=function(env, xy) {
               irep <- get("irep", envir=env)
               assign("inxt", irep+1000, envir=env)
               return(FALSE)
             },
             "Skip 10,000"=function(env, xy) {
               irep <- get("irep", envir=env)
               assign("inxt", irep+10000, envir=env)
               return(FALSE)
             },
             "Skip 100,000"=function(env, xy) {
               irep <- get("irep", envir=env)
               assign("inxt", irep+100000, envir=env)
               return(FALSE)
             },
             "Next Birth"=function(env, xy) {
               assign("inxt", -1, envir=env)
               assign("tnxt", encode.proptype("Birth"), envir=env)
               return(FALSE)
             },
             "Next Death"=function(env, xy) {
               assign("inxt", -1, envir=env)
               assign("tnxt", encode.proptype("Death"), envir=env)
               return(FALSE)
             },
             "Next Shift"=function(env, xy) {
               assign("inxt", -1, envir=env)
               assign("tnxt", encode.proptype("Shift"), envir=env)
               return(FALSE)
             },
             "Exit Debugger"=function(env, xy) {
               assign("inxt", -1L, envir=env)
               return(FALSE)
             }))

  dataclickfun <- function(env, xy) {
    # function for handling clicks in the data window
    z <- get("zoomfactor", envir=env)
    ce <- get("zoomcentre", envir=env)
    midX <- get("midX", envir=env)
    ce <- ce + (unlist(xy) - midX)/z
    assign("zoomcentre", ce, envir=env)
    return(TRUE)
  }

  dataredrawfun <- function(button, name, env) {                             
    # redraw data window
    X <- get("X", envir=env)
    BX <- get("BX", envir=env)
    W <- get("W", envir=env)
    midX <- get("midX", envir=env)
    z <- get("zoomfactor", envir=env)
    ce <- get("zoomcentre", envir=env)
    scaleX <- shift(affine(shift(X, -ce), diag(c(z,z))), unlist(midX))
    scaleW <- shift(affine(shift(W, -ce), diag(c(z,z))), unlist(midX))
    scaleX <- scaleX[, BX]
    scaleW <- intersect.owin(scaleW, BX, fatal=FALSE)
    # redraw data in 'BX' 
    if(!is.null(scaleW)) {
      if(z == 1 && is.rectangle(scaleW)) {
        plot(scaleW, add=TRUE, lwd=2)
      } else {
        plot(BX, add=TRUE, lty=3, border="red")
        if(!identical(BX, scaleW))
          plot(scaleW, add=TRUE, invert=TRUE)
      }
    }
    if(!is.null(scaleX))
      plot(scaleX, add=TRUE)
    invisible(NULL)
  }

# functions to dump the current state, etc
  dumpfuns <- list(
                   "Dump to file"=function(env, xy) {
                     irep <- get("irep", envir=env)
                     X <- get("X", envir=env)
                     xname <- paste("dump", irep, sep="")
                     assign(xname, X)
                     fname <- paste(xname, ".rda", sep="")
                     eval(substitute(save(x, file=y, compress=TRUE), 
                                     list(x=xname, y=fname)))
                     splat("Saved to", sQuote(fname))
                     return(TRUE)
                   },
                   "Print Info"=function(env, xy) {
                     info <- get("info", envir=env)
                     will.accept <- get("accepted", envir=env)
                     cat("\n\n------------------- \n")
                     with(info, {
                       splat("Iteration", irep)
                       splat("Simulation window:")
                       print(Wsim)
                       splat("Clipping window:")
                       print(Wclip)
                       splat("Current state:")
                       print(X)
                       propname <- decode.proptype(proptype)
                       splat("Proposal type:", propname)
                       switch(propname,
                              Reject = { },
                              Birth = {
                                splat("Birth of new point at location",
                                      pastepoint(proplocn, propmark, mlevels))
                              },
                              Death = {
                                Xi <- X[propindx]
                                splat("Death of data point", propindx,
                                      "located at",
                                      pastepoint(Xi))
                              },
                              Shift = {
                                Xi <- X[propindx]
                                splat("Shift data point",
                                      propindx,
                                      "from current location",
                                      pastepoint(Xi),
                                      "to new location",
                                      pastepoint(proplocn, propmark, mlevels))
                              })
                       splat("Hastings ratio = ",
                             numerator, "/", denominator,
                             "=", numerator/denominator)
                       splat("Fate of proposal:",
                             if(will.accept) "Accepted" else "Rejected")
                       return(TRUE)
                     })
                   })

  pastepoint <- function(X, markcode, marklevels) {
    if(is.ppp(X)) {
      xy <- coords(X)
      m <- if(is.marked(X)) dQuote(marks(X)) else NULL
    } else {
      xy <- X
      m <- if(length(marklevels)) dQuote(marklevels[markcode+1L]) else NULL
    }
    xy <- signif(as.numeric(xy), 6)
    paren(paste(c(xy, m), collapse=", "))
  }
      
# function to determine return value
                             
  snoopexit <- function(env) {
    ans <- eval(quote(list(inxt=inxt,
                           tnxt=tnxt,
                           accepted=accepted)),
                envir=env)
    return(ans)
  }
                             
  rmhsnoop
})


#  testit <- function() {
#    rmhsnoop(Wsim=owin(), Wclip=square(0.7), R=0.1,
#             xcoords=runif(40),
#             ycoords=runif(40),
#             mlevels=NULL, mcodes=NULL,
#             irep=3, itype=1,
#             proptype=1, proplocn=c(0.5, 0.5), propmark=0, propindx=0,
#             numerator=42, denominator=24)
#  }
                             

##  pakes.R
##
## The probability distribution that satisfies the distributional equivalence
##              X == U^(1/zeta) (1 + X)
## where X, U are independent r.v.'s and U is uniform [0,1]
##
## Solution due to A.G. Pakes presented in
##     Baddeley, Moller & Pakes (2008)
##     Properties of residuals for spatial point processes,
##     Annals of the Institute of Statistical Mathematics 60 (2008) 627-649
##
## Implementation (c) Adrian Baddeley 2021
## GNU Public Licence >= 2.0


pakesCalc <- function(zeta, dx=0.001, xmax=5) {
  check.1.real(zeta)
  stopifnot(zeta > 0)
  EulerGamma <- -digamma(1) # Euler-Mascheroni constant
  C <- exp(-EulerGamma * zeta)/gamma(1 + zeta)
  ## cat(paste("C=", C, "\n"))
  x <- seq(0, xmax, by=dx)
  xzeta <- x^zeta
  inv1x1zeta <- 1/(1 + x)^(1+zeta)
  nx <- length(x)
  shifted <- seq_len(nx) - floor(1/dx)
  shifted[shifted < 1] <- NA
  Fx <- numeric(nx)
  ceilx <- ceiling(x)
  slice1 <- (ceilx == 1)
  Fx[slice1] <- C * xzeta[slice1]
  nmax <- ceiling(xmax)
  if(nmax > 1) {
    for(k in 2:nmax) {
      integrand <- Fx * inv1x1zeta
      indefInteg <- zeta * dx * cumsum(integrand)
      ## plot(x, indefInteg, type="l")
      shiftedIndefInt <- ifelse(is.na(shifted), 0, indefInteg[shifted])
      ## plot(x, shiftedIndefInt, type="l")
      slicek <- (ceilx == k)
      Fx[slicek] <- xzeta[slicek] * (C - shiftedIndefInt[slicek])
      ## suppress numerical glitch close to F(x) = 1
      if(any(exceed <- (Fx >= 1))) {
        last <- min(which(exceed))
        Fx[last:length(Fx)] <- 1
        break;
      }
    }
  }
  ## suppress numerical glitches
  if(any(dip <- (Fx < cummax(Fx)))) {
    ok <- !dip
    Fx[dip] <- approx(x=x[ok], y=Fx[ok],
                      xout=x[dip],
                      rule=2, yright=1)$y
  }
  ## return
  data.frame(x=x, Fx=Fx)
}

ppakes <- function(q, zeta) {
  q <- as.numeric(q)
  zeta <- as.numeric(zeta)
  if(length(zeta) > 1)
    return(mapply(ppakes, q=q, zeta=zeta))
  a <- pakesCalc(zeta, xmax=max(ceiling(q)))
  Fpakes <- approxfun(a$x, a$Fx, rule=2)
  p <- Fpakes(q)
  return(p)
}

dpakes <- function(x, zeta) {
  x <- as.numeric(x)
  zeta <- as.numeric(zeta)
  if(length(zeta) > 1) 
    return(mapply(dpakes, x=x, zeta=zeta))
  C <- exp(digamma(1) * zeta)/gamma(1 + zeta)
  y <- numeric(length(x))
  if(any(low <- (x <= 1))) 
    y[low] <- C * zeta * x[low]^(zeta-1)
  if(any(high <- !low)) {
    xhigh <- x[high]
    a <- pakesCalc(zeta, xmax=max(xhigh))
    Fxhigh <- approx(x=a$x, y=a$Fx,
                     xout=xhigh,
                     rule=2, yright=1)$y
    Fxhigh1 <- approx(x=a$x, y=a$Fx,
                     xout=xhigh - 1,
                     rule=2, yright=1)$y
    y[high] <- (zeta/xhigh) * (Fxhigh - Fxhigh1)
  }
  return(y)
}

qpakes <- function(p, zeta) {
  p <- as.numeric(p)
  zeta <- as.numeric(zeta)
  if(length(zeta) > 1) 
    return(mapply(qpakes, p=p, zeta=zeta))
  ## find 'xmax' such that F(xmax) = 1 within numerical error
  zetabreaks <- c(0, 0.1, 0.5, 1, 2, 10, 20, Inf)
  xmaxvalues <- c(  3,  6,  8,  10, 20, 30, 1.5 * zeta)
  xmax <- xmaxvalues[findInterval(zeta, zetabreaks, all.inside=TRUE)]
  ## compute CDF
  a <- pakesCalc(zeta, xmax=xmax)
  a <- a[!duplicated(a$Fx), ]
  ## invert
  q <- approx(x=a$Fx, y=a$x,
              xout=p,
              rule=2, yleft=0, yright=1)$y
  return(q)
}

rpakes <- function(n, zeta) {
  qpakes(runif(n), zeta)
}

#'
#'    rcauchy.R
#'
#'   $Revision: 1.16 $ $Date: 2025/05/20 08:21:02 $
#'
#'   Simulation of Cauchy cluster process
#'   using either naive algorithm or BKBC algorithm
#'
#'   rCauchyHom    Interface to C code for stationary case (BKBC algorithm)
#'   rCauchy       General case (naive or BKBC)
#'
#'    Original code for naive simulation of Neyman-Scott by Adrian Baddeley
#'    Original code for simulation of rCauchy offspring by Abdollah Jalilian
#'    Bug fixes by Abdollah, Adrian Baddeley, and Rolf Turner
#'
#'   Implementation of BKBC algorithm by Adrian Baddeley and Ya-Mei Chang
#' 
#'   Copyright (c) 2000-2023 Adrian Baddeley, Abdollah Jalilian, Ya-Mei Chang 
#'   Licence: GNU Public Licence >= 2
#'

rCauchyHom <-function(kappa, mu, scale, W=unit.square(), ..., nsim=1, drop=TRUE,
                      inflate=NULL, saveparents=FALSE, maxinflate=10) {
  check.1.real(kappa) && check.finite(kappa, xname="kappa")
  check.1.real(mu) && check.finite(mu, xname="mu")
  check.1.real(scale) && check.finite(scale, xname="scale")
  check.1.integer(nsim)
  stopifnot(kappa >= 0)
  stopifnot(mu >= 0)
  stopifnot(scale > 0)
  if(!is.null(inflate)) {
    check.1.real(inflate) && check.finite(inflate, xname="inflate")
    stopifnot(inflate >= 1)
  }
  ## trivial cases
  if(nsim == 0) return(simulationresult(list()))
  if(kappa == 0 || mu == 0) {
    ## intensity is zero - patterns are empty
    empt <- ppp(window=W)
    if(saveparents) {
      attr(empt, "parents") <- list(x=numeric(0), y=numeric(0))
      attr(empt, "parentid") <- integer(0)
      attr(empt, "cost") <- 0
    }
    result <- rep(list(empt), nsim)
    return(simulationresult(result, nsim=nsim, drop=drop))
  }
  ## shift window to convenient origin
  oldW <- W
  oldcentre <- as.numeric(centroid.owin(Frame(oldW)))
  W <- shift(oldW, -oldcentre)
  ## enclose it in a disc
  rD <- with(vertices(Frame(W)), sqrt(max(x^2+y^2)))
  ## optimal inflation
  if(is.null(inflate)) {
    a <- if(mu == 0) 1 else (1 + (1-exp(-mu))/mu)
    b <- (rD^2)/(2*a*scale^2)
    if(b <= 1) {
      inflate <- 1
    } else {
      delta <- scale * (b^(2/3) - 1)
      inflate <- 1 + delta/rD
      inflate <- min(inflate, maxinflate)
    }
  }
  ## Prepare for C code
  storage.mode(kappa) <- "double"
  storage.mode(mu) <- "double"
  storage.mode(scale) <- "double"
  storage.mode(rD) <- "double"
  storage.mode(inflate) <- "double"
  ##
  resultlist <- vector(mode="list", length=nsim)
  for(isim in 1:nsim) {
    ## call C code
    if(saveparents) {
      z <- .Call(SR_rcauchyAll,
                 kappa, mu, scale, rD, inflate,
                 PACKAGE="spatstat.random")
    } else {
      z <- .Call(SR_rcauchyOff,
                 kappa, mu, scale, rD, inflate,
                 PACKAGE="spatstat.random")
    }
    ## unpack
    xo <- z[[1]]
    yo <- z[[2]]
    if(saveparents) {
      xp <- z[[3]]
      yp <- z[[4]]
      parentid <- z[[5]]
    }
    ## shift back to original window
    xo <- xo + oldcentre[1L]
    yo <- yo + oldcentre[2L]
    if(saveparents) {
      xp <- xp + oldcentre[1L]
      yp <- yp + oldcentre[2L]
    }
    ## restrict to original window
    retain <- inside.owin(xo, yo, oldW)
    if(!all(retain)) {
      xo <- xo[retain]
      yo <- yo[retain]
      if(saveparents) {
        parentid <- parentid[retain]
        retainedparents <- sort(unique(parentid))
        parentid <- match(parentid, retainedparents)
        xp <- xp[retainedparents]
        yp <- yp[retainedparents]
      }
    }
    ## save as point pattern
    Y <- ppp(xo, yo, window=oldW, check=FALSE)
    if(saveparents) {
      attr(Y, "parents") <- list(x = xp, y = yp)
      attr(Y, "parentid") <- parentid
      attr(Y, "cost") <- length(xo) + length(xp)
    }
    resultlist[[isim]] <- Y
  }
  result <- simulationresult(resultlist, nsim, drop=drop)
  return(result)
}

## ================================================
## Neyman-Scott process with Cauchy kernel function
## ================================================

## scale / omega: scale parameter of Cauchy kernel function
## eta: scale parameter of Cauchy pair correlation function
## eta = 2 * omega

rCauchy <- local({

  ## simulate mixture of normals with inverse-gamma distributed variance
  rnmix.invgam <- function(n = 1, rate) {
    V <- matrix(rnorm(2 * n, 0, 1), nrow = n, ncol = 2)
    s <- 1/rgamma(n, shape=1/2, rate=rate)
    return(sqrt(s) * V)
  }

  ## main function
  rCauchy <- function(kappa, scale, mu, win = square(1),
                         nsim=1, drop=TRUE,
                      ...,
                      n.cond=NULL, w.cond=NULL,
                      algorithm=c("BKBC", "naive"),
                      nonempty=TRUE, 
                      thresh = 0.001,
                      poisthresh=1e-6,
                      expand = NULL,
                      saveparents=FALSE, saveLambda=FALSE,
                      kappamax=NULL, mumax=NULL, LambdaOnly=FALSE) {
    ## Cauchy cluster process
    
    ## scale / omega: scale parameter of Cauchy kernel function
    ## eta: scale parameter of Cauchy pair correlation function

    check.1.integer(nsim)
    stopifnot(nsim >= 0)
    if(nsim == 0) return(simulationresult(list()))
    
    ## Catch old scale syntax (omega)
    dots <- list(...)
    if(missing(scale)) scale <- dots[["omega"]]
    check.1.real(scale)
    stopifnot(scale > 0)

    ## algorithm choices
    doLambda <- isTRUE(saveLambda) || isTRUE(LambdaOnly)
    conditioning <- !is.null(n.cond)
    if((conditioning || doLambda) && !isTRUE(spatstat.options("developer"))) {
      ## The naive algorithm must be used
      ## Change defaults      
      algorithm <- if(missing(algorithm)) "naive" else match.arg(algorithm)
      nonempty  <- if(missing(nonempty)) FALSE else isTRUE(nonempty)
      ## Override given arguments with a warning
      reason <- if(conditioning) "for conditional simulation" else "for intensity calculation"
      algorithm <- warn.reset.arg(algorithm, "naive", reason)
      nonempty  <- warn.reset.arg(nonempty,  FALSE,   reason)
    } else {
      ## Any choice of algorithm is permitted
      algorithm <- match.arg(algorithm)
      nonempty <- isTRUE(nonempty)
    }

    ## conditional simulation
    if(conditioning) {
      mod <- clusterprocess("Cauchy", mu=mu, kappa=kappa, scale=scale)
      result <- CondSimCox(mod, nsim=nsim, ...,
                           nonempty=nonempty, algorithm=algorithm,
                           win=win, n.cond=n.cond, w.cond=w.cond,
                           saveparents=saveparents,
                           saveLambda=saveLambda, LambdaOnly=LambdaOnly,
                           drop=drop)
      return(result)
    }

    ## ------- Unconditional simulation ------------------
    
    ## Catch old name 'eps' for 'thresh':
    if(missing(thresh))
      thresh <- dots[["eps"]] %orifnull% 0.001
      
    ## determine the effective maximum radius of clusters
    ## (for the naive algorithm, or when kappa is not constant)
    if(is.null(expand)){
        expand <- clusterradius("Cauchy", scale = scale, thresh = thresh, ...)
    } else if(!missing(thresh)){
      warning(paste("Argument ", sQuote("thresh"),
                    "is ignored when", sQuote("expand"), "is given"),
              call.=FALSE)
    }

    #' validate 'kappa' and 'mu'
    km <- validate.kappa.mu(kappa, mu, kappamax, mumax,
                            win, expand, ...,
                            context="In rCauchy")
    kappamax <- km[["kappamax"]]
    mumax    <- km[["mumax"]]
      
    ## detect trivial case where patterns are empty
    if(kappamax == 0 || mumax == 0) {
      result <- emptyNeyScot(win, nsim,
                             saveLambda, saveparents, LambdaOnly, ...)
      return(simulationresult(result, nsim=nsim, drop=drop))
    }

    #' determine algorithm
    do.parents <- saveparents || doLambda || !is.numeric(kappa)
    do.hybrid <- (algorithm == "BKBC") && nonempty 

    if(do.hybrid) {
      ## ........ Fast algorithm (BKBC) .................................
      ## run BKBC algorithm for stationary model
      result <- rCauchyHom(kappamax, mumax, scale=scale,
                           W=win, ..., nsim=nsim, drop=FALSE,
                           saveparents=do.parents)

      ## thin 
      if(!is.numeric(kappa))
        result <- solapply(result, thinParents,
                           P=kappa, Pmax=kappamax)
      
      if(!is.numeric(mu)) 
        result <- solapply(result, rthin,
                           P=mu, Pmax=mumax,
                           na.zero=TRUE, fatal=FALSE)
    } else {
      ## .......... Slower algorithm ('naive') ..........................
      ## trap case of large clusters, close to Poisson
      if(is.numeric(kappa) && 1/(pi * kappamax * scale^2) < poisthresh) {
        if(is.function(mu)) mu <- as.im(mu, W=win, ...)
        kapmu <- kappa * mu
        result <- rpoispp(kapmu, win=win, nsim=nsim, drop=drop, warnwin=FALSE)
        result <- fakeNeyScot(result, kapmu, win,
                              saveLambda, saveparents, LambdaOnly)
        return(result)
      }
    
    ## simulate
      result <- rNeymanScott(kappa=kappa,
                             expand=expand,
                             rcluster=list(mu, rnmix.invgam),
                             win=win,
                             rate = scale^2/2, # formal argument of rnmix.invgam
                             nsim=nsim, drop=FALSE,
                             nonempty=nonempty,
                             saveparents = do.parents,
                             kappamax=kappamax, mumax=mumax)

    }

    if(doLambda){
      BW <- Frame(win)
      for(i in 1:nsim) {
        parents <- attr(result[[i]], "parents")
        BX <- boundingbox(BW, bounding.box.xy(parents))
        parents <- as.ppp(parents, W=BX, check=FALSE)
        Lambda <- clusterfield("Cauchy", parents, scale=scale, mu=mu, ...)
        Lambda <- Lambda[win, drop=FALSE]
        if(LambdaOnly) {
          #' save only the intensity
          result[[i]] <- Lambda
          if(saveparents) attr(result[[i]], "parents") <- parents
        } else {
          #' usual case - save intensity as attribute
          attr(result[[i]], "Lambda") <- Lambda
        }
      }
    }
    return(simulationresult(result, nsim, drop))
  }

  rCauchy
})

#'
#' randomcircembed.R
#'
#' Circulant embedding for simulating Gaussian random field
#'
#' Originally derived from code provided in:
#'    Tilman M. Davies and David Bryant
#'    On Circulant Embedding for Gaussian Random Fields in R
#'    Journal of Statistical Software 55 (2013) issue 9
#'    DOI 10.18637/jss.v055.i09
#'
#' Modified by Adrian Baddeley
#'
#'   $Revision: 1.8 $ $Date: 2024/05/09 01:24:56 $
#' 
#'   Copyright (c) 2023 Tilman M. Davies, David Bryant and Adrian Baddeley
#'   GNU Public Licence (>= 2.0)

rGRFcircembed <- local({

  rGRFcircembed <- function(W=owin(), mu=0, var=1, corrfun, ...,
                            nsim=1, drop=TRUE) {
    rCircEmbedEngine(W=W, mu=mu, var=var, corrfun=corrfun,
                     ..., nsim=nsim, drop=drop)
  }

  rCircEmbedEngine <- function(W=owin(), mu=0, var=1, corrfun,
                               ...,
                               dimyx=NULL, eps=NULL, xy=NULL,
                               rule.eps = c("adjust.eps", 
                                            "grow.frame", "shrink.frame"),
                               warn=TRUE, maxrelerr=1e-6,
                               nsim=1, drop=TRUE) {
    ## determine discretisation
    M <- as.mask(W, dimyx=dimyx, eps=eps, xy=xy, rule.eps=rule.eps)
    if(needclip <- !is.rectangle(W))
      outsideM <- !as.vector(as.matrix(M))
    gp <- grid.prep(W, ncol(M), nrow(M))
    ## convert 'mu' to an image on same raster (unless it is a single number)
    if(is.function(mu) || is.im(mu))
      mu <- as.im(mu, W=M, ...)
    ## calculate covariance matrix
    Sigma <- covariance.prep(gp=gp,
                             var=var,
                             corr.func=corrfun,
                             wrap=TRUE,
                             ...)
    ## generate (centred) pixel values for all nsim realisations
    z <- generate.normals(nsim, Sigma, warn, maxrelerr)
    ## reshape
    ## bug fix
    ## WAS: z <- array(as.numeric(z), dim=c(gp$N.ext, gp$M.ext, nsim))
    z <- array(as.numeric(z), dim=c(gp$M.ext, gp$N.ext, nsim))
    z <- aperm(z, c(2,1,3))
    ## end bug fix 
    z <- z[1:(gp$N), 1:(gp$M), , drop=FALSE]
    ## pack up and add 'mu'
    results <- vector(mode="list", length=nsim)
    R0 <- as.im(0, W=M)
        
    for(isim in 1:nsim) {
      zmat <- z[,,isim]
      if(needclip) zmat[outsideM] <- NA
      R <- R0
      R[drop=FALSE] <- zmat
      results[[isim]] <- R+mu
    }
    results <- simulationresult(results, nsim, drop)
    return(results)
  }

  grid.prep <- function(W, M, N, ext = 2) {
    cell.width <- diff(W$xrange)/M
    cell.height <- diff(W$yrange)/N
    
    mgrid <- seq(W$xrange[1], W$xrange[2], by = cell.width)
    ngrid <- seq(W$yrange[1], W$yrange[2], by = cell.height)
    mcens <- (mgrid + 0.5 * cell.width)[-(M + 1)]
    ncens <- (ngrid + 0.5 * cell.height)[-(N + 1)]
    
    if (ext <= 1) {
      mgrid.ext <- ngrid.ext <- mcens.ext <- ncens.ext <-
        M.ext <- N.ext <- NULL
    } else {
      M.ext <- ext * M
      N.ext <- ext * N
      mgrid.ext <- seq(W$xrange[1],
                       W$xrange[2] + (ext - 1) * diff(W$xrange),
                       by = cell.width)
      ngrid.ext <- seq(W$yrange[1],
                       W$yrange[2] + (ext - 1) * diff(W$yrange),
                       by = cell.height)
      mcens.ext <- (mgrid.ext + 0.5 * cell.width)[-(M.ext + 1)]
      ncens.ext <- (ngrid.ext + 0.5 * cell.height)[-(N.ext + 1)]
    }
  
    return(list(M = M,
                N = N,
                mgrid = mgrid,
                ngrid = ngrid,
                mcens = mcens,
                ncens = ncens, 
                cell.width = cell.width,
                cell.height = cell.height,
                M.ext = M.ext,
                N.ext = N.ext, 
                mgrid.ext = mgrid.ext,
                ngrid.ext = ngrid.ext,
                mcens.ext = mcens.ext,
                ncens.ext = ncens.ext))
  }

  ## get.EIG <- function(Sigma){
  ##   eigs <- eigen(Sigma,symmetric=TRUE)
  ##   lambda <- eigs$values
  ##   lambda[lambda < .Machine$double.eps] <- 0
  ##  result <- eigs$vectors %*% diag(sqrt(lambda))
  ##  return(result)
  ## }

  covariance.prep <- function(gp, var, corr.func, wrap=FALSE, ...){
    if(!wrap){
      cent <- expand.grid(gp$mcens,gp$ncens)
      mmat <- matrix(rep(cent[,1],gp$M*gp$N),gp$M*gp$N,gp$M*gp$N)
      nmat <- matrix(rep(cent[,2],gp$M*gp$N),gp$M*gp$N,gp$M*gp$N)
      D <- sqrt((mmat-t(mmat))^2+(nmat-t(nmat))^2)
      covmat <- var*corr.func(D,...)
      return(covmat)
    } else {
      Rx <- gp$M.ext*gp$cell.width
      Ry <- gp$N.ext*gp$cell.height
      m.abs.diff.row1 <- abs(gp$mcens.ext[1]-gp$mcens.ext)
      m.diff.row1 <- pmin(m.abs.diff.row1,Rx-m.abs.diff.row1)
      n.abs.diff.row1 <- abs(gp$ncens.ext[1]-gp$ncens.ext)
      n.diff.row1 <- pmin(n.abs.diff.row1,Ry-n.abs.diff.row1)
      cent.ext.row1 <- expand.grid(m.diff.row1,n.diff.row1)
      D.ext.row1 <- matrix(sqrt(cent.ext.row1[,1]^2+cent.ext.row1[,2]^2),
                           gp$M.ext,gp$N.ext)
      C.tilde <- var*corr.func(D.ext.row1,...)
      return(C.tilde)
    }
  }

  generate.normals <- function(nsim, Sigma, warn=TRUE, maxrelerr=1e-6) {
    ## calculate fft of covariance matrix
    refft <- Re(fft(Sigma, inverse=TRUE))
    if(min(refft) < 0) {
      ## in theory this is impossible because Sigma is positive definite, 
      ## but small negative values do occur
      if(warn) {
        ra <- range(refft)
        if(-ra[1]/ra[2] > maxrelerr) {
          bad <- (refft < 0)
          warning(paste(sum(bad), "out of", length(bad), "terms",
                        paren(percentage(mean(bad))),
                        "in FFT calculation of matrix square root",
                        "were negative, and were set to zero.",
                        "Range:", prange(signif(ra, 3))),
                  call.=FALSE)
        }
      }
      refft <- pmax(0, refft)
    }
    ## fft of square root of matrix Sigma
    sqrtFFTsigma <- sqrt(refft)
    ## set up simulation 
    nr <- nrow(Sigma)
    nc <- ncol(Sigma)
    ncell <- prod(dim(Sigma))
    sqrtncell <- sqrt(ncell)
    ## run
    realisations <- matrix(, ncell, nsim)
    noise <- array(rnorm(ncell * nsim), dim=c(nr, nc, nsim))
    for(i in 1:nsim) {
      field <- sqrtFFTsigma * fft(noise[,,i])/sqrtncell
      realisations[,i] <- Re(fft(field,inverse=TRUE)/sqrtncell)
    }
    return(realisations)
  }

  rGRFcircembed

})

#' Truncated Poisson random variables
#'
#'  $Revision: 1.5 $ $Date: 2023/02/13 10:57:29 $
#' 
#'   Copyright (C) Adrian Baddeley and Ya-Mei Chang 2022 
#'   GNU Public Licence >= 2

rpoisnonzero <- function(n, lambda, method=c("harding", "transform"), implem=c("R", "C")) {
  ## Poisson random variable, conditioned to be nonzero
  method <- match.arg(method)
  implem <- match.arg(implem)
  switch(implem,
         R = {
           switch(method,
                  harding = {
                    ## From a post by Ted Harding (2005)
                    lam1 <- lambda + log(runif(n, min=exp(-lambda), max=1))
                    lam1 <- pmax(0, lam1) ## avoid numerical glitches (lam1 is theoretically > 0)
                    y <- rpois(n, lam1) + 1L
                  },
                  transform = {
                    ## From a post by Peter Dalgaard (2005) in response to Harding
                    ## Surprisingly, this is 3 times slower!
                    y <- as.integer(qpois(runif(n, min=exp(-lambda), max=1), lambda))
                  })
         },
         C = {
           storage.mode(n) <- "integer"
           storage.mode(lambda) <- "double"
           switch(method,
                  harding = {
                    y <- .Call(SR_RrnzpoisHarding,
                               n, lambda,
                               PACKAGE="spatstat.random")
                  },
                  transform = {
                    y <- .Call(SR_RrnzpoisDalgaard,
                               n, lambda,
                               PACKAGE="spatstat.random")
                  })
         })
  return(y)
}

rpoistrunc <- function(n, lambda, minimum=1, method=c("harding", "transform"), implem=c("R", "C")) {
  ## Poisson random variable, conditioned to be at least 'minimum'
  stopifnot(all(is.finite(minimum)))
  minimum <- pmax(0L, as.integer(minimum))
  method <- match.arg(method)
  implem <- match.arg(implem)
  switch(implem,
         R = {
           switch(method,
                  transform = {
                    y <- qpois(runif(n, min=ppois(minimum-1L, lambda), max=1), lambda)
                  },
                  harding = {
                    if(length(minimum) == 1) {
                      for(k in seq_len(minimum)) 
                        lambda <- pmax(0, lambda + log(1 - runif(n) * (1 - exp(-lambda))))
                    } else if(length(minimum) == n) {
                      if(length(lambda) == 1) lambda <- rep(lambda, n)
                      remaining <- minimum
                      while(any(todo <- (remaining > 0))) {
                        lambda[todo] <- pmax(0, lambda[todo] + log(1 - runif(sum(todo)) * (1 - exp(-lambda[todo]))))
                        remaining[todo] <- remaining[todo] - 1L
                      }
                    } else stop("Argument 'minimum' should be a vector of length 1 or n", call.=FALSE)
                    y <- rpois(n, lambda) + minimum
                  })
         },
         C = {
           storage.mode(n) <- "integer"
           storage.mode(lambda) <- "double"
           storage.mode(minimum) <- "integer"
           switch(method,
                  harding = {
                    y <- .Call(SR_RrtruncpoisHarding,
                               n, lambda, minimum, 
                               PACKAGE="spatstat.random")
                  },
                  transform = {
                    y <- .Call(SR_RrtruncpoisDalgaard,
                               n, lambda, minimum, 
                               PACKAGE="spatstat.random")
                  })
         })
  return(y)
}

recipEnzpois <- function(mu, exact=TRUE) {
  ## first reciprocal moment of nzpois
  if(exact && isNamespaceLoaded("gsl")) {
    gamma <- -digamma(1)
    ans <- (gsl::expint_Ei(mu) - log(mu) - gamma) * exp(-mu) /(1 - exp(-mu))
    return(ans)
  } else {
    n <- length(mu)
    ans <- numeric(n)
    xx <- 1:max(ceiling(mu + 6 * sqrt(mu)), 100)
    for(i in 1:n) 
      ans[i] <- sum(dpois(xx, mu[i])/xx)/(1 - exp(-mu[i]))
  }
  return(ans)
}

##
##
##    multipair.util.R
##
##    $Revision: 1.13 $	$Date: 2014/04/29 01:13:35 $
##
##    Utilities for multitype pairwise interactions
##	
## -------------------------------------------------------------------
##	

MultiPair.checkmatrix <-
  function(mat, n, matname, naok=TRUE, zerook=TRUE, asymmok=FALSE) {
    if(missing(matname))
      matname <- short.deparse(substitute(mat))
    if(!is.matrix(mat))
      stop(paste(matname, "must be a matrix"))
    if(any(dim(mat) != rep.int(n,2)))
      stop(paste(matname, "must be a square matrix,",
                 "of size", n, "x", n))
    isna <- is.na(mat)
    if(!naok && any(isna))
      stop(paste("NA entries not allowed in", matname))
    if(any(mat[!isna] < 0))
      stop(paste("Negative entries not allowed in", matname))
    if(!zerook && any(mat[!isna] == 0))
      stop(paste("Zero entries not allowed in", matname))
    if(!asymmok && !isSymmetric(mat))
      stop(paste(matname, "must be a symmetric matrix"))
  }

#'
#' randomImage.R
#'
#' Functions for generating random images
#' 
#'    $Revision: 1.1 $  $Date: 2015/03/23 10:44:04 $
#'
#'

rnoise <- function(rgen=runif, w=square(1), ...) {
  a <- do.call.matched(as.mask, list(w=w, ...), sieve=TRUE)
  W <- a$result
  argh <- a$otherargs
  Z <- as.im(W)
  n <- sum(W$m)
  Z[] <- do.call(rgen, append(list(n=n), argh))
  return(Z)
}

  
  

#
#
#   rmhcontrol.R
#
#   $Revision: 1.35 $  $Date: 2019/12/31 04:56:58 $
#
#

rmhcontrol <- function(...) {
  UseMethod("rmhcontrol")
}

rmhcontrol.rmhcontrol <- function(...) {
  argz <- list(...)
  if(length(argz) == 1)
    return(argz[[1]])
  stop("Arguments not understood")
}

rmhcontrol.list <- function(...) {
  argz <- list(...)
  nama <- names(argz)
  if(length(argz) == 1 && !any(nzchar(nama)))
    do.call(rmhcontrol.default, argz[[1]])
  else
    do.call.matched(rmhcontrol.default, argz)
}

rmhcontrol.default <- function(..., p=0.9, q=0.5, nrep=5e5,
                        expand=NULL, periodic=NULL, ptypes=NULL,
                        x.cond=NULL, fixall=FALSE, nverb=0,
                        nsave=NULL, nburn=nsave, track=FALSE,
                        pstage=c("block", "start"))
{
  argh <- list(...)
  nargh <- length(argh)
  if(nargh > 0) {
    # allow rmhcontrol(NULL), otherwise flag an error
    if(!(nargh == 1 && is.null(argh[[1]])))
      stop(paste("Unrecognised arguments to rmhcontrol;",
                 "valid arguments are listed in help(rmhcontrol.default)"))
  }
  # impose default values
  if(missing(p)) p <- spatstat.options("rmh.p")
  if(missing(q)) q <- spatstat.options("rmh.q")
  if(missing(nrep)) nrep <- spatstat.options("rmh.nrep")
  # validate arguments
  if(!is.numeric(p) || length(p) != 1
     || p < 0 || p > 1)
    stop("p should be a number in [0,1]")
  if(!is.numeric(q) || length(q) != 1
     || q < 0 || q > 1)
    stop("q should be a number in [0,1]")
  if(!is.numeric(nrep) || length(nrep) != 1
     || nrep < 1)
    stop("nrep should be an integer >= 1")
  nrep <- as.integer(nrep)
  if(!is.numeric(nverb) || length(nverb) != 1
     || nverb < 0 || nverb > nrep)
    stop("nverb should be an integer <= nrep")
  nverb <- as.integer(nverb)
  if(!is.logical(fixall) || length(fixall) != 1)
    stop("fixall should be a logical value")
  if(!is.null(periodic) && (!is.logical(periodic) || length(periodic) != 1))
    stop(paste(sQuote("periodic"), "should be a logical value or NULL"))
  if(saving <- !is.null(nsave)) {
    nsave <- as.integer(as.vector(nsave))
    if(length(nsave) == 1L) {
      if(nsave <= 0)
        stop("nsave should be a positive integer")
      stopifnot(nsave < nrep)
    } else {
      stopifnot(all(nsave > 0))
      stopifnot(sum(nsave) <= nrep)
    }
    if(missing(nburn) || is.null(nburn)) {
      nburn <- min(nsave[1], nrep-sum(nsave))
    } else {
      check.1.integer(nburn)
      stopifnot(nburn + sum(nsave) <= nrep)
    }
  }
  stopifnot(is.logical(track))
  pstage <- match.arg(pstage) 

#################################################################
# Conditioning on point configuration
#
# condtype = "none": no conditioning
# condtype = "Palm": conditioning on the presence of specified points
# condtype = "window": conditioning on the configuration in a subwindow
#
  if(is.null(x.cond)) {
    condtype <- "none"
    n.cond <- NULL
  } else if(is.ppp(x.cond)) {
    condtype <- "window"
    n.cond <- x.cond$n
  } else if(is.data.frame(x.cond)) {
    if(ncol(x.cond) %in% c(2,3)) {
      condtype <- "Palm"
      n.cond <- nrow(x.cond)
    } else stop("Wrong number of columns in data frame x.cond")
  } else if(is.list(x.cond)) {
    if(length(x.cond) %in% c(2,3)) {
      x.cond <- as.data.frame(x.cond)
      condtype <- "Palm"
      n.cond <- nrow(x.cond)
    } else stop("Wrong number of components in list x.cond")
  } else stop("Unrecognised format for x.cond")

  if(condtype == "Palm" && n.cond == 0) {
    warning(paste("Ignored empty configuration x.cond;",
                  "conditional (Palm) simulation given an empty point pattern",
                  "is equivalent to unconditional simulation"), call.=FALSE)
    condtype <- "none"
    x.cond <- NULL
    n.cond <- NULL
  }
    
#################################################################
# Fixing the number of points?
#  
# fixcode = 1 <--> no conditioning
# fixcode = 2 <--> conditioning on n = number of points
# fixcode = 3 <--> conditioning on the number of points of each type.

  fixcode    <- 2 - (p<1) + fixall - fixall*(p<1)
  fixing <- switch(fixcode, "none", "n.total", "n.each.type")
  
# Warn about silly combination
  if(fixall && p < 1)
	warning("fixall = TRUE conflicts with p < 1. Ignored.", call.=FALSE)

###############################################################  
# `expand' determines expansion of the simulation window

  expand <- rmhexpand(expand)

# No expansion is permitted if we are conditioning on the
# number of points
  
  if(fixing != "none") {
    if(expand$force.exp)
      stop(paste("When conditioning on the number of points,",
                 "no expansion may be done."), call.=FALSE)
    # no expansion
    expand <- .no.expansion
  }

###################################################################
# return augmented list  
  out <- list(p=p, q=q, 
              nrep=nrep, nverb=nverb,
              expand=expand, 
              periodic=periodic, 
              ptypes=ptypes,
              fixall=fixall,
              fixcode=fixcode,
              fixing=fixing,
              condtype=condtype,
              x.cond=x.cond,
              saving=saving, nsave=nsave, nburn=nburn,
              track=track, pstage=pstage)
  class(out) <- c("rmhcontrol", class(out))
  return(out)
}

print.rmhcontrol <- function(x, ...) {
  verifyclass(x, "rmhcontrol")

  splat("Metropolis-Hastings algorithm control parameters")
  splat("Probability of shift proposal: p =", x$p)
  if(x$fixing == "none") {
    splat("Conditional probability of death proposal: q =", x$q)
    if(!is.null(x$ptypes)) {
      splat("Birth proposal probabilities for each type of point:")
      print(x$ptypes)
    }
  }
  switch(x$fixing,
         none={},
         n.total=splat("The total number of points is fixed"),
         n.each.type=splat("The number of points of each type is fixed"))
  switch(x$condtype,
         none={},
         window={
           splat("Conditional simulation given the",
                 "configuration in a subwindow")
           print(x$x.cond$window)
         },
         Palm={
           splat("Conditional simulation of Palm type")
         })
  splat("Number of M-H iterations: nrep =", x$nrep)
  if(x$saving) {
    nsave <- x$nsave
    len <- length(nsave)
    howmany <- if(len == 1L) nsave else
               if(len < 5L) commasep(nsave) else
               paste(paste(nsave[1:5], collapse=", "), "[...]")
    splat("After a burn-in of", x$nburn, "iterations,",
          "save point pattern after every", howmany, "iterations.")
  }
  pstage <- x$pstage %orifnull% "start"
  hdr <- "Generate random proposal points:"
  switch(pstage,
         start = splat(hdr, "at start of simulations."),
         block = splat(hdr,
                       "before each block of",
                       if(length(x$nsave) == 1L) x$nsave else "",
                       "iterations."))
  cat(paste("Track proposal type and acceptance/rejection?",
            if(x$track) "yes" else "no", "\n"))
  if(x$nverb > 0)
    cat(paste("Progress report every nverb=", x$nverb, "iterations\n"))
  else
    cat("No progress reports (nverb = 0).\n")

  # invoke print.rmhexpand
  print(x$expand)

  cat("Periodic edge correction? ")
  if(is.null(x$periodic)) cat("Not yet determined.\n") else 
  if(x$periodic) cat("Yes.\n") else cat("No.\n")
  #
  
  return(invisible(NULL))
}

default.rmhcontrol <- function(model, w=NULL) {
  # set default for 'expand'
  return(rmhcontrol(expand=default.expand(model, w=w)))
}

update.rmhcontrol <- function(object, ...) {
  do.call.matched(rmhcontrol.default,
                  resolve.defaults(list(...), as.list(object),
                                   .StripNull=TRUE))
}

rmhResolveControl <- function(control, model) {
  # adjust control information once the model is known
  stopifnot(inherits(control, "rmhcontrol"))
  # change *default* expansion rule to something appropriate for model
  # (applies only if expansion rule is undecided)
  control$expand <- change.default.expand(control$expand, default.expand(model))
  return(control)
}

#'
#'      rags.R
#'
#'   Alternating Gibbs Sampler
#'
#'      $Revision: 1.7 $  $Date: 2024/06/09 00:02:20 $
#'
#' Initial implementation for multitype hard core process
#' without interaction within types

rags <- function(model, ..., ncycles=100) {
  if(!is.list(model)) stop("Argument 'model' should be a list")
  if(!all(c("beta", "hradii") %in% names(model)))
    stop("Argument 'model' should have entries 'beta' and 'hradii'")
  do.call(ragsMultiHard, append(model, list(..., ncycles=ncycles)))
}

ragsMultiHard <- function(beta, hradii, ...,
                          types=NULL, bmax=NULL,
                          periodic=FALSE, ncycles=100) {
  ## validate beta by generating first proposal points
  Xprop <- rmpoispp(lambda=beta, lmax=bmax, ..., types=types)
  ntypes <- length(levels(marks(Xprop)))
  check.nmatrix(hradii, ntypes, things="types of points", mname="hradii")
  if(any(is.finite(dh <- diag(hradii)) & dh > 0))
    stop("Interaction between points of the same type is not permitted")
  ## initial state empty
  X <- Xprop[integer(0)]
  Y <- split(X)
  ##
  for(cycle in 1:ncycles) {
    if(cycle > 1)
      Xprop <- rmpoispp(lambda=beta, lmax=bmax, ..., types=types)
    Xprop <- Xprop[order(coords(Xprop)$x)]
    Yprop <- split(Xprop)
    for(i in 1:ntypes) {
      Xi <- Yprop[[i]]
      ok <- TRUE
      for(j in (1:ntypes)[-i]) {
        if(!any(ok)) break;
        ok <- ok & !has.close(Xi, hradii[i,j], Y[[j]], sorted=TRUE,
                             periodic=periodic)
      }
      Y[[i]] <- Xi[ok]
    }
  }
  Z <- do.call(superimpose, Y)
  return(Z)
}

ragsAreaInter <- function(beta, eta, r, ...,
                          win=NULL, bmax=NULL,
                          periodic=FALSE, ncycles=100) {
  check.1.real(eta)
  check.1.real(r)
  if(r == 0 || eta == 1) return(rpoispp(beta, win=win, lmax=bmax, ...))
  if(eta < 1)
    stop("Alternating Gibbs algorithm requires eta >= 1", call.=FALSE)
  if(is.function(beta)) {
    beta <- as.im(beta, W=win, ...)
  } else if(is.numeric(beta)) {
    check.1.real(beta)
    stopifnot(beta >= 0)
  } else if(!is.im(beta)) {
    stop("beta should be a number, a pixel image, or a function(x,y)",
         call.=FALSE)
  }
  if(is.im(beta) && is.null(win))
    win <- as.owin(beta)
  kappa <- beta * eta
  loggamma <- log(eta)/(pi * r^2)
  bmax <- if(is.null(bmax)) NULL else c(max(kappa), loggamma)
  B <- if(is.numeric(beta)) c(kappa, loggamma) else
       solist(kappa, as.im(loggamma, W=win))
  H <- matrix(c(0,r,r,0), 2, 2)
  Y <- ragsMultiHard(B, H, types=1:2, bmax=bmax, periodic=periodic,
                     ncycles=ncycles)
  X <- split(Y)[[1]]
  return(X)
}

#'
#'   randomSSI.R
#'
#'   Simple sequential inhibition
#'
#'   $Revision: 1.4 $ $Date: 2026/03/19 06:11:55 $
#'
#'    Copyright (c) Adrian Baddeley, Ege Rubak and Rolf Turner 1994-2026
#'    GNU Public Licence (>= 2.0)


rSSI <- function(r, n=Inf, win = square(1), 
                 giveup = 1000, x.init=NULL, ...,
                 f=NULL, fmax=NULL,
                 nsim=1, drop=TRUE, verbose=TRUE)
{
  win.given <- !missing(win) && !is.null(win)
  stopifnot(is.numeric(r) && length(r) == 1 && r >= 0)
  stopifnot(is.numeric(n) && length(n) == 1 && n >= 0)
  must.reach.n <- is.finite(n)
  if(!missing(nsim)) {
    check.1.integer(nsim)
    stopifnot(nsim >= 1)
  }
  ## 'verbose' applies only when nsim > 1
  verbose <- verbose && (nsim > 1)
  #' resolve spatial domain
  if(win.given) {
    ## ensure 'win' is a window, a box, or a linear network
    if(!inherits(win, c("owin", "box3", "boxx", "linnet"))) {
      winwin <- try(as.owin(win), silent = TRUE)
      if(inherits(winwin, "try-error"))
        winwin <- try(as.boxx(win), silent = TRUE)
      if(inherits(winwin, "try-error") && requireNamespace("spatstat.linnet"))
        winwin <- try(spatstat.linnet::as.linnet(win), silent=TRUE)
      if(inherits(winwin, "try-error"))
        stop(paste("Could not coerce argument", sQuote("win"), 
                   "to a window, a box, or a linear network"),
             call.=FALSE)
      win <- winwin
    }
  } else if(!is.null(x.init)) {
    if(!inherits(x.init, c("ppp", "lpp", "pp3", "ppx")))
      stop(paste("x.init should be a point pattern of class",
                 commasep(dQuote(c("ppp", "pp3", "ppx", "lpp"), "or"))),
           call.=FALSE)
    win <- domain(x.init)
  } else if(inherits(f, c("im", "funxy", "linfun"))) {
    win <- domain(f)
  } else {
    win <- square(1)
  }

  rSSIengine(win, r=r, n=n, giveup = giveup,
             x.init=x.init, f=f, fmax=fmax,
             nsim=nsim, drop=drop, verbose=verbose, ...)
}

#' Algorithm depends on type of domain

rSSIengine <- function(win, ...) {
  UseMethod("rSSIengine")
}

rSSIengine.owin <- function(win, ..., r,  n=Inf, 
                            giveup = 1000, x.init=NULL,
                            f=NULL, fmax=NULL,
                            nsim=1, drop=TRUE, verbose=TRUE, warn=TRUE) {
  must.reach.n <- is.finite(n)
  if(!is.null(f)) {
    stopifnot(is.numeric(f) || is.im(f) || is.function(f))
    if(is.null(fmax) && !is.numeric(f))
      fmax <- if(is.im(f)) max(f) else max(as.im(f, win))
  }
  ## determine initial state
  if(is.null(x.init)) {
    ## start with empty pattern in specified window
    win <- as.owin(win)
    x.init <- ppp(numeric(0),numeric(0), window=win)
  } else {
    ## start with specified pattern
    stopifnot(is.ppp(x.init))
    ## check compatibility of windows
    if(!identical(win, as.owin(x.init)))
      warning(paste("Argument", sQuote("win"),
                    "is not the same as the window of", sQuote("x.init")))
    x.init.new <- x.init[win]
    if(npoints(x.init.new) == 0)
      stop(paste("No points of x.init lie inside the specified window",
                 sQuote("win")))
    nlost <- npoints(x.init) - npoints(x.init.new)
    if(nlost > 0) 
      warning(paste(nlost, "out of",
                    npoints(x.init), "points of the pattern x.init",
                    "lay outside the specified window",
                    sQuote("win")))
    x.init <- x.init.new
    if(is.finite(n)) {
      if(n < npoints(x.init))
        stop(paste("x.init contains", npoints(x.init), "points",
                   "but a pattern containing only n =", n, "points", 
                   "is required"))
      if(n == npoints(x.init)) {
        warning(paste("Initial state x.init already contains", n, "points;",
                      "no further points were added"))
        result <- rep(list(x.init), nsim)
        result <- simulationresult(result, nsim, drop)
        return(result)
      }
    }
  }
  #' assess packing density
  r2 <- r^2
  winArea <- area(win)
  discarea <- pi * r2/4   # area of disc of diameter r
  arearatio <- winArea/discarea
  nmelt       <- floor( arearatio )
  nclosepack  <- floor( arearatio * pi * sqrt(3)/6 )
  nrandompack <- floor( arearatio * 0.88 )
  nsquarepack <- floor( arearatio * pi/4 )
  if(warn && is.finite(n)) {
    if(n > nmelt) {
      warning(paste("Window is far too small to fit", n, "points",
                    "at minimum separation", r,
                    paren(paste("absolute maximum number is", nmelt))))
    } else if(n > nclosepack) {
      warning(paste("Window is too small to fit", n, "points",
                    "at minimum separation", r,
                    paren(paste("deterministic close packing limit is",
                                nclosepack))))
    } else if(n > nrandompack) {
      warning(paste("Window is very unlikely to fit", n, "points",
                    "at minimum separation", r,
                    paren(paste("random close packing limit is",
                                nrandompack))))
    } else if(n > nsquarepack) {
      warning(paste("Window is unlikely to fit", n, "points",
                    "at minimum separation", r,
                    paren(paste("deterministic square-packing limit is",
                                nsquarepack))))
    }
  }

  #' start simulation 		    
  pstate <- list()
  if(verbose) splat("Generating", nsim, "realisations...")
  result <- vector(mode="list", length=nsim)
  for(isim in seq_len(nsim)) {
    if(verbose) pstate <- progressreport(isim, nsim, state=pstate)
    ## Simple Sequential Inhibition process
    ## fixed number of points
    xx <- coords(x.init)$x
    yy <- coords(x.init)$y
    nn <- npoints(x.init)
    ## Naive implementation, proposals are uniform
    xprop <- yprop <- numeric(0)
    nblock <- if(is.finite(n)) n else min(1024, nmelt)
    ntries <- 0
    while(ntries < giveup) {
      ntries <- ntries + 1
      if(length(xprop) == 0) {
        ## generate some more proposal points
        prop <- if(is.null(f)) runifpoint(nblock, win) else
                               rpoint(nblock, f, fmax, win)
        xprop <- coords(prop)$x
        yprop <- coords(prop)$y
      }
      ## extract next proposal
      xnew <- xprop[1L]
      ynew <- yprop[1L]
      xprop <- xprop[-1L]
      yprop <- yprop[-1L]
      ## check hard core constraint
      dx <- xnew - xx
      dy <- ynew - yy
      if(!any(dx^2 + dy^2 <= r2)) {
        xx <- c(xx, xnew)
        yy <- c(yy, ynew)
        nn <- nn + 1L
        ntries <- 0
      }
      if(nn >= n)
        break
    }
    if(must.reach.n && nn < n)
      warning(paste("Gave up after", giveup,
                    "attempts with only", nn, "points placed out of", n))
    X <- ppp(xx, yy, window=win, check=FALSE)
    result[[isim]] <- X
  }
  result <- simulationresult(result, nsim, drop)
  return(result)
}


rSSIengine.box3 <- function(win, ..., r,  n=Inf, 
                            giveup = 1000, x.init=NULL,
                            f=NULL, fmax=NULL,
                            nsim=1, drop=TRUE, verbose=TRUE, warn = TRUE) {
  must.reach.n <- is.finite(n)
  if(!is.null(f)) {
    stopifnot(is.numeric(f) || is.function(f))
    if(is.null(fmax) && is.function(f))
      stop("Argument fmax is required when f is a function", call.=FALSE)
  }
  ## determine initial state
  if(is.null(x.init)) {
    ## start with empty pattern in specified window
    x.init <- pp3(numeric(0),numeric(0), numeric(0), win)
  } else {
    ## start with specified pattern
    stopifnot(is.pp3(x.init))
    ## check compatibility of domains
    if(!identical(win, domain(x.init)))
      warning(paste("Argument", sQuote("win"),
                    "is not the same as the domain of", sQuote("x.init")))
    x.init.new <- x.init[win]
    if(npoints(x.init.new) == 0)
      stop(paste("No points of x.init lie inside the specified window",
                 sQuote("win")))
    nlost <- npoints(x.init) - npoints(x.init.new)
    if(nlost > 0) 
      warning(paste(nlost, "out of",
                    npoints(x.init), "points of the pattern x.init",
                    "lay outside the specified window",
                    sQuote("win")))
    x.init <- x.init.new
    if(is.finite(n)) {
      if(n < npoints(x.init))
        stop(paste("x.init contains", npoints(x.init), "points",
                   "but a pattern containing only n =", n, "points", 
                   "is required"))
      if(n == npoints(x.init)) {
        warning(paste("Initial state x.init already contains", n, "points;",
                      "no further points were added"))
        result <- rep(list(x.init), nsim)
        result <- simulationresult(result, nsim, drop)
        return(result)
      }
    }
  }
  #' validate radius and 'n' 
  r2 <- r^2
  winVol <- volume(win)
  sphVol <- (pi/6) * r^3
  volratio <- winVol/sphVol
  nmelt       <- floor( volratio )
  nclosepack  <- floor( volratio * pi * sqrt(2)/6 )
  nrandompack <- floor( volratio * 0.64 )
  ncubepack   <- floor( volratio * pi/8 )
  if(warn && is.finite(n) && n > ncubepack) {
    if(n > nmelt) {
      warning(paste("Window is far too small to fit", n, "points",
                    "at minimum separation", r,
                    paren(paste("absolute maximum number is", nmelt))))
    } else if(n > nclosepack) {
      warning(paste("Window is probably too small to fit", n, "points",
                    "at minimum separation", r,
                    paren(paste("deterministic close packing limit is",
                                nclosepack))))
    } else if(n > nrandompack) {
      warning(paste("Algorithm is very unlikely to fit", n, "points",
                    "at minimum separation", r,
                    paren(paste("random close packing limit is",
                                nclosepack))))
    } else if(n > ncubepack) {
      warning(paste("Algorithm may struggle to fit", n, "points",
                    "at minimum separation", r,
                    paren(paste("deterministic cubic packing limit is",
                                ncubepack))))
    }
  }

  #' start simulation 		    
  pstate <- list()
  if(verbose) splat("Generating", nsim, "realisations...")
  result <- vector(mode="list", length=nsim)
  for(isim in seq_len(nsim)) {
    if(verbose) pstate <- progressreport(isim, nsim, state=pstate)
    ## Simple Sequential Inhibition process
    ## fixed number of points
    co <- coords(x.init)
    xx <- co$x
    yy <- co$y
    zz <- co$z
    nn <- npoints(x.init)
    ## Naive implementation, proposals are uniform
    xprop <- yprop <- numeric(0)
    nblock <- if(is.finite(n)) n else min(1024, nmelt)
    ntries <- 0
    while(ntries < giveup) {
      ntries <- ntries + 1
      if(length(xprop) == 0) {
        ## generate some more proposal points
        prop <- runifpoint3(nblock, win)
        if(is.function(f)) {
          ## randomly thin
          p <- with(coords(prop), f(x, y, z, ...)/fmax)
          retain <- runif(npoints(prop)) < p
          prop <- prop[retain]
        }
        cop <- coords(prop)
        xprop <- cop$x
        yprop <- cop$y
        zprop <- cop$z
      }
      if(length(xprop) > 0) {
        ## extract next proposal
        xnew <- xprop[1L]
        ynew <- yprop[1L]
        znew <- zprop[1L]
        xprop <- xprop[-1L]
        yprop <- yprop[-1L]
        zprop <- zprop[-1L]
        ## check hard core constraint
        dx <- xnew - xx
        dy <- ynew - yy
        dz <- znew - zz
        if(!any(dx^2 + dy^2 + dz^2 <= r2)) {
          xx <- c(xx, xnew)
          yy <- c(yy, ynew)
          zz <- c(zz, znew)
          nn <- nn + 1L
          ntries <- 0
        }
        if(nn >= n)
          break
      }
    }
    ## end of rejection method loop for simulation 'isim'
    if(must.reach.n && nn < n) {
      warning(paste("Gave up after", giveup,
                    "attempts with only", nn, "points placed out of", n))
      X <- NAobject("pp3")
    } else {
      X <- pp3(xx, yy, zz, win)
    }
    result[[isim]] <- X
  }
  result <- simulationresult(result, nsim, drop)
  return(result)
}

##
##   randomNS.R
##
##   Simulating from Neyman-Scott process
##   'Naive' algorithm
##
##   $Revision: 1.41 $  $Date: 2025/04/19 03:44:08 $
##
##    Original code for naive simulation of Neyman-Scott by Adrian Baddeley
##    Original code for rCauchy and rVarGamma offspring by Abdollah Jalilian
##    Other code and modifications by Adrian Baddeley
##    Bug fixes by Abdollah, Adrian, and Rolf Turner
##
##   Copyright (c) 2000-2023 Adrian Baddeley and Abdollah Jalilian
##   GNU Public Licence >= 2.0

rNeymanScott <- 
  function(kappa, expand, rcluster, win = unit.square(),
           ..., nsim=1, drop=TRUE, nonempty=TRUE, saveparents=TRUE,
           kappamax=NULL, mumax=NULL)
{
  ## Generic Neyman-Scott process
  ## Implementation for bounded cluster radius
  ##
  check.1.integer(nsim)
  stopifnot(nsim >= 0)
  if(nsim == 0) return(simulationresult(list()))

  ## Catch old argument name 'rmax'
  if(missing(expand) && !is.null(rmax <- list(...)$rmax)) {
    warning("outdated usage in rNeymanScott: 'rmax' should be 'expand'")
    expand <- rmax
  }
    
  ## Catch old argument name 'lmax'
  if(is.null(kappamax) && !is.null(lmax <- list(...)$lmax)) {
    warning("outdated usage in rNeymanScott: 'lmax' should be 'kappamax'")
    kappamax <- lmax
  }
    
  ## 'rcluster' may be
  ##
  ##     (1) a function(x,y, ...) that takes the coordinates
  ##         (x,y) of the parent point and generates a list(x,y) of offspring
  ##

  if(is.function(rcluster))
    return(rPoissonCluster(kappa, expand, rcluster, win, ...,
                           kappamax=kappamax, nsim=nsim, drop=drop,
                           saveparents=saveparents))

  ##     (2) a list(mu, f) where mu is a numeric value, function, or pixel image
  ##         and f is a function(n, ...) generating n i.i.d. offspring at 0,0
  
  if(!(is.list(rcluster) && length(rcluster) == 2))
    stop("rcluster should be either a function, or a list of two elements")
  win <- as.owin(win)
  mu <- rcluster[[1]]
  rdisplace <- rcluster[[2]]
  if(!(is.numeric(mu) || is.im(mu) || is.function(mu))) 
    stop("rcluster[[1]] should be a number, a function or a pixel image")  
  if(is.numeric(mu) && !(length(mu) == 1 && mu >= 0))
    stop("rcluster[[1]] should be a single nonnegative number")
  if(!is.function(rdisplace))
    stop("rcluster[[2]] should be a function")
  if(is.null(mumax))
    mumax <- if(is.numeric(mu)) mu else
             if(is.im(mu)) max(mu) else
             (1.05 * max(as.im(mu, W=win, ..., strict=TRUE)))

  ## Generate parents in dilated window
  frame <- boundingbox(win)
  dilated <- grow.rectangle(frame, expand)
  if(is.im(kappa) && !is.subset.owin(dilated, as.owin(kappa)))
    stop(paste("The window in which the image",
               sQuote("kappa"),
               "is defined\n",
               "is not large enough to contain the dilation of the window",
               sQuote("win")))
  if(nonempty) {
    if(is.function(kappa)) {
      kappa <- as.im(kappa, W=dilated, ..., strict=TRUE)
      kappamax <- NULL
    }
    ## intensity of parents with at least one offspring point
    kappa <- kappa * (1 - exp(-mumax))
  }
  ## generate
  parentlist <- rpoispp(kappa, lmax=kappamax, win=dilated, nsim=nsim,
                        drop=FALSE, warnwin=FALSE)

  resultlist <- vector(mode="list", length=nsim)
  for(i in 1:nsim) {

    ## if(i > 1) gc(FALSE)

    parents <- parentlist[[i]]
    np <- npoints(parents)
    
    ## generate cluster sizes
    if(np == 0) {
      ## no parents - empty pattern
      result <- ppp(numeric(0), numeric(0), window=win)
      parentid <- integer(0)
      noff <- 0
    } else {
      if(!nonempty) {
        ## cluster sizes are Poisson
        csize <- rpois(np, mumax)
      } else {
        ## cluster sizes are Poisson conditional on > 0
        csize <- qpois(runif(np, min=dpois(0, mumax)), mumax)
      }
      noff <- sum(csize)
      xparent <- parents$x
      yparent <- parents$y
      x0 <- rep.int(xparent, csize)
      y0 <- rep.int(yparent, csize)
      ## invoke random generator
      dd <- rdisplace(noff, ...)
      mm <- if(is.ppp(dd)) marks(dd) else NULL
      ## validate
      xy <- xy.coords(dd)
      dx <- xy$x
      dy <- xy$y
      if(!(length(dx) == noff))
        stop("rcluster returned the wrong number of points")
      ## create offspring and offspring-to-parent map
      xoff <- x0 + dx
      yoff <- y0 + dy
      parentid <- rep.int(1:np, csize)
      ## trim to window
      retain <- inside.owin(xoff, yoff, win)
      if(is.im(mu))
        retain[retain] <- inside.owin(xoff[retain], yoff[retain], as.owin(mu))
      xoff <- xoff[retain]
      yoff <- yoff[retain]
      parentid <- parentid[retain]
      if(!is.null(mm)) mm <- marksubset(mm, retain)
      ## done
      result <- ppp(xoff, yoff, window=win, check=FALSE, marks=mm)
    }

    if(is.im(mu)) {
      ## inhomogeneously modulated clusters a la Waagepetersen
      result <- rthin(result, P=mu, Pmax=mumax)
    }

    if(saveparents) {
      attr(result, "parents") <- parents
      attr(result, "parentid") <- parentid
      attr(result, "expand") <- expand
      attr(result, "cost") <- np + noff
    }
    
    resultlist[[i]] <- result
  }

  result <- simulationresult(resultlist, nsim, drop)
  return(result)
}  

fakeNeyScot <- function(Y, lambda, win,
                        saveLambda=FALSE,
                        saveparents=FALSE,
                        LambdaOnly=FALSE, ...) {
  ## Y is a ppp or ppplist obtained from rpoispp
  ## which will be returned as the realisation of a Neyman-Scott process
  ## when the process is degenerately close to Poisson.
  doLambda <- saveLambda || LambdaOnly
  if(doLambda || saveparents) {
    if(doLambda && !is.im(lambda)) lambda <- as.im(lambda, W=win, ...)
    if(isSingle <- is.ppp(Y)) Y <- solist(Y)
    if(LambdaOnly) return(rep(list(lambda), length(Y)))
    for(i in seq_along(Y)) {
      Yi <- Y[[i]]
      if(saveLambda) attr(Yi, "Lambda") <- lambda
      if(saveparents) {
        attr(Yi, "parents") <- list(x=numeric(0), y=numeric(0))
        attr(Yi, "parentid") <- integer(0)
        attr(Yi, "cost") <- npoints(Yi)
      }
      Y[[i]] <- Yi
    }
    if(isSingle) Y <- Y[[1L]]
  }
  return(Y)
}

emptyNeyScot <- function(win, nsim=1, 
                         saveLambda=FALSE,  saveparents=FALSE,
                         LambdaOnly=FALSE, ...) {
  ## generate results of Neyman-Scott when the process is always empty
  empty <- ppp(window=win)
  empties <- as.solist(rep(list(empty), nsim))
  fakeNeyScot(empties, lambda=0, win=win,
              saveLambda=saveLambda,
              saveparents=saveparents,
              LambdaOnly=LambdaOnly, ...)
}

thinParents <- function(X, P, Pmax=1) {
  ## Thin the parents and remove orphans
  Offspring <- X
  Parents <- attr(Offspring, "parents")
  Surname <- attr(Offspring, "parentid")
  retainparents <- rthin(Parents,
                         P=P, Pmax=Pmax,
                         what="fate",
                         na.zero=TRUE, fatal=FALSE)
  retainoffspring <- retainparents[Surname]
  Offspring <- Offspring[retainoffspring]
  attr(Offspring, "parents") <- list(x=Parents$x[retainparents],
                             y=Parents$y[retainparents])
  newserial <- cumsum(retainparents)
  attr(Offspring, "parentid") <- newserial[Surname[retainoffspring]]
  return(Offspring)
}


validate.kappa.mu <- function(kappa, mu, kappamax=NULL, mumax=NULL,
                              win, expand, ..., context="") {
  #' validate 'kappa' and 'mu' arguments
  if(!(is.numeric(mu) || is.im(mu) || is.function(mu)))
    stop(paste(context,
               "mu should be a number, a function or a pixel image"),
         call.=FALSE)
  if(is.numeric(mu)) {
    check.1.real(mu)
    check.finite(mu, xname="mu")
    stopifnot(mu >= 0)
  }
  if(!(is.numeric(kappa) || is.im(kappa) || is.function(kappa)))
    stop(paste(context,
               "kappa should be a number, a function or a pixel image"),
         call.=FALSE)
  if(is.numeric(kappa)) {
    check.1.real(kappa)
    check.finite(kappa, xname="kappa")
    stopifnot(kappa >= 0)
  }

  if(is.im(kappa)) {
    #' check domain 
    frame <- boundingbox(win)
    dilated <- grow.rectangle(frame, expand)
    if(!is.subset.owin(dilated, as.owin(kappa)))
      stop(paste("The window in which the image",
                 sQuote("kappa"),
                 "is defined\n",
                 "is not large enough to contain",
                 "the dilation of the window",
                 sQuote("win")),
             call.=FALSE)
  }

  ## get upper bounds on kappa and mu
  if(is.null(kappamax)) {
    if(is.numeric(kappa)) {
      kappamax <- kappa
    } else if(is.im(kappa)) {
      kappamax <- max(kappa)
    } else if(is.function(kappa)) {
      ## rough upper bound
      frame <- boundingbox(win)
      dilated <- grow.rectangle(frame, expand)
      dotargs <- list(...)
      kargs <- dotargs[names(dotargs) %in% names(args(kappa))]
      kim <- do.call(as.im,
                     append(list(kappa, W=dilated, strict=TRUE),
                            kargs))
      kra <- range(kim)
      kappamax <- kra[2] + 0.05 * diff(kra)
    }
  }
  if(is.null(mumax)) {
    if(is.numeric(mu)) {
      mumax <- mu
    } else if(is.im(mu)) {
      mumax <- max(mu)
    } else if(is.function(mu)) {
      ## rough upper bound
      mim <- as.im(mu, W=win, ..., strict=TRUE)
      mra <- range(mim)
      mumax <- mra[2] + 0.05 * diff(mra)
    } 
  }
  return(list(kappamax=kappamax, mumax=mumax))
}

#'
#'   randompp3.R
#'
#'   Random point patterns in 3 dimensions
#'
#'   runifpoint3    i.i.d. uniformly distributed
#'   rpoint3        i.i.d.
#'   rpoispp3       Poisson (homogeneous or inhomogeneous)
#' 
#'   $Revision: 1.8 $ $Date: 2026/03/19 06:40:37 $
#'
#'   Copyright (c) Adrian Baddeley, Ege Ruba and Rolf Turner 1993-2026
#'   GNU Public Licence (>= 2.0)

runifpoint3 <- function(n, domain=box3(), ..., nsim=1, drop=TRUE, ex=NULL) {
  if(!is.null(ex)) {
    ## make a pattern like 'ex'
    stopifnot(is.pp3(ex))
    if(missing(n) || is.null(n)) n <- npoints(ex)
    if(missing(domain) || is.null(domain)) domain <- domain(ex)
  }
  domain <- as.box3(domain)
  check.1.integer(nsim)
  stopifnot(nsim >= 0)
  result <- vector(mode="list", length=nsim)
  xr <- domain$xrange
  yr <- domain$yrange
  zr <- domain$zrange
  for(i in seq_len(nsim)) {
    x <- runif(n, min=xr[1], max=xr[2])
    y <- runif(n, min=yr[1], max=yr[2])
    z <- runif(n, min=zr[1], max=zr[2])
    result[[i]] <- pp3(x,y,z,domain)
  }
  if(drop && nsim == 1) return(result[[1]])
  result <- as.anylist(result)
  if(nsim > 0) names(result) <- paste("Simulation", seq_len(nsim))
  return(result)
}

rpoint3 <- function(n, f, fmax=NULL, domain=box3(), ...,
                    nsim=1, drop=TRUE, ex=NULL, giveup=1000) {
  if(missing(f) || is.null(f) || (is.numeric(f) && length(f) == 1)) {
    return(runifpoint3(n, domain=domain, nsim=nsim, drop=drop, ex=ex))
  }

  stopifnot(is.function(f))
  if(is.null(fmax)) stop("Argument fmax is required", call.=FALSE)
  check.1.real(fmax)
  stopifnot(fmax >= 0)
  
  if(!is.null(ex)) {
    ## make a pattern like 'ex'
    stopifnot(is.pp3(ex))
    if(missing(n) || is.null(n)) n <- npoints(ex)
    if(missing(domain) || is.null(domain)) domain <- domain(ex)
  }
  domain <- as.box3(domain)
  check.1.integer(nsim)
  stopifnot(nsim >= 0)

  if(fmax == 0) {
    ## empty patterns
    result <- rep(list(NAobject("pp3")), nsim)
    result <- simulationresult(result, drop=drop)
    return(result)
  }

  ## prepare to simulate
  ## first generate all point coordinates
  ntotal <- nsim * n
  xx <- yy <- zz <- numeric(0)
  nn <- 0
  ntries <- 0
  xr <- domain$xrange
  yr <- domain$yrange
  zr <- domain$zrange
  prange <- c(0,1)
  while(nn < ntotal && ntries < giveup) {
    ntries <- ntries + 1
    xprop <- runif(ntotal, min=xr[1], max=xr[2])
    yprop <- runif(ntotal, min=yr[1], max=yr[2])
    zprop <- runif(ntotal, min=zr[1], max=zr[2])
    ## rejection method
    p <- f(xprop,yprop,zprop, ...)/fmax
    if(!all(is.finite(p)))
      stop("Infinite, NA or NaN values in f(x,y,z)", call.=FALSE)
    prange <- range(p, prange)
    retain <- (runif(ntotal) <= p)
    xx <- c(xx, xprop[retain])
    yy <- c(yy, yprop[retain])
    zz <- c(zz, zprop[retain])
    nn <- length(xx)
  }
  if(prange[1L] < 0)
    warning("Negative values of f were encountered", call.=FALSE)
  if(prange[2L] > 1)
    warning("Some values of f exceeded fmax", call.=FALSE)
  ## now divide coordinate vectors into separate point patterns
  result <- vector(mode="list", length=nsim)
  sn <- seq_len(n)
  for(i in seq_len(nsim)) {
    if(nn >= n) {
      result[[i]] <- pp3(xx[sn], yy[sn], zz[sn], domain)
      xx <- xx[-sn]
      yy <- yy[-sn]
      zz <- zz[-sn]
      nn <- length(xx)
    } else {
      warning("Exited after", giveup, "tries with only",
              i - 1L, "patterns generated")
      result[i:nsim] <- rep(list(NAobject("pp3")), nsim-i+1L)
      break
    } 
  }
  result <- simulationresult(result, drop=drop)
  return(result)
}

rpoispp3 <- function(lambda, domain=box3(), ...,
                     nsim=1, drop=TRUE, ex=NULL, lmax=NULL) {
  if(!is.null(ex)) {
    stopifnot(is.pp3(ex))
    if(missing(lambda) || is.null(lambda)) lambda <- intensity(unmark(ex))
    if(missing(domain) || is.null(domain)) domain <- domain(ex)
  }
  domain <- as.box3(domain)
  v <- volume(domain)
  check.1.integer(nsim)
  stopifnot(nsim >= 0)
  if(is.numeric(lambda) && length(as.numeric(lambda)) == 1) {
    lmax <- as.numeric(lambda)
  } else if(is.function(lambda)) {
    if(is.null(lmax))
      stop("lmax is required when lambda is a function", call.=FALSE)
    check.1.real(lmax)
  } else {    
    stop("lambda must be a single numeric value, or a function(x,y,z")
  }
  inhom <- is.function(lambda)
  if(lmax <= 0) {
    ## zero intensity => empty patterns
    none <- numeric(0)
    emptypattern <- pp3(none, none, none, domain)
    result <- rep(list(emptypattern), nsim)
  } else {
    ## generate homogeneous Poisson
    np <- rpois(nsim, lmax * v)
    dom <- as.list(domain)[c("xrange", "yrange", "zrange")]
    result <- vector(mode="list", length=nsim)
    probrange <- numeric(0)
    for(i in seq_len(nsim)) {
      ni <- np[i]
      x <- with(dom, runif(ni, min=xrange[1], max=xrange[2]))
      y <- with(dom, runif(ni, min=yrange[1], max=yrange[2]))
      z <- with(dom, runif(ni, min=zrange[1], max=zrange[2]))
      X.i <- pp3(x,y,z,domain)
      if(inhom && ni > 0) {
        ## Lewis-Shedler thinning 
        p <- lambda(x,y,z)/lmax
        probrange <- range(p, probrange)
        retain <- (runif(ni) <= p)
        X.i <- X.i[retain]
      }
      result[[i]] <- X.i
    }
    if(inhom && length(probrange)) {
      if(probrange[1L] < 0)
        warning("Negative values of lambda(x,y,z) occurred", call.=FALSE)
      if(probrange[2L] > 1)
        warning("Some values of lambda(x,y,z) exceeded lmax", call.=FALSE)
    }
  }
  if(drop && nsim == 1) return(result[[1]])
  result <- as.anylist(result)
  if(nsim > 0) names(result) <- paste("Simulation", seq_len(nsim))
  return(result)
}

#
#
#   rmhstart.R
#
#   $Revision: 1.12 $  $Date: 2016/02/11 10:17:12 $
#
#

rmhstart <- function(start, ...) {
  UseMethod("rmhstart")
}

rmhstart.rmhstart <- function(start, ...) {
  return(start)
}

rmhstart.list <- function(start, ...) {
  st <- do.call.matched(rmhstart.default, start)
  return(st)
}

rmhstart.default <- function(start=NULL, ..., n.start=NULL, x.start=NULL)
{
 if(!is.null(start) || length(list(...)) > 0)
    stop("Syntax should be rmhstart(n.start) or rmhstart(x.start)")
 
  ngiven <- !is.null(n.start)
  xgiven <- !is.null(x.start)
  
  # n.start and x.start are incompatible
  if(ngiven && xgiven)
    stop("Give only one of the arguments n.start and x.start")

  given <- if(ngiven) "n" else if(xgiven) "x" else "none"

  # Validate arguments
  if(ngiven && !is.numeric(n.start))
      stop("n.start should be numeric")
  if(xgiven) {
    # We can't check x.start properly because we don't have the relevant window
    # Just check that it is INTERPRETABLE as a point pattern  
    xx <- as.ppp(x.start, W=ripras, fatal=FALSE)
    if(is.null(xx))
      stop(paste("x.start should be a point pattern object,",
                 "or coordinate data in a format recognised by as.ppp"))
  } else
     xx <- NULL

###################################################################
# return augmented list  
  out <- list(n.start=n.start,
              x.start=x.start,
              given=given,
              xx=xx)
  class(out) <- c("rmhstart", class(out))
  return(out)
}

print.rmhstart <- function(x, ...) {
  verifyclass(x, "rmhstart")

  cat("Metropolis-Hastings algorithm starting parameters\n")
  cat("Initial state: ")
  switch(x$given,
         none={ cat("not given\n") },
         x = {
               cat("given as x.start\n")
               if(is.ppp(x$x.start)) 
                 print(x$x.start)
               else
                 cat(paste("(x,y) coordinates of", x$xx$n,
                           "points (window unspecified)\n"))
               cat("\n")
             },
         n = {
           n.start <- x$n.start
           nstring <-
             if(length(n.start) == 1)
               paste(n.start)
             else 
               paste("(", paste(n.start, collapse=","), ")", sep="")
           cat(paste("number fixed at n.start =", nstring, "\n")) }
         )
}

update.rmhstart <- function(object, ...) {
  do.call.matched(rmhstart.default,
                  resolve.defaults(list(...), as.list(object),
                                   .StripNull=TRUE))
}

\name{rmhexpand}
\alias{rmhexpand}
\title{
  Specify Simulation Window or Expansion Rule
}
\description{
  Specify a spatial domain in which point process simulations
  will be performed. Alternatively, specify a rule which will be
  used to determine the simulation window.
}
\usage{
rmhexpand(x = NULL, ..., area = NULL, length = NULL, distance = NULL)
}
\arguments{
  \item{x}{
    Any kind of data determining the simulation window or the
    expansion rule.
    A window (object of class \code{"owin"}) specifying the
    simulation window, a numerical value specifying an expansion
    factor or expansion distance, a list containing
    one numerical value, an object of class \code{"rmhexpand"},
    or \code{NULL}.
  }
  \item{\dots}{
    Ignored.
  }
  \item{area}{
    Area expansion factor. 
    Incompatible with other arguments.
  }
  \item{length}{
    Length expansion factor.
    Incompatible with other arguments.
    }
  \item{distance}{
    Expansion distance (buffer width).
    Incompatible with other arguments.
  }
}
\details{
  In the Metropolis-Hastings algorithm \code{\link{rmh}}
  for simulating spatial point processes, 
  simulations are usually carried out on a spatial domain that is
  larger than the original window of the point process model,
  then subsequently clipped to the original window.

  The command \code{rmhexpand} can be used to specify the simulation window,
  or to specify a rule which will later be used to determine the
  simulation window from data.

  The arguments are all incompatible: at most one of them should be
  given.

  If the first argument \code{x} is given, it may be any of the
  following:
  \itemize{
    \item
    a window (object of class \code{"owin"}) specifying the
    simulation window.
    \item
    an object of class \code{"rmhexpand"} specifying the
    expansion rule.
    \item
    a single numerical value, without attributes.
    This will be interpreted as the value of the argument \code{area}.
    \item
    either \code{c(area=v)} or \code{list(area=v)},
    where \code{v} is a single numeric value.
    This will be interpreted as the value of the argument \code{area}.
    \item
    either \code{c(length=v)} or \code{list(length=v)},
    where \code{v} is a single numeric value.
    This will be interpreted as the value of the argument \code{length}.
    \item
    either \code{c(distance=v)} or \code{list(distance=v)},
    where \code{v} is a single numeric value.
    This will be interpreted as the value of the argument \code{distance}.
    \item 
    \code{NULL}, meaning that the expansion rule is not yet
    determined. 
  }

  If one of the arguments \code{area}, \code{length} or \code{distance}
  is given, then the simulation window is determined from the original
  data window as follows.
  \describe{
    \item{area}{
      The bounding box of the original data window will be extracted,
      and the simulation window will be a scalar dilation of this rectangle.
      The argument \code{area} should be a numerical value, greater than
      or equal to 1. It specifies the area expansion factor, i.e. the ratio
      of the area of the simulation window to the area of the
      original point process window's bounding box.
    }
    \item{length}{
      The bounding box of the original data window will be extracted,
      and the simulation window will be a scalar dilation of this rectangle.
      The argument \code{length} should be a numerical value, greater than
      or equal to 1. It specifies the length expansion factor, i.e. the ratio
      of the width (height) of the simulation window to the width
      (height) of the original point process window's bounding box.
    }
    \item{distance}{
      The argument \code{distance} should be a numerical value, greater than
      or equal to 0. It specifies the width of a buffer region around the
      original data window. 
      If the original data window is a rectangle, then this window
      is extended by a margin of width equal to \code{distance}
      around all sides of the original rectangle. The result is a
      rectangle.
      If the original data window is not a rectangle, then
      morphological dilation is applied using
      \code{\link[spatstat.geom]{dilation.owin}}
      so that a margin or buffer of width equal to \code{distance}
      is created around all sides of the original window. The result
      is a non-rectangular window, typically of a different shape.
    }
  }
}
\section{Undetermined expansion}{
  If \code{expand=NULL}, this is interpreted to mean that the
  expansion rule is \dQuote{not yet decided}. Expansion will be decided
  later, by the simulation algorithm \code{\link{rmh}}.
  If the model cannot be expanded (for example if the covariate data
  in the model are not available on a larger domain) then expansion
  will not occur. If the model can be expanded, then
  if the point process model has a finite interaction range \code{r},
  the default is \code{rmhexpand(distance=2*r)}, and
  otherwise \code{rmhexpand(area=2)}.
}
\value{
  An object of class \code{"rmhexpand"} specifying the
  expansion rule. There is a \code{print} method for this class.
}
\author{
  \adrian
  and \rolf
}
\seealso{
  \code{\link{expand.owin}} to apply the rule to a window.

  \code{\link{will.expand}} to test whether expansion will occur.

  \code{\link{rmh}}, \code{\link{rmhcontrol}} for background details.
}
\examples{
  rmhexpand()
  rmhexpand(2)
  rmhexpand(1)
  rmhexpand(length=1.5)
  rmhexpand(distance=0.1)
  rmhexpand(letterR)
}
\keyword{spatial}
\keyword{datagen}

\name{quadratresample}
\alias{quadratresample}
\title{Resample a Point Pattern by Resampling Quadrats}
\description{
  Given a point pattern dataset, create a resampled point pattern
  by dividing the window into rectangular quadrats and randomly
  resampling the list of quadrats. 
}
\usage{
quadratresample(X, nx, ny=nx, ...,
                replace = FALSE, nsamples = 1,
                verbose = (nsamples > 1))
}
\arguments{
  \item{X}{
    A point pattern dataset (object of class \code{"ppp"}).
  }
  \item{nx,ny}{
    Numbers of quadrats in the \eqn{x} and \eqn{y} directions.
  }
  \item{\dots}{Ignored.}
  \item{replace}{
    Logical value. Specifies whether quadrats should be sampled
    with or without replacement.
  }
  \item{nsamples}{Number of randomised point patterns to be generated.}
  \item{verbose}{Logical value indicating whether to print progress reports.}
}
\details{
  This command implements a very simple bootstrap resampling procedure
  for spatial point patterns \code{X}.

  The dataset \code{X} must be a point pattern (object of class
  \code{"ppp"}) and its observation window must be a rectangle.

  The window is first divided into \code{N = nx * ny} rectangular tiles
  (quadrats) of equal size and shape. 
  To generate one resampled point pattern, a random sample of
  \code{N} quadrats is selected from the list of \code{N} quadrats,
  with replacement (if \code{replace=TRUE}) or without replacement
  (if \code{replace=FALSE}). The \eqn{i}th quadrat in the original
  dataset is then replaced by the \eqn{i}th sampled quadrat, after the
  latter is shifted so that it
  occupies the correct spatial position. The quadrats are then
  reconstituted into a point pattern inside the same window as \code{X}.

  If \code{replace=FALSE}, this procedure effectively involves a random
  permutation of the quadrats. The resulting resampled point pattern has
  the same number of points as \code{X}.
  If \code{replace=TRUE}, the number of points in the resampled point
  pattern is random.
}
\value{
  A point pattern (if \code{nsamples = 1}) or a 
  list of point patterns (if \code{nsamples > 1}).
}
\author{\adrian
  and \rolf
}
\seealso{
  \code{\link[spatstat.geom]{quadrats}},
  \code{\link[spatstat.geom]{quadratcount}}.

  See \code{\link[spatstat.explore]{varblock}} to estimate the variance of
  a summary statistic by block resampling.
}
\examples{
  quadratresample(bei, 6, 3)
}
\keyword{spatial}
\keyword{datagen}

\name{rpoisppOnLines}
\alias{rpoisppOnLines}
\title{Generate Poisson Point Pattern on Line Segments}
\description{
  Given a line segment pattern, generate a Poisson random point pattern
  on the line segments.
}
\usage{
rpoisppOnLines(lambda, L, lmax = NULL, \dots, nsim=1, drop=TRUE)
}
\arguments{
  \item{lambda}{Intensity of the Poisson process.
    A single number, a \code{function(x,y)}, a pixel image
    (object of class \code{"im"}), or a vector of numbers,
    a list of functions, or a list of images.
  }
  \item{L}{Line segment pattern (object of class \code{"psp"})
    on which the points should be generated.
  }
  \item{lmax}{
    Optional upper bound (for increased computational efficiency).
    A known upper bound for the values of \code{lambda},
    if \code{lambda} is a function or a pixel image.
    That is, \code{lmax} should be a number which is 
    known to be greater than or equal to all values of \code{lambda}. 
  }
  \item{\dots}{Additional arguments passed to \code{lambda} if it is a
    function.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
}
\details{
  This command generates a Poisson point process on the one-dimensional
  system of line segments in \code{L}. The result is a point pattern
  consisting of points lying on the line segments in \code{L}.
  The number of random points falling on any given line segment follows
  a Poisson distribution. The patterns of points on different segments
  are independent.

  The intensity \code{lambda} is the expected number of points
  per unit \bold{length} of line segment. 
  It may be constant, or it may depend on spatial location.

  In order to generate an unmarked Poisson process,
  the argument \code{lambda} may be a single number,
  or a \code{function(x,y)}, or a pixel image (object of class
  \code{"im"}). 

  In order to generate a \emph{marked} Poisson process,
  \code{lambda} may be a numeric vector, a list of functions,
  or a list of images, each entry giving the intensity for
  a different mark value.

  If \code{lambda} is not numeric, then the (Lewis-Shedler)
  rejection method is used. 
  The rejection method requires knowledge of \code{lmax},
  the maximum possible value of \code{lambda}. This should be either
  a single number, or a numeric vector of the same length as
  \code{lambda}. If \code{lmax} is not
  given, it will be computed approximately, by sampling many values of
  \code{lambda}.

  If \code{lmax} is given, then it \bold{must} be larger than
  any possible value of \code{lambda}, otherwise the results of the
  algorithm will be incorrect.
}
\value{
  If \code{nsim = 1}, a point pattern
  (object of class \code{"ppp"}) in the same window
  as \code{L}. If \code{nsim > 1}, a list of such point patterns.
}
\seealso{
  \code{\link[spatstat.geom]{psp}},
  \code{\link[spatstat.geom]{ppp}},
  \code{\link{runifpointOnLines}},
  \code{\link{rpoispp}}
}
\examples{
  live <- interactive()
  L <- psp(runif(10), runif(10), runif(10), runif(10),  window=owin())
  if(live) plot(L, main="")

  # uniform intensity
  Y <- rpoisppOnLines(4, L)
  if(live) plot(Y, add=TRUE, pch="+")

  # uniform MARKED process with types 'a' and 'b'
  Y <- rpoisppOnLines(c(a=4, b=5), L)
  if(live) {
    plot(L, main="")
    plot(Y, add=TRUE, pch="+")
  }

  # intensity is a function
  Y <- rpoisppOnLines(function(x,y){ 10 * x^2}, L, 10)
  if(live) { 
    plot(L, main="")
    plot(Y, add=TRUE, pch="+")
  }

  # intensity is an image
  Z <- as.im(function(x,y){10 * sqrt(x+y)}, unit.square())
  Y <- rpoisppOnLines(Z, L, 15)
  if(live) {
   plot(L, main="")
   plot(Y, add=TRUE, pch="+")
  }
}
\author{\adrian
  
  
  and \rolf
  
}
\keyword{spatial}
\keyword{datagen}

\name{rCauchy}
\alias{rCauchy}
\title{Simulate Neyman-Scott Point Process with Cauchy cluster kernel}
\description{
  Generate a random point pattern, a simulated realisation of the
  Neyman-Scott process with Cauchy cluster kernel.
}
\usage{
 rCauchy(kappa, scale, mu, win = square(1),
            nsim=1, drop=TRUE,
            \dots,
            n.cond = NULL, w.cond = NULL,
            algorithm=c("BKBC", "naive"),
            nonempty=TRUE, 
            thresh = 0.001, poisthresh=1e-6,
            expand = NULL,
            saveparents=FALSE, saveLambda=FALSE,
            kappamax=NULL, mumax=NULL, LambdaOnly=FALSE)
}
\arguments{
  \item{kappa}{
    Intensity of the Poisson process of cluster centres.
    A single positive number, a function, or a pixel image.
  }
  \item{scale}{
    Scale parameter for cluster kernel. Determines the size of clusters.
    A single positive number, in the same units as the spatial coordinates.
  }
  \item{mu}{
    Mean number of points per cluster (a single positive number)
    or reference intensity for the cluster points (a function or
    a pixel image).
  }
  \item{win}{
    Window in which to simulate the pattern.
    An object of class \code{"owin"}
    or something acceptable to \code{\link[spatstat.geom]{as.owin}}.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
  \item{\dots}{
    Passed to \code{\link[spatstat.random]{clusterfield}} to control the image
    resolution when \code{saveLambda=TRUE}, and to 
    \code{\link[spatstat.random]{clusterradius}} when
    \code{expand} is missing or \code{NULL}.
  }
  \item{n.cond}{
    Optional. Integer specifying a fixed number of points.
    See the section on \emph{Conditional Simulation}.
  }
  \item{w.cond}{
    Optional. Conditioning region. A window (object of class \code{"owin"})
    specifying the region which must contain exactly \code{n.cond} points.
    See the section on \emph{Conditional Simulation}.
  }
  \item{algorithm}{
    String (partially matched) specifying the simulation algorithm.
    See Details.
  }
  \item{nonempty}{
    Logical. If \code{TRUE} (the default), a more efficient algorithm is
    used, in which parents are generated conditionally on having at
    least one offspring point. If \code{FALSE}, parents are generated
    even if they have no offspring. Both choices are valid; the default
    is recommended unless you need to simulate all the parent points
    for some other purpose.
  }
  \item{thresh}{
    Threshold relative to the cluster kernel value at the origin (parent
    location) determining when the cluster kernel will be treated as
    zero for simulation purposes. Will be overridden by argument
    \code{expand} if that is given.
  }
  \item{poisthresh}{
    Numerical threshold below which the model will be treated
    as a Poisson process. See Details.
  }
  \item{expand}{
    Window expansion distance. A single number.
    The distance by which the original window will be expanded
    in order to generate parent points.
    Has a sensible default, determined by calling
    \code{\link[spatstat.random]{clusterradius}}
    with the numeric threshold value given
    in \code{thresh}.
  }
  \item{saveparents}{
    Logical value indicating whether to save the locations of the
    parent points as an attribute.
  }
  \item{saveLambda}{
    Logical. If \code{TRUE} then the random intensity corresponding to
    the simulated parent points will also be calculated and saved,
    and returns as an attribute of the point pattern.
  }
  \item{kappamax}{
    Optional. Numerical value which is an upper bound for the
    values of \code{kappa}, when \code{kappa} is a pixel image or a
    function.
  }
  \item{mumax}{
    Optional. Numerical value which is an upper bound for the
    values of \code{mu}, when \code{mu} is a pixel image or a
    function.
  }
  \item{LambdaOnly}{
    Logical value specifying whether to return only the random intensity,
    rather than the point pattern.
  }
}
\value{
  A point pattern (object of class \code{"ppp"})
  or a list of point patterns.

  Additionally, some intermediate results of the simulation are returned
  as attributes of this point pattern (see
  \code{\link[spatstat.random]{rNeymanScott}}).
  Furthermore, the simulated intensity
  function is returned as an attribute \code{"Lambda"}, if
  \code{saveLambda=TRUE}.

  If \code{LambdaOnly=TRUE} the result is a pixel image
  (object of class \code{"im"}) or a list of pixel images.
}
\details{
  This algorithm generates a realisation of the Neyman-Scott process
  with Cauchy cluster kernel, inside the window \code{win}.

  The process is constructed by first
  generating a Poisson point process of \dQuote{parent} points 
  with intensity \code{kappa}. Then each parent point is
  replaced by a random cluster of points, the number of points in each
  cluster being random with a Poisson (\code{mu}) distribution,
  and the points being placed independently and uniformly
  according to a Cauchy kernel.

  Note that, for correct simulation of the model,
  the parent points are not restricted to lie inside the 
  window \code{win};
  the parent process is effectively the uniform Poisson process
  on the infinite plane.

  The algorithm can also generate spatially inhomogeneous versions of
  the cluster process:
  \itemize{
    \item The parent points can be spatially inhomogeneous.
    If the argument \code{kappa} is a \code{function(x,y)}
    or a pixel image (object of class \code{"im"}), then it is taken
    as specifying the intensity function of an inhomogeneous Poisson
    process that generates the parent points.
    \item The offspring points can be inhomogeneous. If the
    argument \code{mu} is a \code{function(x,y)}
    or a pixel image (object of class \code{"im"}), then it is
    interpreted as the reference density for offspring points,
    in the sense of Waagepetersen (2006).
  }
  When the parents are homogeneous (\code{kappa} is a single number)
  and the offspring are inhomogeneous (\code{mu} is a
  function or pixel image), the model can be fitted to data
  using \code{\link[spatstat.model]{kppm}}.  

  If the pair correlation function of the model is very close
  to that of a Poisson process, deviating by less than
  \code{poisthresh}, then the model is approximately a Poisson process,
  and will be simulated as a Poisson process with intensity
  \code{kappa * mu}, using \code{\link[spatstat.random]{rpoispp}}. 
  This avoids computations that would otherwise require huge amounts
  of memory.
}
\section{Simulation Algorithm}{
  Two simulation algorithms are implemented.
  \itemize{
    \item The \emph{naive} algorithm generates the cluster process 
    by directly following the description given above. First the window
    \code{win} is expanded by a distance equal to \code{expand}.
    Then the parent points are generated in the expanded window according to
    a Poisson process with intensity \code{kappa}. Then each parent
    point is replaced by a finite cluster of offspring points as
    described above.
    The naive algorithm is used if \code{algorithm="naive"} or if
    \code{nonempty=FALSE}.
    \item The \emph{BKBC} algorithm, proposed by Baddeley and Chang
    (2023), is a modification of the algorithm of Brix and Kendall (2002). 
    Parents are generated in the infinite plane, subject to the
    condition that they have at least one offspring point inside the
    window \code{win}.
    The BKBC algorithm is used when \code{algorithm="BKBC"} (the default)
    and \code{nonempty=TRUE} (the default).
  }
  The naive algorithm becomes very slow when \code{scale} is large,
  while the BKBC algorithm is uniformly fast (Baddeley and Chang, 2023).

  If \code{saveparents=TRUE}, then the simulated point pattern will
  have an attribute \code{"parents"} containing the coordinates of the
  parent points, and an attribute \code{"parentid"} mapping each
  offspring point to its parent.

  If \code{nonempty=TRUE} (the default), then parents are generated
  subject to the condition that they have at least one offspring point 
  in the window \code{win}. 
  \code{nonempty=FALSE}, then parents without offspring will be included;
  this option is not available in the \emph{BKBC} algorithm.
  
  Note that if \code{kappa} is a pixel image, its domain must be larger
  than the window \code{win}. This is because an offspring point inside
  \code{win} could have its parent point lying outside \code{win}.
  In order to allow this, the naive simulation algorithm
  first expands the original window \code{win}
  by a distance equal to \code{expand} and generates the Poisson process of
  parent points on this larger window. If \code{kappa} is a pixel image,
  its domain must contain this larger window.

  If the pair correlation function of the model is very close
  to that of a Poisson process, with maximum deviation less than
  \code{poisthresh}, then the model is approximately a Poisson process.
  This is detected by the naive algorithm which then
  simulates a Poisson process with intensity
  \code{kappa * mu}, using \code{\link[spatstat.random]{rpoispp}}. 
  This avoids computations that would otherwise require huge amounts
  of memory.
}
\section{Conditional Simulation}{
  If \code{n.cond} is specified, it should be a single integer.
  Simulation will be conditional on the event 
  that the pattern contains exactly \code{n.cond} points
  (or contains exactly \code{n.cond} points inside
  the region \code{w.cond} if it is given).

  Conditional simulation uses the rejection algorithm described
  in Section 6.2 of Moller, Syversveen and Waagepetersen (1998).
  There is a maximum number of proposals which will be attempted.
  Consequently the return value may contain fewer
  than \code{nsim} point patterns.

  The current algorithm for conditional simulation ignores the
  argument \code{saveparents} and does not save the parent points.
}
\section{Fitting cluster models to data}{
  The Cauchy cluster model with homogeneous parents
  (i.e. where \code{kappa} is a single number)
  where the offspring are either homogeneous or inhomogeneous (\code{mu}
  is a single number, a function or pixel image)
  can be fitted to point pattern data using \code{\link[spatstat.model]{kppm}},
  or fitted to the inhomogeneous \eqn{K} function
  using \code{\link[spatstat.model]{cauchy.estK}}
  or \code{\link[spatstat.model]{cauchy.estpcf}}.
  
  Currently \pkg{spatstat} does not support fitting the
  Cauchy cluster process model
  with inhomogeneous parents.

  A Cauchy cluster process model fitted by \code{\link[spatstat.model]{kppm}}
  can be simulated automatically using \code{\link[spatstat.model]{simulate.kppm}}
  (which invokes \code{rCauchy} to perform the simulation).
}

\seealso{
\code{\link[spatstat.random]{rpoispp}},    
\code{\link[spatstat.random]{rMatClust}},  
\code{\link[spatstat.random]{rThomas}},    
\code{\link[spatstat.random]{rVarGamma}},  
\code{\link[spatstat.random]{rNeymanScott}}, 
\code{\link[spatstat.random]{rGaussPoisson}}.

For fitting the model, see
\code{\link[spatstat.model]{kppm}}, 
\code{\link[spatstat.model]{clusterfit}}. 
}
\examples{
 # homogeneous
 X <- rCauchy(30, 0.01, 5)
 # inhomogeneous
 ff <- function(x,y){ exp(2 - 3 * abs(x)) }
 Z <- as.im(ff, W= owin())
 Y <- rCauchy(50, 0.01, Z)
 YY <- rCauchy(ff, 0.01, 5)
}
\references{
  \baddchangclustersim

  Brix, A. and Kendall, W.S. (2002)
  Simulation of cluster point processes without edge effects.
  \emph{Advances in Applied Probability} \bold{34}, 267--280.

  Ghorbani, M. (2013) Cauchy cluster process.
  \emph{Metrika} \bold{76}, 697-706.

  Jalilian, A., Guan, Y. and Waagepetersen, R. (2013)
  Decomposition of variance for spatial Cox processes.
  \emph{Scandinavian Journal of Statistics} \bold{40}, 119-137.

  \Moller, J., Syversveen, A. and Waagepetersen, R. (1998)
  Log Gaussian Cox Processes.
  \emph{Scandinavian Journal of Statistics} \bold{25}, 451--482.

  Waagepetersen, R. (2007)
  An estimating function approach to inference for
  inhomogeneous Neyman-Scott processes.
  \emph{Biometrics} \bold{63}, 252--258.
}
\author{
  Original algorithm by Abdollah Jalilian and Rasmus Waagepetersen.
  Adapted for \pkg{spatstat} by \adrian.
  Brix-Kendall-Baddeley-Chang algorithm implemented by
  \adrian and \yamei.
}
\keyword{spatial}
\keyword{datagen}

\name{clusterprocess}
\alias{clusterprocess}
\title{
  Cluster Point Process Model
}
\description{
  Creates an object representing a cluster point process model
  with the specified parameters.
  Typically used for simulations or calculations about such a model.
}
\usage{
clusterprocess(name = "Thomas", \dots, mu, kappa, scale)
}
\arguments{
  \item{name}{
    Name of the cluster process. One of
    \code{"Thomas"},
    \code{"MatClust"},
    \code{"VarGamma"} or
    \code{"Cauchy"}.
  }
  \item{\dots}{
    Other arguments needed for the model.
  }
  \item{mu}{
    Mean cluster size. A single number, or a pixel image.
  }
  \item{kappa}{
    Parent intensity. A single number.
  }
  \item{scale}{
    Cluster scale parameter of the model.
  }
}
\details{
  This function creates an object representing a Neyman-Scott-Cox
  cluster process model with the specified parameter values.
  The object belongs to the class \code{"clusterprocess"}.

  This is different from the model-fitting function
  \code{\link[spatstat.model]{kppm}} which fits such a model to a point pattern dataset.

  There are methods for simulating a \code{"clusterprocess"},
  calculating its moments, and other purposes, listed under
  \emph{See Also}.
}
\value{
  Object of class \code{"clusterprocess"}.
}
\author{
  \adrian
}
\seealso{
  Methods for 
  \code{simulate},
  \code{predict},
  \code{intensity},
  \code{print},
  \code{clusterradius} and 
  \code{reach}
  are supplied in package \pkg{spatstat.random}
  and documented under \code{\link{methods.clusterprocess}}.

  The functions
  \code{\link[spatstat.model]{Kmodel}},
  \code{\link[spatstat.model]{pcfmodel}},
  \code{\link[spatstat.model]{psib}},
  \code{\link[spatstat.model]{persist}},
  \code{\link[spatstat.model]{clusterstrength}} and
  \code{\link[spatstat.model]{varcount}}
  in package \pkg{spatstat.model}
  can also be applied to a \code{"clusterprocess"}.
}
\examples{
  m <- clusterprocess("Thomas", kappa=10, mu=5, scale=0.1)
  simulate(m, win=square(2))
}
\keyword{spatial}
\keyword{models}

\name{rnoise}
\alias{rnoise}
\title{
  Random Pixel Noise
}
\description{
  Generate a pixel image whose pixel values are random numbers
  following a specified probability distribution.
}
\usage{
rnoise(rgen = runif, w = square(1), \dots)
}
\arguments{
  \item{rgen}{
    Random generator for the pixel values.
    A function in the \R language.
  }
  \item{w}{
    Window (region or pixel raster) in which to generate the image.
    Any data acceptable to \code{\link[spatstat.geom]{as.mask}}.
  }
  \item{\dots}{
    Arguments, matched by name,
    to be passed to \code{rgen} to specify the parameters of the
    probability distribution, or passed to \code{\link[spatstat.geom]{as.mask}}
    to control the pixel resolution.
  }
}
\details{
  The argument \code{w} could be a window (class \code{"owin"}),
  a pixel image (class \code{"im"}) or other data. It is 
  first converted to a binary mask by \code{\link[spatstat.geom]{as.mask}}
  using any relevant arguments in \code{\dots}.
  
  Then each pixel inside the window (i.e. with logical value
  \code{TRUE} in the mask) is assigned a random numerical value
  by calling the function \code{rgen}.

  The function \code{rgen} would typically be one of the standard
  random variable generators like \code{\link{runif}} (uniformly
  distributed random values) or \code{\link{rnorm}} (Gaussian random
  values). Its first argument \code{n} is the number of values to be
  generated. Other arguments to \code{rgen} must be matched by name.
}
\value{
  A pixel image (object of class \code{"im"}).
}
\author{
\adrian


\rolf

and \ege

}
\seealso{
  \code{\link[spatstat.geom]{as.mask}},
  \code{\link[spatstat.geom]{as.im}},
  \code{\link[stats]{Distributions}}.
}
\examples{
  plot(rnoise(), main="Uniform noise")
  plot(rnoise(rnorm, dimyx=32, mean=2, sd=1),
       main="White noise")
}
\keyword{spatial}
\keyword{datagen}

\name{rDGS}
\alias{rDGS}
\title{Perfect Simulation of the Diggle-Gates-Stibbard Process}
\description{
  Generate a random pattern of points, a simulated realisation
  of the Diggle-Gates-Stibbard process, using a perfect simulation algorithm.
}
\usage{
  rDGS(beta, rho, W = owin(), expand=TRUE, nsim=1, drop=TRUE)
}
\arguments{
  \item{beta}{
    intensity parameter (a positive number).
  }
  \item{rho}{
    interaction range (a non-negative number).
  }
  \item{W}{
    window (object of class \code{"owin"}) in which to
    generate the random pattern. 
  }
  \item{expand}{
    Logical. If \code{FALSE}, simulation is performed
    in the window \code{W}, which must be rectangular.
    If \code{TRUE} (the default), simulation is performed
    on a larger window, and the result is clipped to the original
    window \code{W}.
    Alternatively \code{expand} can be an object of class 
    \code{"rmhexpand"} (see \code{\link[spatstat.random]{rmhexpand}})
    determining the expansion method.
  }
  \item{nsim}{Number of simulated realisations to be generated.}  
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
}
\details{
  This function generates a realisation of the 
  Diggle-Gates-Stibbard point process in the window \code{W}
  using a \sQuote{perfect simulation} algorithm.

  Diggle, Gates and Stibbard (1987) proposed a pairwise interaction
  point process in which each pair of points separated by
  a distance \eqn{d} contributes a factor \eqn{e(d)} to the
  probability density, where
  \deqn{
    e(d) = \sin^2\left(\frac{\pi d}{2\rho}\right)
  }{
    e(d) = sin^2((pi * d)/(2 * rho))
  }
  for \eqn{d < \rho}{d < rho}, and \eqn{e(d)} is equal to 1
  for \eqn{d \ge \rho}{d >= rho}.

  The simulation algorithm used to generate the point pattern
  is \sQuote{dominated coupling from the past}
  as implemented by Berthelsen and \Moller (2002, 2003).
  This is a \sQuote{perfect simulation} or \sQuote{exact simulation}
  algorithm, so called because the output of the algorithm is guaranteed
  to have the correct probability distribution exactly (unlike the
  Metropolis-Hastings algorithm used in \code{\link[spatstat.random]{rmh}}, whose output
  is only approximately correct).

  There is a tiny chance that the algorithm will 
  run out of space before it has terminated. If this occurs, an error
  message will be generated.
}
\value{
  If \code{nsim = 1}, a point pattern (object of class \code{"ppp"}).
  If \code{nsim > 1}, a list of point patterns.
}
\references{
  Berthelsen, K.K. and \Moller, J. (2002)
  A primer on perfect simulation for spatial point processes.
  \emph{Bulletin of the Brazilian Mathematical Society} 33, 351-367.

  Berthelsen, K.K. and \Moller, J. (2003)
  Likelihood and non-parametric Bayesian MCMC inference 
  for spatial point processes based on perfect simulation and
  path sampling. 
  \emph{Scandinavian Journal of Statistics} 30, 549-564.

  Diggle, P.J., Gates, D.J., and Stibbard, A. (1987)
   A nonparametric estimator for pairwise-interaction point processes.
   Biometrika \bold{74}, 763 -- 770.
   \emph{Scandinavian Journal of Statistics} \bold{21}, 359--373.

  \Moller, J. and Waagepetersen, R. (2003).
  \emph{Statistical Inference and Simulation for Spatial Point Processes.}
  Chapman and Hall/CRC.
}
\author{
  \adrian,
  based on original code for the Strauss process by 
  Kasper Klitgaard Berthelsen.
}
\examples{
   X <- rDGS(50, 0.05)
   Z <- rDGS(50, 0.03, nsim=2)
}
\seealso{
  \code{\link[spatstat.random]{rmh}},
  \code{\link[spatstat.model]{DiggleGatesStibbard}}.

  \code{\link[spatstat.random]{rStrauss}},
  \code{\link[spatstat.random]{rHardcore}},
  \code{\link[spatstat.random]{rStraussHard}},
  \code{\link[spatstat.random]{rDiggleGratton}},
  \code{\link[spatstat.random]{rPenttinen}}.
}
\keyword{spatial}
\keyword{datagen}

\name{default.rmhcontrol}
\alias{default.rmhcontrol}
\title{Set Default Control Parameters for Metropolis-Hastings Algorithm.}
\description{
  For a Gibbs point process model (either a fitted model,
  or a model specified by its parameters), this command
  sets appropriate default values of the
  parameters controlling the iterative behaviour
  of the Metropolis-Hastings algorithm.
}
\usage{
   default.rmhcontrol(model, w=NULL)
}
\arguments{
  \item{model}{
    A fitted point process model (object of class \code{"ppm"})
    or a description of a Gibbs point process model
    (object of class \code{"rmhmodel"}).
  }
  \item{w}{
    Optional. Window for the resulting simulated patterns.
  }
}
\value{
  An object of class \code{"rmhcontrol"}. See \code{\link{rmhcontrol}}.
}
\details{
  This function sets the values of 
  the parameters controlling the iterative behaviour
  of the Metropolis-Hastings
  simulation algorithm. It uses default values
  that would be appropriate for the fitted point
  process model \code{model}.

  The expansion parameter \code{expand} is set to
  \code{\link{default.expand}(model, w)}.

  All other parameters revert to their defaults given in
  \code{\link{rmhcontrol.default}}.
  
  See \code{\link{rmhcontrol}} for the full list of control parameters.
  To override default parameters, use \code{\link{update.rmhcontrol}}.
}
\seealso{
  \code{\link[spatstat.random]{rmhcontrol}},
  \code{\link[spatstat.random]{update.rmhcontrol}},
  \code{\link[spatstat.model]{ppm}},
  \code{\link[spatstat.random]{default.expand}}
}
\examples{
if(require(spatstat.model)) {
  fit <- ppm(cells, ~1, Strauss(0.1))
  default.rmhcontrol(fit)
  default.rmhcontrol(fit, w=square(2))
}
   m <- rmhmodel(cif='strauss',
                 par=list(beta=100, gamma=0.5, r=0.1),
                 w=unit.square())
  default.rmhcontrol(m)
  default.rmhcontrol(m, w=square(2))
}
\author{
  \adrian
  and \rolf
}
\keyword{spatial}
\keyword{datagen}

\name{rDiggleGratton}
\alias{rDiggleGratton}
\title{Perfect Simulation of the Diggle-Gratton Process}
\description{
  Generate a random pattern of points, a simulated realisation
  of the Diggle-Gratton process, using a perfect simulation algorithm.
}
\usage{
  rDiggleGratton(beta, delta, rho, kappa=1, W = owin(),
                 expand=TRUE, nsim=1, drop=TRUE)
}
\arguments{
  \item{beta}{
    intensity parameter (a positive number).
  }
  \item{delta}{
    hard core distance (a non-negative number).
  }
  \item{rho}{
    interaction range (a number greater than \code{delta}).
  }
  \item{kappa}{
    interaction exponent (a non-negative number).
  }
  \item{W}{
    window (object of class \code{"owin"}) in which to
    generate the random pattern. Currently this must be a rectangular
    window.
  }
  \item{expand}{
    Logical. If \code{FALSE}, simulation is performed
    in the window \code{W}, which must be rectangular.
    If \code{TRUE} (the default), simulation is performed
    on a larger window, and the result is clipped to the original
    window \code{W}.
    Alternatively \code{expand} can be an object of class 
    \code{"rmhexpand"} (see \code{\link[spatstat.random]{rmhexpand}})
    determining the expansion method.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
}
\details{
  This function generates a realisation of the 
  Diggle-Gratton point process in the window \code{W}
  using a \sQuote{perfect simulation} algorithm.

  Diggle and Gratton (1984, pages 208-210)
  introduced the pairwise interaction point
  process with pair potential \eqn{h(t)} of the form
  \deqn{
    h(t) = \left( \frac{t-\delta}{\rho-\delta} \right)^\kappa
    \quad\quad \mbox{  if  } \delta \le t \le \rho
  }{
    h(t) = ((t - delta)/(rho - delta))^kappa, {    } delta <= t <= rho
  }
  with \eqn{h(t) = 0} for \eqn{t < \delta}{t < delta}
  and  \eqn{h(t) = 1} for \eqn{t > \rho}{t > rho}.
  Here \eqn{\delta}{delta}, \eqn{\rho}{rho} and \eqn{\kappa}{kappa}
  are parameters.

  Note that we use the symbol \eqn{\kappa}{kappa}
  where Diggle and Gratton (1984) 
  use \eqn{\beta}{beta}, since in \pkg{spatstat} we reserve the symbol
  \eqn{\beta}{beta} for an intensity parameter.

  The parameters must all be nonnegative,
  and must satisfy \eqn{\delta \le \rho}{delta <= rho}.

  The simulation algorithm used to generate the point pattern
  is \sQuote{dominated coupling from the past}
  as implemented by Berthelsen and \Moller (2002, 2003).
  This is a \sQuote{perfect simulation} or \sQuote{exact simulation}
  algorithm, so called because the output of the algorithm is guaranteed
  to have the correct probability distribution exactly (unlike the
  Metropolis-Hastings algorithm used in \code{\link[spatstat.random]{rmh}}, whose output
  is only approximately correct).

  There is a tiny chance that the algorithm will 
  run out of space before it has terminated. If this occurs, an error
  message will be generated.
}
\value{
  If \code{nsim = 1}, a point pattern (object of class \code{"ppp"}).
  If \code{nsim > 1}, a list of point patterns.
}
\references{
  Berthelsen, K.K. and \Moller, J. (2002)
  A primer on perfect simulation for spatial point processes.
  \emph{Bulletin of the Brazilian Mathematical Society} 33, 351-367.

  Berthelsen, K.K. and \Moller, J. (2003)
  Likelihood and non-parametric Bayesian MCMC inference 
  for spatial point processes based on perfect simulation and
  path sampling. 
  \emph{Scandinavian Journal of Statistics} 30, 549-564.

  Diggle, P.J. and Gratton, R.J. (1984)
  Monte Carlo methods of inference for implicit statistical models.
  \emph{Journal of the Royal Statistical Society, series B}
  \bold{46}, 193 -- 212.

  \Moller, J. and Waagepetersen, R. (2003).
  \emph{Statistical Inference and Simulation for Spatial Point Processes.}
  Chapman and Hall/CRC.
}
\author{
  \adrian
  
  
  based on original code for the Strauss process by 
  Kasper Klitgaard Berthelsen.
}
\examples{
   X <- rDiggleGratton(50, 0.02, 0.07)
   Z <- rDiggleGratton(50, 0.02, 0.07, 2, nsim=2)
}
\seealso{
  \code{\link[spatstat.random]{rmh}},
  \code{\link[spatstat.random]{rStrauss}},
  \code{\link[spatstat.random]{rHardcore}},
  \code{\link[spatstat.random]{rStraussHard}},
  \code{\link[spatstat.random]{rDGS}},
  \code{\link[spatstat.random]{rPenttinen}}.

  For fitting the model, see \code{\link[spatstat.model]{DiggleGratton}}.
}
\keyword{spatial}
\keyword{datagen}

\name{runifpointx}
\alias{runifpointx}
\title{
  Generate N Uniform Random Points in Any Dimensions
}
\description{
  Generate a random point pattern containing \code{n}
  independent, uniform random points in any number of spatial dimensions.
}
\usage{
runifpointx(n, domain, nsim=1, drop=TRUE)
}
\arguments{
  \item{n}{
    Number of points to be generated.
  }
  \item{domain}{
    Multi-dimensional box in which the process should be generated.
    An object of class \code{"boxx"}.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a single point pattern.
  }
}
\value{
  If \code{nsim = 1} and \code{drop=TRUE},
  a point pattern (an object of class \code{"ppx"}).
  If \code{nsim > 1} or \code{drop=FALSE}, a list of such point patterns.
}
\details{
  This function generates a pattern of \code{n} independent random points,
  uniformly distributed in the multi-dimensional box \code{domain}.
}
\seealso{
  \code{\link{rpoisppx}}, 
  \code{\link[spatstat.geom]{ppx}}, 
  \code{\link[spatstat.geom]{boxx}}
}
\examples{
   w <- boxx(x=c(0,1), y=c(0,1), z=c(0,1), t=c(0,3))
   X <- runifpointx(50, w)
}
\author{
  \adrian
  and \rolf.
}
\keyword{spatial}
\keyword{datagen}

\name{dpakes}
\alias{dpakes}
\alias{ppakes}
\alias{qpakes}
\alias{rpakes}
\title{
  Pakes distribution
}
\description{
  Probability density, cumulative distribution function,
  quantile function, and random generation for the Pakes
  distribution.
}
\usage{
dpakes(x, zeta)
ppakes(q, zeta)
qpakes(p, zeta)
rpakes(n, zeta)
}
\arguments{
  \item{x,q}{
    Numeric vector of quantiles.
  }
  \item{p}{Numeric vector of probabilities}
  \item{n}{Number of observations.}
  \item{zeta}{
    Mean of distribution. A single, non-negative, numeric value.
  }
}
\details{
  These functions concern the probability distribution of the random
  variable
  \deqn{
    X = \sum_{n=1}^\infty \prod_{j=1}^n U_j^{1/\zeta}
  }{
    X = sum_[n=1]^[infty] prod_[j=1]^[n] U[j]^(1/zeta)
  }
  where \eqn{U_1, U_2, \ldots}{U[1], U[2], ...} are independent
  random variables uniformly distributed on \eqn{[0,1]}
  and \eqn{\zeta}{zeta} is a parameter.

  This distribution arises in many contexts. For example, 
  for a homogeneous Poisson point process in two-dimensional space
  with intensity \eqn{\lambda}{lambda},
  the standard Gaussian kernel estimator of intensity
  with bandwidth \eqn{\sigma}, evaluated at any fixed location \eqn{u},
  has the same distribution as \eqn{(\lambda/\zeta) X}{(lambda/zeta) * X}
  where
  \eqn{\zeta = 2 \pi \lambda\sigma^2}{zeta = 2 * pi * lambda * sigma^2}.
  
  Following the usual convention,
  \code{dpakes} computes the probability density,
  \code{ppakes} the cumulative distribution function,
  and \code{qpakes} the quantile function,
  and \code{rpakes} generates random variates with this distribution.

  The computation is based on a recursive integral equation
  for the cumulative distribution function, due to Professor Tony Pakes,
  presented in Baddeley, Moller and Pakes (2008).
  The solution uses the fact that the random variable
  satisfies the distributional equivalence
  \deqn{
    X \equiv U^{1/\zeta} (1 + X)
  }{
    X == U^(1/zeta) * (1+X)
  }
  where \eqn{U} is uniformly distributed on \eqn{[0,1]} and independent
  of \eqn{X}.
}
\value{
  A numeric vector. 
}
\references{
  Baddeley, A.,  Moller, J. and Pakes, A.G. (2008)
  Properties of residuals for spatial point processes,
  \emph{Annals of the Institute of Statistical Mathematics}
  \bold{60}, 627--649.
}
\author{
  Adrian Baddeley.
}
\examples{
 curve(dpakes(x, 1.5), to=4)
 rpakes(3, 1.5)
}
\keyword{distribution}

\name{rSSI}
\alias{rSSI}
\title{Simulate Simple Sequential Inhibition}
\description{
  Generate a random point pattern, a realisation of the
  Simple Sequential Inhibition (SSI) process,
  in two- or three-dimensional space.
}
\usage{
 rSSI(r, n=Inf, win = square(1), giveup = 1000, x.init=NULL, ...,
      f=NULL, fmax=NULL, nsim=1, drop=TRUE, verbose=TRUE)
}
\arguments{
  \item{r}{
    Inhibition distance.
  }
  \item{n}{
    Maximum number of points allowed. 
    If \code{n} is finite, stop when the \emph{total} number of points
    in the point pattern reaches \code{n}.
    If \code{n} is infinite (the default), stop only when
    it is apparently impossible to add any more points.
    See \bold{Details}.
  }
  \item{win}{
    Window in which to simulate the pattern.
    An object of class \code{"owin"} or \code{"box3"}
    or something acceptable to \code{\link[spatstat.geom]{as.owin}}
    or \code{\link[spatstat.geom]{as.box3}}.
    The default window is the unit square in two dimensions, unless 
    \code{x.init} is specified, when the default window 
    is the window of \code{x.init}.
  }
  \item{giveup}{
    Number of rejected proposals after which the algorithm should terminate.
  }
  \item{x.init}{
    Optional. Initial configuration of points. A point pattern
    in two or three dimensions
    (object of class \code{"ppp"} or \code{"pp3"}).
    The pattern returned by
    \code{rSSI} consists of this pattern together with the points
    added via simple sequential inhibition.  See \bold{Details}.
  }
  \item{\dots}{Ignored.}
  \item{f,fmax}{
    Optional arguments passed to \code{\link{rpoint}}
    to specify a non-uniform probability density for the random points.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
  \item{verbose}{
    Logical value specifying whether to print progress reports
    when \code{nsim > 1}.
  }
}
\value{
  A point pattern in two or three dimensional space
  (an object of class \code{"ppp"} or \code{"pp3"})
  if \code{nsim=1} and \code{drop=TRUE},
  otherwise a list of point patterns.
}
\details{
  This algorithm generates one or more realisations of the Simple Sequential
  Inhibition point process inside the window \code{win}.

  The window \code{win} may be a two-dimensional region (object of
  class \code{"owin"}) or a three-dimensional box (object of class
  \code{"box3"}). Accordingly the result will be a point pattern
  in two- or three-dimensional space.

  Starting with an empty window (or with the point pattern
  \code{x.init} if specified), the algorithm adds points
  one-by-one. Each new point is generated uniformly in the window
  and independently of preceding points. If the new point lies
  closer than \code{r} units from an existing point, then it is
  rejected and another random point is generated.
  The algorithm terminates when either
  \describe{
    \item{(a)}{
      the desired number \code{n} of points is reached, or
    }
    \item{(b)}{
      the current point configuration
      has not changed for \code{giveup} iterations,
      suggesting that it is no longer possible to add new points.
    }
  }
  If \code{n} is infinite (the default) then the algorithm terminates
  only when (b) occurs. The result is sometimes called a
  \emph{Random Sequential Packing}.

  Note that argument \code{n} specifies the maximum permitted
  \bold{total} number of points in the pattern returned by
  \code{rSSI()}. If \code{x.init} is not \code{NULL} then
  the number of points that are \emph{added}
  is at most \code{n - npoints(x.init)} if \code{n} is finite.

  Thus if \code{x.init} is not \code{NULL} then argument \code{n}
  must be at least as large as \code{npoints(x.init)}, otherwise
  an error is given.  If \code{n==npoints(x.init)} then a warning
  is given and the call to \code{rSSI()} has no real effect;
  \code{x.init} is returned.

  There is no requirement that the points of \code{x.init} be at
  a distance at least \code{r} from each other.  All of the \emph{added}
  points will be at a distance at least \code{r} from each other
  and from any point of \code{x.init}.

  The points will be generated inside the window \code{win}
  and the result will be a point pattern in the same window.
  
  The default window is the unit square, \code{win = square(1)},
  unless \code{x.init} is specified, when the default
  is \code{win=domain(x.init)}, the window of \code{x.init}.

  If both \code{win} and \code{x.init} are specified, and if the
  two windows are different, then a warning will be issued.
  Any points of \code{x.init} lying outside \code{win} will be removed,
  with a warning.
}
\seealso{
\code{\link{rpoispp}},
\code{\link{rMaternI}},
\code{\link{rMaternII}}.
}
\examples{
 Vinf <- rSSI(0.07)

 V100 <- rSSI(0.07, 100)

 X <- runifpoint(100)
 Y <- rSSI(0.03,142,x.init=X) # Y consists of X together with
                              # 42 added points.
 if(online <- interactive()) {
   plot(Y, main="rSSI")
   plot(X,add=TRUE,chars=20,cols="red")
 }

 ## inhomogeneous
 Z <- rSSI(0.07, 50, f=function(x,y){x})
 if(online) plot(Z)

 ## three dimensions
 A <- rSSI(0.05, 20, box3())
 if(online) plot(A)
}
\author{
\spatstatAuthors.
}
\keyword{spatial}
\keyword{datagen}

\name{spatstat.random-internal} 
\title{Internal spatstat.random functions}
\alias{spatstat.random-internal} %DoNotExport

\alias{assignParents}
\alias{change.default.expand}
\alias{clusterkernel.clusterprocess}
\alias{CondSimCox}
\alias{datagen.runifpointOnLines}
\alias{datagen.runifpoisppOnLines}
\alias{datagen.rpoisppOnLines}
\alias{default.clipwindow}
\alias{detect.par.format}
\alias{expandwinPerfect}
\alias{emptyNeyScot}
\alias{fakeNeyScot}
\alias{handle.rshift.args}
\alias{HermiteCoefs}
\alias{is.cadlag}
\alias{is.expandable}
\alias{is.expandable.rmhmodel}
\alias{is.poisson.NAobject}
\alias{is.stationary.NAobject}
\alias{kraever}
\alias{MultiPair.checkmatrix}
\alias{optimalinflation}
\alias{print.rmhcontrol}
\alias{print.rmhexpand}
\alias{print.rmhmodel}
\alias{print.rmhstart}
\alias{print.rmhInfoList}
\alias{print.summary.rmhexpand}
\alias{reheat}
\alias{resolve.vargamma.shape}
\alias{retrieve.param}
\alias{rGRFcircembed}
\alias{rMaternInhibition}
\alias{rMatClustHom}
\alias{rThomasHom}
\alias{rCauchyHom}
\alias{rPoissonClusterEngine}
\alias{RmhExpandRule}
\alias{rmhsnoop}
\alias{rmhResolveControl}
\alias{rmhResolveExpansion}
\alias{rmhResolveTypes}
\alias{rmhSnoopEnv}
\alias{rmhcontrol.rmhcontrol}
\alias{rmhcontrol.list}
\alias{rmhEngine}
\alias{rmhmodel.rmhmodel}
\alias{rmhstart.rmhstart}
\alias{rmhstart.list}
\alias{rmpoint.I.allim}
\alias{rpoint.multi}
\alias{rSSIengine}
\alias{rSSIengine.owin}
\alias{rSSIengine.box3}
\alias{rthinEngine}
\alias{runifpoispp}          
\alias{runifpoisppOnLines}
\alias{spatstatClusterModelInfo}
\alias{spatstatClusterSimInfo}
\alias{spatstatClusterSimModelMatch}
\alias{spatstatRmhInfo}
\alias{summarise.trend}
\alias{summary.rmhexpand}
\alias{thinjump}
\alias{thinParents}
\alias{update.rmhstart}
\alias{validate.kappa.mu}



%%%%%%%
\description{
  Internal spatstat.random functions.
}
\usage{



assignParents(offspring, parents, kernfun)
change.default.expand(x, newdefault)
\method{clusterkernel}{clusterprocess}(model, \dots)
CondSimCox(object, nsim, \dots, win, window, n.cond, w.cond,
           giveup, maxchunk, saveLambda, LambdaOnly, verbose, drop)
datagen.runifpointOnLines(n, L)
datagen.runifpoisppOnLines(lambda, L)
datagen.rpoisppOnLines(lambda, L, lmax, \dots, check)
default.clipwindow(object, epsilon)
expandwinPerfect(W, expand, amount)
detect.par.format(par, native, generic)
emptyNeyScot(win, nsim, saveLambda, saveparents, LambdaOnly, \dots)
fakeNeyScot(Y, lambda, win, saveLambda, saveparents,
            LambdaOnly, \dots)
handle.rshift.args(W, \dots, radius, width, height,
                   edge, clip, edgedefault)
HermiteCoefs(order)
is.cadlag(s)
is.expandable(x)
\method{is.expandable}{rmhmodel}(x) 
\method{is.poisson}{NAobject}(x) 
\method{is.stationary}{NAobject}(x) 
kraever(package, fatal, loaded, \dots, preamble)
MultiPair.checkmatrix(mat, n, matname, naok, zerook, asymmok)
optimalinflation(clusters, mod, rD)
\method{print}{rmhcontrol}(x, \dots)
\method{print}{rmhexpand}(x, \dots, prefix=TRUE)
\method{print}{rmhmodel}(x, \dots)
\method{print}{rmhstart}(x, \dots)
\method{print}{rmhInfoList}(x, \dots)
\method{print}{summary.rmhexpand}(x, \dots)
reheat(model, invtemp)
resolve.vargamma.shape(\dots, nu.ker, nu.pcf, nu, allow.nu, allow.default)
retrieve.param(desired, aliases, \dots, par)
rGRFcircembed(W, mu, var, corrfun, \dots, nsim, drop)
rMaternInhibition(type, kappa, r, win, stationary, \dots, nsim, drop)
rMatClustHom(kappa, mu, R, W, \dots, nsim, drop, inflate, saveparents)
rThomasHom(kappa, mu, sigma, W, \dots,
           nsim, drop, inflate, saveparents, maxinflate)
rCauchyHom(kappa, mu, scale, W, \dots,
           nsim, drop, inflate, saveparents, maxinflate)
rPoissonClusterEngine(kappa, expand, rcluster, win, \dots,
                      nsim, drop, saveparents, kappamax, lmax, rmax) 
RmhExpandRule(nama)
\method{rmhcontrol}{rmhcontrol}(\dots) 
\method{rmhcontrol}{list}(\dots) 
rmhEngine(InfoList, \dots, verbose, kitchensink, preponly, snoop,
                           overrideXstart, overrideclip) 
rmhResolveControl(control, model)
rmhResolveExpansion(win, control, imagelist, itype)
rmhResolveTypes(model, start, control)
rmhsnoop(\dots, Wsim, Wclip, R, xcoords, ycoords, mlevels, mcodes, irep, itype, 
     proptype, proplocn, propmark, propindx, numerator, denominator,
     panel.only)
rmhSnoopEnv(Xinit, Wclip, R)
\method{rmhmodel}{rmhmodel}(model, \dots) 
\method{rmhstart}{rmhstart}(start, \dots) 
\method{rmhstart}{list}(start, \dots) 
rmpoint.I.allim(n, f, types, nsim)
rpoint.multi(n, f, fmax, marks, win, giveup, fail.action,
             verbose, warn, nsim, drop)
rSSIengine(win, \dots)
\method{rSSIengine}{owin}(win, \dots, r, n, 
   giveup, x.init, f, fmax, nsim, drop, verbose, warn)
\method{rSSIengine}{box3}(win, \dots, r, n, 
   giveup, x.init, f, fmax, nsim, drop, verbose, warn)
rthinEngine(X, P, \dots, nsim, drop, Pmax, na.zero, what, fatal, warn)
runifpoispp(lambda, win, \dots, nsim, drop)
runifpoisppOnLines(lambda, L, nsim, drop)
spatstatClusterModelInfo(name, onlyPCP)
spatstatClusterSimInfo(name)
spatstatClusterSimModelMatch(name, verbose)
spatstatRmhInfo(cifname)
summarise.trend(trend, w, a)
\method{summary}{rmhexpand}(object, \dots)
thinjump(n, p)
thinParents(X, P, Pmax)
\method{update}{rmhstart}(object, \dots)
validate.kappa.mu(kappa, mu, kappamax, mumax,
                  win, expand, \dots, context)


}
\details{
  These internal \pkg{spatstat.random} functions should not be called
  directly by the user. Their names and capabilities may change
  without warning from one version of \pkg{spatstat.random} to the next.
}
\value{
The return values of these functions are not documented,
and may change without warning.
}
\keyword{internal}

\name{indefinteg}
\alias{indefinteg}
\title{
  Indefinite Integral
}
\description{
  Computes the indefinite integral of the given function.
}
\usage{
  indefinteg(f, x, \dots,
             method=c("trapezoid", "quadrature"),
             lower=min(x), nfine=8192) 
}
\arguments{
  \item{f}{
    an \R function taking a numeric first argument and returning a
    numeric vector of the same length.
  }
  \item{x}{
    Vector of values of the argument for which the indefinite integral
    should be evaluated. 
  }
  \item{\dots}{
    additional arguments to be passed to \code{f}.
  }
  \item{method}{
    String (partially matched) specifying how to compute the integrals.
  }
  \item{lower}{
    Lower limit of integration. A single number.
  }
  \item{nfine}{
    Number of sub-intervals to use for computation
    if \code{method='trapezoid'}.
  }
}
\details{
  The indefinite integral of the given function \code{f}
  is computed numerically at each of the desired values \code{x}.
  The lower limit of integration is taken to be \code{min(x)}.

  The result is a numeric vector \code{y} of the same length as
  \code{x}, with entries
  \deqn{
    y_i = \int_{\mbox{lower}}^{x_i} f(t) dt
  }{
    y[i] = integral[lower]^(x[i]) f(t) dt
  }

  If \code{method='trapezoid'} (the default),
  the integrals are computed rapidly using the trapezoid rule.
  If \code{method='quadrature'} the integrals are computed
  accurately but much more slowly, using the numerical quadrature routine
  \code{\link[stats]{integrate}}.
  
  If \code{method='trapezoid'} 
  the function \code{f} is first evaluated 
  on a finer grid of values of the function argument.
  The fine grid contains \code{nfine} sample points.
  The values of the indefinite integral on the fine grid
  are computed using the trapezoidal approximation.
  Finally the values of the indefinite integral are extracted at
  the desired argument values \code{x}.
}
\value{
  Numeric vector of the same length as \code{x}. 
}
\author{
  \adrian.
}
\seealso{
  \code{\link[stats]{integrate}}
}
\examples{
  curve(indefinteg(sin, x), to=pi)
}
\keyword{math}

\name{spatstat.random-package}
\alias{spatstat.random-package} 
\alias{spatstat.random} 
\docType{package}
\title{The spatstat.random Package}
\description{
  The \pkg{spatstat.random} package
  belongs to the \pkg{spatstat} family of packages.
  It contains the functionality for generating random spatial patterns
  and simulation of random point processes.
}
\details{
  \pkg{spatstat} is a family of \R packages
  for the statistical analysis of spatial data.
  Its main focus is the analysis of
  spatial patterns of points in two-dimensional space.

  This sub-package \pkg{spatstat.random} contains the
  functions that perform random generation of spatial patterns
  and simulation of random point processes:
  \itemize{
    \item
    generation of random spatial patterns of points
    according to many simple rules
    (completely random patterns, random grids, systematic random
    points);
    \item
    randomised alteration of spatial patterns (thinning, random shifting,
    jittering, random labelling);
    \item
    generation of quasirandom patterns;
    \item
    direct simulation of random point processes
    (Poisson process, binomial process, cell process,
    simple sequential inhibition, \Matern inhibition models,
    log-Gaussian Cox processes;
    \item
    simulation of Neyman-Scott cluster processes
    (truncated direct algorithm, Brix-Kendall and hybrid algorithms)
    and product shot noise cluster processes;
    \item
    simulation of Gibbs point processes
    (Metropolis-Hastings birth-death-shift algorithm,
    perfect simulation/ dominated coupling from the past,
    alternating Gibbs sampler).
  }
  Some other types of spatial object are also supported:
  \itemize{
    \item
    generation of random patterns of points in 3 dimensions;
    \item
    generation of random spatial patterns of line segments;
    \item
    generation of random tessellations;
    \item
    generation of random images (random noise, random mosaics).
  }
  (Functions for linear networks
  are in the separate sub-package \pkg{spatstat.linnet}.)
}
\section{Structure of the spatstat family}{  
  The \pkg{spatstat} family of packages
  is designed to support a complete statistical analysis
  of spatial data. It supports
  \itemize{
    \item creation, manipulation and plotting of point patterns;
    \item exploratory data analysis;
    \item spatial random sampling;
    \item simulation of point process models;
    \item parametric model-fitting;
    \item non-parametric smoothing and regression;
    \item formal inference (hypothesis tests, confidence intervals);
    \item model diagnostics.
  }
  The orginal \pkg{spatstat} package grew to be very large.
  It has now been divided into several \bold{sub-packages}:
  \itemize{
    \item \pkg{spatstat.utils} containing basic utilities
    \item \pkg{spatstat.sparse} containing linear algebra utilities
    \item \pkg{spatstat.data} containing datasets
    \item \pkg{spatstat.univar} containing functions for estimating
    probability distributions of random variables
    \item \pkg{spatstat.geom} containing geometrical objects
    and geometrical operations
    \item \pkg{spatstat.random} containing functionality for
    simulation and random generation
    \item \pkg{spatstat.explore} containing the main functionality
    for exploratory data analysis and nonparametric analysis
    \item \pkg{spatstat.model} containing the main functionality
    for parametric modelling and formal inference for spatial data
    \item \pkg{spatstat.linnet} containing functions for
    spatial data on a linear network
    \item \pkg{spatstat}, which simply loads the other sub-packages
    listed above, and provides documentation.
  }
  When you install \pkg{spatstat}, these sub-packages are also
  installed. Then if you load the \pkg{spatstat} package by typing
  \code{library(spatstat)}, the other sub-packages listed above will
  automatically be loaded or imported.

  For an overview of all the functions available in
  the sub-packages of \pkg{spatstat},
  see the help file for \code{"spatstat-package"}
  in the \pkg{spatstat} package.

  Additionally there are several \bold{extension packages:}
  \itemize{
    \item \pkg{spatstat.gui} for interactive graphics
    \item \pkg{spatstat.local} for local likelihood
    (including geographically weighted regression)
    \item \pkg{spatstat.Knet} for additional, computationally efficient code
    for linear networks
    \item \pkg{spatstat.sphere} (under development) for spatial data
    on a sphere, including spatial data on the earth's surface
  }
  The extension packages must be installed separately
  and loaded explicitly if needed. They also have separate documentation.
}
\section{Functionality in \pkg{spatstat.random}}{
  Following is a list of the functionality provided in the
  \pkg{spatstat.random} package only.
  
  \bold{To simulate a random point pattern:}
  
  \tabular{ll}{
	\code{\link[spatstat.random]{runifpoint}} \tab
	generate \eqn{n} independent uniform random points \cr
	\code{\link[spatstat.random]{rpoint}} \tab
	generate \eqn{n} independent random points \cr
	\code{\link[spatstat.random]{rmpoint}} \tab
	generate \eqn{n} independent multitype random points \cr
	\code{\link[spatstat.random]{rpoispp}} \tab
	simulate the (in)homogeneous Poisson point process \cr
	\code{\link[spatstat.random]{rmpoispp}} \tab
	simulate the (in)homogeneous multitype Poisson point process \cr
	\code{\link[spatstat.random]{runifdisc}} \tab
	generate \eqn{n} independent uniform random points in disc\cr
	\code{\link[spatstat.random]{rstrat}} \tab
	stratified random sample of points \cr
	\code{\link[spatstat.random]{rMaternI}}  \tab
	simulate the \Matern Model I inhibition process\cr
	\code{\link[spatstat.random]{rMaternII}} \tab
	simulate the \Matern Model II inhibition process\cr
	\code{\link[spatstat.random]{rSSI}} \tab
	simulate Simple Sequential Inhibition process\cr
	\code{\link[spatstat.random]{rStrauss}} \tab
	simulate Strauss process (perfect simulation)\cr
	\code{\link[spatstat.random]{rHardcore}} \tab
	simulate Hard Core process (perfect simulation)\cr
	\code{\link[spatstat.random]{rStraussHard}} \tab
	simulate Strauss-hard core process (perfect simulation)\cr
	\code{\link[spatstat.random]{rDiggleGratton}} \tab
	simulate Diggle-Gratton process (perfect simulation)\cr
	\code{\link[spatstat.random]{rDGS}} \tab
	simulate Diggle-Gates-Stibbard process (perfect simulation)\cr
	\code{\link[spatstat.random]{rPenttinen}} \tab
	simulate Penttinen process (perfect simulation)\cr
	\code{\link[spatstat.random]{rNeymanScott}} \tab
	simulate a general Neyman-Scott process\cr
	\code{\link[spatstat.random]{rPoissonCluster}} \tab
	simulate a general Poisson cluster process\cr
	\code{\link[spatstat.random]{rMatClust}} \tab
	simulate the \Matern Cluster process\cr
	\code{\link[spatstat.random]{rThomas}} \tab
	simulate the Thomas process  \cr
	\code{\link[spatstat.random]{rGaussPoisson}}  \tab
	simulate the Gauss-Poisson cluster process\cr
	\code{\link[spatstat.random]{rCauchy}} \tab
	simulate Neyman-Scott Cauchy cluster process \cr
	\code{\link[spatstat.random]{rVarGamma}} \tab
	simulate Neyman-Scott Variance Gamma cluster process \cr
	\code{\link[spatstat.random]{rthin}} \tab  random thinning  \cr
	\code{\link[spatstat.random]{rcell}} \tab
	simulate the Baddeley-Silverman cell process  \cr
	\code{\link[spatstat.random]{rmh}} \tab
	simulate Gibbs point process using Metropolis-Hastings \cr
	\code{\link[spatstat.random]{rags}} \tab
	alternating Gibbs sampler for multitype processes \cr
	\code{\link[spatstat.random]{ragsAreaInter}} \tab
	alternating Gibbs sample for area-interaction process \cr
	\code{\link[spatstat.random]{ragsMultiHard}} \tab
	alternating Gibbs sample for multitype hardcore process \cr
	\code{\link[spatstat.random]{runifpointOnLines}} \tab
	generate \eqn{n} random points along specified line segments \cr
	\code{\link[spatstat.random]{rpoisppOnLines}} \tab
	generate Poisson random points along specified line segments 
      }

      \bold{To randomly change an existing point pattern:}
      
      \tabular{ll}{
	\code{\link[spatstat.random]{rshift}} \tab random shifting of points \cr
	\code{\link[spatstat.random]{rthin}} \tab  random thinning \cr
	\code{\link[spatstat.random]{rlabel}} \tab random (re)labelling of a multitype
	point pattern \cr
        \code{\link[spatstat.random]{quadratresample}} \tab block resampling 
      }
      See also \code{\link[spatstat.geom]{rjitter}} and \code{\link[spatstat.geom]{rexplode}} in the
      \pkg{spatstat.geom} package.
      
      \bold{Random pixel images:}

      An object of class \code{"im"} represents a pixel image.

      \tabular{ll}{
	\code{\link[spatstat.random]{rnoise}} \tab random pixel noise
     }

    \bold{Line segment patterns}

    An object of class \code{"psp"} represents a pattern of straight line
    segments.

    \tabular{ll}{
      \code{\link[spatstat.random]{rpoisline}} \tab generate a realisation of the
      Poisson line process inside a window
    }

    \bold{Tessellations}

    An object of class \code{"tess"} represents a tessellation.

    \tabular{ll}{
      \code{\link[spatstat.random]{rpoislinetess}} \tab generate tessellation using Poisson line
      process 
    }

    \bold{Three-dimensional point patterns}

    An object of class \code{"pp3"} represents a three-dimensional
    point pattern in a rectangular box. The box is represented by
    an object of class \code{"box3"}.

    \tabular{ll}{
      \code{\link[spatstat.random]{runifpoint3}} \tab generate uniform random points in 3-D \cr
      \code{\link[spatstat.random]{rpoispp3}} \tab generate Poisson random points in 3-D \cr
    }

    \bold{Multi-dimensional space-time point patterns}

    An object of class \code{"ppx"} represents a 
    point pattern in multi-dimensional space and/or time.

    \tabular{ll}{
      \code{\link[spatstat.random]{runifpointx}} \tab generate uniform random points \cr
      \code{\link[spatstat.random]{rpoisppx}} \tab generate Poisson random points 
    }
    

    \bold{Probability Distributions}

    \tabular{ll}{
      \code{\link[spatstat.random]{rknn}} \tab theoretical distribution of
      nearest neighbour distance \cr
      \code{\link[spatstat.random]{dmixpois}} \tab mixed Poisson distribution \cr
 }

  
  \bold{Simulation}

  There are many ways to generate a random point pattern,
  line segment pattern, pixel image or tessellation
  in \pkg{spatstat}. 

  \bold{Random point patterns:}

  \tabular{ll}{
    \code{\link[spatstat.random]{runifpoint}} \tab
    generate \eqn{n} independent uniform random points \cr
    \code{\link[spatstat.random]{rpoint}} \tab
    generate \eqn{n} independent random points \cr
    \code{\link[spatstat.random]{rmpoint}} \tab
    generate \eqn{n} independent multitype random points \cr
    \code{\link[spatstat.random]{rpoispp}} \tab
    simulate the (in)homogeneous Poisson point process \cr
    \code{\link[spatstat.random]{rmpoispp}} \tab
    simulate the (in)homogeneous multitype Poisson point process \cr
    \code{\link[spatstat.random]{runifdisc}} \tab
    generate \eqn{n} independent uniform random points in disc\cr
    \code{\link[spatstat.random]{rstrat}} \tab
    stratified random sample of points \cr
    \code{\link[spatstat.random]{rMaternI}}  \tab
    simulate the \Matern Model I inhibition process\cr
    \code{\link[spatstat.random]{rMaternII}} \tab
    simulate the \Matern Model II inhibition process\cr
    \code{\link[spatstat.random]{rSSI}} \tab
    simulate Simple Sequential Inhibition process\cr
    \code{\link[spatstat.random]{rHardcore}} \tab
    simulate hard core process (perfect simulation)\cr
    \code{\link[spatstat.random]{rStrauss}} \tab
    simulate Strauss process (perfect simulation)\cr
    \code{\link[spatstat.random]{rStraussHard}} \tab
    simulate Strauss-hard core process (perfect simulation)\cr
    \code{\link[spatstat.random]{rDiggleGratton}} \tab
    simulate Diggle-Gratton process (perfect simulation)\cr
    \code{\link[spatstat.random]{rDGS}} \tab
    simulate Diggle-Gates-Stibbard process (perfect simulation)\cr
    \code{\link[spatstat.random]{rPenttinen}} \tab
    simulate Penttinen process (perfect simulation)\cr
    \code{\link[spatstat.random]{rNeymanScott}} \tab
    simulate a general Neyman-Scott process\cr
    \code{\link[spatstat.random]{rMatClust}} \tab
    simulate the \Matern Cluster process\cr
    \code{\link[spatstat.random]{rThomas}} \tab
    simulate the Thomas process  \cr
    \code{\link[spatstat.random]{rLGCP}} \tab
    simulate the log-Gaussian Cox process  \cr
    \code{\link[spatstat.random]{rGaussPoisson}}  \tab
    simulate the Gauss-Poisson cluster process\cr
    \code{\link[spatstat.random]{rCauchy}} \tab
    simulate Neyman-Scott process with Cauchy clusters \cr
    \code{\link[spatstat.random]{rVarGamma}} \tab
    simulate Neyman-Scott process with Variance Gamma clusters \cr
    \code{\link[spatstat.random]{rcell}} \tab
    simulate the Baddeley-Silverman cell process  \cr
    \code{\link[spatstat.random]{runifpointOnLines}} \tab
    generate \eqn{n} random points along specified line segments \cr
    \code{\link[spatstat.random]{rpoisppOnLines}} \tab
    generate Poisson random points along specified line segments 
  }
      
  \bold{Resampling a point pattern:}

  \tabular{ll}{
    \code{\link[spatstat.random]{quadratresample}} \tab block resampling \cr
    \code{\link[spatstat.random]{rshift}} \tab random shifting of (subsets of) points\cr
    \code{\link[spatstat.random]{rthin}} \tab  random thinning 
  }
  
   \bold{Other random patterns:}

   \tabular{ll}{
     \code{\link[spatstat.random]{rpoisline}} \tab
     simulate the Poisson line process within a window \cr
     \code{\link[spatstat.random]{rpoislinetess}} \tab
     generate random tessellation using Poisson line process \cr
     \code{\link[spatstat.random]{rMosaicSet}} \tab
     generate random set by selecting some tiles of a tessellation \cr
     \code{\link[spatstat.random]{rMosaicField}} \tab
     generate random pixel image by assigning random values
     in each tile of a tessellation
   }

  \bold{Resampling and randomisation procedures}

  You can build your own tests based on randomisation
  and resampling using the following capabilities:
  
  \tabular{ll}{
    \code{\link[spatstat.random]{quadratresample}} \tab block resampling \cr
    \code{\link[spatstat.random]{rshift}} \tab random shifting of (subsets of) points\cr
    \code{\link[spatstat.random]{rthin}} \tab  random thinning  
  }
}
\section{Licence}{
  This library and its documentation are usable under the terms of the "GNU 
  General Public License", a copy of which is distributed with the package.
}
\author{
  \spatstatAuthors.
}
\section{Acknowledgements}{
  Kasper Klitgaard Berthelsen,
  Ya-Mei Chang,
  Tilman Davies,
  Ute Hahn,
  Abdollah Jalilian,
  Dominic Schuhmacher
  and
  Rasmus Waagepetersen
  made substantial contributions of code.

  For comments, corrections, bug alerts and suggestions, we thank
  Monsuru Adepeju,
  Corey Anderson,
  Ang Qi Wei,
  Ryan Arellano,
  Jens \ifelse{latex}{\out{{\AA}str{\" o}m}}{Astrom},
  Robert Aue,
  Marcel Austenfeld,
  Sandro Azaele,
  Guy Bayegnak,
  Colin Beale,
  Melanie Bell,
  Thomas Bendtsen,
  Ricardo Bernhardt,
  Andrew Bevan,
  Brad Biggerstaff,
  Anders Bilgrau,
  Leanne Bischof,
  Christophe Biscio,
  Roger Bivand,
  Jose M. Blanco Moreno,
  Florent Bonneu,
  Jordan Brown,
  Ian Buller,
  Julian Burgos,
  Simon Byers,
  Ya-Mei Chang,
  Jianbao Chen,
  Igor Chernayavsky,
  Y.C. Chin,
  Bjarke Christensen,
  \ifelse{latex}{\out{Luc\'{\i{}}a}}{Lucia} Cobo Sanchez,
  Jean-Francois Coeurjolly,
  Kim Colyvas,
  Hadrien Commenges,
  Rochelle Constantine,
  Robin Corria Ainslie,
  Richard Cotton,
  Marcelino de la Cruz,
  Peter Dalgaard,
  Mario D'Antuono,
  Sourav Das,
  Peter Diggle,
  Patrick Donnelly,
  Ian Dryden,
  Stephen Eglen,
  Ahmed El-Gabbas,
  Belarmain Fandohan,
  Olivier Flores,
  David Ford,
  Peter Forbes,
  Shane Frank,
  Janet Franklin,
  Funwi-Gabga Neba,
  Oscar Garcia,
  Agnes Gault,
  Jonas Geldmann,
  Marc Genton,
  Shaaban Ghalandarayeshi,
  Jason Goldstick,
  Pavel Grabarnik,
  C. Graf,
  Ute Hahn,
  Andrew Hardegen,
  Martin \Bogsted Hansen,
  Martin Hazelton,
  Juha Heikkinen,
  Mandy Hering,
  Markus Herrmann,
  Maximilian Hesselbarth,
  Paul Hewson,
  Hamidreza Heydarian,
  Kurt Hornik,
  Philipp Hunziker,
  Jack Hywood,
  Ross Ihaka,
  \ifelse{latex}{\out{\u{C}enk I\c{c}\"{o}s}}{Cenk Icos},
  Aruna Jammalamadaka,
  Robert John-Chandran,
  Devin Johnson,
  Mahdieh Khanmohammadi,
  Bob Klaver,
  Lily Kozmian-Ledward,
  Peter Kovesi,
  Mike Kuhn,
  Jeff Laake,
  Robert Lamb,
  \ifelse{latex}{\out{Fr\'{e}d\'{e}ric}}{Frederic} Lavancier,
  Tom Lawrence,
  Tomas Lazauskas,
  Jonathan Lee,
  George Leser,
  Angela Li,
  Li Haitao,
  George Limitsios,
  Andrew Lister,
  Nestor Luambua,
  Ben Madin,
  Martin Maechler,
  Kiran Marchikanti,
  Jeff Marcus,
  Robert Mark,
  Peter McCullagh,
  Monia Mahling,
  Jorge Mateu Mahiques,
  Ulf Mehlig,
  Frederico Mestre,
  Sebastian Wastl Meyer,
  Mi Xiangcheng,
  Lore De Middeleer,
  Robin Milne,
  Enrique Miranda,
  Jesper \Moller,
  Annie \ifelse{latex}{\out{Molli{\'e}}}{Mollie},
  Ines Moncada,
  Mehdi Moradi,
  Virginia Morera Pujol,
  Erika Mudrak,
  Gopalan Nair,
  Nader Najari,
  Nicoletta Nava,
  Linda Stougaard Nielsen,
  Felipe Nunes,
  Jens Randel Nyengaard,
  Jens \Oehlschlaegel,
  Thierry Onkelinx,
  Sean O'Riordan,
  Evgeni Parilov,
  Jeff Picka,
  Nicolas Picard,
  Tim Pollington,
  Mike Porter,
  Sergiy Protsiv,
  Adrian Raftery,
  Ben Ramage,
  Pablo Ramon,
  Xavier Raynaud,
  Nicholas Read,
  Matt Reiter,
  Ian Renner,
  Tom Richardson,
  Brian Ripley,
  Ted Rosenbaum,
  Barry Rowlingson,
  Jason Rudokas,
  Tyler Rudolph,
  John Rudge,
  Christopher Ryan,
  Farzaneh Safavimanesh,
  Aila \Sarkka,
  Cody Schank,
  Katja Schladitz,
  Sebastian Schutte,
  Bryan Scott,
  Olivia Semboli,
  \ifelse{latex}{\out{Fran\c{c}ois S\'{e}m\'{e}curbe}}{Francois Semecurbe},
  Vadim Shcherbakov,
  Shen Guochun,
  Shi Peijian,
  Harold-Jeffrey Ship,
  Tammy L Silva,
  Ida-Maria Sintorn,
  Yong Song, 
  Malte Spiess,
  Mark Stevenson,
  Kaspar Stucki,
  Jan Sulavik,
  Michael Sumner,
  P. Surovy,
  Ben Taylor,
  Thordis Linda Thorarinsdottir,
  Leigh Torres,
  Berwin Turlach,
  Torben Tvedebrink,
  Kevin Ummer,
  Medha Uppala,
  Malissa Usher,
  Andrew van Burgel,
  Tobias Verbeke,
  Mikko Vihtakari,
  Alexendre Villers,
  Fabrice Vinatier,
  Maximilian Vogtland,
  Sasha Voss,
  Sven Wagner,
  Hao Wang,
  H. Wendrock,
  Jan Wild,
  Carl G. Witthoft,
  Selene Wong,
  Maxime Woringer,
  Luke Yates,
  Mike Zamboni
  and
  Achim Zeileis.
}
\keyword{spatial}
\keyword{package}

\name{rlabel}
\alias{rlabel}
\title{Random Re-Labelling of Point Pattern}
\description{
  Randomly allocates marks to a point pattern,
  or permutes the existing marks, or resamples
  from the existing marks.
}
\usage{
   rlabel(X, labels=marks(X), permute=TRUE, group=NULL, \dots, nsim=1, drop=TRUE)
}
\arguments{
  \item{X}{
    Point pattern (object of class \code{"ppp"},
    \code{"lpp"}, \code{"pp3"} or \code{"ppx"})
    or line segment pattern (object of class \code{"psp"}).
  }
  \item{labels}{
    Vector of values from which the new marks will be drawn
    at random. Defaults to the vector of existing marks.
  }
  \item{permute}{
    Logical value indicating whether to generate new marks
    by randomly permuting \code{labels} or
    by drawing a random sample with replacement.
  }
  \item{group}{
    Optional. A factor, or other data dividing the points into groups.
    Random relabelling will be performed separately within each group.
    See Details.
  }
  \item{\dots}{Additional arguments passed to \code{\link[spatstat.geom]{cut.ppp}} to
    determine the grouping factor, when \code{group} is given.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
}
\value{
  If \code{nsim = 1} and \code{drop=TRUE},
  a marked point pattern (of the same class as \code{X}).
  If \code{nsim > 1}, a list of point patterns.
}
\details{
  This very simple function allocates random marks to
  an existing point pattern \code{X}. It is useful
  for hypothesis testing purposes. (The function can also be applied
  to line segment patterns.)

  In the simplest case, the command \code{rlabel(X)} yields
  a point pattern obtained from \code{X} by randomly permuting
  the marks of the points.

  If \code{permute=TRUE}, then \code{labels} should be a vector of
  length equal to the number of points in \code{X}.
  The result of \code{rlabel} will be a point pattern
  with locations given by \code{X} and marks given by
  a random permutation of \code{labels} (i.e. a random sample without
  replacement).

  If \code{permute=FALSE}, then \code{labels} may be a vector of
  any length. 
  The result of \code{rlabel} will be a point pattern
  with locations given by \code{X} and marks given by
  a random sample from \code{labels} (with replacement).

  The argument \code{group} specifies that the points are
  divided into several different groups, and that the random labelling
  shall be performed separately on each group.
  The arguments \code{group} and \code{\dots} are passed to
  \code{\link[spatstat.geom]{cut.ppp}} to determine the grouping. Thus \code{group}
  could be a \code{factor}, or the name of a column of marks in
  \code{X}, or a tessellation, or a factor-valued pixel image, etc.
}
\seealso{
  \code{\link[spatstat.geom]{marks<-}} to assign arbitrary marks.
}
\examples{
   amacrine

   # Randomly permute the marks "on" and "off"
   # Result always has 142 "off" and 152 "on"
   Y <- rlabel(amacrine)

   # randomly allocate marks "on" and "off"
   # with probabilities p(off) = 0.48, p(on) = 0.52
   Y <- rlabel(amacrine, permute=FALSE)

   # randomly allocate marks "A" and "B" with equal probability
   Y <- rlabel(cells, labels=factor(c("A", "B")), permute=FALSE)

   # divide the window into tiles and 
   # randomly permute the marks within each tile
   Z <- rlabel(amacrine, group=quadrats(Window(amacrine), 4, 3))
}
\author{
  \spatstatAuthors.
}
\keyword{spatial}
\keyword{datagen}

\name{rGRFgauss}
\alias{rGRFgauss}
\alias{rGRFexpo}
\alias{rGRFstable}
\alias{rGRFgencauchy}
\alias{rGRFmatern}
\title{
  Simulate a Gaussian Random Field
}
\description{
  Generate a realisation of a Gaussian Random Field
  with given first and second moments.
}
\usage{
rGRFgauss(W = owin(), mu = 0, var = 1, scale,
          \dots, nsim = 1, drop = TRUE)
rGRFexpo(W = owin(), mu = 0, var = 1, scale,
          \dots, nsim = 1, drop = TRUE)
rGRFstable(W = owin(), mu = 0, var = 1, scale, alpha,
           \dots, nsim = 1, drop = TRUE)
rGRFgencauchy(W = owin(), mu = 0, var = 1, scale, alpha, beta, 
           \dots, nsim = 1, drop = TRUE)
rGRFmatern(W = owin(), mu = 0, var = 1, scale, nu, 
           \dots, nsim = 1, drop = TRUE)
}
\arguments{
  \item{W}{
    Window (object of class \code{"owin"}) in which to generate the
    simulated random field.
  }
  \item{mu}{
    The mean of the random field. A single numeric value,
    or a \code{function(x, y, ...)},
    or a pixel image (object of class \code{"im"}).
  }
  \item{var}{
    Variance of the random field. A single positive number.
  }
  \item{scale}{
    Spatial scale parameter \eqn{h}. A single positive number.
    See Details.
  }
  \item{alpha,beta,nu}{
    Additional parameters for specific models. See Details.
  }
  \item{\dots}{
    Arguments passed to \code{\link[spatstat.geom]{as.mask}} to determine
    the pixel resolution.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
}
\details{
  These functions generate simulated realisations
  of a Gaussian random field.

  The mean \eqn{E[Z(u)]} of the Gaussian random field value \eqn{Z(u)}
  at any location \eqn{u} is specified by the argument \code{mu},
  which may be a constant, a \code{function(x,y,...)}, or a pixel image.

  The variance \eqn{V[Z(u)]} of the Gaussian random field value
  is specified by the argument \code{var}, which should be a single
  positive numerical value.

  The correlation \eqn{C(u - v) = C(Z(u), Z(v))} between the values
  at two locations \eqn{u} and \eqn{v} depends on the
  distance \eqn{r = \| u-v\|}{r = |u-v|} as follows:
  
  \describe{
    \item{\code{rGRFexpo}}{
      the exponential covariance function
      \deqn{C(r) = \sigma^2 \exp(-r/h)}{C(r) = sigma^2 * exp(-r/h)}
      where \eqn{\sigma^2} is the variance parameter \code{var},
      and \eqn{h} is the scale parameter \code{scale}.
    }
    \item{\code{rGRFgauss}}{
      the Gaussian covariance function
      \deqn{C(r) = \sigma^2 \exp(-(r/h)^2)}{C(r) = sigma^2 * exp(-(r/h)^2)}
      where \eqn{\sigma^2} is the variance parameter \code{var},
      and \eqn{h} is the scale parameter \code{scale}.
    }
    \item{\code{rGRFstable}}{
      the stable covariance function
      \deqn{
	C(r) = \sigma^2 \exp(-(r/h)^\alpha)
      }{
	C(r) = sigma^2 * exp(-(r/h)^alpha)
      }
      where \eqn{\sigma^2} is the variance parameter \code{var},
      \eqn{h} is the scale parameter \code{scale},
      and \eqn{\alpha} is the shape parameter \code{alpha}.
    }
    \item{\code{rGRFgencauchy}}{
      the generalised Cauchy covariance function
      \deqn{
	C(r) = \sigma^2 (1 + (x/h)^\alpha)^{-\beta/\alpha}
      }{
	C(r) = sigma^2 * (1 + (x/h)^\alpha)^(-\beta/\alpha)
      }
      where \eqn{\sigma^2} is the variance parameter \code{var},
      \eqn{h} is the scale parameter \code{scale},
      and \eqn{\alpha} and \eqn{\beta} are the shape parameters
      \code{alpha} and \code{beta}.
    }
    \item{\code{rGRFmatern}}{
      the Whittle-\Matern covariance function
      \deqn{
	C(r) = \sigma^2 \frac{1}{2^{\nu-1} \Gamma(\nu)}
	(\sqrt{2 \nu} \, r/h)^\nu K_\nu(\sqrt{2\nu}\, r/h)
      }{
	C(r) = \sigma^2 * 2^(1-\nu) * \Gamma(\nu)^(-1) *
	(sqrt(2 *\nu) * r/h)^\nu * K[\nu](sqrt(2 * nu) * r/h)
      }
      where \eqn{\sigma^2} is the variance parameter \code{var},
      \eqn{h} is the scale parameter \code{scale},
      and \eqn{\nu} is the shape parameter \code{nu}.
    }
  }
  The algorithm generates \code{nsim} simulated realisations
  of the random field using the circulant embedding technique
  (Davies and Bryant, 2013).
}
\value{
  If \code{nsim=1} and \code{drop=TRUE}, a pixel image
  (object of class \code{"im"}).
  Otherwise, a list of pixel images.
}
\references{
  Davies, T.M. and Bryant, D. (2013)
  On Circulant Embedding for Gaussian Random Fields in R.
  \emph{Journal of Statistical Software} 55, issue 9
  \doi{10.18637/jss.v055.i09}
}
\author{
  \tilman and David Bryant.
  Modified by \adrian.
}
\seealso{
  \code{\link[spatstat.random]{rLGCP}}
}
\examples{
  plot(rGRFgauss(scale=0.1))
}
\keyword{spatial}
\keyword{datagen}

\name{rMatClust}
\alias{rMatClust}
\title{Simulate Matern Cluster Process}
\description{
  Generate a random point pattern, a simulated realisation of the
  \Matern Cluster Process.
}
\usage{
 rMatClust(kappa, scale, mu, win = square(1),
           nsim=1, drop=TRUE, \dots,
           n.cond=NULL, w.cond=NULL,
           algorithm=c("BKBC", "naive"),
           nonempty=TRUE, 
           poisthresh=1e-6, saveparents=FALSE, saveLambda=FALSE,
           kappamax=NULL, mumax=NULL, LambdaOnly=FALSE)
}
\arguments{
  \item{kappa}{
    Intensity of the Poisson process of cluster centres.
    A single positive number, a function, or a pixel image.
  }
  \item{scale}{
    Radius of the clusters. A single positive number.
  }
  \item{mu}{
    Mean number of points per cluster (a single positive number)
    or reference intensity for the cluster points (a function or
    a pixel image).
  }
  \item{win}{
    Window in which to simulate the pattern.
    An object of class \code{"owin"}
    or something acceptable to \code{\link[spatstat.geom]{as.owin}}.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
  \item{\dots}{
    Passed to \code{\link[spatstat.random]{clusterfield}} to control the image
    resolution when \code{saveLambda=TRUE}.
  }
  \item{n.cond}{
    Optional. Integer specifying a fixed number of points.
    See the section on \emph{Conditional Simulation}.
  }
  \item{w.cond}{
    Optional. Conditioning region. A window (object of class \code{"owin"})
    specifying the region which must contain exactly \code{n.cond} points.
    See the section on \emph{Conditional Simulation}.
  }
  \item{algorithm}{
    String (partially matched) specifying the simulation algorithm.
    See Details.
  }
  \item{nonempty}{
    Logical. If \code{TRUE} (the default), a more efficient algorithm is
    used, in which parents are generated conditionally on having at
    least one offspring point in the window.
    If \code{FALSE}, parents are generated
    even if they have no offspring in the window. The default
    is recommended unless you need to simulate all the parent points
    for some other purpose.
  }
  \item{poisthresh}{
    Numerical threshold below which the model will be treated
    as a Poisson process. See Details.
  }
  \item{saveparents}{
    Logical value indicating whether to save the locations of the
    parent points as an attribute.
  }
  \item{saveLambda}{
    Logical. If \code{TRUE} then the random intensity corresponding to
    the simulated parent points will also be calculated and saved,
    and returns as an attribute of the point pattern.
  }
  \item{kappamax}{
    Optional. Numerical value which is an upper bound for the
    values of \code{kappa}, when \code{kappa} is a pixel image or a
    function.
  }
  \item{mumax}{
    Optional. Numerical value which is an upper bound for the
    values of \code{mu}, when \code{mu} is a pixel image or a
    function.
  }
  \item{LambdaOnly}{
    Logical value specifying whether to return only the random intensity,
    rather than the point pattern.
  }
}
\value{
  A point pattern (object of class \code{"ppp"})
  or a list of point patterns.

  Additionally, some intermediate results of the simulation are returned
  as attributes of this point pattern (see \code{\link[spatstat.random]{rNeymanScott}}).
  Furthermore, the simulated intensity
  function is returned as an attribute \code{"Lambda"}, if
  \code{saveLambda=TRUE}.

  If \code{LambdaOnly=TRUE} the result is a pixel image
  (object of class \code{"im"}) or a list of pixel images.
}
\details{
  This algorithm generates a realisation of
  \Matern's cluster process,
  a special case of the Neyman-Scott process, inside the window \code{win}.

  In the simplest case, where \code{kappa} and \code{mu}
  are single numbers, the cluster process is formed by first
  generating a uniform Poisson point process of \dQuote{parent} points 
  with intensity \code{kappa}. Then each parent point is
  replaced by a random cluster of \dQuote{offspring} points,
  the number of points per cluster being Poisson (\code{mu})
  distributed, and their
  positions being placed and uniformly inside
  a disc of radius \code{scale} centred on the parent point.
  The resulting point pattern
  is a realisation of the classical
  \dQuote{stationary \Matern cluster process}.
  This point process has intensity \code{kappa * mu}.

  The algorithm can also generate spatially inhomogeneous versions of
  the \Matern cluster process:
  \itemize{
    \item The parent points can be spatially inhomogeneous.
    If the argument \code{kappa} is a \code{function(x,y)}
    or a pixel image (object of class \code{"im"}), then it is taken
    as specifying the intensity function of an inhomogeneous Poisson
    process that generates the parent points.
    \item The offspring points can be inhomogeneous. If the
    argument \code{mu} is a \code{function(x,y)}
    or a pixel image (object of class \code{"im"}), then it is
    interpreted as the reference density for offspring points,
    in the sense of Waagepetersen (2007).
    For a given parent point, the offspring constitute a Poisson process
    with intensity function equal to 
    \code{mu/(pi * scale^2)}
    inside the disc of radius \code{scale} centred on the parent
    point, and zero intensity outside this disc.
    Equivalently we first generate,
    for each parent point, a Poisson (\eqn{M}) random number of
    offspring (where \eqn{M} is the maximum value of \code{mu})
    placed independently and uniformly in the disc of radius \code{scale}
    centred on the parent location, and then randomly thin the
    offspring points, with retention probability \code{mu/M}.
    \item
    Both the parent points and the offspring points can be
    inhomogeneous, as described above.
  }
  The intensity of the \Matern cluster
  process is \code{kappa * mu}
  if either \code{kappa} or \code{mu} is a single number. In the general
  case the intensity is an integral involving \code{kappa}, \code{mu}
  and \code{scale}.
}
\section{Simulation Algorithm}{
  Two simulation algorithms are implemented.
  \itemize{
    \item The \emph{naive} algorithm generates the cluster process 
    by directly following the description given above. First the window
    \code{win} is expanded by a distance equal to \code{scale}.
    Then the parent points are generated in the expanded window according to
    a Poisson process with intensity \code{kappa}. Then each parent
    point is replaced by a finite cluster of offspring points as
    described above.
    The naive algorithm is used if \code{algorithm="naive"} or if
    \code{nonempty=FALSE}.
    \item The \emph{BKBC} algorithm, proposed by Baddeley and Chang
    (2023), is a modification of the algorithm of Brix and Kendall (2002). 
    Parents are generated in the infinite plane, subject to the
    condition that they have at least one offspring point inside the
    window \code{win}.
    The BKBC algorithm is used when \code{algorithm="BKBC"} (the default)
    and \code{nonempty=TRUE} (the default).
  }
  The naive algorithm becomes very slow when \code{scale} is large,
  while the BKBC algorithm is uniformly fast (Baddeley and Chang, 2023).

  If \code{saveparents=TRUE}, then the simulated point pattern will
  have an attribute \code{"parents"} containing the coordinates of the
  parent points, and an attribute \code{"parentid"} mapping each
  offspring point to its parent.

  If \code{nonempty=TRUE} (the default), then parents are generated
  subject to the condition that they have at least one offspring point 
  in the window \code{win}. 
  \code{nonempty=FALSE}, then parents without offspring will be included;
  this option is not available in the \emph{BKBC} algorithm.
  
  Note that if \code{kappa} is a pixel image, its domain must be larger
  than the window \code{win}. This is because an offspring point inside
  \code{win} could have its parent point lying outside \code{win}.
  In order to allow this, the naive simulation algorithm
  first expands the original window \code{win}
  by a distance equal to \code{scale} and generates the Poisson process of
  parent points on this larger window. If \code{kappa} is a pixel image,
  its domain must contain this larger window.

  If the pair correlation function of the model is very close
  to that of a Poisson process, with maximum deviation less than
  \code{poisthresh}, then the model is approximately a Poisson process.
  This is detected by the naive algorithm which then
  simulates a Poisson process with intensity
  \code{kappa * mu}, using \code{\link[spatstat.random]{rpoispp}}. 
  This avoids computations that would otherwise require huge amounts
  of memory.
}
\section{Fitting cluster models to data}{
  The \Matern cluster process model with homogeneous parents
  (i.e. where \code{kappa} is a single number)
  where the offspring are either homogeneous or inhomogeneous (\code{mu}
  is a single number, a function or pixel image)
  can be fitted to point pattern data using \code{\link[spatstat.model]{kppm}},
  or fitted to the inhomogeneous \eqn{K} function
  using \code{\link[spatstat.model]{matclust.estK}}
  or \code{\link[spatstat.model]{matclust.estpcf}}.

  Currently \pkg{spatstat} does not support fitting the
  \Matern cluster process model
  with inhomogeneous parents.

  A fitted \Matern cluster process model can be simulated automatically
  using   \code{\link[spatstat.model]{simulate.kppm}}
  (which invokes \code{rMatClust} to perform the simulation).
}
\section{Conditional Simulation}{
  If \code{n.cond} is specified, it should be a single integer.
  Simulation will be conditional on the event 
  that the pattern contains exactly \code{n.cond} points
  (or contains exactly \code{n.cond} points inside
  the region \code{w.cond} if it is given).

  Conditional simulation uses the rejection algorithm described
  in Section 6.2 of Moller, Syversveen and Waagepetersen (1998).
  There is a maximum number of proposals which will be attempted.
  Consequently the return value may contain fewer
  than \code{nsim} point patterns.

  The current algorithm for conditional simulation ignores the
  argument \code{saveparents} and does not save the parent points.
}
\seealso{
  \code{\link[spatstat.random]{rpoispp}}, 
  \code{\link[spatstat.random]{rThomas}}, 
  \code{\link[spatstat.random]{rCauchy}}, 
  \code{\link[spatstat.random]{rVarGamma}}, 
  \code{\link[spatstat.random]{rNeymanScott}}, 
  \code{\link[spatstat.random]{rGaussPoisson}}.

  For fitting the model, see 
  \code{\link[spatstat.model]{kppm}},
  \code{\link[spatstat.model]{clusterfit}}.
}
\examples{
 # homogeneous
 X <- rMatClust(10, 0.05, 4)
 # inhomogeneous
 ff <- function(x,y){ 4 * exp(2 * abs(x) - 1) }
 Z <- as.im(ff, owin())
 Y <- rMatClust(10, 0.05, Z)
 YY <- rMatClust(ff, 0.05, 3)
}
\references{
  \baddchangclustersim

  Brix, A. and Kendall, W.S. (2002)
  Simulation of cluster point processes without edge effects.
  \emph{Advances in Applied Probability} \bold{34}, 267--280.

  \Matern, B. (1960)
  \emph{Spatial Variation}.
  Meddelanden \ifelse{latex}{\out{fr\r{a}n}}{fraan}
  Statens Skogsforskningsinstitut,
  volume 59, number 5.  Statens Skogsforskningsinstitut, Sweden.

  \Matern, B. (1986)
  \emph{Spatial Variation}.
  Lecture Notes in Statistics 36, Springer-Verlag, New York.

  \Moller, J., Syversveen, A. and Waagepetersen, R. (1998)
  Log Gaussian Cox Processes.
  \emph{Scandinavian Journal of Statistics} \bold{25}, 451--482.

  Waagepetersen, R. (2007)
  An estimating function approach to inference for
  inhomogeneous Neyman-Scott processes.
  \emph{Biometrics} \bold{63}, 252--258.
}
\author{
  \adrian, \yamei and \rolf.
}
\keyword{spatial}
\keyword{datagen}

\name{runifpoint}
\alias{runifpoint}
\title{Generate N Uniform Random Points}
\description{
  Generate a random point pattern
  containing \eqn{n} independent uniform random points.
}
\usage{
 runifpoint(n, win=owin(c(0,1),c(0,1)), giveup=1000, warn=TRUE, \dots,
            fail.action=c("error", "pass", "missing"),
            nsim=1, drop=TRUE, ex=NULL)
}
\arguments{
  \item{n}{
    Number of points.
  }
  \item{win}{
    Window in which to simulate the pattern.
    An object of class \code{"owin"}
    or something acceptable to \code{\link[spatstat.geom]{as.owin}}.
    (Alternatively a tessellation; see the section on
    tessellations).
  }
  \item{giveup}{
    Number of attempts in the rejection method after which
    the algorithm should stop trying to generate new points.
  }
  \item{warn}{
    Logical. Whether to issue a warning if \code{n} is very large.
    See Details.
  }
  \item{\dots}{Ignored.}
  \item{fail.action}{
    Character string (partially matched) specifying what to do
    if the number of attempts exceeds \code{giveup}.
    If \code{fail.action="error"} (the default), a fatal error will be
    generated. If \code{fail.action="pass"}, the pattern of accepted
    points (containing fewer than \code{n} points) will be returned.
    If \code{fail.action="missing"}, the result will be a
    \sQuote{missing point pattern}, an object belonging to
    the classes \code{"NAobject"} and \code{"ppp"}.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
  \item{ex}{
    Optional. A point pattern to use as the example.
    If \code{ex} is given and \code{n} and \code{win} are missing,
    then \code{n} and \code{win} will be calculated from
    the point pattern \code{ex}.
  }
}
\value{
  A point pattern (an object of class \code{"ppp"})
  or a list of point patterns.
}
\details{
  This function generates \code{n} independent random points,
  uniformly distributed in the window \code{win}.
  (For nonuniform distributions, see \code{\link{rpoint}}.)

  The algorithm depends on the type of window, as follows:
  \itemize{
    \item
    If \code{win} is a rectangle then 
    \eqn{n} independent random points, uniformly distributed
    in the rectangle, are generated by assigning uniform random values to their
    cartesian coordinates.
    \item
    If \code{win} is a binary image mask, then a random sequence of 
    pixels is selected (using \code{\link{sample}})
    with equal probabilities. Then for each pixel in the sequence
    we generate a uniformly distributed random point in that pixel.
    \item
    If \code{win} is a polygonal window, the algorithm uses the rejection
    method. It finds a rectangle enclosing the window,
    generates points in this rectangle, and tests whether they fall in
    the desired window. It gives up when \code{giveup * n} tests
    have been performed without yielding \code{n} successes.
  }
  The algorithm for binary image masks is faster than the rejection
  method but involves discretisation.

  If \code{warn=TRUE} (the default), a warning will be issued if \code{n} is very large.
  The threshold is \code{\link[spatstat.geom]{spatstat.options}("huge.npoints")}.
  This warning has no consequences,
  but it helps to trap a number of common errors.
}
\section{Tessellation}{
  The argument \code{win} may be a tessellation
  (object of class \code{"tess"}, see \code{\link[spatstat.geom]{tess}}).
  Then the specified number of points \code{n} will be randomly generated
  inside each tile of the tessellation. The argument \code{n} may be
  either a single integer, or an integer vector specifying the number
  of points to be generated in each individual tile. The result will
  be a point pattern in the window \code{\link[spatstat.geom]{as.owin}(win)}.
}
\seealso{
\code{\link[spatstat.geom]{ppp.object}},
\code{\link[spatstat.geom]{owin.object}},
\code{\link{rpoispp}},
\code{\link{rpoint}}
}
\examples{
 # 100 random points in the unit square
 pp <- runifpoint(100)
 # irregular window
 letterR
 # polygonal
 pp <- runifpoint(100, letterR)
 # binary image mask
 pp <- runifpoint(100, as.mask(letterR))

 # randomising an existing point pattern
 runifpoint(npoints(cells), win=Window(cells))
 runifpoint(ex=cells)

 # tessellation
 A <- quadrats(unit.square(), 2, 3)
 # different numbers of points in each cell
 X <- runifpoint(1:6, A)
}
\author{\adrian
  and \rolf
}
\keyword{spatial}
\keyword{datagen}

\name{gauss.hermite}
\alias{gauss.hermite}
\title{
  Gauss-Hermite Quadrature Approximation to Expectation for Normal Distribution
}
\description{
  Calculates an approximation to the expected value of any function of a
  normally-distributed random variable, using Gauss-Hermite quadrature.
}
\usage{
gauss.hermite(f, mu = 0, sd = 1, ..., order = 5)
}
\arguments{
  \item{f}{
    The function whose moment should be approximated.
  }
  \item{mu}{
    Mean of the normal distribution.
  }
  \item{sd}{
    Standard deviation of the normal distribution.
  }
  \item{\dots}{
    Additional arguments passed to \code{f}.
  }
  \item{order}{
    Number of quadrature points in the Gauss-Hermite quadrature
    approximation. A small positive integer.
  }
}
\details{
  This algorithm calculates the approximate expected value of
  \code{f(Z)} when \code{Z} is a normally-distributed random
  variable with mean \code{mu} and standard deviation \code{sd}.
  The expected value is an integral with respect to the
  Gaussian density; this integral is approximated
  using Gauss-Hermite quadrature.

  The argument \code{f} should be a function in the \R language
  whose first argument is the variable \code{Z}. Additional arguments
  may be passed through \code{\dots}. The value returned by \code{f}
  may be a single numeric value, a vector, or a matrix. The values
  returned by \code{f} for different values of \code{Z} must have
  compatible dimensions.

  The result is a weighted average of several values of \code{f}.
}
\value{
  Numeric value, vector or matrix.
}
\author{\adrian
  
  ,
  \rolf
  
  and \ege.
}
\examples{
  gauss.hermite(function(x) x^2, 3, 1)
}
\keyword{math}

\name{rmhmodel}
\alias{rmhmodel}
\title{Define Point Process Model for Metropolis-Hastings Simulation.}
\description{
  Builds a description of a point process model
  for use in simulating the model by the Metropolis-Hastings
  algorithm. 
}
\usage{
  rmhmodel(...)
}
\arguments{
  \item{\dots}{Arguments specifying the point process model
    in some format.
  }
}
\value{
  An object of class \code{"rmhmodel"}, which is essentially
  a list of parameter values for the model.
  
  There is a \code{print} method for this class, which prints
  a sensible description of the model chosen.
}
\details{
  Simulated realisations of many point process models
  can be generated using the Metropolis-Hastings algorithm
  \code{\link{rmh}}. The algorithm requires the model to be specified
  in a particular format: an object of class \code{"rmhmodel"}.

  The function \code{\link{rmhmodel}} takes a
  description of a point process model in some other format, and
  converts it into an object of class \code{"rmhmodel"}.
  It also checks that the parameters of the model are valid.

  The function \code{\link{rmhmodel}} is generic, with methods
  for
  \describe{
    \item{fitted point process models:}{
      an object of class \code{"ppm"}, obtained by a call to the
      model-fitting function \code{\link[spatstat.model]{ppm}}.
      See \code{\link[spatstat.model]{rmhmodel.ppm}}.
    }
    \item{lists:}{
      a list of parameter values in a certain format.
      See \code{\link{rmhmodel.list}}.
    }
    \item{default:}{
      parameter values specified as separate arguments to \code{\dots}.
      See \code{\link{rmhmodel.default}}.
    }
  }
}
\references{
   Diggle, P. J. (2003) \emph{Statistical Analysis of Spatial Point
   Patterns} (2nd ed.) Arnold, London.

   Diggle, P.J. and Gratton, R.J. (1984)
   Monte Carlo methods of inference for implicit statistical models.
   \emph{Journal of the Royal Statistical Society, series B}
   \bold{46}, 193 -- 212.

   Diggle, P.J., Gates, D.J., and Stibbard, A. (1987)
   A nonparametric estimator for pairwise-interaction point processes.
   Biometrika \bold{74}, 763 -- 770.
   \emph{Scandinavian Journal of Statistics} \bold{21}, 359--373.

   Geyer, C.J. (1999)
   Likelihood Inference for Spatial Point
   Processes. Chapter 3 in  O.E. Barndorff-Nielsen, W.S. Kendall and
   M.N.M. Van Lieshout (eds) \emph{Stochastic Geometry: Likelihood and
   Computation}, Chapman and Hall / CRC,  Monographs on Statistics and
   Applied Probability, number 80. Pages 79--140.
}

\seealso{
  \code{\link[spatstat.model]{rmhmodel.ppm}},
  \code{\link{rmhmodel.default}},
  \code{\link{rmhmodel.list}},
  \code{\link{rmh}},
  \code{\link{rmhcontrol}},
  \code{\link{rmhstart}},
  \code{\link[spatstat.model]{ppm}},
  \code{\link[spatstat.model]{Strauss}},
  \code{\link[spatstat.model]{Softcore}},
  \code{\link[spatstat.model]{StraussHard}},
  \code{\link[spatstat.model]{Triplets}},
  \code{\link[spatstat.model]{MultiStrauss}},
  \code{\link[spatstat.model]{MultiStraussHard}},
  \code{\link[spatstat.model]{DiggleGratton}},
  \code{\link[spatstat.model]{PairPiece}}
  \code{\link[spatstat.model]{Penttinen}}
}
\author{\adrian
  
  
  and \rolf
  
}
\keyword{spatial}
\keyword{datagen}

\name{recipEnzpois}
\alias{recipEnzpois}
\title{
  First Reciprocal Moment of the Truncated Poisson Distribution
}
\description{
  Computes the first reciprocal moment (first negative moment)
  of the truncated Poisson distribution
  (the Poisson distribution conditioned to have a nonzero value).
}
\usage{
  recipEnzpois(mu, exact=TRUE)
}
\arguments{
  \item{mu}{
    The mean of the original Poisson distribution.
    A single positive numeric value, or a vector of positive numbers.
  }
  \item{exact}{
    Logical value specifying whether to use the exact analytic formula
    if possible.
  }
}
\details{
  This function calculates the expected value of \eqn{1/N}
  given \eqn{N > 0}, where \eqn{N} is a Poisson random variable
  with mean \eqn{\mu}.

  If the library \pkg{gsl} is loaded, and if \code{exact=TRUE} (the
  default), then the calculation uses
  the exact analytic formula
  \deqn{
    \nu = \frac{e^{-\mu}}{1- e^{-\mu}}
    \left( Ei(\mu) - \log \mu - \gamma \right)
  }{
    nu = (exp(-mu)/(1 - exp(-mu))) (Ei(mu) - log(mu) - gamma)
  }
  (see e.g. Grab and Savage, 1954)
  where \eqn{\nu} is the desired reciprocal moment, and
  \deqn{
    Ei(x) = \int_{-\infty}^x t e^{-t} dt
  }{
    Ei(x) = int_[-infty]^x t * exp(-t) dt
  }
  is the first exponential integral, and
  \eqn{\gamma \approx 0.577}{\gamma ~= 0.577}
  is the Euler-Mascheroni constant.

  If \pkg{gsl} is not loaded, or if \code{exact=FALSE} is specified,
  the value is computed approximately (and more slowly)
  by summing over the possible values of \eqn{N} up to a finite limit.
}
\value{
  A single numerical value or a numeric vector.
}
\author{
  \adrian.
}
\seealso{
  \code{\link{rpoisnonzero}}
}
\examples{
  if(require(gsl)) {
    v <- recipEnzpois(10)
    print(v)
  }
  recipEnzpois(10, exact=FALSE)
}
\references{
  Grab, E.L. and Savage, I.R. (1954)
  Tables of the expected value of 1/X for positive
  Bernoulli and Poisson variables.
  \emph{Journal of the American Statistical Association}
  \bold{49}, 169--177.
}
\keyword{math}
\keyword{distribution}

\name{rjitter.psp}
\alias{rjitter.psp}
\title{Random Perturbation of Line Segment Pattern}
\description{
  Randomly pertubs a spatial pattern of line segments by applying
  independent random displacements to the segment endpoints.
}
\usage{
\method{rjitter}{psp}(X, radius, \dots, clip=TRUE, nsim=1, drop=TRUE)
}
\arguments{
  \item{X}{
    A point pattern on a linear network
    (object of class \code{"psp"}).
  }
  \item{radius}{
    Scale of perturbations. A positive numerical value.
    Each point will be displaced by a random distance,
    with maximum displacement equal to this value.
  }
  \item{\dots}{
    Ignored.
  }
  \item{clip}{
    Logical value specifying what to do if segments cross the boundary
    of the window. See Details.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a spatial pattern of line segments (class
    \code{"psp"}) rather than a list of length 1 containing this pattern.
  }
}
\details{
  The function \code{\link[spatstat.geom]{rjitter}} is generic. This function is
  the method for the class \code{"psp"} of line segment patterns.

  Each of the endpoints of each segment in \code{X} will be
  subjected to an independent random displacement. The displacement vectors are
  uniformly distributed in a circle of radius \code{radius}.
  Marks attached to the segments will be unchanged.
  
  If \code{clip=TRUE} (the default), segment endpoints
  are permitted to move to locations slightly outside the window of \code{X},
  and the resulting segments will be clipped to the window.
  If \code{clip=FALSE}, segment endpoints are conditioned to fall
  inside the window.

  If \code{nsim=1} and \code{drop=TRUE}, the result is another
  spatial pattern of line segments (object of class \code{"psp"}).
  Otherwise, the result is a list of \code{nsim} line segment patterns.
}
\value{
  A spatial pattern of line segments
  (object of class \code{"psp"})
  or a list of such patterns.
}
\author{
  \spatstatAuthors.
}
\seealso{
  \code{\link[spatstat.geom]{rjitter}} for point patterns in two dimensions.
}
\examples{
   E <- edges(letterR)
   Window(E) <- owin(c(1.9, 4.1), c(0.5, 3.5))
   plot(rjitter(E, 0.1))
}
\keyword{spatial}
\keyword{datagen}

\name{rtemper}
\alias{rtemper}
\title{
  Simulated Annealing or Simulated Tempering for Gibbs Point Processes
}
\description{
  Performs simulated annealing or simulated tempering
  for a Gibbs point process model using a specified
  annealing schedule.
}
\usage{
rtemper(model, invtemp, nrep, \dots, track=FALSE, start = NULL, verbose = FALSE)
}
\arguments{
  \item{model}{
    A Gibbs point process model: a fitted Gibbs point process model
    (object of class \code{"ppm"}), or any data acceptable to
    \code{\link{rmhmodel}}.
  }
  \item{invtemp}{
    A numeric vector of positive numbers.
    The sequence of values of inverse temperature that will be used.
  }
  \item{nrep}{
    An integer vector of the same length as \code{invtemp}.
    The value \code{nrep[i]} specifies the number of steps of the
    Metropolis-Hastings algorithm that will be performed
    at inverse temperature \code{invtemp[i]}.
  }
  \item{start}{
    Initial starting state for the simulation.
    Any data acceptable to \code{\link{rmhstart}}.
  }
  \item{track}{
    Logical flag indicating whether to save the transition
    history of the simulations.
  }
  \item{\dots}{
    Additional arguments passed to \code{\link{rmh.default}}.
  }
  \item{verbose}{
    Logical value indicating whether to print progress reports.
  }
}
\details{
  The Metropolis-Hastings simulation algorithm
  \code{\link{rmh}} is run for
  \code{nrep[1]} steps at inverse temperature \code{invtemp[1]},
  then for 
  \code{nrep[2]} steps at inverse temperature \code{invtemp[2]},
  and so on.

  Setting the inverse temperature to a value \eqn{\alpha}{alpha}
  means that the probability density of the Gibbs model, \eqn{f(x)},
  is replaced by \eqn{g(x) = C\, f(x)^\alpha}{g(x) = C f(x)^alpha}
  where \eqn{C} is a normalising constant depending on
  \eqn{\alpha}{alpha}.
  Larger values of \eqn{\alpha}{alpha} exaggerate the high and low
  values of probability density, while smaller values of \eqn{\alpha}{alpha}
  flatten out the probability density.

  For example if the original \code{model} is a Strauss process,
  the modified model is close to a hard core process
  for large values of inverse temperature, and close to a Poisson process
  for small values of inverse temperature. 
}
\value{
  A point pattern (object of class \code{"ppp"}).

  If \code{track=TRUE}, the result also has an attribute
  \code{"history"} which is a data frame with columns
  \code{proposaltype}, \code{accepted}, 
  \code{numerator} and \code{denominator}, as described
  in \code{\link{rmh.default}}.
}
\author{
  \spatstatAuthors.
}
\seealso{
  \code{\link{rmh.default}},
  \code{\link{rmh}}.
}
\examples{
   stra <- rmhmodel(cif="strauss",
                    par=list(beta=2,gamma=0.2,r=0.7),
                    w=square(10))
   nr <- if(interactive()) 1e5 else 1e3
   Y <- rtemper(stra, c(1, 2, 4, 8), nr * (1:4), verbose=TRUE, track=TRUE)
}
\keyword{spatial}
\keyword{datagen}

\name{runifpoint3}
\alias{runifpoint3}
\title{
  Generate N Uniform Random Points in Three Dimensions
}
\description{
  Generate a random point pattern containing \code{n}
  independent, uniform random points in three dimensions.
}
\usage{
runifpoint3(n, domain = box3(), nsim=1, drop=TRUE)
}
\arguments{
  \item{n}{
    Number of points to be generated.
  }
  \item{domain}{
    Three-dimensional box in which the process should be generated.
    An object of class \code{"box3"}.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
}
\value{
  If \code{nsim = 1} and \code{drop=TRUE}, a point pattern in
  three dimensions (an object of class \code{"pp3"}).
  If \code{nsim > 1}, a list of such point patterns.
}
\details{
  This function generates \code{n} independent random points,
  uniformly distributed in the three-dimensional box \code{domain}.
}
\seealso{
  \code{\link{rpoispp3}}, 
  \code{\link[spatstat.geom]{pp3}}, 
  \code{\link[spatstat.geom]{box3}}
}
\examples{
   X <- runifpoint3(50)
}
\author{
  \adrian
  and \rolf.
}
\keyword{spatial}
\keyword{datagen}
\concept{Three-dimensional}

\name{rPenttinen}
\alias{rPenttinen}
\title{Perfect Simulation of the Penttinen Process}
\description{
  Generate a random pattern of points, a simulated realisation
  of the Penttinen process, using a perfect simulation algorithm.
}
\usage{
  rPenttinen(beta, gamma=1, R, W = owin(), expand=TRUE, nsim=1, drop=TRUE)
}
\arguments{
  \item{beta}{
    intensity parameter (a positive number).
  }
  \item{gamma}{
    Interaction strength parameter (a number between 0 and 1).
  }
  \item{R}{
    disc radius (a non-negative number).
  }
  \item{W}{
    window (object of class \code{"owin"}) in which to
    generate the random pattern. 
  }
  \item{expand}{
    Logical. If \code{FALSE}, simulation is performed
    in the window \code{W}, which must be rectangular.
    If \code{TRUE} (the default), simulation is performed
    on a larger window, and the result is clipped to the original
    window \code{W}.
    Alternatively \code{expand} can be an object of class 
    \code{"rmhexpand"} (see \code{\link[spatstat.random]{rmhexpand}})
    determining the expansion method.
  }
  \item{nsim}{Number of simulated realisations to be generated.}  
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
}
\details{
  This function generates a realisation of the 
  Penttinen point process in the window \code{W}
  using a \sQuote{perfect simulation} algorithm.

  Penttinen (1984, Example 2.1, page 18), citing Cormack (1979),
  described the pairwise interaction point process with interaction factor
  \deqn{
    h(d) = e^{\theta A(d)} = \gamma^{A(d)}
  }{
    h(d) = exp(theta * A(d)) = gamma^(A(d))
  }
  between each pair of points separated by a distance $d$.
  Here \eqn{A(d)} is the area of intersection between two discs
  of radius \eqn{R} separated by a distance \eqn{d}, normalised so that
  \eqn{A(0) = 1}.

  The simulation algorithm used to generate the point pattern
  is \sQuote{dominated coupling from the past}
  as implemented by
  Berthelsen and \Moller (2002, 2003).
  This is a \sQuote{perfect simulation} or \sQuote{exact simulation}
  algorithm, so called because the output of the algorithm is guaranteed
  to have the correct probability distribution exactly (unlike the
  Metropolis-Hastings algorithm used in \code{\link[spatstat.random]{rmh}}, whose output
  is only approximately correct).

  There is a tiny chance that the algorithm will 
  run out of space before it has terminated. If this occurs, an error
  message will be generated.
}
\value{
  If \code{nsim = 1}, a point pattern (object of class \code{"ppp"}).
  If \code{nsim > 1}, a list of point patterns.
}
\references{
  Berthelsen, K.K. and \Moller, J. (2002)
  A primer on perfect simulation for spatial point processes.
  \emph{Bulletin of the Brazilian Mathematical Society} 33, 351-367.

  Berthelsen, K.K. and \Moller, J. (2003)
  Likelihood and non-parametric Bayesian MCMC inference 
  for spatial point processes based on perfect simulation and
  path sampling. 
  \emph{Scandinavian Journal of Statistics} 30, 549-564.

  Cormack, R.M. (1979)
  Spatial aspects of competition between individuals.
  Pages 151--212 in \emph{Spatial and Temporal Analysis in Ecology},
  eds. R.M. Cormack and J.K. Ord, International Co-operative
  Publishing House, Fairland, MD, USA. 

  \Moller, J. and Waagepetersen, R. (2003).
  \emph{Statistical Inference and Simulation for Spatial Point Processes.}
  Chapman and Hall/CRC.

  Penttinen, A. (1984) 
  \emph{Modelling Interaction in Spatial Point Patterns:
  Parameter Estimation by the Maximum Likelihood Method.}
  \Jyvaskyla Studies in Computer Science, Economics and Statistics \bold{7},
  University of \Jyvaskyla, Finland.
}
\author{
  \adrian,
  based on original code for the Strauss process by 
  Kasper Klitgaard Berthelsen.
}
\examples{
   X <- rPenttinen(50, 0.5, 0.02)
   Z <- rPenttinen(50, 0.5, 0.01, nsim=2)
}
\seealso{
  \code{\link[spatstat.random]{rmh}},

  \code{\link[spatstat.random]{rStrauss}},
  \code{\link[spatstat.random]{rHardcore}},
  \code{\link[spatstat.random]{rStraussHard}},
  \code{\link[spatstat.random]{rDiggleGratton}},
  \code{\link[spatstat.random]{rDGS}}.

  \code{\link[spatstat.model]{Penttinen}}.
}
\keyword{spatial}
\keyword{datagen}

\name{methods.clusterprocess}
\alias{methods.clusterprocess} % DoNotExport
\alias{predict.clusterprocess}
\alias{intensity.clusterprocess}
\alias{print.clusterprocess}
\alias{clusterradius.clusterprocess}
\alias{reach.clusterprocess}
\alias{simulate.clusterprocess}
\title{
  Methods for Cluster Models
}
\description{
  Methods for the class \code{"clusterprocess"} of cluster point process
  models with specified values of the parameters.
}
\usage{
 \method{intensity}{clusterprocess}(X, \dots)

 \method{predict}{clusterprocess}(object, \dots,
                  locations, type = "intensity", ngrid = NULL)

 \method{print}{clusterprocess}(x, \dots)

 \method{clusterradius}{clusterprocess}(model,\dots,thresh=NULL, precision=FALSE)

 \method{reach}{clusterprocess}(x, \dots, epsilon)

 \method{simulate}{clusterprocess}(object, nsim=1, \dots, win=unit.square(), window=win)
}
\arguments{
  \item{model,object,x,X}{
    Object of class \code{"clusterprocess"}.
  }
  \item{\dots}{
    Arguments passed to other methods.
  }
  \item{locations}{
    Locations where prediction should be performed.
    A window or a point pattern.
  }
  \item{type}{
    Currently must equal \code{"intensity"}.
  }
  \item{ngrid}{
    Pixel grid dimensions for prediction, if \code{locations} is
    a rectangle or polygon.
  }
  \item{thresh,epsilon}{Tolerance thresholds}
  \item{precision}{
    Logical value stipulating whether the precision should also be returned.
  }
  \item{win,window}{
    Window (object of class \code{"owin"}) in which the simulated
    pattern should be generated.
  }
  \item{nsim}{
    Number of simulated patterns to be generated.
  }
}
\details{
  An object of class \code{"clusterprocess"} represents a Neyman-Scott-Cox
  cluster process model with specified parameter values.

  This page documents methods for printing, simulating and predicting
  such models, supplied by the package \pkg{spatstat.random}.
  Other methods are supplied in other packages.
}
\value{
  Same as for other methods.
}
\author{
  \adrian
}
\seealso{
  \code{\link{clusterprocess}}
  %% \code{\link[spatstat.model]{Kmodel.clusterprocess}} WHEN AVAILABLE
}
\examples{
  m <- clusterprocess("Thomas", kappa=10, mu=5, scale=0.1)
  m2 <- clusterprocess("VarGamma", kappa=10, mu=10, scale=0.1, nu=0.7)
  m
  m2
  intensity(m)
  reach(m)
  clusterradius(m)
  Z <- predict(m, locations=square(2))
  X <- simulate(m, win=square(2))
}
\keyword{spatial}
\keyword{models}

\name{default.expand}
\alias{default.expand}
\title{Default Expansion Rule for Simulation of Model}
\description{
  Defines the default expansion window or expansion rule
  for simulation of a point process model.
}
\usage{
  default.expand(object, m=2, epsilon=1e-6, w=Window(object))
}
\arguments{
  \item{object}{
    A point process model (object of class \code{"ppm"}
    or \code{"rmhmodel"}).
  }
  \item{m}{
    A single numeric value.
    The window will be expanded by a distance 
    \code{m * reach(object)} along each side.
  }
  \item{epsilon}{
    Threshold argument passed to \code{\link[spatstat.random]{reach}} to determine
    \code{reach(object)}.
  }
  \item{w}{
    Optional. The un-expanded window in which the model is defined.
    The resulting simulated point patterns will lie in this window. 
  }
} 
\value{
  A window expansion rule (object of class \code{"rmhexpand"}).
}
\details{
  This function computes a default value for the
  expansion rule (the argument \code{expand} in \code{\link[spatstat.random]{rmhcontrol}})
  given a fitted point process model \code{object}.
  This default is used by
  \code{\link[spatstat.random]{rmh}},
  \code{\link[spatstat.model]{simulate.ppm}},
  \code{\link[spatstat.explore]{envelope}}, 
  \code{\link[spatstat.model]{qqplot.ppm}},
  and other functions.

  Suppose we wish to generate simulated realisations
  of a fitted point process model inside a window \code{w}.
  It is advisable to first simulate
  the pattern on a larger window, and then clip it to the original
  window \code{w}. This avoids edge effects in the simulation.
  It is called \emph{expansion} of the simulation window.
  
  Accordingly, for the Metropolis-Hastings simulation algorithm
  \code{\link[spatstat.random]{rmh}}, the algorithm control parameters specified by
  \code{\link[spatstat.random]{rmhcontrol}} include an argument \code{expand} that
  determines the expansion of the simulation window.

  The function \code{default.expand} determines the default expansion
  rule for a fitted point process model \code{object}.
  
  If the model is Poisson, then no expansion is necessary.
  No expansion is performed by default,
  and \code{default.expand} returns a rule representing no expansion.
  The simulation window is the original window \code{w = Window(object)}.
  
  If the model depends on external covariates (i.e.\ covariates other than
  the Cartesian covariates \code{x} and \code{y} and the \code{marks})
  then no expansion is feasible, in general, because the spatial domain
  of the covariates is not guaranteed to be large enough.
  \code{default.expand} returns a rule representing no expansion.
  The simulation window is the original window \code{w = Window(object)}.

  If the model depends on the Cartesian covariates \code{x} and \code{y},
  it would be feasible to expand the simulation window, and this was the
  default for \pkg{spatstat} version 1.24-1 and earlier.
  However this sometimes produces artefacts (such as an empty point pattern)
  or memory overflow, because the fitted trend, extrapolated outside the
  original window of the data, may become very large.
  In \pkg{spatstat} version 1.24-2 and later, the
  default rule is \emph{not} to expand if the model depends
  on \code{x} or \code{y}.
  Again \code{default.expand} returns a rule representing no expansion.
  
  Otherwise, expansion will occur.
  The original window \code{w = Window(object)} is expanded by
  a distance \code{m * rr}, where
  \code{rr} is the interaction range of the model, computed by
  \code{\link[spatstat.random]{reach}}. If \code{w} is a rectangle then
  each edge of \code{w} is displaced outward by distance \code{m * rr}.
  If \code{w} is not a rectangle then \code{w} is dilated by
  distance \code{m * rr} using \code{\link[spatstat.geom]{dilation}}.
}
\seealso{
  \code{\link[spatstat.random]{rmhexpand}},
  \code{\link[spatstat.random]{rmhcontrol}},
  \code{\link[spatstat.random]{rmh}},
  \code{\link[spatstat.explore]{envelope}},
  \code{\link[spatstat.model]{qqplot.ppm}}
}
\examples{
if(require(spatstat.model)) {
  fit <- ppm(cells ~1, Strauss(0.07), nd=20)
  default.expand(fit)
}
  mod <- rmhmodel(cif="strauss", par=list(beta=100, gamma=0.5, r=0.07))
  default.expand(mod)
}
\author{
  \adrian
  and \rolf
}
\keyword{spatial}
\keyword{datagen}

\name{rshift.psp}
\alias{rshift.psp}
\title{Randomly Shift a Line Segment Pattern}
\description{
  Randomly shifts the segments in a line segment pattern.
}
\usage{
   \method{rshift}{psp}(X, \dots, group=NULL, which=NULL)
}
\arguments{
  \item{X}{Line segment pattern to be subjected to a random shift.
    An object of class \code{"psp"}.
  }
  \item{\dots}{
    Arguments controlling the randomisation and the handling of edge
    effects. See \code{\link{rshift.ppp}}.
  }
  \item{group}{
    Optional. Factor specifying a grouping of the line segments of \code{X},
    or \code{NULL} indicating that all line segments belong to the same group.
    Each group will be shifted together, and
    separately from other groups.
  }
  \item{which}{
    Optional. Identifies which groups of the pattern will be shifted,
    while other groups are not shifted. A vector of levels of \code{group}.
  }
}
\value{
  A line segment pattern (object of class \code{"psp"}).
}
\details{
  This operation randomly shifts the locations of the line segments
  in a line segment pattern.

  The function \code{rshift} is generic. This function \code{rshift.psp}
  is the method for line segment patterns.

  The line segments of \code{X} are first divided into groups,
  then the line segments within a group are shifted by a common
  random displacement vector. Different groups of line segments are shifted
  independently.
  If the argument \code{group} is present, then this determines the grouping.
  Otherwise, all line segments belong to a single group.

  The argument \code{group} should be a factor, of length equal to the
  number of line segments in \code{X}.
  Alternatively \code{group} may be \code{NULL},
  which specifies that all line segments of \code{X} belong to a single group.

  By default, every group of line segments will be shifted.
  The argument \code{which} indicates that only some of the groups
  should be shifted, while other groups should be left unchanged.
  \code{which} must be a vector of levels of \code{group}
  indicating which groups are to be shifted. 

  The displacement vector, i.e. the vector
  by which the data line segments are shifted,
  is generated at random.
  The \emph{default} behaviour is 
  to generate a displacement vector at random with equal probability
  for all possible displacements. This means that the \eqn{x} and
  \eqn{y} coordinates of the displacement vector are independent random
  variables, uniformly distributed over the range of possible coordinates.

  Alternatively, the displacement vector can be generated by
  another random mechanism, controlled by the arguments
  \code{radius}, \code{width} and \code{height}. 
  \describe{
    \item{rectangular:}{
      if \code{width} and \code{height} are given, then 
      the displacement vector is uniformly distributed
      in a rectangle of these dimensions, centred at
      the origin.  The maximum possible displacement in the \eqn{x}
      direction is \code{width/2}. The maximum possible displacement in
      the \eqn{y} direction is \code{height/2}. The \eqn{x} and \eqn{y}
      displacements are independent. (If \code{width} and \code{height}
      are actually equal to the dimensions of the observation window,
      then this is equivalent to the default.)
    }
    \item{radial:}{
      if \code{radius} is given, then the displacement vector is
      generated by choosing a random line segment inside a disc of
      the given radius, centred at the origin, with uniform probability
      density over the disc. Thus the argument \code{radius} determines
      the maximum possible displacement distance.
      The argument \code{radius} is incompatible with the
      arguments \code{width} and \code{height}.
    }
  }

  The argument \code{edge} controls what happens when 
  a shifted line segment lies partially or completely
  outside the window of \code{X}. Currently the only option is
  \code{"erode"} which specifies that the segments will be clipped
  to a smaller window. 

  The optional argument \code{clip} specifies a smaller window
  to which the pattern should be restricted.
}
\seealso{
  \code{\link{rshift}},
  \code{\link{rshift.ppp}}
}
\examples{
  X <- psp(runif(20), runif(20), runif(20), runif(20),  window=owin())
  Y <- rshift(X, radius=0.1)
}
\author{\adrian
  
  
  and \rolf
  
}
\keyword{spatial}
\keyword{datagen}

\name{rpoispp}
\alias{rpoispp}
\title{Generate Poisson Point Pattern}
\description{
  Generate a random point pattern using the
  (homogeneous or inhomogeneous) Poisson process.
  Includes CSR (complete spatial randomness).
}
\usage{
 rpoispp(lambda, lmax=NULL, win=owin(), \dots,
         nsim=1, drop=TRUE, ex=NULL,
         forcewin=FALSE, warnwin=TRUE)
}
\arguments{
  \item{lambda}{
    Intensity of the Poisson process.
    Either a single positive number, a \code{function(x,y, \dots)},
    or a pixel image.
  }
  \item{lmax}{
    Optional. An upper bound for the value of \code{lambda(x,y)},
    if \code{lambda} is a function.
  }
  \item{win}{
    Window in which to simulate the pattern.
    An object of class \code{"owin"}
    or something acceptable to \code{\link[spatstat.geom]{as.owin}}.
    (Ignored if \code{lambda} is a pixel image
    unless \code{forcewin=TRUE}.)
  }
  \item{\dots}{
    Arguments passed to \code{lambda} if it is a function.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
  \item{ex}{
    Optional. A point pattern to use as the example.
    If \code{ex} is given and \code{lambda,lmax,win} are missing,
    then \code{lambda} and \code{win} will be calculated from
    the point pattern \code{ex}.
  }
  \item{forcewin}{
    Logical value specifying whether to use the argument \code{win}
    as the simulation window when \code{lambda} is an image.
  }
  \item{warnwin}{
    Logical value specifying whether to issue a warning
    when \code{win} is ignored (which occurs when \code{lambda}
    is an image, \code{win} is present and \code{forcewin=FALSE}).
  }
}
\value{
  A point pattern (an object of class \code{"ppp"})
  if \code{nsim=1}, or a list of point patterns if \code{nsim > 1}.
}
\details{
  If \code{lambda} is a single number,
  then this algorithm generates a realisation
  of the uniform Poisson process (also known as 
  Complete Spatial Randomness, CSR) inside the window \code{win} with 
  intensity \code{lambda} (points per unit area).
 
  If \code{lambda} is a function, then this algorithm generates a realisation
  of the inhomogeneous Poisson process with intensity function
  \code{lambda(x,y,\dots)} at spatial location \code{(x,y)}
  inside the window \code{win}.
  The function \code{lambda} must work correctly with vectors \code{x}
  and \code{y}.

  If \code{lmax} is given,
  it must be an upper bound on the values of \code{lambda(x,y,\dots)}
  for all locations \code{(x, y)}
  inside the window \code{win}. That is, we must have
  \code{lambda(x,y,\dots) <= lmax} for all locations \code{(x,y)}.
  If this is not true then the results of
  the algorithm will be incorrect.

  If \code{lmax} is missing or \code{NULL},
  an approximate upper bound is computed by finding the maximum value
  of \code{lambda(x,y,\dots)}
  on a grid of locations \code{(x,y)} inside the window \code{win},
  and adding a safety margin equal to 5 percent of the range of
  \code{lambda} values. This can be computationally intensive,
  so it is advisable to specify \code{lmax} if possible.

  If \code{lambda} is a pixel image object of class \code{"im"}
  (see \code{\link[spatstat.geom]{im.object}}), this algorithm generates a realisation
  of the inhomogeneous Poisson process with intensity equal to the
  pixel values of the image. (The value of the intensity function at an
  arbitrary location is the pixel value of the nearest pixel.)
  If \code{forcewin=FALSE} (the default),
  the simulation window will be the window of the pixel image
  (converted to a rectangle if possible
  using \code{\link[spatstat.geom]{rescue.rectangle}}).
  If \code{forcewin=TRUE}, the simulation window will be the argument
  \code{win}.

  For \emph{marked} point patterns, use \code{\link{rmpoispp}}.
}
\section{Warning}{
  Note that \code{lambda} is the \bold{intensity}, that is,
  the expected number of points \bold{per unit area}.
  The total number of points in the simulated
  pattern will be random with expected value \code{mu = lambda * a}
  where \code{a} is the area of the window \code{win}. 
}
\section{Reproducibility}{
  The simulation algorithm has changed in the following cases.
  \itemize{
    \item
    \code{lambda} is a function which is constant on each tile of
    a tessellation (a function of class \code{"tessfun"} created by
    \code{\link[spatstat.geom]{as.tess}}) and the tiles are rectangles or polygons.
    The algorithm was changed in \code{spatstat.random} version \code{3.3-3}.
    The new algorithm generates uniform Poisson
    realisations in each tile of the tessellation.
    This algorithm is exact (i.e. does not involve spatial
    discretisation), and is usually faster than the old algorithm.
    Set the argument \code{tilewise=FALSE} to use the previous
    rejection algorithm.
    \item
    \code{lambda} is a pixel image.
    The algorithm was changed in \pkg{spatstat}
    version \code{1.42-3}.
    The new faster algorithm randomly selects pixels with
    probability proportional to intensity, and generates point locations
    inside the selected pixels.
    Set \code{spatstat.options(fastpois=FALSE)}
    to use the previous, slower algorithm, if it is desired to reproduce
    results obtained with earlier versions.
  }
  In both cases the previous algorithm
  uses ``thinning'': it first generates a uniform
  Poisson process of intensity \code{lmax},
  then randomly deletes or retains each point, independently of other points,
  with retention probability
  \eqn{p(x,y) = \lambda(x,y)/\mbox{lmax}}{p(x,y) = lambda(x,y)/lmax}.

  Thinning is still used when \code{lambda} is a
  \code{function(x,y,\dots)} in all other cases.
}
\seealso{
  \code{\link{rmpoispp}} for Poisson \emph{marked} point patterns,
  \code{\link{runifpoint}} for a fixed number of independent
  uniform random points;
  \code{\link{rpoint}}, \code{\link{rmpoint}} for a fixed number of
  independent random points with any distribution;
  \code{\link{rMaternI}},
  \code{\link{rMaternII}},
  \code{\link{rSSI}},
  \code{\link{rStrauss}},
  \code{\link{rstrat}}
  for random point processes with spatial inhibition
  or regularity; 
  \code{\link{rThomas}},
  \code{\link{rGaussPoisson}},
  \code{\link{rMatClust}},
  \code{\link{rcell}}
  for random point processes exhibiting clustering;
  \code{\link{rmh.default}} for Gibbs processes.
  See also \code{\link[spatstat.geom]{ppp.object}},
  \code{\link[spatstat.geom]{owin.object}}.
}
\examples{
 # uniform Poisson process with intensity 100 in the unit square
 pp <- rpoispp(100)
 
 # uniform Poisson process with intensity 1 in a 10 x 10 square
 pp <- rpoispp(1, win=owin(c(0,10),c(0,10)))
 # plots should look similar !
 
 # inhomogeneous Poisson process in unit square
 # with intensity lambda(x,y) = 100 * exp(-3*x)
 # Intensity is bounded by 100
 pp <- rpoispp(function(x,y) {100 * exp(-3*x)}, 100)

 # How to tune the coefficient of x
 lamb <- function(x,y,a) { 100 * exp( - a * x)}
 pp <- rpoispp(lamb, 100, a=3)

 # pixel image
 Z <- as.im(function(x,y){100 * sqrt(x+y)}, unit.square())
 pp <- rpoispp(Z)

 # randomising an existing point pattern
 rpoispp(intensity(cells), win=Window(cells))
 rpoispp(ex=cells)
}
\author{
  \spatstatAuthors.
}
\keyword{spatial}
\keyword{datagen}

\name{rmhcontrol}
\alias{rmhcontrol}
\alias{rmhcontrol.default}
\title{Set Control Parameters for Metropolis-Hastings Algorithm.}
\description{
  Sets up a list of parameters controlling the iterative behaviour
  of the Metropolis-Hastings algorithm. 
}
\usage{
   rmhcontrol(\dots)

   \method{rmhcontrol}{default}(\dots, p=0.9, q=0.5, nrep=5e5,
                      expand=NULL, periodic=NULL, ptypes=NULL,
                      x.cond=NULL, fixall=FALSE, nverb=0,
                      nsave=NULL, nburn=nsave, track=FALSE,
                      pstage=c("block", "start"))
}
\arguments{
  \item{\dots}{Arguments passed to methods.}
  \item{p}{Probability of proposing a shift (as against a birth/death).}
  \item{q}{Conditional probability of proposing a death given that a
    birth or death will be proposed.}
  \item{nrep}{Total number of steps (proposals) of Metropolis-Hastings
    algorithm that should be run.}
  \item{expand}{
    Simulation window or expansion rule.
    Either a window (object of class \code{"owin"})
    or a numerical expansion factor, specifying that
    simulations are to be performed in a domain other than the
    original data window, then clipped to the original data window.
    This argument is passed to \code{\link{rmhexpand}}.
    A numerical expansion factor can be in several formats:
    see \code{\link{rmhexpand}}.
  }
  \item{periodic}{
    Logical value (or \code{NULL}) indicating whether to simulate
    ``periodically'', i.e. identifying opposite edges of the rectangular
    simulation window. A \code{NULL} value means ``undecided.''
  }
  \item{ptypes}{For multitype point processes, the distribution of
    the mark attached to a new random point (when a birth is
    proposed)}
  \item{x.cond}{Conditioning points for conditional simulation.}
  \item{fixall}{(Logical) for multitype point processes,
    whether to fix the number of points of each type.}
  \item{nverb}{Progress reports will be printed every \code{nverb}
    iterations}
  \item{nsave,nburn}{
    If these values are specified, then
    intermediate states of the simulation algorithm will be saved
    every \code{nsave} iterations, after an initial burn-in period of
    \code{nburn} iterations.
  }
  \item{track}{
    Logical flag indicating whether to save the transition
    history of the simulations.
  }
  \item{pstage}{
    Character string specifying when to generate
    proposal points. Either \code{"start"} or \code{"block"}.
  }
}

\value{
  An object of class \code{"rmhcontrol"}, which is essentially
  a list of parameter values for the algorithm.
  
  There is a \code{print} method for this class, which prints
  a sensible description of the parameters chosen.
}
\details{
  The Metropolis-Hastings algorithm, implemented as \code{\link{rmh}},
  generates simulated realisations of point process models.
  The function \code{rmhcontrol}
  sets up a list of parameters which control the 
  iterative behaviour
  and termination of the Metropolis-Hastings algorithm, for use in a
  subsequent call to \code{\link{rmh}}. It also checks that the
  parameters are valid.

  (A separate function \code{\link{rmhstart}}
  determines the initial state of the algorithm,
  and \code{\link{rmhmodel}} determines the model to be simulated.)

  The parameters are as follows:
  
  \describe{
    \item{p}{The probability of proposing a ``shift''
      (as opposed to a birth or death) in the Metropolis-Hastings
      algorithm.

      If \eqn{p = 1} then the algorithm only alters existing points,
      so the number of points never changes, i.e. we are
      simulating conditionally upon the number of points.
      The number of points is determined by the initial state
      (specified by \code{\link{rmhstart}}).

      If \eqn{p=1} and \code{fixall=TRUE} and the model
      is a multitype point process model, then the algorithm
      only shifts the locations of existing points and does not
      alter their marks (types). 
      This is equivalent to simulating conditionally
      upon the number of points of each type.
      These numbers are again specified by the initial state.

      If \eqn{p = 1} then no expansion of the simulation window
      is allowed (see \code{expand} below).

      The default value of \code{p} can be changed by setting
      the parameter \code{rmh.p} in \code{\link[spatstat.geom]{spatstat.options}}.
    }
    \item{q}{The conditional probability of proposing a death
      (rather than a birth) given that a shift is not proposed.
      This is of course ignored if \code{p} is equal to 1.

      The default value of \code{q} can be changed by setting
      the parameter \code{rmh.q} in \code{\link[spatstat.geom]{spatstat.options}}.
    }
    \item{nrep}{The number of repetitions or iterations 
      to be made by the Metropolis-Hastings algorithm.  It should
      be large.

      The default value of \code{nrep} can be changed by setting
      the parameter \code{rmh.nrep} in \code{\link[spatstat.geom]{spatstat.options}}.
    }
    \item{expand}{
      Either a number or a window (object of class \code{"owin"}).
      Indicates that the process is to be simulated on a 
      domain other than the original data window \code{w},
      then clipped to \code{w} when the algorithm has finished.
      This would often be done in order to approximate the
      simulation of a stationary process (Geyer, 1999)
      or more generally a process existing in the
      whole plane, rather than just in the window \code{w}.

      If \code{expand} is a window object, it is taken as the
      larger domain in which simulation is performed.

      If \code{expand} is numeric, it is interpreted
      as an expansion factor or expansion distance
      for determining the simulation domain from the data window.
      It should be a \emph{named} scalar, such as
      \code{expand=c(area=2)}, \code{expand=c(distance=0.1)},
      \code{expand=c(length=1.2)}.  See \code{\link{rmhexpand}()} for
      more details. If the name is omitted, it defaults to \code{area}.
     
      Expansion is not permitted if the number of points has been
      fixed by setting \code{p = 1} or if the
      starting configuration has been specified via the
      argument \code{x.start} in \code{\link{rmhstart}}.

      If \code{expand} is \code{NULL}, this is interpreted to mean
      \dQuote{not yet decided}. An expansion rule will be determined
      at a later stage, using appropriate defaults.
      See \code{\link{rmhexpand}}.
    }
    \item{periodic}{A logical value (or \code{NULL})
      determining whether to simulate \dQuote{periodically}.
      If \code{periodic} is \code{TRUE}, and if the simulation window
      is a rectangle, then the simulation algorithm effectively
      identifies opposite edges of the rectangle. Points
      near the right-hand edge of the rectangle are deemed to be close
      to points near the left-hand edge. Periodic simulation usually
      gives a better approximation to a stationary point process.
      For periodic simulation, the simulation window must be a rectangle.
      (The simulation window is determined by \code{expand} as described
      above.)

      The value \code{NULL} means \sQuote{undecided}.
      The decision is postponed until \code{\link{rmh}} is called.
      Depending on the point process model to be simulated,
      \code{rmh} will then set \code{periodic=TRUE} if the simulation window
      is expanded \emph{and} the expanded simulation window is rectangular;
      otherwise \code{periodic=FALSE}.

      Note that \code{periodic=TRUE} is only permitted when the
      simulation window (i.e. the expanded window) is rectangular.       
    }
    \item{ptypes}{A vector of probabilities (summing to 1) to be used
      in assigning a random type to a new point.  Defaults to a vector
      each of whose entries is \eqn{1/nt} where \eqn{nt} is the number
      of types for the process.  Convergence of the simulation
      algorithm should be improved if \code{ptypes} is close to the
      relative frequencies of the types which will result from the
      simulation.
    }
    \item{x.cond}{
      If this argument is given,
      then \emph{conditional simulation} will be performed,
      and \code{x.cond} specifies the location of the
      fixed points as well as the type of conditioning.
      It should be either a point pattern
      (object of class \code{"ppp"}) or a \code{list(x,y)}
      or a \code{data.frame}.
      See the section on Conditional Simulation.
    }
    \item{fixall}{A logical scalar specifying whether to condition on
      the number of points of each type.  Meaningful only if a marked
      process is being simulated, and if \eqn{p = 1}.  A warning message
      is given if \code{fixall} is set equal to \code{TRUE} when it is
      not meaningful.
    }
    \item{nverb}{An integer specifying how often ``progress reports''
      (which consist simply of the number of repetitions completed)
      should be printed out.  If nverb is left at 0, the default,
      the simulation proceeds silently.
    }
    \item{nsave,nburn}{
      If these integers are given, then the
      current state of the simulation algorithm (i.e. the current
      random point pattern) will be saved every \code{nsave} iterations,
      starting from iteration \code{nburn}.
      (Alternatively \code{nsave} can be a vector, specifying
      different numbers of iterations between each successive save.
      This vector will be recycled until the end of the simulations.)
    }
    \item{track}{
      Logical flag indicating whether to save the transition
      history of the simulations (i.e. information specifying
      what type of proposal was made, and whether it was accepted
      or rejected, for each iteration).
    }
    \item{pstage}{
      Character string specifying the stage of the algorithm
      at which the randomised proposal points should be generated.
      If \code{pstage="start"} or if \code{nsave=0},
      the entire sequence of \code{nrep}
      random proposal points is generated at the start of the
      algorithm. This is the original
      behaviour of the code, and should be used in order to maintain
      consistency with older versions of \pkg{spatstat}.
      If \code{pstage="block"} and \code{nsave > 0}, then
      a set of \code{nsave} random proposal points will be generated
      before each block of \code{nsave} iterations. This is much more
      efficient.
      The default is \code{pstage="block"}.
    }
  }
}
\section{Conditional Simulation}{
  For a Gibbs point process \eqn{X},
  the Metropolis-Hastings algorithm easily accommodates several
  kinds of conditional simulation:
  \describe{
    \item{conditioning on the total number of points:}{
      We fix the total number of points \eqn{N(X)} to be equal to
      \eqn{n}. We simulate from the conditional distribution of
      \eqn{X} given \eqn{N(X) = n}. 
    }
    \item{conditioning on the number of points of each type:}{
      In a multitype point process, where \eqn{Y_j}{Y[[j]]} denotes the
      process of points of type \eqn{j}, we fix the number
      \eqn{N(Y_j)}{N(Y[[j]])} of points of type \eqn{j} to be equal to
      \eqn{n_j}{n[j]}, for \eqn{j=1,2,\ldots,m}{j=1,2,...,m}.
      We simulate from the conditional distribution of \eqn{X}
      given \eqn{N(Y_j)=n_j}{N(Y[[j]]) = n[j]} for
      \eqn{j=1,2,\ldots,m}{j=1,2,...,m}. 
    }
    \item{conditioning on the realisation in a subwindow:}{
      We require that the point process \eqn{X} should,
      within a specified sub-window \eqn{V},
      coincide with a specified point pattern \eqn{y}.
      We simulate from the conditional distribution of \eqn{X}
      given \eqn{X \cap V = y}{(X intersect V) = y}.
    }
    \item{Palm conditioning:}{
      We require that the point process \eqn{X} include
      a specified list of points \eqn{y}. We simulate from
      the point process with probability density
      \eqn{g(x) = c f(x \cup y)}{g(x) = c * f(x union y)}
      where \eqn{f} is the probability density of the original
      process \eqn{X}, and \eqn{c} is a normalising constant.
    }
  }
  To achieve each of these types of conditioning we
  do as follows:
  \describe{
    \item{conditioning on the total number of points:}{
      Set \code{p=1}.
      The number of points is determined by the initial state
      of the simulation: see \code{\link{rmhstart}}.
    }
    \item{conditioning on the number of points of each type:}{
      Set \code{p=1} and \code{fixall=TRUE}.
      The number of points of each type is determined by the initial state
      of the simulation: see \code{\link{rmhstart}}.
    }
    \item{conditioning on the realisation in a subwindow:}{
      Set \code{x.cond} to be a point pattern (object of
      class \code{"ppp"}). Its window \code{V=Window(x.cond)} becomes the
      conditioning subwindow \eqn{V}.
    }
    \item{Palm conditioning:}{
      Set \code{x.cond} to be a \code{list(x,y)} or \code{data.frame}
      with two columns containing the coordinates of the points, or a 
      \code{list(x,y,marks)} or \code{data.frame} with three columns
      containing the coordinates and marks of the points.
    }
  }
  The arguments \code{x.cond}, \code{p} and \code{fixall} can be
  combined.   
}
\references{
   Geyer, C.J. (1999)
   Likelihood Inference for Spatial Point
   Processes. Chapter 3 in  O.E. Barndorff-Nielsen, W.S. Kendall and
   M.N.M. Van Lieshout (eds) \emph{Stochastic Geometry: Likelihood and
   Computation}, Chapman and Hall / CRC,  Monographs on Statistics and
   Applied Probability, number 80. Pages 79--140.
}

\seealso{
  \code{\link{rmh}},
  \code{\link{rmhmodel}},
  \code{\link{rmhstart}},
  \code{\link{rmhexpand}},
  \code{\link[spatstat.geom]{spatstat.options}}
}
\examples{
   # parameters given as named arguments
   c1 <- rmhcontrol(p=0.3,periodic=TRUE,nrep=1e6,nverb=1e5)

   # parameters given as a list
   liz <- list(p=0.9, nrep=1e4)
   c2 <- rmhcontrol(liz)

   # parameters given in rmhcontrol object
   c3 <- rmhcontrol(c1)
}
\author{
  \spatstatAuthors.
}
\keyword{spatial}
\keyword{datagen}

\name{rshift.splitppp}  
\alias{rshift.splitppp}
\title{Randomly Shift a List of Point Patterns}
\description{
  Randomly shifts each point pattern in a list of point patterns.
}
\usage{
   \method{rshift}{splitppp}(X, \dots, which=seq_along(X), nsim=1, drop=TRUE)
}
\arguments{
  \item{X}{
    An object of class \code{"splitppp"}.
    Basically a list of point patterns.
  }
  \item{\dots}{
    Parameters controlling the generation of the
    random shift vector and the handling of edge effects.
    See \code{\link{rshift.ppp}}.
  }
  \item{which}{
    Optional. Identifies which patterns will be shifted,
    while other patterns are not shifted.
    Any valid subset index for \code{X}.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a split point pattern object, rather than a list 
    containing the split point pattern.
  }
}
\value{
  Another object of class \code{"splitppp"},
  or a list of such objects.
}
\details{
  This operation applies a random shift to each of the
  point patterns in the list \code{X}.
  
  The function \code{\link{rshift}} is generic.
  This function \code{rshift.splitppp}
  is the method for objects of class \code{"splitppp"}, which are
  essentially lists of point patterns, created by the function
  \code{\link[spatstat.geom]{split.ppp}}.

  By default, every pattern in the list \code{X} will be shifted.
  The argument \code{which} indicates that only some of the patterns
  should be shifted, while other groups should be left unchanged.
  \code{which} can be any valid subset index for \code{X}.

  Each point pattern in the list \code{X}
  (or each pattern in \code{X[which]})
  is shifted by a random displacement vector.
  The shifting is performed by \code{\link{rshift.ppp}}.

  See the help page for \code{\link{rshift.ppp}}
  for details of the other arguments.

  If \code{nsim > 1}, then the simulation procedure is
  performed \code{nsim} times; the result is a list of 
  split point patterns. 
}
\seealso{
  \code{\link{rshift}},
  \code{\link{rshift.ppp}}
}
\examples{
   Y <- split(amacrine)

   # random toroidal shift
   # shift "on" and "off" points separately
   X <- rshift(Y)

   # shift "on" points and leave "off" points fixed
   X <- rshift(Y, which="on")

   # maximum displacement distance 0.1 units
   X <- rshift(Y, radius=0.1)

   # shift with erosion
   X <- rshift(Y, radius=0.1, edge="erode")
}
\author{\adrian
  and \rolf
}
\keyword{spatial}
\keyword{datagen}

\name{rthinclumps}
\alias{rthinclumps}
\title{Random Thinning of Clumps}
\description{
  Finds the topologically-connected clumps of a spatial region
  and randomly deletes some of the clumps.
}
\usage{
rthinclumps(W, p, \dots)
}
\arguments{
  \item{W}{
    Window (object of class \code{"owin"}
    or pixel image (object of class \code{"im"}).
  }
  \item{p}{
    Probability of \emph{retaining} each clump.
    A single number between 0 and 1.
  }
  \item{\dots}{
    Additional arguments passed to \code{\link[spatstat.geom]{connected.im}}
    or \code{\link[spatstat.geom]{connected.owin}} to determine the connected clumps.
  }
}
\details{
  The argument \code{W} specifies a region of space, typically
  consisting of several clumps that are not connected to each other.
  The algorithm randomly deletes or retains each clump. The fate of
  each clump is independent of other clumps.

  If \code{W} is a spatial window (class \code{"owin"}) then
  it will be divided into clumps using 
  \code{\link[spatstat.geom]{connected.owin}}. Each clump will either be
  retained (with probability \code{p}) or deleted in its entirety
  (with probability \code{1-p}). 

  If \code{W} is a pixel image (class \code{"im"}) then its domain
  will be divided into clumps using \code{\link[spatstat.geom]{connected.im}}. The default
  behaviour depends on the type of pixel values. If the pixel values are
  logical, then the spatial region will be taken to consist of all
  pixels whose value is \code{TRUE}. Otherwise, the spatial region is
  taken to consist of all pixels whose value is defined (i.e. not equal
  to \code{NA}). This behaviour can be changed using the argument
  \code{background} passed to \code{\link[spatstat.geom]{connected.im}}.

  The result is a window comprising all the clumps that were retained.
}
\value{
  Window (object of class \code{"owin"}).
}
\author{
  \adrian.
}
\seealso{
  \code{\link{rthin}} for thinning other kinds of objects.
}
\examples{
  A <- (distmap(cells) < 0.06)
  opa <- par(mfrow=c(1,2))
  plot(A)
  plot(rthinclumps(A, 0.5))
  par(opa)
}
\keyword{spatial}
\keyword{datagen}
\keyword{manip}

\name{reach}
\alias{reach}
\alias{reach.rmhmodel}
\title{Interaction Distance of a Point Process Model}
\description{
  Computes the interaction distance of a point process model.
}
\usage{
  reach(x, \dots)

  \method{reach}{rmhmodel}(x, \dots)

}
\arguments{
  \item{x}{Either a fitted point process model (object of class
    \code{"ppm"}), an interpoint interaction (object of class
    \code{"interact"}), a fitted interpoint interaction (object of
    class \code{"fii"}) or a point process model for simulation
    (object of class \code{"rmhmodel"}).
  }
  \item{\dots}{
    Other arguments are ignored.
  }
}
\value{
  The interaction distance, or \code{NA} if this cannot be
  computed from the information given.
}
\details{
  The function \code{reach} computes the 
  `interaction distance' or `interaction range' of a point process
  model.

  The definition of the interaction distance depends on the
  type of point process model. This help page explains the
  interaction distance for a Gibbs point process. For other kinds of
  models, see \code{\link[spatstat.model]{reach.kppm}} and
  \code{\link[spatstat.model]{reach.dppm}}.

  For a Gibbs point process model, the interaction distance
  is the shortest distance \eqn{D} such that any two points in the
  process which are separated by a distance greater than \eqn{D} do not
  interact with each other.

  For example, the interaction range of a Strauss process
  (see \code{\link[spatstat.model]{Strauss}} or \code{\link[spatstat.random]{rStrauss}})
  with parameters \eqn{\beta,\gamma,r}{beta,gamma,r} is equal to
  \eqn{r}, unless \eqn{\gamma=1}{gamma=1} in which case the model is
  Poisson and the interaction
  range is \eqn{0}.
  The interaction range of a Poisson process is zero.
  The interaction range of the Ord threshold process
  (see \code{\link[spatstat.model]{OrdThresh}}) is infinite, since two points \emph{may}
  interact at any distance apart.

  The function \code{reach} is generic, with methods
  for the case where \code{x} is 
  \itemize{
    \item
    a fitted point process model
    (object of class \code{"ppm"}, usually obtained from the model-fitting
    function \code{\link[spatstat.model]{ppm}});
    \item
    an interpoint interaction structure (object of class
    \code{"interact"})
    \item
    a fitted interpoint interaction (object of class
    \code{"fii"})
    \item
    a point process model for simulation (object of class
    \code{"rmhmodel"}), usually obtained from \code{\link[spatstat.random]{rmhmodel}}.
  }
}
\section{Other types of models}{
  Methods for \code{reach} are also defined for
  point process models of class \code{"kppm"} and \code{"dppm"}.
  Their technical definition is different from this one.
  See \code{\link[spatstat.model]{reach.kppm}} and \code{\link[spatstat.model]{reach.dppm}}.
}
\seealso{
    \code{\link[spatstat.model]{reach.ppm}}

     \code{\link{rmhmodel}}

    See \code{\link[spatstat.model]{reach.kppm}} and \code{\link[spatstat.model]{reach.dppm}}
    for other types of point process models.
}
\examples{
    reach(rmhmodel(cif='poisson', par=list(beta=100)))
    # returns 0

    reach(rmhmodel(cif='strauss', par=list(beta=100, gamma=0.1, r=7)))
    # returns 7

    reach(rmhmodel(cif='sftcr', par=list(beta=100, sigma=1, kappa=0.7)))
    # returns Inf
    
    reach(rmhmodel(cif='multihard',
                   par=list(beta=c(10,10), hradii=matrix(c(1,3,3,1),2,2))))
    # returns 3
}
\author{
  \adrian
  and \rolf
}
\keyword{spatial}
\keyword{models}

\name{rPSNCP}
\alias{rPSNCP}
\title{Simulate Product Shot-noise Cox Process}
\description{
  Generate a random multitype point pattern, a realisation of the
  product shot-noise Cox process.
}
\usage{
 rPSNCP(lambda=rep(100, 4), kappa=rep(25, 4), omega=rep(0.03, 4), 
        alpha=matrix(runif(16, -1, 3), nrow=4, ncol=4), 
        kernels=NULL, nu.ker=NULL, win=owin(), nsim=1, drop=TRUE,
        \dots,
        cnames=NULL, epsth=0.001)
%        , mc.cores=1L
}
\arguments{
  \item{lambda}{
    List of intensities of component processes. Either a
    numeric vector determining the constant (homogeneous) intensities 
    or a list of pixel images (objects of class \code{"im"}) determining 
    the (inhomogeneous) intensity functions of  component processes. 
    The length of \code{lambda} determines the number of component processes.
  }
  \item{kappa}{
    Numeric vector of intensities of the Poisson process of cluster centres
    for component processes. Must have the same size as \code{lambda}.
  }
  \item{omega}{
    Numeric vector of bandwidths of cluster dispersal kernels
    for component processes. Must have the same size as \code{lambda} 
    and \code{kappa}.
  }
  \item{alpha}{
    Matrix of interaction parameters. Square numeric matrix with the same 
    number of rows and columns as the length of \code{lambda},
    \code{kappa} and \code{omega}.
    All entries of \code{alpha} must be greater than -1.
  }
  \item{kernels}{
    Vector of character string determining the cluster dispersal kernels
    of component processes. Implemented kernels are Gaussian 
    kernel (\code{"Thomas"}) with bandwidth \code{omega}, 
    Variance-Gamma (Bessel) kernel (\code{"VarGamma"}) with 
    bandwidth \code{omega} and shape parameter \code{nu.ker} 
    and Cauchy kernel (\code{"Cauchy"}) with bandwidth \code{omega}.
    Must have the same length as \code{lambda}, \code{kappa} and \code{omega}.
  }
  \item{nu.ker}{
    Numeric vector of bandwidths of shape parameters for Variance-Gamma
    kernels. 
  }
  \item{win}{
    Window in which to simulate the pattern.
    An object of class \code{"owin"}.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{cnames}{
    Optional vector of character strings giving the names of
    the component processes.
  }
  \item{\dots}{
    Optional arguments passed to \code{\link[spatstat.geom]{as.mask}}
    to determine the pixel array geometry.
    See \code{\link[spatstat.geom]{as.mask}}.
  }
  \item{epsth}{
    Numerical threshold to determine the maximum interaction range for 
    cluster kernels.
    % See Details.
    % NO DETAILS ARE GIVEN!
  }
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
%  \item{mc.cores}{
%    Integer value indicating the number of cores for parallel computing using
%    \code{"mclapply"} function in the \pkg{parallel} package.
%  }
}
\value{
  A point pattern (an object of class \code{"ppp"}) if \code{nsim=1}, or a
     list of point patterns if \code{nsim > 1}.  Each point pattern is
     multitype (it carries a vector of marks which is a factor).
}
\details{
  This function generates a realisation of a product shot-noise Cox
  process (PSNCP). This is a multitype (multivariate) Cox point process 
  in which each element of the multivariate random intensity
  \eqn{\Lambda(u)} 
  of the process is obtained by 
  \deqn{
    \Lambda_i(u) = \lambda_i(u) S_i(u) \prod_{j \neq i} E_{ji}(u)
  }{
    Lambda[i](u) = lambda[i](u) S[i](u) prod[j != i] E[ji](u)
  }
  where \eqn{\lambda_i(u)}{\lambda[i](u)} is the intensity
  of component \eqn{i} of the process,
  \deqn{
    S_i(u) = \frac{1}{\kappa_{i}} \sum_{v \in \Phi_i} k_{i}(u - v)
  }{
    S[i](u) = 1 / (kappa[i]) sum[v in Phi[i]] k[i](u - v)
  }
  is the shot-noise random field for component \eqn{i} and 
  \deqn{
      E_{ji}(u) = \exp(-\kappa_{j} \alpha_{ji} / k_{j}(0)) \prod_{v \in \Phi_{j}} {1 + \alpha_{ji} \frac{k_j(u-v)}{k_j(0)}}
    }{
      E[ji](u) = exp(-\kappa[j] \alpha[ji] / k[j](0)) prod[v in Phi[j]] (1 + alpha[ji] k[j](u-v) / k[j](0))
    }
  is a product field controlling impulses from the parent Poisson process 
  \eqn{\Phi_j}{\Phi[j]} with constant intensity \eqn{\kappa_j}{\kappa[j]} of 
  component process \eqn{j} on \eqn{\Lambda_i(u)}{\Lambda[i](u)}.
  Here \eqn{k_i(u)}{k[i](u)} is an isotropic kernel (probability
  density) function on \eqn{R^2} with bandwidth \eqn{\omega_i}{\omega[i]} and 
  shape parameter \eqn{\nu_i}{\nu[i]},
  and \eqn{\alpha_{ji}>-1}{\alpha[j,i] > -1} is the interaction parameter.
}
\seealso{
\code{\link{rmpoispp}},
\code{\link{rThomas}},
\code{\link{rVarGamma}},
\code{\link{rCauchy}},
\code{\link{rNeymanScott}}
}
\references{
  Jalilian, A., Guan, Y., Mateu, J. and Waagepetersen, R. (2015)
  Multivariate product-shot-noise Cox point process models. 
  \emph{Biometrics}  \bold{71}(4), 1022--1033.
}
\examples{
  online <- interactive()
  # Example 1: homogeneous components
  lambda <- c(250, 300, 180, 400)
  kappa <- c(30, 25, 20, 25)
  omega <- c(0.02, 0.025, 0.03, 0.02)
  alpha <- matrix(runif(16, -1, 1), nrow=4, ncol=4)
  if(!online) {
     lambda <- lambda[1:2]/10
     kappa  <- kappa[1:2]
     omega  <- omega[1:2]
     alpha  <- alpha[1:2, 1:2]
  }
  X <- rPSNCP(lambda, kappa, omega, alpha)
  if(online) {
    plot(X)
    plot(split(X))
  }

  #Example 2: inhomogeneous components
  z1 <- scaletointerval.im(bei.extra$elev, from=0, to=1)
  z2 <- scaletointerval.im(bei.extra$grad, from=0, to=1)
  if(!online) {
    ## reduce resolution to reduce check time
    z1 <- as.im(z1, dimyx=c(40,80))
    z2 <- as.im(z2, dimyx=c(40,80))
  } 
  lambda <- list(
         exp(-8 + 1.5 * z1 + 0.5 * z2),
         exp(-7.25 + 1 * z1  - 1.5 * z2),
         exp(-6 - 1.5 * z1 + 0.5 * z2),
         exp(-7.5 + 2 * z1 - 3 * z2))
  kappa <- c(35, 30, 20, 25) / (1000 * 500)
  omega <- c(15, 35, 40, 25)
  alpha <- matrix(runif(16, -1, 1), nrow=4, ncol=4)
  if(!online) {
     lambda <- lapply(lambda[1:2], "/", e2=10)
     kappa  <- kappa[1:2]
     omega  <- omega[1:2]
     alpha  <- alpha[1:2, 1:2]
  } else {
     sapply(lambda, integral)
  }
  X <- rPSNCP(lambda, kappa, omega, alpha, win = Window(bei), dimyx=dim(z1))
  if(online) {
    plot(X)
    plot(split(X), cex=0.5)
  }
}
\author{Abdollah Jalilian.
  Modified by \spatstatAuthors.
}
\keyword{spatial}
\keyword{datagen}

\name{rclusterBKBC}
\alias{rclusterBKBC}
\title{
  Simulate Cluster Process using Brix-Kendall Algorithm or Modifications
}
\description{
  Generates simulated realisations of a stationary Neyman-Scott
  cluster point process, using the Brix-Kendall (2002) algorithm or various
  modifications proposed by Baddeley and Chang (2023).
  For advanced research use.
}
\usage{
rclusterBKBC(clusters="Thomas",
   kappa, mu, scale,
   \dots,
   W = unit.square(),
   nsim = 1, drop = TRUE,
   best = FALSE,
   external = c("BK", "superBK", "border"),
   internal = c("dominating", "naive"),
   inflate = 1,
   psmall = 1e-04,
   use.inverse=TRUE,
   use.special=TRUE,
   integralmethod=c("quadrature", "trapezoid"),
   verbose = TRUE, warn=TRUE)
}
\arguments{
  \item{clusters}{
    Character string (partially matched) specifying the cluster process.
    Current options include \code{"Thomas"}, \code{"MatClust"},
    \code{"Cauchy"} and \code{"VarGamma"}.
  }
  \item{kappa}{
    Intensity of the parent process. A nonnegative number.
  }
  \item{mu}{
    Mean number of offspring per parent. A nonnegative number.
  }
  \item{scale}{
    Cluster scale. Interpretation depends on the model.
  }
  \item{\dots}{
    Additional arguments controlling the shape of the cluster kernel, if any.
  }
  \item{W}{
    Window in which the simulation should be generated.
    An object of class \code{"owin"}.
  }
  \item{nsim}{
    The number of simulated point patterns to be generated. A positive integer.
  }
  \item{drop}{
    Logical value. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
  \item{best}{
    Logical value. If \code{best=TRUE}, the code will choose the fastest
    algorithm. If \code{best=FALSE} (the default), the algorithm will be
    specified by the other arguments \code{external} and
    \code{internal}.
    See Details.
  }
  \item{external}{
    Algorithm to be used to generate parent points which lie outside the
    bounding window. See Details. 
  }
  \item{internal}{
    Algorithm to be used to generate parent points which lie inside the
    bounding window. See Details.
  }
  \item{inflate}{
    Numerical value determining the position of the bounding window.
    See Details.
  }
  \item{psmall}{
    Threshold of small probability for use in the algorithm.
  }
  \item{use.inverse}{
    Logical value specifying whether to compute the inverse function
    analytically, if possible (\code{use.inverse=TRUE}, the default)
    or by numerical root-finding (\code{use.inverse=FALSE}).
    This is mainly for checking validity of code.
  }
  \item{use.special}{
    Logical value specifying whether to use efficient special code
    (if available) to generate the simulations (\code{use.special=TRUE},
    the default) or to use generic code (\code{use.special=FALSE}).
    This is mainly for checking validity of code.
  }
  \item{integralmethod}{
    Character string (partially matched)
    specifying how to perform numerical computation of integrals
    when required. This argument is passed to
    \code{\link[spatstat.univar]{indefinteg}}.
    The default \code{integralmethod="quadrature"} is accurate but
    can be slow. 
    Faster, but possibly less accurate, integration can be performed
    by setting \code{integralmethod="trapezoid"}.
  }
  \item{verbose}{
    Logical value specifying whether to print detailed information about
    the simulation algorithm during execution.
  }
  \item{warn}{
    Logical value specifying whether to issue a warning
    if the number of random proposal points is very large.
  }
}
\details{
  This function is intended for advanced research use.
  It implements the algorithm of Brix and Kendall (2002)
  for generating simulated realisations of a stationary Neyman-Scott
  process, and various modifications of this algorithm proposed
  in Baddeley and Chang (2023).
  It is an alternative to \code{\link[spatstat.random]{rNeymanScott}}.

  The function supports the following models:
  \itemize{
    \item \code{clusters="Thomas"}: the (modified) Thomas cluster process
    which can also be simulated by
    \code{\link[spatstat.random]{rThomas}}.  
    \item \code{clusters="MatClust"}: the \Matern cluster process
    which can also be simulated by
    \code{\link[spatstat.random]{rMatClust}}.  
    \item \code{clusters="Cauchy"}: the Cauchy cluster process
    which can also be simulated by
    \code{\link[spatstat.random]{rCauchy}}.  
    \item \code{clusters="VarGamma"}: the variance-gamma cluster process
    which can also be simulated by
    \code{\link[spatstat.random]{rVarGamma}}.  
    \item 
    any other Poisson cluster process models that may be recognised by 
    \code{\link[spatstat.model]{kppm}}. 
  }

  By default, the code executes the original Brix-Kendall algorithm
  described in Sections 2.3 and 3.1 of Brix and Kendall (2002).

  Modifications of this algorithm, proposed in Baddeley and Chang
  (2023), can be selected using the
  arguments \code{external} and \code{internal}, or \code{best}.

  If \code{best=TRUE}, the code will choose the algorithm
  that would run fastest with the given parameters.
  If \code{best=FALSE} (the default), the choice of algorithm
  is determined by the arguments \code{external} and \code{internal}.

  First the window \code{W} is enclosed in a disc \code{D}
  and Monte Carlo proposal densities are defined with reference to \code{D}
  as described in Brix and Kendall (2002).
  Then \code{D} is inflated by the scale factor \code{inflate}
  to produce a larger disc \code{E} (by default \code{inflate=1}
  implying \code{E=D}). 
  Then the parent points of the clusters are generated, possibly
  using different mechanisms inside and outside \code{E}.

  The argument \code{external} determines the algorithm for generating
  parent points outside \code{E}.
  \itemize{
    \item
    If \code{external="BK"} (the default), proposed parents outside
    \code{E} will be generated from a dominating point process as described in
    Section 3.1 of Brix and Kendall (2002). These points will be thinned
    to obtain the correct intensity of parent points.
    For each accepted parent, offspring points are generated inside \code{D},
    subject to the condition that the parent has at least one offspring inside \code{D}.
    Offspring points are subsequently clipped to the true window \code{W}.
    \item 
    If \code{external="superBK"}, proposed parents will initially be generated
    from a process that dominates the dominating point process
    as described in Baddeley and Chang (2023).
    These proposals will then be thinned to obtain the correct intensity
    of the dominating process, then thinned again to obtain the correct
    intensity of parent points. This procedure reduces computation time
    when \code{scale} is large.
    For each accepted parent, offspring points are generated inside \code{D},
    subject to the condition that the parent has at least one offspring inside \code{D}.
    Offspring points are subsequently clipped to the true window \code{W}.
    \item
    If \code{external="border"} then proposed parents will be generated
    with uniform intensity in a border region
    surrounding the disc \code{D}.
    For each proposed parent, offspring points are generated in the
    entire plane according to the cluster offspring distribution, without
    any restriction.
    Offspring points are subsequently clipped to the true window \code{W}.
    This is the technique currently used in
    \code{\link[spatstat.random]{rNeymanScott}}.
  }
  The argument \code{internal} determines the algorithm for generating
  proposed parent points inside \code{E}.
  \itemize{
    \item
    If \code{internal="dominating"}, parent points in \code{E} are generated
    according to the dominating point process described in 
    Sections 2.3 and 3.1 of Brix and Kendall (2002), and then thinned
    to obtain the correct intensity of parent points. 
    For each accepted parent, offspring points are generated inside \code{D},
    subject to the condition that the parent has at least one offspring inside \code{D}.
    Offspring points are subsequently clipped to the true window \code{W}.
    \item
    If \code{internal="naive"}, parent points in \code{E} are generated with
    uniform intensity inside \code{E} and are not thinned.
    For each proposed parent, offspring points are generated in the
    entire plane according to the cluster offspring distribution, without
    any restriction.
    Offspring points are subsequently clipped to the true window
    \code{W}.
    This is the technique currently used in \code{\link[spatstat.random]{rNeymanScott}}.
  }
  If \code{warn=TRUE}, then a warning will be issued if
  the number of random proposal points (proposed parents and proposed
  offspring) is very large.
  The threshold is \code{\link[spatstat.geom]{spatstat.options}("huge.npoints")}.
  This warning has no consequences,
  but it helps to trap a number of common problems.
}
\value{
  A point pattern, or a list of point patterns.

  If \code{nsim=1} and \code{drop=TRUE}, the result is 
  a point pattern (an object of class \code{"ppp"}).

  Otherwise, the result is a list of \code{nsim} point patterns,
  and also belongs to the class \code{"solist"}.
}
\author{
  \adrian and \yamei.
}
\references{
  \baddchangclustersim

  Brix, A. and Kendall, W.S. (2002)
  Simulation of cluster point processes without edge effects.
  \emph{Advances in Applied Probability} \bold{34}, 267--280.
}
\seealso{
  \code{\link[spatstat.random]{rNeymanScott}},
  \code{\link[spatstat.random]{rMatClust}},
  \code{\link[spatstat.random]{rThomas}},
  \code{\link[spatstat.random]{rCauchy}},
  \code{\link[spatstat.random]{rVarGamma}}
}
\examples{
  Y <- rclusterBKBC("Thomas", 10,5,0.2)
  Y
  Z <- rclusterBKBC("VarGamma", 10,5,0.2,
          nu=-1/4,
          internal="naive", external="super",
          verbose=FALSE)
}
\keyword{datagen}
\keyword{spatial}

\name{rpoistrunc}
\alias{rpoisnonzero}
\alias{rpoistrunc}
\title{
  Random Values from the Truncated Poisson Distribution
}
\description{
  Generate realisations of a Poisson random variable
  which are truncated, that is, conditioned to be nonzero, or conditioned
  to be at least a given number.
}
\usage{
rpoisnonzero(n, lambda, method=c("harding", "transform"), implem=c("R", "C"))
rpoistrunc(n, lambda, minimum = 1, method=c("harding", "transform"), implem=c("R", "C"))
}
\arguments{
  \item{n}{Number of random values to be generated.}
  \item{lambda}{
    Mean value of the un-truncated Poisson distribution.
    A nonnegative number, or vector of nonnegative numbers.
  }
  \item{minimum}{
    Minimum permitted value for the random variables.
    A nonnegative integer, or vector of nonnegative integers.
  }
  \item{method}{
    Character string (partially matched) specifying the simulation
    algorithm to be used. See Details.
  }
  \item{implem}{
    Character string specifying whether to use the implementation
    in interpreted R code (\code{implem="R"}, the default)
    or C code (\code{implem="C"}).
  }
}
\details{
  \code{rpoisnonzero}
  generates realisations of the
  Poisson distribution with mean \code{lambda}
  conditioned on the event that the values are not equal to zero.

  \code{rpoistrunc} 
  generates realisations of the
  Poisson distribution with mean \code{lambda}
  conditioned on the event that the values are greater than
  or equal to \code{minimum}.
  The default \code{minimum=1} is equivalent to
  generating zero-truncated Poisson random variables
  using \code{rpoisnonzero}.
  The value \code{minimum=0} is equivalent to
  generating un-truncated Poisson random variables
  using \code{\link[stats]{rpois}}.

  The arguments \code{lambda} and \code{minimum} can be
  vectors of length \code{n}, specifying different means
  for the un-truncated Poisson distribution, and different
  minimum values, for each of the \code{n} random output values.

  If \code{method="transform"} the simulated values are generated
  by transforming a uniform random variable using the quantile function
  of the Poisson distribution.
  If \code{method="harding"} (the default) the simulated values are
  generated using an algorithm proposed by E.F. Harding which exploits
  properties of the Poisson point process. The Harding algorithm seems
  to be faster.
}
\value{
  An integer vector of length \code{n}.
}
\author{
  \adrian, after ideas of Ted Harding and Peter Dalgaard.
}
\references{
  E.F. Harding (2005) Email to R-help email group, 01 May 2005.

  P. Dalgaard (2005) Email to R-help email group, 01 May 2005.
}
\seealso{
  \code{\link[stats]{rpois}} for Poisson random variables.

  \code{\link{recipEnzpois}} for the reciprocal moment of \code{rpoisnonzero}.
}
\examples{
  rpoisnonzero(10, 0.8)

  rpoistrunc(10, 1, 2)
}
\keyword{datagen}

\name{rLGCP}
\alias{rLGCP}
\title{Simulate Log-Gaussian Cox Process}
\description{
  Generate a random point pattern, a realisation of the
  log-Gaussian Cox process.
}
\usage{
 rLGCP(model=c("exponential", "gauss", "stable", "gencauchy", "matern"),
       mu = 0, param = NULL,
       \dots,
       win=NULL, saveLambda=TRUE, nsim=1, drop=TRUE,
       n.cond=NULL, w.cond=NULL)
}
\arguments{
  \item{model}{
    character string (partially matched) giving the name of a
    covariance model for the Gaussian random field. 
  }
  \item{mu}{
    mean function of the Gaussian random field. Either a
    single number, a \code{function(x,y, ...)} or a pixel
    image (object of class \code{"im"}).
  }
  \item{param}{
    List of parameters for the covariance.
    Standard arguments are \code{var} and \code{scale}.
  }
  \item{\dots}{
    Additional parameters for the covariance,
    or arguments passed to \code{\link[spatstat.geom]{as.mask}} to determine
    the pixel resolution.
  }
  \item{win}{
    Window in which to simulate the pattern.
    An object of class \code{"owin"}.
  }
  \item{saveLambda}{
    Logical. If \code{TRUE} (the default) then the
    simulated random intensity will also be saved,
    and returns as an attribute of the point pattern.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
  \item{n.cond}{
    Optional. Integer specifying a fixed number of points.
    See the section on \emph{Conditional Simulation}.
  }
  \item{w.cond}{
    Optional. Conditioning region. A window (object of class \code{"owin"})
    specifying the region which must contain exactly \code{n.cond} points.
    See the section on \emph{Conditional Simulation}.
  }
}
\value{
  A point pattern (object of class \code{"ppp"})
  or a list of point patterns.

  Additionally, the simulated intensity function for each point pattern is
  returned as an attribute \code{"Lambda"} of the point pattern,
  if \code{saveLambda=TRUE}.
}
\details{
  This function generates a realisation of a log-Gaussian Cox
  process (LGCP). This is a Cox point process in which
  the logarithm of the random intensity is a Gaussian random
  field with mean function \eqn{\mu} and covariance function
  \eqn{c(r)}. Conditional on the random intensity, the point process
  is a Poisson process with this intensity.

  The string \code{model} specifies the covariance 
  function of the Gaussian random field, and the parameters
  of the covariance are determined by \code{param} and \code{\dots}.

  All models recognise the parameters \code{var}
  for the variance at distance zero, and \code{scale} for the scale
  parameter. Some models require additional parameters which are listed
  below. 
  
  The available models are as follows:
  \describe{
    \item{\code{model="exponential"}:}{
      the exponential covariance function
      \deqn{C(r) = \sigma^2 \exp(-r/h)}{C(r) = sigma^2 * exp(-r/h)}
      where \eqn{\sigma^2} is the variance parameter \code{var},
      and \eqn{h} is the scale parameter \code{scale}.
    }
    \item{\code{model="gauss"}:}{
      the Gaussian covariance function
      \deqn{C(r) = \sigma^2 \exp(-(r/h)^2)}{C(r) = sigma^2 * exp(-(r/h)^2)}
      where \eqn{\sigma^2} is the variance parameter \code{var},
      and \eqn{h} is the scale parameter \code{scale}.
    }
    \item{\code{model="stable"}:}{
      the stable covariance function
      \deqn{
	C(r) = \sigma^2 \exp(-(r/h)^\alpha)
      }{
	C(r) = sigma^2 * exp(-(r/h)^alpha)
      }
      where \eqn{\sigma^2} is the variance parameter \code{var},
      \eqn{h} is the scale parameter \code{scale},
      and \eqn{\alpha} is the shape parameter \code{alpha}.
      The parameter \code{alpha} must be given, either as a stand-alone
      argument, or as an entry in the list \code{param}.
    }
    \item{\code{model="gencauchy"}:}{
      the generalised Cauchy covariance function
      \deqn{
	C(r) = \sigma^2 (1 + (x/h)^\alpha)^{-\beta/\alpha}
      }{
	C(r) = sigma^2 * (1 + (x/h)^\alpha)^(-\beta/\alpha)
      }
      where \eqn{\sigma^2} is the variance parameter \code{var},
      \eqn{h} is the scale parameter \code{scale},
      and \eqn{\alpha} and \eqn{\beta} are the shape parameters
      \code{alpha} and \code{beta}.
      The parameters \code{alpha} and \code{beta}
      must be given, either as stand-alone arguments, or as entries
      in the list \code{param}.
    }
    \item{\code{model="matern"}:}{
      the Whittle-\Matern covariance function
      \deqn{
	C(r) = \sigma^2 \frac{1}{2^{\nu-1} \Gamma(\nu)}
	       (\sqrt{2 \nu} \, r/h)^\nu K_\nu(\sqrt{2\nu}\, r/h)
      }{
	C(r) = \sigma^2 * 2^(1-\nu) * \Gamma(\nu)^(-1) *
	       (sqrt(2 *\nu) * r/h)^\nu * K[\nu](sqrt(2 * nu) * r/h)
      }
      where \eqn{\sigma^2} is the variance parameter \code{var},
      \eqn{h} is the scale parameter \code{scale},
      and \eqn{\nu} is the shape parameter \code{nu}.
      The parameter \code{nu} must be given, either as a stand-alone
      argument, or as an entry in the list \code{param}.
    }
  }
  The algorithm uses the circulant embedding technique to 
  generate values of a Gaussian random field,
  with the specified mean function \code{mu}
  and the covariance specified by the arguments \code{model} and
  \code{param}, on the points of a regular grid. The exponential
  of this random field is taken as the intensity of a Poisson point
  process, and a realisation of the Poisson process is then generated by the 
  function \code{\link[spatstat.random]{rpoispp}} in the \pkg{spatstat.random} package.
  
  If the simulation window \code{win} is missing or \code{NULL},
  then it defaults to 
  \code{Window(mu)} if \code{mu} is a pixel image,
  and it defaults to the unit square otherwise.
  
  The LGCP model can be fitted to data using \code{\link[spatstat.model]{kppm}}.
}
\section{Conditional Simulation}{
  If \code{n.cond} is specified, it should be a single integer.
  Simulation will be conditional on the event 
  that the pattern contains exactly \code{n.cond} points
  (or contains exactly \code{n.cond} points inside
  the region \code{w.cond} if it is given).
 
  Conditional simulation uses the rejection algorithm described
  in Section 6.2 of Moller, Syversveen and Waagepetersen (1998).
  There is a maximum number of proposals which will be attempted.
  Consequently the return value may contain fewer
  than \code{nsim} point patterns.
}
\section{Warning: new implementation}{
  The simulation algorithm for \code{rLGCP} has been completely re-written
  in \pkg{spatstat.random} version \code{3.2-0} to avoid depending on
  the package \pkg{RandomFields} which is now defunct (and is sadly missed).

  It is no longer possible to replicate results that were obtained using
  \code{rLGCP} in previous versions of \pkg{spatstat.random}.

  The current code is a new implementation and should be considered
  vulnerable to new bugs. 
}
\seealso{
\code{\link[spatstat.random]{rpoispp}},
\code{\link[spatstat.random]{rMatClust}},
\code{\link[spatstat.random]{rGaussPoisson}},
\code{\link[spatstat.random]{rNeymanScott}}.

For fitting the model, see \code{\link[spatstat.model]{kppm}},
\code{\link[spatstat.model]{lgcp.estK}}.

For generating Gaussian Random Fields, see \code{\link[spatstat.random]{rGRFgauss}}.
}
\references{
  \Moller, J., Syversveen, A. and Waagepetersen, R. (1998)
  Log Gaussian Cox Processes.
  \emph{Scandinavian Journal of Statistics} \bold{25}, 451--482.
}
\examples{
    online <- interactive()

    # homogeneous LGCP with exponential covariance function
    X <- rLGCP("exp", 3, var=0.2, scale=.1)

    # inhomogeneous LGCP with Gaussian covariance function
    m <- as.im(function(x, y){5 - 1.5 * (x - 0.5)^2 + 2 * (y - 0.5)^2}, W=owin())
    X <- rLGCP("gauss", m, var=0.15, scale =0.1)

    if(online) {
     plot(attr(X, "Lambda"))
     points(X)
    }

    # inhomogeneous LGCP with Matern covariance function
    X <- rLGCP("matern", function(x, y){ 1 - 0.4 * x},
               var=2, scale=0.7, nu=0.5,
               win = owin(c(0, 10), c(0, 10)))
    if(online) plot(X)
}
\author{Abdollah Jalilian and Rasmus Waagepetersen.
  Modified by \spatstatAuthors.
}
\keyword{spatial}
\keyword{datagen}

\name{rPoissonCluster}
\alias{rPoissonCluster}
\title{Simulate Poisson Cluster Process}
\description{
  Generate a random point pattern, a realisation of the
  general Poisson cluster process.
}
\usage{
 rPoissonCluster(kappa, expand, rcluster, win = owin(c(0,1),c(0,1)),
                 \dots, nsim=1, drop=TRUE, saveparents=TRUE, kappamax=NULL)
}
\arguments{
  \item{kappa}{
    Intensity of the Poisson process of cluster centres.
    A single positive number, a function, or a pixel image.
  }
  \item{expand}{
    Size of the expansion of the simulation window for generating parent
    points. A single non-negative number.
  }
  \item{rcluster}{
    A function which generates random clusters.
  }
  \item{win}{
    Window in which to simulate the pattern.
    An object of class \code{"owin"}
    or something acceptable to \code{\link[spatstat.geom]{as.owin}}.
  }
  \item{\dots}{
    Arguments passed to \code{rcluster}
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
  \item{saveparents}{
    Logical value indicating whether to save the locations of the
    parent points as an attribute.
  }
  \item{kappamax}{
    Optional. Upper bound on the values of \code{kappa}
    when \code{kappa} is a function or pixel image.
  }
}
\value{
  A point pattern (an object of class \code{"ppp"})
  if \code{nsim=1}, or a list of point patterns if \code{nsim > 1}.
  
  Additionally,  some intermediate results of the simulation are
  returned as attributes of the point pattern: see Details.
}
\details{
  This algorithm generates a realisation of the
  general Poisson cluster process, with the cluster mechanism
  given by the function \code{rcluster}. 

  First, the algorithm
  generates a Poisson point process of ``parent'' points 
  with intensity \code{kappa} in an expanded
  window as explained below.. Here \code{kappa} may be a single
  positive number, a function \code{kappa(x, y)}, or a pixel image
  object of class \code{"im"} (see \code{\link[spatstat.geom]{im.object}}).
  See \code{\link{rpoispp}} for details.
  
  Second, each parent point is replaced by a random cluster of points,
  created by calling the function \code{rcluster}.  These clusters are
  combined together to yield a single point pattern, and the restriction
  of this pattern to the window \code{win} is then returned as the
  result of \code{rPoissonCluster}.

  The expanded window consists of \code{\link[spatstat.geom]{as.rectangle}(win)}
  extended by the amount \code{expand} in each direction. The size of
  the expansion is saved in the attribute \code{"expand"} and may be
  extracted by \code{attr(X, "expand")} where \code{X} is the generated
  point pattern.

  The function \code{rcluster} should expect to be called as
  \code{rcluster(xp[i],yp[i],\dots)} for each parent point at a location
  \code{(xp[i],yp[i])}. The return value of \code{rcluster}
  should be a list with elements
  \code{x,y} which are vectors of equal length giving the absolute
  \eqn{x} and \code{y} coordinates of the points in the cluster.

  If the return value of \code{rcluster} is a point pattern (object of
  class \code{"ppp"}) then it may have marks. The result of
  \code{rPoissonCluster} will then be a marked point pattern.

  If required, the intermediate stages of the simulation (the parents
  and the individual clusters) can also be extracted from
  the return value of \code{rPoissonCluster}
  through the attributes \code{"parents"} and \code{"parentid"}.
  The attribute \code{"parents"} is the point pattern of parent points.
  The attribute \code{"parentid"} is an integer vector specifying
  the parent for each of the points in the simulated pattern.
  (If these data are not required, it is more efficient to
  set \code{saveparents=FALSE}.)
}
\seealso{
  \code{\link{rpoispp}},
  \code{\link{rMatClust}},
  \code{\link{rThomas}},
  \code{\link{rCauchy}},
  \code{\link{rVarGamma}},
  \code{\link{rNeymanScott}},
  \code{\link{rGaussPoisson}}.
}
\examples{
  # each cluster consist of 10 points in a disc of radius 0.2
  nclust <- function(x0, y0, radius, n) {
              return(runifdisc(n, radius, centre=c(x0, y0)))
            }
  plot(rPoissonCluster(10, 0.2, nclust, radius=0.2, n=5))

  # multitype Neyman-Scott process (each cluster is a multitype process)
  nclust2 <- function(x0, y0, radius, n, types=c("a", "b")) {
     X <- runifdisc(n, radius, centre=c(x0, y0))
     M <- sample(types, n, replace=TRUE)
     marks(X) <- M
     return(X)
  }
  plot(rPoissonCluster(15,0.1,nclust2, radius=0.1, n=5))
}
\author{\adrian
  
  
  and \rolf
  
}
\keyword{spatial}
\keyword{datagen}

\name{rpoint3}
\alias{rpoint3}
\title{
  Generate N Random Points in 3 Dimensions
}
\description{
  Generate a random point pattern in three-dimensional space
  containing \eqn{n} independent, identically distributed random points
  with a specified distribution.
}
\usage{
rpoint3(n, f, fmax = NULL, domain = box3(), \dots,
  nsim = 1, drop = TRUE, ex = NULL, giveup = 1000)
}
\arguments{
  \item{n}{
    Number of points to generate.
  }
  \item{f}{
    The probability density of the points,
    possibly un-normalised.
    Either a constant, or a function \code{f(x,y,z, \dots)}.
  }
  \item{fmax}{
    An upper bound on the values of \code{f}.
  }
  \item{domain}{
    Three-dimensional box (object of class \code{"box3"})
    in which to generate the point pattern.
  }
  \item{\dots}{
    Additional arguments passed to the function \code{f}.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
  \item{ex}{
    Optional. Example point pattern in three dimensions
    (object of class \code{"pp3"}). The number of points \code{n}
    and the spatial region \code{domain} will be taken from \code{ex}.
  }
  \item{giveup}{
    Integer. Maximum number of attempts permitted in the rejection method.
  }
}
\details{
  This function generates \code{n} independent, identically distributed
  random points with common probability density proportional to
  \code{f} inside the specified three-dimensional region \code{domain}.

  The argument \code{f} may be
  \describe{
    \item{a numerical constant:}{
      uniformly distributed random points will
      be generated.
    }
    \item{a function:}{random points will be generated
      in the \code{domain} with probability density proportional
      to \code{f(x, y, z, \dots)} where \code{x}, \code{y}, \code{z}
      are the cartesian
      coordinates. The function \code{f} must accept 
      \emph{vectors} of coordinates \code{x,y,z} and return the corresponding
      vector of function values. Additional arguments \code{\dots} of any kind
      may be passed to the function.
    }
  }
  The algorithm is as follows:
  \itemize{
    \item
    If \code{f} is a constant, we invoke \code{\link{runifpoint3}}.
    \item
    If \code{f} is a function, then we use the rejection method.
    Proposal points are generated from the uniform distribution.
    A proposal point \eqn{(x,y,z)} is accepted with probability
    \code{f(x,y,z,\dots)/fmax} and otherwise rejected.
    The algorithm continues until \code{n} points have been
    accepted. It gives up after \code{giveup * n} proposals
    if there are still fewer than \code{n} points.
  }
}
\value{
  A three-dimensional point pattern (an object of class \code{"pp3"})
  if \code{nsim=1} and \code{drop=TRUE},
  otherwise a list of three-dimensional point patterns.
}
\author{
  \adrian.
}
\seealso{
  \code{\link{runifpoint3}}
}
\examples{
  rpoint3(10, 1)
  rpoint3(10, f=function(x,y,z) {sqrt(x)}, fmax=1)
}
\keyword{spatial}
\keyword{datagen}
\concept{Three-dimensional}

\name{rcell}
\alias{rcell}
\title{Simulate Baddeley-Silverman Cell Process}
\description{
  Generates a random point pattern, a simulated realisation of the
  Baddeley-Silverman cell process model. 
}
\usage{
 rcell(win=square(1), nx=NULL, ny=nx, \dots, dx=NULL, dy=dx,
       N=10, nsim=1, drop=TRUE)
}
\arguments{
  \item{win}{
    A window. 
    An object of class \code{\link[spatstat.geom]{owin}},
    or data in any format acceptable to \code{\link[spatstat.geom]{as.owin}()}.
  }
  \item{nx}{
    Number of columns of cells in the window.
    Incompatible with \code{dx}.
  }
  \item{ny}{
    Number of rows of cells in the window.
    Incompatible with \code{dy}.
  }
  \item{\dots}{Ignored.}
  \item{dx}{
    Width of the cells. Incompatible with \code{nx}.
  }
  \item{dy}{
    Height of the cells.
    Incompatible with \code{ny}.
  }
  \item{N}{
    Integer. Distributional parameter:
    the maximum number of random points in each cell.
    Passed to \code{\link[spatstat.random]{rcellnumber}}.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
}
\value{
  A point pattern (an object of class \code{"ppp"})
  if \code{nsim=1}, or a list of point patterns if \code{nsim > 1}.
}
\details{ 
  This function generates a simulated realisation of the \dQuote{cell process}
  (Baddeley and Silverman, 1984), a random point process
  with the same second-order properties as the uniform Poisson process.
  In particular, the \eqn{K} function of this process is identical to
  the \eqn{K} function of the uniform Poisson process (aka Complete
  Spatial Randomness). The same holds for the pair correlation function
  and all other second-order properties.
  The cell process is a counterexample to the claim that the
  \eqn{K} function completely characterises a point pattern.
  
  A cell process is generated by dividing space into equal rectangular
  tiles. In each tile, a random number of random points is placed.
  By default, there are either \eqn{0}, \eqn{1} or \eqn{10} points,
  with probabilities \eqn{1/10}, \eqn{8/9} and \eqn{1/90}
  respectively. 
  The points within a tile are independent and uniformly distributed in
  that tile, and the numbers of points in different tiles are
  independent random integers. 

  The tile width is determined
  either by the number of columns \code{nx} or by the
  horizontal spacing \code{dx}.
  The tile height is determined
  either by the number of rows \code{ny} or by the
  vertical spacing \code{dy}. 
  The cell process is then generated in these tiles.
  The random numbers of points are generated by \code{\link[spatstat.random]{rcellnumber}}.

  Some of the resulting random points may lie outside the window \code{win}:
  if they do, they are deleted.
  The result is a point pattern inside the window \code{win}.
}
\seealso{
  \code{\link{rcellnumber}},
  \code{\link{rstrat}},
  \code{\link[spatstat.geom]{rsyst}},
  \code{\link{runifpoint}},
  \code{\link[spatstat.explore]{Kest}}
}
\examples{
  X <- rcell(nx=15)
  plot(X)
  if(require(spatstat.explore)) {
     plot(Kest(X))
  }
}
\references{
  Baddeley, A.J. and Silverman, B.W. (1984)
  A cautionary example on the use of second-order methods for analyzing
  point patterns. \emph{Biometrics} \bold{40}, 1089-1094.
}

\author{\adrian
  and \rolf
}
\keyword{spatial}
\keyword{datagen}

\name{rstrat}
\alias{rstrat}
\title{Simulate Stratified Random Point Pattern}
\description{
  Generates a ``stratified random'' pattern of points in a window,
  by dividing the window into rectangular tiles and placing
  \code{k} random points independently in each tile.
}
\usage{
 rstrat(win=square(1), nx, ny=nx, k = 1, nsim=1, drop=TRUE)
}
\arguments{
  \item{win}{
    A window. 
    An object of class \code{\link[spatstat.geom]{owin}},
    or data in any format acceptable to \code{\link[spatstat.geom]{as.owin}()}.
  }
  \item{nx}{Number of tiles in each column.
  }
  \item{ny}{Number of tiles in each row.
  }
  \item{k}{Number of random points to generate in each tile.
  }
  \item{nsim}{Number of simulated realisations to be generated.}
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a point pattern.
  }
}
\value{
  A point pattern (an object of class \code{"ppp"})
  if \code{nsim=1}, or a list of point patterns if \code{nsim > 1}.
}
\details{
  This function generates a random pattern of points
  in a ``stratified random'' sampling design. It can be useful
  for generating random spatial sampling points.

  The bounding rectangle of \code{win} is divided into
  a regular \eqn{nx \times ny}{nx * ny} grid of rectangular tiles.
  In each tile, \code{k} random points are generated independently
  with a uniform distribution in that tile. 

  Some of these grid points may lie outside the window \code{win}:
  if they do, they are deleted.

  The result is a point pattern inside the window \code{win}.

  This function is useful in creating dummy points for quadrature
  schemes (see \code{\link[spatstat.geom]{quadscheme}}) as well as in simulating
  random point patterns.
}
\seealso{
  \code{\link[spatstat.geom]{rsyst}},
  \code{\link{runifpoint}},
  \code{\link[spatstat.geom]{quadscheme}}
}
\examples{
  X <- rstrat(nx=10)
  plot(X)

  # polygonal boundary
  X <- rstrat(letterR, 5, 10, k=3)
  plot(X)
}
\author{
  \adrian
  and \rolf.
}
\keyword{spatial}
\keyword{datagen}

\name{will.expand}
\alias{will.expand}
\title{
  Test Expansion Rule
}
\description{
  Determines whether an expansion rule will
  actually expand the window or not.
}
\usage{
will.expand(x)
}
\arguments{
  \item{x}{
    Expansion rule.
    An object of class \code{"rmhexpand"}.
  }
}
\details{
  An object of class \code{"rmhexpand"} describes a rule for
  expanding a simulation window. See \code{\link{rmhexpand}}
  for details.

  One possible expansion rule is to do nothing, i.e. not to expand
  the window.
  
  This command inspects the expansion rule \code{x}
  and determines whether it will or will not actually expand the window.
  It returns \code{TRUE} if the window will be expanded.
}
\value{
  Logical value.
}
\author{\adrian
  
  
  and \rolf
  
}
\seealso{
  \code{\link{rmhexpand}},
  \code{\link{expand.owin}}
}
\examples{
  x <- rmhexpand(distance=0.2)
  y <- rmhexpand(area=1)
  will.expand(x)
  will.expand(y)
}
\keyword{spatial}
\keyword{manip}

\name{rcellnumber}
\alias{rcellnumber}
\title{
  Generate Random Numbers of Points for Cell Process
}
\description{
  Generates random integers for the Baddeley-Silverman counterexample.
}
\usage{
 rcellnumber(n, N = 10, mu=1)
}
\arguments{
  \item{n}{
    Number of random integers to be generated.
  }
  \item{N}{
    Distributional parameter: the largest possible value
    (when \code{mu <= 1}).
    An integer greater than 1.
  }
  \item{mu}{
    Mean of the distribution (equals the variance).
    Any positive real number.
  }
}
\details{
  If \code{mu = 1} (the default),
  this function generates random integers which have mean and variance
  equal to 1, but which do not have a Poisson distribution. 
  The random integers take the values \eqn{0}, \eqn{1} and \eqn{N}
  with probabilities \eqn{1/N}, \eqn{(N-2)/(N-1)} and \eqn{1/(N(N-1))}
  respectively.
  See Baddeley and Silverman (1984).

  If \code{mu} is another positive number, the random integers will
  have mean and variance equal to \code{mu}. They are obtained by
  generating the
  one-dimensional counterpart of the cell process and counting the
  number of points in the interval from \code{0} to \code{mu}. The
  maximum possible value of each random integer is \code{N * ceiling(mu)}.
}
\value{
  An integer vector of length \code{n}.
}
\references{
  Baddeley, A.J. and Silverman, B.W. (1984)
  A cautionary example on the use of second-order methods for analyzing
  point patterns. \emph{Biometrics} \bold{40}, 1089-1094.
}
\author{
  \spatstatAuthors.
}
\seealso{
  \code{\link{rcell}}
}
\examples{
   rcellnumber(30, 3)
}
\keyword{datagen}

\name{rmh}
\alias{rmh}
\title{Simulate point patterns using the Metropolis-Hastings algorithm.}
\description{
  Generic function for running the Metropolis-Hastings algorithm
  to produce simulated realisations of a point process model.
}

\usage{rmh(model, \dots)}

\arguments{
  \item{model}{The point process model to be simulated.
  }
  \item{\dots}{Further arguments controlling the simulation.
  }
}

\details{
  The Metropolis-Hastings algorithm can be used to
  generate simulated realisations from a wide range of
  spatial point processes. For caveats, see below.
  
  The function \code{rmh} is generic; it has methods
  \code{\link[spatstat.model]{rmh.ppm}} (for objects of class \code{"ppm"})
  and  \code{\link{rmh.default}} (the default).
  The actual implementation of the Metropolis-Hastings algorithm is
  contained in \code{\link{rmh.default}}.
  For details of its use, see 
  \code{\link[spatstat.model]{rmh.ppm}} or \code{\link{rmh.default}}.

  [If the model is a Poisson process, then Metropolis-Hastings
  is not used; the Poisson model is generated directly
  using \code{\link{rpoispp}} or \code{\link{rmpoispp}}.]

  In brief, the Metropolis-Hastings algorithm is a Markov Chain,
  whose states are spatial point patterns, and whose limiting
  distribution is the desired point process. After
  running the algorithm for a very large number of iterations,
  we may regard the state of the algorithm as a realisation
  from the desired point process.

  However, there are difficulties in deciding whether the
  algorithm has run for ``long enough''. The convergence of the
  algorithm may indeed be extremely slow. No guarantees of
  convergence are given!

  While it is fashionable to decry the Metropolis-Hastings algorithm
  for its poor convergence and other properties, it has the advantage
  of being easy to implement for a wide range of models.
}

\section{Warning}{
As of version 1.22-1 of \code{spatstat} a subtle change was
made to \code{rmh.default()}.  We had noticed that the results
produced were sometimes not ``scalable'' in that two models,
differing in effect only by the units in which distances are
measured and starting from the same seed, gave different results.
This was traced to an idiosyncracy of floating point arithmetic.
The code of \code{rmh.default()} has been changed so that the
results produced by \code{rmh} are now scalable.  The downside of
this is that code which users previously ran may now give results
which are different from what they formerly were.

In order to recover former behaviour (so that previous results
can be reproduced) set \code{spatstat.options(scalable=FALSE)}.
See the last example in the help for \code{\link{rmh.default}}.
}

\value{
  A point pattern, in the form of an object of class \code{"ppp"}.
  See \code{\link{rmh.default}} for details.
}

\seealso{
  \code{\link{rmh.default}}
}

\examples{
    # See examples in rmh.default and rmh.ppm
}

\author{\adrian
  
  
  and \rolf
  
}
\keyword{spatial}
\keyword{datagen}

\name{update.rmhcontrol}
\alias{update.rmhcontrol}
\title{Update Control Parameters of Metropolis-Hastings Algorithm}
\description{
  \code{update} method for class \code{"rmhcontrol"}.
}
\usage{
  \method{update}{rmhcontrol}(object, \dots)
}
\arguments{
  \item{object}{
    Object of class \code{"rmhcontrol"} containing control parameters
    for a Metropolis-Hastings algorithm.
  }
  \item{\dots}{
    Arguments to be updated in the new call to \code{\link{rmhcontrol}}.
  }
}
\details{
  This is a method for the generic function \code{\link{update}}
  for the class \code{"rmhcontrol"}. An object of class \code{"rmhcontrol"}
  describes a set of control parameters for the Metropolis-Hastings
  simulation algorithm. See \code{\link{rmhcontrol}}).

  \code{update.rmhcontrol} will modify the parameters
  specified by \code{object} according to the new arguments given.
}
\value{
  Another object of class \code{"rmhcontrol"}.
}
\examples{
  a <- rmhcontrol(expand=1)
  update(a, expand=2)
}
\author{\adrian
  
  
  and \rolf
  
}
\keyword{spatial}
\keyword{methods}
\keyword{models}

\name{rmh.default}
\alias{rmh.default}
\title{Simulate Point Process Models using the Metropolis-Hastings Algorithm.}
\description{
  Generates a random point pattern, simulated from
  a chosen point process model, using the Metropolis-Hastings
  algorithm. 
}

\usage{
   \method{rmh}{default}(model, start=NULL,
   control=default.rmhcontrol(model),
   \dots,
   nsim=1, drop=TRUE, saveinfo=TRUE,
   verbose=TRUE, snoop=FALSE)
}

\arguments{
  \item{model}{Data specifying the point process model
    that is to be simulated.
  }
  \item{start}{Data determining the initial state of
    the algorithm.
  }
  \item{control}{Data controlling the iterative behaviour
    and termination of the algorithm.
  }
  \item{\dots}{
    Further arguments passed to \code{\link{rmhcontrol}}
    or to trend functions in \code{model}.
  }
  \item{nsim}{
    Number of simulated point patterns that should be generated.
  }
  \item{drop}{
    Logical. If \code{nsim=1} and \code{drop=TRUE} (the default), the
    result will be a point pattern, rather than a list 
    containing a single point pattern.
  }
  \item{saveinfo}{
    Logical value indicating whether to save auxiliary information.
  }
  \item{verbose}{
    Logical value indicating whether to print progress reports.
  }
  \item{snoop}{
    Logical. If \code{TRUE}, activate the visual debugger. 
  }
}

\value{
  A point pattern (an object of class \code{"ppp"}, see
  \code{\link[spatstat.geom]{ppp.object}}) or a list of point patterns.

  The returned value has an attribute \code{info} containing
  modified versions of the arguments
  \code{model}, \code{start}, and \code{control} which together specify
  the exact simulation procedure. The \code{info} attribute can be
  printed (and is printed automatically by \code{\link[spatstat.geom]{summary.ppp}}).
  For computational efficiency, the \code{info} attribute can be omitted
  by setting \code{saveinfo=FALSE}.

  The value of \code{\link[base:Random]{.Random.seed}} at the start
  of the simulations is also saved and returned as an attribute
  \code{seed}.

  If the argument \code{track=TRUE} was given (see \code{\link{rmhcontrol}}),
  the transition history of the algorithm
  is saved, and returned as an attribute \code{history}. The transition
  history is a data frame containing a factor \code{proposaltype}
  identifying the proposal type (Birth, Death or Shift) and
  a logical vector \code{accepted} indicating whether the proposal was
  accepted.
  The data frame also has columns \code{numerator}, \code{denominator}
  which give the numerator and denominator of the Hastings ratio for
  the proposal.

  If the argument \code{nsave} was given (see \code{\link{rmhcontrol}}),
  the return value has an attribute \code{saved} which is a list of
  point patterns, containing the intermediate states of the algorithm.
}

\details{
  This function generates simulated realisations from any of a range of
  spatial point processes, using the Metropolis-Hastings algorithm.
  It is the default method for the generic function \code{\link{rmh}}.

  This function executes a Metropolis-Hastings algorithm
  with birth, death and shift proposals as described in
  Geyer and \Moller (1994).

  The argument \code{model} specifies the point process model to be
  simulated. It is either a list, or an object of class
  \code{"rmhmodel"}, with the following components:

  \describe{
    \item{cif}{A character string specifying the choice of
      interpoint interaction for the point process.
    }
    \item{par}{
      Parameter values for the conditional
      intensity function.
    }
    \item{w}{
      (Optional) window in which the pattern is
      to be generated. An object of class \code{"owin"},
      or data acceptable to \code{\link[spatstat.geom]{as.owin}}.
    }
    \item{trend}{
      Data specifying the spatial trend in the model, if it has a trend.
      This may be a function, a pixel image (of class \code{"im"}),
      (or a list of functions or images if the model
      is multitype).
      
      If the trend is a function or functions,
      any auxiliary arguments \code{...} to \code{rmh.default}
      will be passed to these functions, which
      should be of the form \code{function(x, y, ...)}.
    }
    \item{types}{
      List of possible types, for a multitype point process.
    }
  }
  For full details of these parameters, see \code{\link{rmhmodel.default}}.
  
  The argument \code{start} determines the initial state of the
  Metropolis-Hastings algorithm. It is either \code{NULL},
  or an object of class \code{"rmhstart"},
  or a list with the following components:

  \describe{
    \item{n.start}{
      Number of points in the initial point pattern.
      A single integer, or a vector of integers giving the
      numbers of points of each type in a multitype point pattern.
      Incompatible with \code{x.start}.
    }
    \item{x.start}{
      Initial point pattern configuration.
      Incompatible with \code{n.start}.

      \code{x.start} may be a point pattern (an
      object of class \code{"ppp"}), or data which can be coerced
      to this class by \code{\link[spatstat.geom]{as.ppp}},  or an object with
      components \code{x} and \code{y}, or a two-column matrix.
      In the last two cases, the window for the pattern is determined
      by \code{model$w}.
      In the first two cases, if \code{model$w} is also present,
      then the final simulated pattern will be clipped to
      the window \code{model$w}.
    }
  }
  For full details of these parameters, see \code{\link{rmhstart}}.

  The third argument \code{control} controls the simulation
  procedure (including \emph{conditional simulation}),
  iterative behaviour, and termination of the
  Metropolis-Hastings algorithm. It is either \code{NULL}, or
  a list, or an object of class \code{"rmhcontrol"}, with components:
  \describe{
    \item{p}{The probability of proposing a ``shift''
      (as opposed to a birth or death) in the Metropolis-Hastings
      algorithm.
    }
    \item{q}{The conditional probability of proposing a death
      (rather than a birth)
      given that birth/death has been chosen over shift.  
    }
    \item{nrep}{The number of repetitions or iterations
      to be made by the Metropolis-Hastings algorithm.  It should
      be large.
    }
    \item{expand}{
      Either a numerical expansion factor, or
      a window (object of class \code{"owin"}). Indicates that
      the process is to be simulated on a larger domain than the
      original data window \code{w}, then clipped to \code{w}
      when the algorithm has finished.

      The default is to expand the simulation window
      if the model is stationary and non-Poisson
      (i.e. it has no trend and the interaction is not Poisson)
      and not to expand in all other cases. 
      
      If the model has a trend, then in order for expansion to
      be feasible, the trend must be given either as a function,
      or an image whose bounding box is large enough to contain
      the expanded window.
    }
    \item{periodic}{A logical scalar; if \code{periodic} is \code{TRUE}
      we simulate a process on the torus formed by identifying
      opposite edges of a rectangular window.  
    }
    \item{ptypes}{A vector of probabilities (summing to 1) to be used
      in assigning a random type to a new point.
    }
    \item{fixall}{A logical scalar specifying whether to condition on
      the number of points of each type.
    }
    \item{nverb}{An integer specifying how often ``progress reports''
      (which consist simply of the number of repetitions completed)
      should be printed out.  If nverb is left at 0, the default,
      the simulation proceeds silently.
    }
    \item{x.cond}{If this argument is present, then
      \emph{conditional simulation} will be performed, and \code{x.cond}
      specifies the conditioning points and the type of conditioning.
    }
    \item{nsave,nburn}{
      If these values are specified, then
      intermediate states of the simulation algorithm will be saved
      every \code{nsave} iterations, after an initial burn-in period of
      \code{nburn} iterations.
    }
    \item{track}{
      Logical flag indicating whether to save the transition
      history of the simulations.
    }
  }
  For full details of these parameters, see \code{\link{rmhcontrol}}.
  The control parameters can also be given in the \code{\dots} arguments.
}
\section{Conditional Simulation}{
  There are several kinds of conditional simulation.
  \itemize{
    \item
    Simulation \emph{conditional upon the number of points},
    that is, holding the number of points fixed.
    To do this, set \code{control$p} (the probability of a shift) equal to 1.
    The number of points is then determined by the starting state, which
    may be specified either by setting \code{start$n.start} to be a
    scalar, or by setting the initial pattern \code{start$x.start}.
    \item 
    In the case of multitype processes, it is possible to simulate the
    model \emph{conditionally upon the number of points of each type},
    i.e. holding the number of points of each type
    to be fixed. To do this, set \code{control$p} equal to 1
    and \code{control$fixall} to be \code{TRUE}.
    The number of points is then determined by the starting state, which
    may be specified either by setting \code{start$n.start} to be an
    integer vector, or by setting the initial pattern \code{start$x.start}.
    \item
    Simulation 
    \emph{conditional on the configuration observed in a sub-window},
    that is, requiring that, inside a specified sub-window \eqn{V},
    the simulated pattern should agree with a specified point pattern
    \eqn{y}.To do this, set \code{control$x.cond} to equal the
    specified point pattern \eqn{y}, making sure that it is an object of class
    \code{"ppp"} and that the window \code{Window(control$x.cond)}
    is the conditioning window \eqn{V}.
    \item
    Simulation \emph{conditional on the presence of specified points},
    that is, requiring that the simulated pattern should include a
    specified set of points. This is simulation from the Palm
    distribution of the point process given a pattern \eqn{y}.
    To do this, set \code{control$x.cond} to be a
    \code{data.frame} containing the coordinates (and marks,
    if appropriate) of the specified points.
  }
  For further information, see \code{\link{rmhcontrol}}.
  
  Note that, when we simulate conditionally on the number of points, or
  conditionally on the number of points of each type,
  no expansion of the window is possible.
}
\section{Visual Debugger}{
  If \code{snoop = TRUE}, an interactive debugger is activated.
  On the current plot device, the debugger displays the current
  state of the Metropolis-Hastings algorithm together with
  the proposed transition to the next state.
  Clicking on this graphical display (using the left mouse button)
  will re-centre the display at the clicked location.
  Surrounding this graphical display is an array of boxes representing
  different actions.
  Clicking on one of the action boxes (using the left mouse button)
  will cause the action to be performed.
  Debugger actions include:
  \itemize{
    \item Zooming in or out
    \item Panning (shifting the field of view) left, right, up or down
    \item Jumping to the next iteration
    \item Skipping 10, 100, 1000, 10000 or 100000 iterations
    \item Jumping to the next Birth proposal (etc)
    \item Changing the fate of the proposal (i.e. changing whether
    the proposal is accepted or rejected)
    \item Dumping the current state and proposal to a file
    \item Printing detailed information at the terminal
    \item Exiting the debugger (so that the simulation
    algorithm continues without further interruption).
  }
  Right-clicking the mouse will also cause the debugger to exit.
}

\references{
   Baddeley, A. and Turner, R. (2000) Practical maximum
   pseudolikelihood for spatial point patterns.
   \emph{Australian and New Zealand Journal of Statistics}
   \bold{42}, 283 -- 322.

   Diggle, P. J. (2003) \emph{Statistical Analysis of Spatial Point
   Patterns} (2nd ed.) Arnold, London.

   Diggle, P.J. and Gratton, R.J. (1984)
   Monte Carlo methods of inference for implicit statistical models.
   \emph{Journal of the Royal Statistical Society, series B}
   \bold{46}, 193 -- 212.

   Diggle, P.J., Gates, D.J., and Stibbard, A. (1987)
   A nonparametric estimator for pairwise-interaction point processes.
   Biometrika \bold{74}, 763 -- 770.

   Geyer, C.J. and \Moller, J. (1994)
   Simulation procedures and likelihood inference for spatial
   point processes.
   \emph{Scandinavian Journal of Statistics} \bold{21}, 359--373.

   Geyer, C.J. (1999)
   Likelihood Inference for Spatial Point
   Processes. Chapter 3 in  O.E. Barndorff-Nielsen, W.S. Kendall and
   M.N.M. Van Lieshout (eds) \emph{Stochastic Geometry: Likelihood and
   Computation}, Chapman and Hall / CRC,  Monographs on Statistics and
   Applied Probability, number 80. Pages 79--140.
}

\section{Warnings}{

There is never a guarantee that the Metropolis-Hastings algorithm
has converged to its limiting distribution.

If \code{start$x.start} is specified then \code{expand} is set equal to 1
and simulation takes place in \code{Window(x.start)}.  Any specified
value for \code{expand} is simply ignored.

The presence of both a component \code{w} of \code{model} and a
non-null value for \code{Window(x.start)} makes sense ONLY if \code{w}
is contained in \code{Window(x.start)}.  

For multitype processes make sure that, even if there is to be no
trend corresponding to a particular type, there is still a component
(a NULL component) for that type, in the list.
}

\seealso{
  \code{\link{rmh}},
  \code{\link[spatstat.model]{rmh.ppm}},
  \code{\link{rStrauss}},
  \code{\link[spatstat.geom]{ppp}},
  \code{\link[spatstat.model]{ppm}}
  
  Interactions: \rmhInteractionsList.
}
\section{Other models}{
  In theory, any finite point process model can be simulated using
  the Metropolis-Hastings algorithm, provided the conditional
  intensity is uniformly bounded.

  In practice, the list of point process models that can be simulated using
  \code{rmh.default} is limited to those that have been implemented
  in the package's internal C code. More options will be added in the future.

  Note that the \code{lookup} conditional intensity function
  permits the simulation (in theory, to any desired degree
  of approximation) of any pairwise interaction process for
  which the interaction depends only on the distance between
  the pair of points.
}
\section{Reproducible simulations}{
  If the user wants the simulation to be exactly reproducible
  (e.g. for a figure in a journal article, where it is useful to
  have the figure consistent from draft to draft) then the state of
  the random number generator should be set before calling
  \code{rmh.default}. This can be done either by calling
  \code{\link[base:Random]{set.seed}} or by assigning a value to
  \code{\link[base:Random]{.Random.seed}}. In the examples below, we use
  \code{\link[base:Random]{set.seed}}.  

  If a simulation has been performed and the user now wants to 
  repeat it exactly, the random seed should be extracted from
  the simulated point pattern \code{X} by \code{seed <- attr(x, "seed")},
  then assigned to the system random nunber state by
  \code{.Random.seed <- seed} before calling \code{rmh.default}.
}
\examples{
   if(online <- interactive()) {
     nr   <- 1e5
     nv  <- 5000
     ns <- 200
   } else {
     nr  <- 20
     nv <- 5
     ns <- 20
     oldopt <- spatstat.options()
     spatstat.options(expand=1.05)
   }
   set.seed(961018)
   
   # Strauss process.
   mod01 <- list(cif="strauss",par=list(beta=2,gamma=0.2,r=0.7),
                 w=c(0,10,0,10))
   X1.strauss <- rmh(model=mod01,start=list(n.start=ns),
                     control=list(nrep=nr,nverb=nv))

   if(online) plot(X1.strauss)
   
   # Strauss process, conditioning on n = 42:
   X2.strauss <- rmh(model=mod01,start=list(n.start=42),
                     control=list(p=1,nrep=nr,nverb=nv))

   # Tracking algorithm progress:
   # (a) saving intermediate states:
   X <- rmh(model=mod01,start=list(n.start=ns),
            control=list(nrep=nr, nsave=nr/5, nburn=nr/2))
   Saved <- attr(X, "saved")
   plot(Saved)

   # (b) inspecting transition history:
   X <- rmh(model=mod01,start=list(n.start=ns),
            control=list(nrep=nr, track=TRUE))
   History <- attr(X, "history")
   head(History)

   # Hard core process:
   mod02 <- list(cif="hardcore",par=list(beta=2,hc=0.7),w=c(0,10,0,10))
   X3.hardcore <- rmh(model=mod02,start=list(n.start=ns),
                     control=list(nrep=nr,nverb=nv))
   
   if(online) plot(X3.hardcore)

   # Strauss process equal to pure hardcore:
   mod02s <- list(cif="strauss",par=list(beta=2,gamma=0,r=0.7),w=c(0,10,0,10))
   X3.strauss <- rmh(model=mod02s,start=list(n.start=ns),
                     control=list(nrep=nr,nverb=nv))
   
   # Strauss process in a polygonal window.
   x     <- c(0.55,0.68,0.75,0.58,0.39,0.37,0.19,0.26,0.42)
   y     <- c(0.20,0.27,0.68,0.99,0.80,0.61,0.45,0.28,0.33)
   mod03 <- list(cif="strauss",par=list(beta=2000,gamma=0.6,r=0.07),
                w=owin(poly=list(x=x,y=y)))
   X4.strauss <- rmh(model=mod03,start=list(n.start=ns),
                     control=list(nrep=nr,nverb=nv))
   if(online) plot(X4.strauss)
   
   # Strauss process in a polygonal window, conditioning on n = 80.
   X5.strauss <- rmh(model=mod03,start=list(n.start=ns),
                     control=list(p=1,nrep=nr,nverb=nv))
   
   # Strauss process, starting off from X4.strauss, but with the
   # polygonal window replace by a rectangular one.  At the end,
   # the generated pattern is clipped to the original polygonal window.
   xxx <- X4.strauss
   Window(xxx) <- as.owin(c(0,1,0,1))
   X6.strauss <- rmh(model=mod03,start=list(x.start=xxx),
                     control=list(nrep=nr,nverb=nv))
   
   # Strauss with hardcore:
   mod04 <- list(cif="straush",par=list(beta=2,gamma=0.2,r=0.7,hc=0.3),
                w=c(0,10,0,10))
   X1.straush <- rmh(model=mod04,start=list(n.start=ns),
                     control=list(nrep=nr,nverb=nv))
   
   # Another Strauss with hardcore (with a perhaps surprising result):
   mod05 <- list(cif="straush",par=list(beta=80,gamma=0.36,r=45,hc=2.5),
                w=c(0,250,0,250))
   X2.straush <- rmh(model=mod05,start=list(n.start=ns),
                     control=list(nrep=nr,nverb=nv))
   
   # Pure hardcore (identical to X3.strauss).
   mod06 <- list(cif="straush",par=list(beta=2,gamma=1,r=1,hc=0.7),
                w=c(0,10,0,10))
   X3.straush <- rmh(model=mod06,start=list(n.start=ns),
                     control=list(nrep=nr,nverb=nv))
   
   # Soft core:
   w    <- c(0,10,0,10)
   mod07 <- list(cif="sftcr",par=list(beta=0.8,sigma=0.1,kappa=0.5),
                w=c(0,10,0,10))
   X.sftcr <- rmh(model=mod07,start=list(n.start=ns),
                  control=list(nrep=nr,nverb=nv))
   if(online) plot(X.sftcr)

   # Area-interaction process:
   mod42 <- rmhmodel(cif="areaint",par=list(beta=2,eta=1.6,r=0.7),
                 w=c(0,10,0,10))
   X.area <- rmh(model=mod42,start=list(n.start=ns),
                  control=list(nrep=nr,nverb=nv))
   if(online) plot(X.area)

   # Triplets process
   modtrip <- list(cif="triplets",par=list(beta=2,gamma=0.2,r=0.7),
                   w=c(0,10,0,10))
   X.triplets <- rmh(model=modtrip,
                     start=list(n.start=ns),
                     control=list(nrep=nr,nverb=nv))
   if(online) plot(X.triplets)
   
   # Multitype Strauss:
   beta <- c(0.027,0.008)
   gmma <- matrix(c(0.43,0.98,0.98,0.36),2,2)
   r    <- matrix(c(45,45,45,45),2,2)
   mod08 <- list(cif="straussm",par=list(beta=beta,gamma=gmma,radii=r),
                w=c(0,250,0,250))
   X1.straussm <- rmh(model=mod08,start=list(n.start=ns),
                      control=list(ptypes=c(0.75,0.25),nrep=nr,nverb=nv))
   if(online) plot(X1.straussm)
   
   # Multitype Strauss conditioning upon the total number
   # of points being 80:
   X2.straussm <- rmh(model=mod08,start=list(n.start=ns),
                      control=list(p=1,ptypes=c(0.75,0.25),nrep=nr,
                                   nverb=nv))
   
   # Conditioning upon the number of points of type 1 being 60
   # and the number of points of type 2 being 20:
   X3.straussm <- rmh(model=mod08,start=list(n.start=c(60,20)),
                      control=list(fixall=TRUE,p=1,ptypes=c(0.75,0.25),
                                   nrep=nr,nverb=nv))
   
   # Multitype Strauss hardcore:
   rhc  <- matrix(c(9.1,5.0,5.0,2.5),2,2)
   mod09 <- list(cif="straushm",par=list(beta=beta,gamma=gmma,
                iradii=r,hradii=rhc),w=c(0,250,0,250))
   X.straushm <- rmh(model=mod09,start=list(n.start=ns),
                     control=list(ptypes=c(0.75,0.25),nrep=nr,nverb=nv))
   
   # Multitype Strauss hardcore with trends for each type:
   beta  <- c(0.27,0.08)
   tr3   <- function(x,y){x <- x/250; y <- y/250;
   			   exp((6*x + 5*y - 18*x^2 + 12*x*y - 9*y^2)/6)
                         }
                         # log quadratic trend
   tr4   <- function(x,y){x <- x/250; y <- y/250;
                         exp(-0.6*x+0.5*y)}
                        # log linear trend
   mod10 <- list(cif="straushm",par=list(beta=beta,gamma=gmma,
                 iradii=r,hradii=rhc),w=c(0,250,0,250),
                 trend=list(tr3,tr4))
   X1.straushm.trend <- rmh(model=mod10,start=list(n.start=ns),
                            control=list(ptypes=c(0.75,0.25),
                            nrep=nr,nverb=nv))
   if(online) plot(X1.straushm.trend)
   
   # Multitype Strauss hardcore with trends for each type, given as images:
   bigwin <- square(250)
   i1 <- as.im(tr3, bigwin)
   i2 <- as.im(tr4, bigwin)   
   mod11 <- list(cif="straushm",par=list(beta=beta,gamma=gmma,
                 iradii=r,hradii=rhc),w=bigwin,
                 trend=list(i1,i2))
   X2.straushm.trend <- rmh(model=mod11,start=list(n.start=ns),
                            control=list(ptypes=c(0.75,0.25),expand=1,
                            nrep=nr,nverb=nv))
   
   # Diggle, Gates, and Stibbard:
   mod12 <- list(cif="dgs",par=list(beta=3600,rho=0.08),w=c(0,1,0,1))
   X.dgs <- rmh(model=mod12,start=list(n.start=ns),
                control=list(nrep=nr,nverb=nv))
   if(online) plot(X.dgs)
   
   # Diggle-Gratton:
   mod13 <- list(cif="diggra",
                 par=list(beta=1800,kappa=3,delta=0.02,rho=0.04),
                 w=square(1))
   X.diggra <- rmh(model=mod13,start=list(n.start=ns),
                   control=list(nrep=nr,nverb=nv))
   if(online) plot(X.diggra)
   
   # Fiksel:
   modFik <- list(cif="fiksel",
                 par=list(beta=180,r=0.15,hc=0.07,kappa=2,a= -1.0),
                 w=square(1))
   X.fiksel <- rmh(model=modFik,start=list(n.start=ns),
                   control=list(nrep=nr,nverb=nv))
   if(online) plot(X.fiksel)
   
   # Geyer:
   mod14 <- list(cif="geyer",par=list(beta=1.25,gamma=1.6,r=0.2,sat=4.5),
                 w=c(0,10,0,10))
   X1.geyer <- rmh(model=mod14,start=list(n.start=ns),
                   control=list(nrep=nr,nverb=nv))
   if(online) plot(X1.geyer)
   
   # Geyer; same as a Strauss process with parameters
   # (beta=2.25,gamma=0.16,r=0.7):
   
   mod15 <- list(cif="geyer",par=list(beta=2.25,gamma=0.4,r=0.7,sat=10000),
                 w=c(0,10,0,10))
   X2.geyer <- rmh(model=mod15,start=list(n.start=ns),
                   control=list(nrep=nr,nverb=nv))
   
   mod16 <- list(cif="geyer",par=list(beta=8.1,gamma=2.2,r=0.08,sat=3))

   X3.geyer <- rmh(model=mod16,start=list(x.start=redwood),
                   control=list(periodic=TRUE,nrep=nr,nverb=nv))
   
   # Geyer, starting from the redwood data set, simulating
   # on a torus, and conditioning on n:
   X4.geyer <- rmh(model=mod16,start=list(x.start=redwood),
                   control=list(p=1,periodic=TRUE,nrep=nr,nverb=nv))

   # Lookup (interaction function h_2 from page 76, Diggle (2003)):
      r <- seq(from=0,to=0.2,length=101)[-1] # Drop 0.
      h <- 20*(r-0.05)
      h[r<0.05] <- 0
      h[r>0.10] <- 1
      mod17 <- list(cif="lookup",par=list(beta=4000,h=h,r=r),w=c(0,1,0,1))
      X.lookup <- rmh(model=mod17,start=list(n.start=ns),
                      control=list(nrep=nr,nverb=nv))
      if(online) plot(X.lookup)
                   
   # Strauss with trend
   tr <- function(x,y){x <- x/250; y <- y/250;
   			   exp((6*x + 5*y - 18*x^2 + 12*x*y - 9*y^2)/6)
                         }
   beta <- 0.3
   gmma <- 0.5
   r    <- 45
   modStr <- list(cif="strauss",par=list(beta=beta,gamma=gmma,r=r),
                 w=square(250), trend=tr)
   X1.strauss.trend <- rmh(model=modStr,start=list(n.start=ns),
                           control=list(nrep=nr,nverb=nv))
   # Baddeley-Geyer
   r <- seq(0,0.2,length=8)[-1]
   gmma <- c(0.5,0.6,0.7,0.8,0.7,0.6,0.5)
   mod18 <- list(cif="badgey",par=list(beta=4000, gamma=gmma,r=r,sat=5),
                 w=square(1))
   X1.badgey <- rmh(model=mod18,start=list(n.start=ns),
                    control=list(nrep=nr,nverb=nv))
   mod19 <- list(cif="badgey",
                 par=list(beta=4000, gamma=gmma,r=r,sat=1e4),
                 w=square(1))
   set.seed(1329)
   X2.badgey <- rmh(model=mod18,start=list(n.start=ns),
                    control=list(nrep=nr,nverb=nv))

   # Check:
   h <- ((prod(gmma)/cumprod(c(1,gmma)))[-8])^2
   hs <- stepfun(r,c(h,1))
   mod20 <- list(cif="lookup",par=list(beta=4000,h=hs),w=square(1))
   set.seed(1329)
   X.check <- rmh(model=mod20,start=list(n.start=ns),
                      control=list(nrep=nr,nverb=nv))
   # X2.badgey and X.check will be identical.

   mod21 <- list(cif="badgey",par=list(beta=300,gamma=c(1,0.4,1),
                 r=c(0.035,0.07,0.14),sat=5), w=square(1))
   X3.badgey <- rmh(model=mod21,start=list(n.start=ns),
                    control=list(nrep=nr,nverb=nv))
   # Same result as Geyer model with beta=300, gamma=0.4, r=0.07,
   # sat = 5 (if seeds and control parameters are the same)

   # Or more simply:
   mod22 <- list(cif="badgey",
                 par=list(beta=300,gamma=0.4,r=0.07, sat=5),
                 w=square(1))
   X4.badgey <- rmh(model=mod22,start=list(n.start=ns),
                    control=list(nrep=nr,nverb=nv))
   # Same again --- i.e. the BadGey model includes the Geyer model.


   # Illustrating scalability.
   if(FALSE) {
    M1 <- rmhmodel(cif="strauss",par=list(beta=60,gamma=0.5,r=0.04),w=owin())
    set.seed(496)
    X1 <- rmh(model=M1,start=list(n.start=300))
    M2 <- rmhmodel(cif="strauss",par=list(beta=0.6,gamma=0.5,r=0.4),
              w=owin(c(0,10),c(0,10)))
    set.seed(496)
    X2  <- rmh(model=M2,start=list(n.start=300))
    chk <- affine(X1,mat=diag(c(10,10)))
    all.equal(chk,X2,check.attributes=FALSE)
    # Under the default spatstat options the foregoing all.equal()
    # will yield TRUE.  Setting spatstat.options(scalable=FALSE) and
    # re-running the code will reveal differences between X1 and X2.
   }

   if(!online) spatstat.options(oldopt)
}
\author{\adrian
  and \rolf
}
\keyword{spatial}
\keyword{datagen}

\name{rshift}
\alias{rshift}
\title{Random Shift}
\description{
  Randomly shifts the points of a point pattern or
  line segment pattern. Generic.
}
\usage{
   rshift(X, \dots)
}
\arguments{
  \item{X}{Pattern to be subjected to a random shift.
    A point pattern (class \code{"ppp"}),
    a line segment pattern (class \code{"psp"})
    or an object of class \code{"splitppp"}.
  }
  \item{\dots}{
    Arguments controlling the generation of the
    random shift vector, or specifying which parts of the pattern
    will be shifted. 
  }
}
\value{
  An object of the same type as \code{X}.
}
\details{
  This operation applies a random shift (vector displacement) to
  the points in a point pattern,
  or to the segments in a line segment pattern.

  The argument \code{X} may be 
  \itemize{
    \item
    a point pattern
    (an object of class \code{"ppp"})
    \item
    a line segment pattern
    (an object of class \code{"psp"})
    \item
    an object of class \code{"splitppp"}
    (basically a list of point patterns, obtained from
    \code{\link[spatstat.geom]{split.ppp}}).
  }
  The function \code{rshift} is generic, with
  methods for the three classes \code{"ppp"},
  \code{"psp"} and \code{"splitppp"}.

  See the help pages for these methods, \code{\link{rshift.ppp}},
  \code{\link{rshift.psp}} and
  \code{\link{rshift.splitppp}}, for further information.
}
\seealso{
  \code{\link{rshift.ppp}},
  \code{\link{rshift.psp}},
  \code{\link{rshift.splitppp}}
}
\author{
  \adrian
  and \rolf.
}
\keyword{spatial}
\keyword{datagen}

\name{rmhmodel.default}
\alias{rmhmodel.default}
\title{Build Point Process Model for Metropolis-Hastings Simulation.}
\description{
  Builds a description of a point process model
  for use in simulating the model by the Metropolis-Hastings
  algorithm. 
}
\usage{
  \method{rmhmodel}{default}(..., 
         cif=NULL, par=NULL, w=NULL, trend=NULL, types=NULL)
}
\arguments{
  \item{\dots}{Ignored.}
  \item{cif}{Character string specifying the choice of model}
  \item{par}{Parameters of the model}
  \item{w}{Spatial window in which to simulate}
  \item{trend}{Specification of the trend in the model}
  \item{types}{A vector of factor levels defining the possible
    marks, for a multitype process.
  }
}
\value{
  An object of class \code{"rmhmodel"}, which is essentially
  a list of parameter values for the model.
  
  There is a \code{print} method for this class, which prints
  a sensible description of the model chosen.
}
\details{
  The generic function \code{\link{rmhmodel}} takes a
  description of a point process model in some format, and
  converts it into an object of class \code{"rmhmodel"}
  so that simulations of the model can be generated using
  the Metropolis-Hastings algorithm \code{\link{rmh}}. 
  
  This function \code{rmhmodel.default} is the default method.
  It builds a description of the point process model
  from the simple arguments listed.

  The argument \code{cif} is a character string specifying the choice of
  interpoint interaction for the point process. The current options are
  \describe{
    \item{\code{'areaint'}}{Area-interaction process.}
    \item{\code{'badgey'}}{Baddeley-Geyer (hybrid Geyer) process.}
    \item{\code{'dgs'}}{Diggle, Gates and Stibbard (1987) process}
    \item{\code{'diggra'}}{Diggle and Gratton (1984) process}
    \item{\code{'fiksel'}}{Fiksel double exponential process (Fiksel, 1984).}
    \item{\code{'geyer'}}{Saturation process (Geyer, 1999).}
    \item{\code{'hardcore'}}{Hard core process}
    \item{\code{'lennard'}}{Lennard-Jones process}
    \item{\code{'lookup'}}{General isotropic pairwise interaction process,
      with the interaction function specified via a ``lookup table''.}
    \item{\code{'multihard'}}{Multitype hardcore process}
    \item{\code{'penttinen'}}{The Penttinen process}
    \item{\code{'strauss'}}{The Strauss process}
    \item{\code{'straush'}}{The Strauss process with hard core}
    \item{\code{'sftcr'}}{The Softcore process}
    \item{\code{'straussm'}}{ The multitype Strauss process}
    \item{\code{'straushm'}}{Multitype Strauss process with hard core}
    \item{\code{'triplets'}}{Triplets process (Geyer, 1999).}
  }
  It is also possible to specify a \emph{hybrid} of these interactions
  in the sense of Baddeley et al (2013).
  In this case, \code{cif} is a character vector containing names from
  the list above. For example, \code{cif=c('strauss', 'geyer')} would
  specify a hybrid of the Strauss and Geyer models.
  
  The argument \code{par} supplies parameter values appropriate to
  the conditional intensity function being invoked.
  For the interactions listed above, these parameters are:
  \describe{
    \item{areaint:}{
      (Area-interaction process.) A \bold{named} list with components
      \code{beta,eta,r} which are respectively the ``base''
      intensity, the scaled interaction parameter and the
      interaction radius.  
    }
    \item{badgey:}{
      (Baddeley-Geyer process.)
      A \bold{named} list with components
      \code{beta} (the ``base'' intensity), \code{gamma} (a vector
      of non-negative interaction parameters), \code{r} (a vector
      of interaction radii, of the same length as \code{gamma},
      in \emph{increasing} order), and \code{sat} (the saturation
      parameter(s); this may be a scalar, or a vector of the same
      length as \code{gamma} and \code{r}; all values should be at
      least 1).  Note that because of the presence of ``saturation''
      the \code{gamma} values are permitted to be larger than 1.
    }
    \item{dgs:}{
      (Diggle, Gates, and Stibbard process.
      See Diggle, Gates, and Stibbard (1987))
      A \bold{named} list with components
      \code{beta} and \code{rho}.  This process has pairwise interaction
      function equal to
      \deqn{
	e(t) = \sin^2\left(\frac{\pi t}{2\rho}\right)
      }{
	e(t) = sin^2((pi * t)/(2 * rho))
      }
      for \eqn{t < \rho}{t < rho}, and equal to 1
      for \eqn{t \ge \rho}{t >= rho}.
    }
    \item{diggra:}{
      (Diggle-Gratton process. See Diggle and Gratton (1984)
      and Diggle, Gates and Stibbard (1987).)
      A \bold{named} list with components \code{beta},
      \code{kappa}, \code{delta} and \code{rho}.  This process has
      pairwise interaction function \eqn{e(t)} equal to 0
      for \eqn{t < \delta}{t < delta}, equal to
      \deqn{
	\left(\frac{t-\delta}{\rho-\delta}\right)^\kappa
      }{
	((t-delta)/(rho-delta))^kappa
      }
      for \eqn{\delta \le t < \rho}{delta <= t < rho},
      and equal to 1 for \eqn{t \ge  \rho}{t >= rho}.
      Note that here we use the symbol
      \eqn{\kappa}{kappa} where Diggle, Gates, and Stibbard use
      \eqn{\beta}{beta} since we reserve the symbol \eqn{\beta}{beta}
      for an intensity parameter.
    }
    \item{fiksel:}{
      (Fiksel double exponential process, see Fiksel (1984))
      A \bold{named} list with components \code{beta},
      \code{r}, \code{hc}, \code{kappa} and \code{a}.  This process has
      pairwise interaction function \eqn{e(t)} equal to 0
      for \eqn{t < hc}, equal to
      \deqn{
	\exp(a \exp(- \kappa t))
      }{
	exp(a * exp( - kappa * t))
      }
      for \eqn{hc \le t < r}{hc <= t < r},
      and equal to 1 for \eqn{t \ge  r}{t >= r}.
    }
    \item{geyer:}{
      (Geyer's saturation process. See Geyer (1999).)
      A \bold{named} list
      with components \code{beta}, \code{gamma}, \code{r}, and \code{sat}.
      The components \code{beta}, \code{gamma}, \code{r} are as for
      the Strauss model, and \code{sat} is the ``saturation''
      parameter.  The model is Geyer's ``saturation'' point process
      model, a modification of the Strauss process in which
      we effectively impose an upper limit (\code{sat}) on the number of
      neighbours which will be counted as close to a given point.
      
      Explicitly, a saturation point process with interaction
      radius \eqn{r}, saturation threshold \eqn{s}, and
      parameters \eqn{\beta}{beta} and \eqn{\gamma}{gamma},
      is the point process in which each point \eqn{x_i}{x[i]}
      in the pattern \eqn{X} contributes a factor
      \deqn{\beta \gamma^{\min(s, t(x_i,X))}}{beta gamma^min(s,t(x[i],X))}
      to the probability density of the point pattern,
      where \eqn{t(x_i,X)}{t(x[i],X)} denotes the number of
      ``\eqn{r}-close neighbours'' of \eqn{x_i}{x[i]} in the
      pattern \eqn{X}.

      If the saturation threshold \eqn{s} is infinite,
      the Geyer process reduces to a Strauss process
      with interaction parameter \eqn{\gamma^2}{gamma^2}
      rather than \eqn{\gamma}{gamma}.
    }
    \item{hardcore:}{
      (Hard core process.) A \bold{named} list
      with components \code{beta} and \code{hc}
      where \code{beta} is the base intensity and \code{hc} is the
      hard core distance.
      This process has pairwise interaction function \eqn{e(t)}
      equal to 1 if \eqn{t > hc} and 0 if \eqn{t <= hc}.
    }
    \item{lennard:}{
      (Lennard-Jones process.) A \bold{named} list
      with components \code{sigma} and \code{epsilon},
      where \code{sigma} is the characteristic diameter
      and \code{epsilon} is the well depth.
      See \code{\link[spatstat.model]{LennardJones}} for explanation.
    }
    \item{multihard:}{
      (Multitype hard core process.) A \bold{named} list
      with components \code{beta} and \code{hradii},
      where \code{beta} is a vector of base intensities for each type
      of point, and \code{hradii} is a matrix of hard core radii
      between each pair of types. 
    }
    \item{penttinen:}{
      (Penttinen process.) A \bold{named} list with components
      \code{beta,gamma,r} which are respectively the ``base''
      intensity, the pairwise interaction parameter, and the disc radius.
      Note that \code{gamma} must be less than or equal to 1.
      See \code{\link[spatstat.model]{Penttinen}} for explanation.
      (Note that there is also an algorithm for perfect simulation
      of the Penttinen process, \code{\link{rPenttinen}})
    }
    \item{strauss:}{
      (Strauss process.) A \bold{named} list with components
      \code{beta,gamma,r} which are respectively the ``base''
      intensity, the pairwise interaction parameter and the
      interaction radius.  Note that \code{gamma} must be less than
      or equal to 1.
      (Note that there is also an algorithm for perfect simulation
      of the Strauss process, \code{\link{rStrauss}})
    }
    \item{straush:}{
      (Strauss process with hardcore.) A \bold{named} list with
      entries \code{beta,gamma,r,hc} where \code{beta}, \code{gamma},
      and \code{r} are as for the Strauss process, and \code{hc} is
      the hardcore radius.  Of course \code{hc} must be less than
      \code{r}.
    }
    \item{sftcr:}{
      (Softcore process.) A \bold{named} list with components
      \code{beta,sigma,kappa}.  Again \code{beta} is a ``base''
      intensity. The pairwise interaction between two points
      \eqn{u \neq v}{u != v} is
      \deqn{
	\exp \left \{
	- \left ( \frac{\sigma}{||u-v||} \right )^{2/\kappa}
	\right \}
      }{-(sigma/||u-v||)^(2/kappa)}
      Note that it is necessary that \eqn{0 < \kappa < 1}{0 < kappa <1}.
    }
    \item{straussm:}{
      (Multitype Strauss process.) A \bold{named} list with components
      \itemize{
	\item
	\code{beta}: 
	A vector of ``base'' intensities, one for each possible type.
	\item
	\code{gamma}:
	A \bold{symmetric} matrix of interaction parameters,
	with \eqn{\gamma_{ij}}{gamma_ij} pertaining to the interaction between
	type \eqn{i} and type \eqn{j}.
	\item
	\code{radii}:
	A \bold{symmetric} matrix of interaction radii, with
	entries \eqn{r_{ij}}{r_ij} pertaining to the interaction between type
	\eqn{i} and type \eqn{j}.
      }
    }
    \item{straushm:}{
      (Multitype Strauss process with hardcore.)
      A \bold{named} list with components \code{beta} and \code{gamma}
      as for \code{straussm} and
      \bold{two} ``radii'' components:
      \itemize{
        \item \code{iradii}: the interaction radii
        \item \code{hradii}: the hardcore radii
      }
      which are both symmetric matrices of nonnegative numbers.
      The entries of \code{hradii} must be less than the
      corresponding entries
      of \code{iradii}.
    }
    \item{triplets:}{
      (Triplets process.) A \bold{named} list with components
      \code{beta,gamma,r} which are respectively the ``base''
      intensity, the triplet interaction parameter and the
      interaction radius.  Note that \code{gamma} must be less than
      or equal to 1.
    }
    \item{lookup:}{
      (Arbitrary pairwise interaction process with isotropic interaction.)
      A \bold{named} list with components
      \code{beta}, \code{r}, and \code{h}, or just with components
      \code{beta} and \code{h}.

      This model is the pairwise interaction process
      with an isotropic interaction given by any chosen function \eqn{H}.
      Each pair of points \eqn{x_i, x_j}{x[i], x[j]} in the
      point pattern contributes
      a factor \eqn{H(d(x_i, x_j))}{H(d(x[i],x[j]))}
      to the probability density, where \eqn{d} denotes distance
      and \eqn{H} is the pair interaction function.

      The component \code{beta} is a
      (positive) scalar which determines the ``base'' intensity
      of the process.

      In this implementation, \eqn{H} must be a step function.
      It is specified by the user in one of two ways.
      \itemize{
	\item
	\bold{as a vector of values:}
	If \code{r} is present, then \code{r} is assumed to 
	give the locations of jumps in the function \eqn{H},
	while the vector \code{h} gives the corresponding
	values of the function.

	Specifically, the interaction function
	\eqn{H(t)} takes the value \code{h[1]}
	for distances \eqn{t} in the interval 
	\code{[0, r[1])}; takes the value \code{h[i]}
	for distances \eqn{t} in the interval 
	\code{[r[i-1], r[i])} where
	\eqn{i = 2,\ldots, n}{i = 2, ..., n};
	and takes the value 1 for \eqn{t \ge r[n]}{t >= r[n]}.
	Here \eqn{n} denotes the length of \code{r}.
	    
	The components \code{r} and \code{h}
	must be numeric vectors of equal length.
	The \code{r} values must be strictly positive, and 
	sorted in increasing order.

	The entries of \code{h} must be non-negative. 
	If any entry of \code{h} is greater than 1,
	then the entry \code{h[1]} must be 0 (otherwise the specified
	process is non-existent).

	Greatest efficiency is achieved if the values of
	\code{r} are equally spaced.
	    
	[\bold{Note:} The usage of \code{r} and \code{h}
	has \emph{changed} from the previous usage in \pkg{spatstat}
	versions 1.4-7 to 1.5-1, in which ascending order was not required,
	and in which the first entry of \code{r} had to be 0.]

	\item
	\bold{as a stepfun object:}
	If \code{r} is absent, then \code{h} must be
	an object of class \code{"stepfun"} specifying
	a step function. Such objects are created by
	\code{\link{stepfun}}. 

	The stepfun object \code{h} must be right-continuous
	(which is the default using \code{\link{stepfun}}.)

	The values of the step function must all be nonnegative.
	The values must all be less than 1
	unless the function is identically zero on some initial
	interval \eqn{[0,r)}. The rightmost value (the value of
	\code{h(t)} for large \code{t}) must be equal to 1.

	Greatest efficiency is achieved if the jumps (the
	``knots'' of the step function) are equally spaced.
      }
    }
  }
  For a hybrid model, the argument \code{par} should be a list,
  of the same length as \code{cif}, such that \code{par[[i]]}
  is a list of the parameters required for the interaction
  \code{cif[i]}. See the Examples.
  
  The optional argument \code{trend} determines the spatial trend in the model,
  if it has one. It should be a function or image
  (or a list of such, if the model is multitype)
  to provide the value of the trend at an arbitrary point.
  \describe{
    \item{trend given as a function:}{A trend
      function may be a function of any number of arguments,
      but the first two must be the \eqn{x,y} coordinates of
      a point.  Auxiliary arguments may be passed
      to the \code{trend} function at the time of simulation,
      via the \code{\dots} argument to \code{\link{rmh}}.
      
      The function \bold{must} be \bold{vectorized}.
      That is, it must be capable of accepting vector valued
      \code{x} and \code{y} arguments.  Put another way,
      it must be capable of calculating the trend value at a
      number of points, simultaneously, and should return the
      \bold{vector} of corresponding trend values.
    }
    \item{trend given as an image:}{
      An image (see \code{\link[spatstat.geom]{im.object}})
      provides the trend values at a grid of
      points in the observation window and determines the trend
      value at other points as the value at the nearest grid point.
    }
  }
  Note that the trend or trends must be \bold{non-negative};
  no checking is done for this.
  
  The optional argument \code{w} specifies the window
  in which the pattern is to be generated.  If specified, it must be in
  a form which can be coerced to an object of class \code{owin}
  by \code{\link[spatstat.geom]{as.owin}}.

  The optional argument \code{types} specifies the possible
  types in a multitype point process. If the model being simulated
  is multitype, and \code{types} is not specified, then this vector
  defaults to \code{1:ntypes} where \code{ntypes} is the number of
  types.
}
\references{
  Baddeley, A., Turner, R., Mateu, J. and Bevan, A. (2013)
  Hybrids of Gibbs point process models and their implementation.
  \emph{Journal of Statistical Software} \bold{55}:11, 1--43.
  \code{DOI: 10.18637/jss.v055.i11}

   Diggle, P. J. (2003) \emph{Statistical Analysis of Spatial Point
   Patterns} (2nd ed.) Arnold, London.

   Diggle, P.J. and Gratton, R.J. (1984)
   Monte Carlo methods of inference for implicit statistical models.
   \emph{Journal of the Royal Statistical Society, series B}
   \bold{46}, 193 -- 212.

   Diggle, P.J., Gates, D.J., and Stibbard, A. (1987)
   A nonparametric estimator for pairwise-interaction point processes.
   Biometrika \bold{74}, 763 -- 770.
   \emph{Scandinavian Journal of Statistics} \bold{21}, 359--373.

   Fiksel, T. (1984)
   Estimation of parameterized pair potentials
   of marked and non-marked Gibbsian point processes.
   \emph{Electronische Informationsverabeitung und Kybernetika}
   \bold{20}, 270--278.

   Geyer, C.J. (1999)
   Likelihood Inference for Spatial Point
   Processes. Chapter 3 in  O.E. Barndorff-Nielsen, W.S. Kendall and
   M.N.M. Van Lieshout (eds) \emph{Stochastic Geometry: Likelihood and
   Computation}, Chapman and Hall / CRC,  Monographs on Statistics and
   Applied Probability, number 80. Pages 79--140.
}

\section{Warnings in Respect of ``lookup''}{

For the \code{lookup} cif, 
the entries of the \code{r} component of \code{par}
must be \emph{strictly positive} and sorted into ascending order.

Note that if you specify the \code{lookup} pairwise interaction
function via \code{\link{stepfun}()} the arguments \code{x}
and \code{y} which are passed to \code{stepfun()} are slightly
different from \code{r} and \code{h}:  \code{length(y)} is equal
to \code{1+length(x)}; the final entry of \code{y} must be equal
to 1 --- i.e. this value is explicitly supplied by the user rather
than getting tacked on internally.

The step function returned by \code{stepfun()} must be right
continuous (this is the default behaviour of \code{stepfun()})
otherwise an error is given.
}

\seealso{
  \code{\link{rmh}},
  \code{\link{rmhcontrol}},
  \code{\link{rmhstart}},
  \code{\link[spatstat.model]{ppm}},
  \rmhInteractionsList.
}
\examples{
   # Strauss process:
   mod01 <- rmhmodel(cif="strauss",par=list(beta=2,gamma=0.2,r=0.7),
                 w=c(0,10,0,10))
   mod01
   # The above could also be simulated using 'rStrauss'

   # Strauss with hardcore:
   mod04 <- rmhmodel(cif="straush",par=list(beta=2,gamma=0.2,r=0.7,hc=0.3),
                w=owin(c(0,10),c(0,5)))

   # Hard core:
   mod05 <- rmhmodel(cif="hardcore",par=list(beta=2,hc=0.3),
              w=square(5))

   # Soft core:
   w    <- square(10)
   mod07 <- rmhmodel(cif="sftcr",
                     par=list(beta=0.8,sigma=0.1,kappa=0.5),
                     w=w)
   
   # Penttinen process:
   modpen <- rmhmodel(cif="penttinen",par=list(beta=2,gamma=0.6,r=1),
                 w=c(0,10,0,10))

   # Area-interaction process:
   mod42 <- rmhmodel(cif="areaint",par=list(beta=2,eta=1.6,r=0.7),
                 w=c(0,10,0,10))

   # Baddeley-Geyer process:
   mod99 <- rmhmodel(cif="badgey",par=list(beta=0.3,
                     gamma=c(0.2,1.8,2.4),r=c(0.035,0.07,0.14),sat=5),
                     w=unit.square())

   # Multitype Strauss:
   beta <- c(0.027,0.008)
   gmma <- matrix(c(0.43,0.98,0.98,0.36),2,2)
   r    <- matrix(c(45,45,45,45),2,2)
   mod08 <- rmhmodel(cif="straussm",
                     par=list(beta=beta,gamma=gmma,radii=r),
                     w=square(250))
   # specify types
   mod09 <- rmhmodel(cif="straussm",
                     par=list(beta=beta,gamma=gmma,radii=r),
                     w=square(250),
                     types=c("A", "B"))

   # Multitype Hardcore:
   rhc  <- matrix(c(9.1,5.0,5.0,2.5),2,2)
   mod08hard <- rmhmodel(cif="multihard",
                     par=list(beta=beta,hradii=rhc),
                     w=square(250),
                     types=c("A", "B"))

   
   # Multitype Strauss hardcore with trends for each type:
   beta  <- c(0.27,0.08)
   ri    <- matrix(c(45,45,45,45),2,2)
   rhc  <- matrix(c(9.1,5.0,5.0,2.5),2,2)
   tr3   <- function(x,y){x <- x/250; y <- y/250;
   			   exp((6*x + 5*y - 18*x^2 + 12*x*y - 9*y^2)/6)
                         }
                         # log quadratic trend
   tr4   <- function(x,y){x <- x/250; y <- y/250;
                         exp(-0.6*x+0.5*y)}
                        # log linear trend
   mod10 <- rmhmodel(cif="straushm",par=list(beta=beta,gamma=gmma,
                 iradii=ri,hradii=rhc),w=c(0,250,0,250),
                 trend=list(tr3,tr4))

   # Triplets process:
   mod11 <- rmhmodel(cif="triplets",par=list(beta=2,gamma=0.2,r=0.7),
                 w=c(0,10,0,10))

   # Lookup (interaction function h_2 from page 76, Diggle (2003)):
      r <- seq(from=0,to=0.2,length=101)[-1] # Drop 0.
      h <- 20*(r-0.05)
      h[r<0.05] <- 0
      h[r>0.10] <- 1
      mod17 <- rmhmodel(cif="lookup",par=list(beta=4000,h=h,r=r),w=c(0,1,0,1))

  # hybrid model
  modhy <- rmhmodel(cif=c('strauss', 'geyer'),
                    par=list(list(beta=100,gamma=0.5,r=0.05),
                             list(beta=1, gamma=0.7,r=0.1, sat=2)),
                    w=square(1))
  modhy
}
\author{
  \adrian
  and
  \rolf
}
\keyword{spatial}
\keyword{datagen}
